//
// File: Cego.cc
// This code was produced by the dragon parser generator
//
#include "Cego.h"
#include <lfcbase/Exception.h>
#include <lfcbase/StackT.h>

Cego::ScannerStateEntry::ScannerStateEntry()
{
}

Cego::ScannerStateEntry::ScannerStateEntry(int state, ScannerStateType type)
{
   _state = state;
   _type = type;
}

Cego::ScannerStateEntry& Cego::ScannerStateEntry::operator = (const Cego::ScannerStateEntry& s)
{
   _state = s._state;
   _type = s._type;
   return(*this);
}

bool Cego::ScannerStateEntry::operator == (const Cego::ScannerStateEntry& s)
{
   if ( _state == s._state )
      return true;
   return false;
}

Cego::ScannerStateType Cego::ScannerStateEntry::getType()
{
   return _type;
}
int Cego::ScannerStateEntry::getState()
{
   return _state;
}


Cego::ScannerTransEntry::ScannerTransEntry()
{
}

Cego::ScannerTransEntry::ScannerTransEntry(int state, char c)
{
   _state = state;
   _c = c;
}

Cego::ScannerTransEntry::ScannerTransEntry(int state, char c, int fstate)
{
   _state = state;
   _c = c;
   _fstate = fstate;
}

Cego::ScannerTransEntry& Cego::ScannerTransEntry::operator = (const Cego::ScannerTransEntry& s)
{
   _state = s._state;
   _c = s._c;
   _fstate = s._fstate;
   return(*this);
}

bool Cego::ScannerTransEntry::operator == (const Cego::ScannerTransEntry& s)
{
   if ( _state == s._state && _c == s._c)
      return true;
   return false;
}

int Cego::ScannerTransEntry::getFState()
{
   return _fstate;
}


Cego::Scanner::Scanner()
{
}


Cego::Scanner::Scanner(Token t)
{
   _token = t;
}

Cego::Token Cego::Scanner::getToken()
{
   return _token;
}

void Cego::Scanner::addState(ScannerStateEntry s)
{
   _stateList.Insert(s);
}

void Cego::Scanner::addTransition(ScannerTransEntry t)
{
   _transList.Insert(t);
}

bool Cego::Scanner::checkPattern(const Chain& p)
{
   unsigned long state = 0;
   ScannerStateEntry* pS = _stateList.First();
   while (pS)
   {
      if (pS->getType() == START || pS->getType() == ANY)
      {
         state = pS->getState();
         pS = 0;
      }
      else
      {
         pS = _stateList.Next();
      }
   }
   unsigned long i = 0;
   ScannerTransEntry* pT = 
   _transList.Find(ScannerTransEntry(state, p[i]));
   while (pT)
   {
      ScannerStateEntry* pS = _stateList.Find(ScannerStateEntry(pT->getFState())); 
      if (pS)
      {
         if ( ( i == p.length()-2 ) && ( pS->getType() == FINAL || pS->getType() == ANY))
         {
            return true;
         }
         else
         {
            state = pT->getFState();
         }
      }
      else
      {
         return false;
      }
      i++;
      pT = _transList.Find(ScannerTransEntry(state, p[i]));
   }
   return false;
}
Cego::StackEntry::StackEntry()
{
   _symbol = NONE;
}

Cego::StackEntry::StackEntry(Symbol symbol, int num, int state, Chain tval)
{
   _symbol=symbol;
   _num=num;
   _state=state;
   _tval=tval;
}

Cego::StackEntry& Cego::StackEntry::operator = (const Cego::StackEntry& se)
{
   _symbol=se._symbol;
   _num=se._num;
   _state=se._state;
   _tval=se._tval;
   return(*this);
}

int Cego::StackEntry::getState()
{
   return _state;
}
Cego::Symbol Cego::StackEntry::getSymbol()
{
   return _symbol;
}
Chain& Cego::StackEntry::getTval()
{
   return _tval;
}

Cego::ActionEntry::ActionEntry()
{
   _action=NULLACTION;
}

Cego::ActionEntry::ActionEntry(Action action , int num)
{
   _action=action;
   _num=num;
}

bool Cego::ActionEntry::operator == (const Cego::ActionEntry& ae)
{
   if (_action == ae._action && _num == ae._num)
      return true;
   return false;
}

Cego::ActionEntry& Cego::ActionEntry::operator = (const Cego::ActionEntry& ae)
{
   _action=ae._action;
   _num=ae._num;
   return(*this);
}

Cego::Action Cego::ActionEntry::getAction()
{
   return _action;
}

int Cego::ActionEntry::getNum()
{
   return _num;
}

Cego::ProdEntry::ProdEntry()
{
}

Cego::ProdEntry::ProdEntry(int id)
{
   _id = id;
}

Cego::ProdEntry::ProdEntry(int id, Production prod, int numSymbol)
{
   _id = id;
   _prod = prod;
   _numSymbol = numSymbol;
}

bool Cego::ProdEntry::operator == (const Cego::ProdEntry& pe)
{
   if (_id == pe._id)
      return true;
   return false;
}

Cego::ProdEntry& Cego::ProdEntry::operator = (const Cego::ProdEntry& pe)
{
   _id = pe._id;
   _prod = pe._prod;
   _numSymbol = pe._numSymbol;
   return(*this);
}


int Cego::ProdEntry::getId()
{
   return _id;
}

Cego::Production Cego::ProdEntry::getProd()
{
   return _prod;
}

int Cego::ProdEntry::getNumSymbol()
{
   return _numSymbol;
}
void Cego::loadScanner()
{
   Scanner s0(ADD);
   s0.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(2 ,START));
   s0.addState(ScannerStateEntry(3 ,FINAL));
   s0.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s0.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s0.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s0.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s0.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s0.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s0);

   Scanner s1(AND);
   s1.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(2 ,START));
   s1.addState(ScannerStateEntry(3 ,FINAL));
   s1.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s1.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s1.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s1.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s1.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s1.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s1);

   Scanner s2(ALL);
   s2.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(2 ,START));
   s2.addState(ScannerStateEntry(3 ,FINAL));
   s2.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s2.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s2.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s2.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s2.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s2.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s2);

   Scanner s3(ALTER);
   s3.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(2 ,START));
   s3.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(5 ,FINAL));
   s3.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s3.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s3.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s3.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s3.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s3.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s3.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s3.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s3.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s3.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s3);

   Scanner s4(APPEND);
   s4.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(2 ,START));
   s4.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(6 ,FINAL));
   s4.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s4.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s4.addTransition(ScannerTransEntry(1 ,'P' ,3));
   s4.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s4.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s4.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s4.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s4.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s4.addTransition(ScannerTransEntry(4 ,'N' ,5));
   s4.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s4.addTransition(ScannerTransEntry(5 ,'D' ,6));
   s4.addTransition(ScannerTransEntry(5 ,'d' ,6));
   _scannerList.Insert(s4);

   Scanner s5(AS);
   s5.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(1 ,FINAL));
   s5.addState(ScannerStateEntry(2 ,START));
   s5.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s5.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s5.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s5.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s5);

   Scanner s6(ASC);
   s6.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(2 ,START));
   s6.addState(ScannerStateEntry(3 ,FINAL));
   s6.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s6.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s6.addTransition(ScannerTransEntry(1 ,'C' ,3));
   s6.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s6.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s6.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s6);

   Scanner s7(AUTHORIZE);
   s7.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(2 ,START));
   s7.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(9 ,FINAL));
   s7.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s7.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s7.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s7.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s7.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s7.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s7.addTransition(ScannerTransEntry(3 ,'H' ,4));
   s7.addTransition(ScannerTransEntry(3 ,'h' ,4));
   s7.addTransition(ScannerTransEntry(4 ,'O' ,5));
   s7.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s7.addTransition(ScannerTransEntry(5 ,'R' ,6));
   s7.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s7.addTransition(ScannerTransEntry(6 ,'I' ,7));
   s7.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s7.addTransition(ScannerTransEntry(7 ,'Z' ,8));
   s7.addTransition(ScannerTransEntry(7 ,'z' ,8));
   s7.addTransition(ScannerTransEntry(8 ,'E' ,9));
   s7.addTransition(ScannerTransEntry(8 ,'e' ,9));
   _scannerList.Insert(s7);

   Scanner s8(AUTOCOMMIT);
   s8.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(2 ,START));
   s8.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(10 ,FINAL));
   s8.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s8.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s8.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s8.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s8.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s8.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s8.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s8.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s8.addTransition(ScannerTransEntry(4 ,'C' ,5));
   s8.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s8.addTransition(ScannerTransEntry(5 ,'O' ,6));
   s8.addTransition(ScannerTransEntry(5 ,'o' ,6));
   s8.addTransition(ScannerTransEntry(6 ,'M' ,7));
   s8.addTransition(ScannerTransEntry(6 ,'m' ,7));
   s8.addTransition(ScannerTransEntry(7 ,'M' ,8));
   s8.addTransition(ScannerTransEntry(7 ,'m' ,8));
   s8.addTransition(ScannerTransEntry(8 ,'I' ,9));
   s8.addTransition(ScannerTransEntry(8 ,'i' ,9));
   s8.addTransition(ScannerTransEntry(9 ,'T' ,10));
   s8.addTransition(ScannerTransEntry(9 ,'t' ,10));
   _scannerList.Insert(s8);

   Scanner s9(AVG);
   s9.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(2 ,START));
   s9.addState(ScannerStateEntry(3 ,FINAL));
   s9.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s9.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s9.addTransition(ScannerTransEntry(1 ,'G' ,3));
   s9.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s9.addTransition(ScannerTransEntry(2 ,'A' ,0));
   s9.addTransition(ScannerTransEntry(2 ,'a' ,0));
   _scannerList.Insert(s9);

   Scanner s10(BEGIN);
   s10.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(2 ,START));
   s10.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(5 ,FINAL));
   s10.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s10.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s10.addTransition(ScannerTransEntry(1 ,'G' ,3));
   s10.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s10.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s10.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s10.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s10.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s10.addTransition(ScannerTransEntry(4 ,'N' ,5));
   s10.addTransition(ScannerTransEntry(4 ,'n' ,5));
   _scannerList.Insert(s10);

   Scanner s11(BETWEEN);
   s11.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(2 ,START));
   s11.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(7 ,FINAL));
   s11.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s11.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s11.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s11.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s11.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s11.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s11.addTransition(ScannerTransEntry(3 ,'W' ,4));
   s11.addTransition(ScannerTransEntry(3 ,'w' ,4));
   s11.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s11.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s11.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s11.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s11.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s11.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s11);

   Scanner s12(BIGINT);
   s12.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(2 ,START));
   s12.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(6 ,FINAL));
   s12.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s12.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s12.addTransition(ScannerTransEntry(1 ,'G' ,3));
   s12.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s12.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s12.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s12.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s12.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s12.addTransition(ScannerTransEntry(4 ,'N' ,5));
   s12.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s12.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s12.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s12);

   Scanner s13(BITAND);
   s13.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(2 ,START));
   s13.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(6 ,FINAL));
   s13.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s13.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s13.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s13.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s13.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s13.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s13.addTransition(ScannerTransEntry(3 ,'A' ,4));
   s13.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s13.addTransition(ScannerTransEntry(4 ,'N' ,5));
   s13.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s13.addTransition(ScannerTransEntry(5 ,'D' ,6));
   s13.addTransition(ScannerTransEntry(5 ,'d' ,6));
   _scannerList.Insert(s13);

   Scanner s14(BITOR);
   s14.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(2 ,START));
   s14.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(5 ,FINAL));
   s14.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s14.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s14.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s14.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s14.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s14.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s14.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s14.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s14.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s14.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s14);

   Scanner s15(BITXOR);
   s15.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(2 ,START));
   s15.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(6 ,FINAL));
   s15.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s15.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s15.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s15.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s15.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s15.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s15.addTransition(ScannerTransEntry(3 ,'X' ,4));
   s15.addTransition(ScannerTransEntry(3 ,'x' ,4));
   s15.addTransition(ScannerTransEntry(4 ,'O' ,5));
   s15.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s15.addTransition(ScannerTransEntry(5 ,'R' ,6));
   s15.addTransition(ScannerTransEntry(5 ,'r' ,6));
   _scannerList.Insert(s15);

   Scanner s16(BLOB);
   s16.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(2 ,START));
   s16.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(4 ,FINAL));
   s16.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s16.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s16.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s16.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s16.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s16.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s16.addTransition(ScannerTransEntry(3 ,'B' ,4));
   s16.addTransition(ScannerTransEntry(3 ,'b' ,4));
   _scannerList.Insert(s16);

   Scanner s17(BLOBSIZE);
   s17.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(2 ,START));
   s17.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(8 ,FINAL));
   s17.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s17.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s17.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s17.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s17.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s17.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s17.addTransition(ScannerTransEntry(3 ,'B' ,4));
   s17.addTransition(ScannerTransEntry(3 ,'b' ,4));
   s17.addTransition(ScannerTransEntry(4 ,'S' ,5));
   s17.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s17.addTransition(ScannerTransEntry(5 ,'I' ,6));
   s17.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s17.addTransition(ScannerTransEntry(6 ,'Z' ,7));
   s17.addTransition(ScannerTransEntry(6 ,'z' ,7));
   s17.addTransition(ScannerTransEntry(7 ,'E' ,8));
   s17.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s17);

   Scanner s18(BOOL);
   s18.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(2 ,START));
   s18.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(4 ,FINAL));
   s18.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s18.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s18.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s18.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s18.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s18.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s18.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s18.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s18);

   Scanner s19(BTREE);
   s19.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(2 ,START));
   s19.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(5 ,FINAL));
   s19.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s19.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s19.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s19.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s19.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s19.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s19.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s19.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s19.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s19.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s19);

   Scanner s20(BY);
   s20.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(1 ,FINAL));
   s20.addState(ScannerStateEntry(2 ,START));
   s20.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s20.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s20.addTransition(ScannerTransEntry(2 ,'B' ,0));
   s20.addTransition(ScannerTransEntry(2 ,'b' ,0));
   _scannerList.Insert(s20);

   Scanner s21(CALL);
   s21.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(2 ,START));
   s21.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(4 ,FINAL));
   s21.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s21.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s21.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s21.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s21.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s21.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s21.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s21.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s21);

   Scanner s22(CASE);
   s22.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(2 ,START));
   s22.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(4 ,FINAL));
   s22.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s22.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s22.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s22.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s22.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s22.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s22.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s22.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s22);

   Scanner s23(CHECK);
   s23.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(2 ,START));
   s23.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(5 ,FINAL));
   s23.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s23.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s23.addTransition(ScannerTransEntry(1 ,'E' ,3));
   s23.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s23.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s23.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s23.addTransition(ScannerTransEntry(3 ,'C' ,4));
   s23.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s23.addTransition(ScannerTransEntry(4 ,'K' ,5));
   s23.addTransition(ScannerTransEntry(4 ,'k' ,5));
   _scannerList.Insert(s23);

   Scanner s24(CLOSE);
   s24.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(2 ,START));
   s24.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(5 ,FINAL));
   s24.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s24.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s24.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s24.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s24.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s24.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s24.addTransition(ScannerTransEntry(3 ,'S' ,4));
   s24.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s24.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s24.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s24);

   Scanner s25(COMMIT);
   s25.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(2 ,START));
   s25.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(6 ,FINAL));
   s25.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s25.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s25.addTransition(ScannerTransEntry(1 ,'M' ,3));
   s25.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s25.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s25.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s25.addTransition(ScannerTransEntry(3 ,'M' ,4));
   s25.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s25.addTransition(ScannerTransEntry(4 ,'I' ,5));
   s25.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s25.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s25.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s25);

   Scanner s26(COLUMN);
   s26.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(2 ,START));
   s26.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(6 ,FINAL));
   s26.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s26.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s26.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s26.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s26.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s26.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s26.addTransition(ScannerTransEntry(3 ,'U' ,4));
   s26.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s26.addTransition(ScannerTransEntry(4 ,'M' ,5));
   s26.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s26.addTransition(ScannerTransEntry(5 ,'N' ,6));
   s26.addTransition(ScannerTransEntry(5 ,'n' ,6));
   _scannerList.Insert(s26);

   Scanner s27(CONSTRAINT);
   s27.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(2 ,START));
   s27.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(10 ,FINAL));
   s27.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s27.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s27.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s27.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s27.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s27.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s27.addTransition(ScannerTransEntry(3 ,'S' ,4));
   s27.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s27.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s27.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s27.addTransition(ScannerTransEntry(5 ,'R' ,6));
   s27.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s27.addTransition(ScannerTransEntry(6 ,'A' ,7));
   s27.addTransition(ScannerTransEntry(6 ,'a' ,7));
   s27.addTransition(ScannerTransEntry(7 ,'I' ,8));
   s27.addTransition(ScannerTransEntry(7 ,'i' ,8));
   s27.addTransition(ScannerTransEntry(8 ,'N' ,9));
   s27.addTransition(ScannerTransEntry(8 ,'n' ,9));
   s27.addTransition(ScannerTransEntry(9 ,'T' ,10));
   s27.addTransition(ScannerTransEntry(9 ,'t' ,10));
   _scannerList.Insert(s27);

   Scanner s28(COUNT);
   s28.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(2 ,START));
   s28.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(5 ,FINAL));
   s28.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s28.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s28.addTransition(ScannerTransEntry(1 ,'U' ,3));
   s28.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s28.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s28.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s28.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s28.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s28.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s28.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s28);

   Scanner s29(COUNTER);
   s29.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(2 ,START));
   s29.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(7 ,FINAL));
   s29.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s29.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s29.addTransition(ScannerTransEntry(1 ,'U' ,3));
   s29.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s29.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s29.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s29.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s29.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s29.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s29.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s29.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s29.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s29.addTransition(ScannerTransEntry(6 ,'R' ,7));
   s29.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s29);

   Scanner s30(CREATE);
   s30.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(2 ,START));
   s30.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(6 ,FINAL));
   s30.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s30.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s30.addTransition(ScannerTransEntry(1 ,'E' ,3));
   s30.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s30.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s30.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s30.addTransition(ScannerTransEntry(3 ,'A' ,4));
   s30.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s30.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s30.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s30.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s30.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s30);

   Scanner s31(CURSOR);
   s31.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(2 ,START));
   s31.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(6 ,FINAL));
   s31.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s31.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s31.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s31.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s31.addTransition(ScannerTransEntry(2 ,'C' ,0));
   s31.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s31.addTransition(ScannerTransEntry(3 ,'S' ,4));
   s31.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s31.addTransition(ScannerTransEntry(4 ,'O' ,5));
   s31.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s31.addTransition(ScannerTransEntry(5 ,'R' ,6));
   s31.addTransition(ScannerTransEntry(5 ,'r' ,6));
   _scannerList.Insert(s31);

   Scanner s32(DATE);
   s32.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(2 ,START));
   s32.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(4 ,FINAL));
   s32.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s32.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s32.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s32.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s32.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s32.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s32.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s32.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s32);

   Scanner s33(DATE2STR);
   s33.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(2 ,START));
   s33.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(8 ,FINAL));
   s33.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s33.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s33.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s33.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s33.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s33.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s33.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s33.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s33.addTransition(ScannerTransEntry(4 ,'2' ,5));
   s33.addTransition(ScannerTransEntry(5 ,'S' ,6));
   s33.addTransition(ScannerTransEntry(5 ,'s' ,6));
   s33.addTransition(ScannerTransEntry(6 ,'T' ,7));
   s33.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s33.addTransition(ScannerTransEntry(7 ,'R' ,8));
   s33.addTransition(ScannerTransEntry(7 ,'r' ,8));
   _scannerList.Insert(s33);

   Scanner s34(DATE2INT);
   s34.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(2 ,START));
   s34.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(8 ,FINAL));
   s34.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s34.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s34.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s34.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s34.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s34.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s34.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s34.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s34.addTransition(ScannerTransEntry(4 ,'2' ,5));
   s34.addTransition(ScannerTransEntry(5 ,'I' ,6));
   s34.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s34.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s34.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s34.addTransition(ScannerTransEntry(7 ,'T' ,8));
   s34.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s34);

   Scanner s35(DATETIME);
   s35.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(2 ,START));
   s35.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(8 ,FINAL));
   s35.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s35.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s35.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s35.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s35.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s35.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s35.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s35.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s35.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s35.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s35.addTransition(ScannerTransEntry(5 ,'I' ,6));
   s35.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s35.addTransition(ScannerTransEntry(6 ,'M' ,7));
   s35.addTransition(ScannerTransEntry(6 ,'m' ,7));
   s35.addTransition(ScannerTransEntry(7 ,'E' ,8));
   s35.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s35);

   Scanner s36(DECIMAL);
   s36.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(2 ,START));
   s36.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(7 ,FINAL));
   s36.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s36.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s36.addTransition(ScannerTransEntry(1 ,'C' ,3));
   s36.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s36.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s36.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s36.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s36.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s36.addTransition(ScannerTransEntry(4 ,'M' ,5));
   s36.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s36.addTransition(ScannerTransEntry(5 ,'A' ,6));
   s36.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s36.addTransition(ScannerTransEntry(6 ,'L' ,7));
   s36.addTransition(ScannerTransEntry(6 ,'l' ,7));
   _scannerList.Insert(s36);

   Scanner s37(DEFAULT);
   s37.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(2 ,START));
   s37.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(7 ,FINAL));
   s37.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'F' ,3));
   s37.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s37.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s37.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s37.addTransition(ScannerTransEntry(3 ,'A' ,4));
   s37.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s37.addTransition(ScannerTransEntry(4 ,'U' ,5));
   s37.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s37.addTransition(ScannerTransEntry(5 ,'L' ,6));
   s37.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s37.addTransition(ScannerTransEntry(6 ,'T' ,7));
   s37.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s37);

   Scanner s38(DELETETOK);
   s38.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(2 ,START));
   s38.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(6 ,FINAL));
   s38.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s38.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s38.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s38.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s38.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s38.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s38.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s38.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s38.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s38.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s38);

   Scanner s39(DESC);
   s39.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(2 ,START));
   s39.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(4 ,FINAL));
   s39.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s39.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s39.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s39.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s39.addTransition(ScannerTransEntry(3 ,'C' ,4));
   s39.addTransition(ScannerTransEntry(3 ,'c' ,4));
   _scannerList.Insert(s39);

   Scanner s40(DISTINCT);
   s40.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(2 ,START));
   s40.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(8 ,FINAL));
   s40.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s40.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s40.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s40.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s40.addTransition(ScannerTransEntry(3 ,'T' ,4));
   s40.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s40.addTransition(ScannerTransEntry(4 ,'I' ,5));
   s40.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s40.addTransition(ScannerTransEntry(5 ,'N' ,6));
   s40.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s40.addTransition(ScannerTransEntry(6 ,'C' ,7));
   s40.addTransition(ScannerTransEntry(6 ,'c' ,7));
   s40.addTransition(ScannerTransEntry(7 ,'T' ,8));
   s40.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s40);

   Scanner s41(DIV);
   s41.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(2 ,START));
   s41.addState(ScannerStateEntry(3 ,FINAL));
   s41.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s41.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s41.addTransition(ScannerTransEntry(1 ,'V' ,3));
   s41.addTransition(ScannerTransEntry(1 ,'v' ,3));
   s41.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s41.addTransition(ScannerTransEntry(2 ,'d' ,0));
   _scannerList.Insert(s41);

   Scanner s42(DOUBLE);
   s42.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(2 ,START));
   s42.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s42.addState(ScannerStateEntry(6 ,FINAL));
   s42.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'U' ,3));
   s42.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s42.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s42.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s42.addTransition(ScannerTransEntry(3 ,'B' ,4));
   s42.addTransition(ScannerTransEntry(3 ,'b' ,4));
   s42.addTransition(ScannerTransEntry(4 ,'L' ,5));
   s42.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s42.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s42.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s42);

   Scanner s43(DROP);
   s43.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(2 ,START));
   s43.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(4 ,FINAL));
   s43.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s43.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s43.addTransition(ScannerTransEntry(2 ,'D' ,0));
   s43.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s43.addTransition(ScannerTransEntry(3 ,'P' ,4));
   s43.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s43);

   Scanner s44(ELSE);
   s44.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s44.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s44.addState(ScannerStateEntry(2 ,START));
   s44.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s44.addState(ScannerStateEntry(4 ,FINAL));
   s44.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s44.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s44.addTransition(ScannerTransEntry(2 ,'E' ,0));
   s44.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s44.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s44.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s44);

   Scanner s45(ELSIF);
   s45.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(2 ,START));
   s45.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s45.addState(ScannerStateEntry(5 ,FINAL));
   s45.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s45.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s45.addTransition(ScannerTransEntry(2 ,'E' ,0));
   s45.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s45.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s45.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s45.addTransition(ScannerTransEntry(4 ,'F' ,5));
   s45.addTransition(ScannerTransEntry(4 ,'f' ,5));
   _scannerList.Insert(s45);

   Scanner s46(END_TOKEN);
   s46.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(2 ,START));
   s46.addState(ScannerStateEntry(3 ,FINAL));
   s46.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s46.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s46.addTransition(ScannerTransEntry(2 ,'E' ,0));
   s46.addTransition(ScannerTransEntry(2 ,'e' ,0));
   _scannerList.Insert(s46);

   Scanner s47(EXCEPTION);
   s47.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(2 ,START));
   s47.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(9 ,FINAL));
   s47.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'C' ,3));
   s47.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s47.addTransition(ScannerTransEntry(2 ,'E' ,0));
   s47.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s47.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s47.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s47.addTransition(ScannerTransEntry(4 ,'P' ,5));
   s47.addTransition(ScannerTransEntry(4 ,'p' ,5));
   s47.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s47.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s47.addTransition(ScannerTransEntry(6 ,'I' ,7));
   s47.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s47.addTransition(ScannerTransEntry(7 ,'O' ,8));
   s47.addTransition(ScannerTransEntry(7 ,'o' ,8));
   s47.addTransition(ScannerTransEntry(8 ,'N' ,9));
   s47.addTransition(ScannerTransEntry(8 ,'n' ,9));
   _scannerList.Insert(s47);

   Scanner s48(EXISTS);
   s48.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(2 ,START));
   s48.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s48.addState(ScannerStateEntry(6 ,FINAL));
   s48.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s48.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s48.addTransition(ScannerTransEntry(2 ,'E' ,0));
   s48.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s48.addTransition(ScannerTransEntry(3 ,'S' ,4));
   s48.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s48.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s48.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s48.addTransition(ScannerTransEntry(5 ,'S' ,6));
   s48.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s48);

   Scanner s49(FALSEVAL);
   s49.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(2 ,START));
   s49.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(5 ,FINAL));
   s49.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s49.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s49.addTransition(ScannerTransEntry(2 ,'F' ,0));
   s49.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s49.addTransition(ScannerTransEntry(3 ,'S' ,4));
   s49.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s49.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s49.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s49);

   Scanner s50(FETCH);
   s50.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(2 ,START));
   s50.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(5 ,FINAL));
   s50.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s50.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s50.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s50.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'F' ,0));
   s50.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s50.addTransition(ScannerTransEntry(3 ,'C' ,4));
   s50.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s50.addTransition(ScannerTransEntry(4 ,'H' ,5));
   s50.addTransition(ScannerTransEntry(4 ,'h' ,5));
   _scannerList.Insert(s50);

   Scanner s51(FIXED);
   s51.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s51.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s51.addState(ScannerStateEntry(2 ,START));
   s51.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s51.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s51.addState(ScannerStateEntry(5 ,FINAL));
   s51.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s51.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s51.addTransition(ScannerTransEntry(1 ,'X' ,3));
   s51.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s51.addTransition(ScannerTransEntry(2 ,'F' ,0));
   s51.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s51.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s51.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s51.addTransition(ScannerTransEntry(4 ,'D' ,5));
   s51.addTransition(ScannerTransEntry(4 ,'d' ,5));
   _scannerList.Insert(s51);

   Scanner s52(FLOAT);
   s52.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(2 ,START));
   s52.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s52.addState(ScannerStateEntry(5 ,FINAL));
   s52.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s52.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s52.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s52.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s52.addTransition(ScannerTransEntry(2 ,'F' ,0));
   s52.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s52.addTransition(ScannerTransEntry(3 ,'A' ,4));
   s52.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s52.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s52.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s52);

   Scanner s53(FOR);
   s53.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s53.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s53.addState(ScannerStateEntry(2 ,START));
   s53.addState(ScannerStateEntry(3 ,FINAL));
   s53.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s53.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s53.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s53.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s53.addTransition(ScannerTransEntry(2 ,'F' ,0));
   s53.addTransition(ScannerTransEntry(2 ,'f' ,0));
   _scannerList.Insert(s53);

   Scanner s54(FOREIGN);
   s54.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(2 ,START));
   s54.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s54.addState(ScannerStateEntry(7 ,FINAL));
   s54.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s54.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s54.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s54.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s54.addTransition(ScannerTransEntry(2 ,'F' ,0));
   s54.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s54.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s54.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s54.addTransition(ScannerTransEntry(4 ,'I' ,5));
   s54.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s54.addTransition(ScannerTransEntry(5 ,'G' ,6));
   s54.addTransition(ScannerTransEntry(5 ,'g' ,6));
   s54.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s54.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s54);

   Scanner s55(FROM);
   s55.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s55.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s55.addState(ScannerStateEntry(2 ,START));
   s55.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s55.addState(ScannerStateEntry(4 ,FINAL));
   s55.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s55.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s55.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s55.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s55.addTransition(ScannerTransEntry(2 ,'F' ,0));
   s55.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s55.addTransition(ScannerTransEntry(3 ,'M' ,4));
   s55.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s55);

   Scanner s56(GETPOS);
   s56.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(2 ,START));
   s56.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s56.addState(ScannerStateEntry(6 ,FINAL));
   s56.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s56.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s56.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s56.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s56.addTransition(ScannerTransEntry(2 ,'G' ,0));
   s56.addTransition(ScannerTransEntry(2 ,'g' ,0));
   s56.addTransition(ScannerTransEntry(3 ,'P' ,4));
   s56.addTransition(ScannerTransEntry(3 ,'p' ,4));
   s56.addTransition(ScannerTransEntry(4 ,'O' ,5));
   s56.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s56.addTransition(ScannerTransEntry(5 ,'S' ,6));
   s56.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s56);

   Scanner s57(GROUP);
   s57.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(2 ,START));
   s57.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s57.addState(ScannerStateEntry(5 ,FINAL));
   s57.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s57.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s57.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s57.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s57.addTransition(ScannerTransEntry(2 ,'G' ,0));
   s57.addTransition(ScannerTransEntry(2 ,'g' ,0));
   s57.addTransition(ScannerTransEntry(3 ,'U' ,4));
   s57.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s57.addTransition(ScannerTransEntry(4 ,'P' ,5));
   s57.addTransition(ScannerTransEntry(4 ,'p' ,5));
   _scannerList.Insert(s57);

   Scanner s58(HAVING);
   s58.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s58.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s58.addState(ScannerStateEntry(2 ,START));
   s58.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s58.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s58.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s58.addState(ScannerStateEntry(6 ,FINAL));
   s58.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s58.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s58.addTransition(ScannerTransEntry(1 ,'V' ,3));
   s58.addTransition(ScannerTransEntry(1 ,'v' ,3));
   s58.addTransition(ScannerTransEntry(2 ,'H' ,0));
   s58.addTransition(ScannerTransEntry(2 ,'h' ,0));
   s58.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s58.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s58.addTransition(ScannerTransEntry(4 ,'N' ,5));
   s58.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s58.addTransition(ScannerTransEntry(5 ,'G' ,6));
   s58.addTransition(ScannerTransEntry(5 ,'g' ,6));
   _scannerList.Insert(s58);

   Scanner s59(IDENTIFIED);
   s59.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(2 ,START));
   s59.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s59.addState(ScannerStateEntry(10 ,FINAL));
   s59.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s59.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s59.addTransition(ScannerTransEntry(1 ,'E' ,3));
   s59.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s59.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s59.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s59.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s59.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s59.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s59.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s59.addTransition(ScannerTransEntry(5 ,'I' ,6));
   s59.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s59.addTransition(ScannerTransEntry(6 ,'F' ,7));
   s59.addTransition(ScannerTransEntry(6 ,'f' ,7));
   s59.addTransition(ScannerTransEntry(7 ,'I' ,8));
   s59.addTransition(ScannerTransEntry(7 ,'i' ,8));
   s59.addTransition(ScannerTransEntry(8 ,'E' ,9));
   s59.addTransition(ScannerTransEntry(8 ,'e' ,9));
   s59.addTransition(ScannerTransEntry(9 ,'D' ,10));
   s59.addTransition(ScannerTransEntry(9 ,'d' ,10));
   _scannerList.Insert(s59);

   Scanner s60(IF);
   s60.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s60.addState(ScannerStateEntry(1 ,FINAL));
   s60.addState(ScannerStateEntry(2 ,START));
   s60.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s60.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s60.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s60.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s60);

   Scanner s61(INTOK);
   s61.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s61.addState(ScannerStateEntry(1 ,FINAL));
   s61.addState(ScannerStateEntry(2 ,START));
   s61.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s61.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s61.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s61.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s61);

   Scanner s62(INDEX);
   s62.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s62.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s62.addState(ScannerStateEntry(2 ,START));
   s62.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s62.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s62.addState(ScannerStateEntry(5 ,FINAL));
   s62.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s62.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s62.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s62.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s62.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s62.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s62.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s62.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s62.addTransition(ScannerTransEntry(4 ,'X' ,5));
   s62.addTransition(ScannerTransEntry(4 ,'x' ,5));
   _scannerList.Insert(s62);

   Scanner s63(INNER);
   s63.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s63.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s63.addState(ScannerStateEntry(2 ,START));
   s63.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s63.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s63.addState(ScannerStateEntry(5 ,FINAL));
   s63.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s63.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s63.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s63.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s63.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s63.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s63.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s63.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s63.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s63.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s63);

   Scanner s64(INT);
   s64.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s64.addState(ScannerStateEntry(2 ,START));
   s64.addState(ScannerStateEntry(3 ,FINAL));
   s64.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s64.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s64.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s64.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s64.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s64.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s64);

   Scanner s65(INTO);
   s65.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(2 ,START));
   s65.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s65.addState(ScannerStateEntry(4 ,FINAL));
   s65.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s65.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s65.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s65.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s65.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s65.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s65.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s65.addTransition(ScannerTransEntry(3 ,'o' ,4));
   _scannerList.Insert(s65);

   Scanner s66(INT2DATE);
   s66.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(2 ,START));
   s66.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s66.addState(ScannerStateEntry(8 ,FINAL));
   s66.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s66.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s66.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s66.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s66.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s66.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s66.addTransition(ScannerTransEntry(3 ,'2' ,4));
   s66.addTransition(ScannerTransEntry(4 ,'D' ,5));
   s66.addTransition(ScannerTransEntry(4 ,'d' ,5));
   s66.addTransition(ScannerTransEntry(5 ,'A' ,6));
   s66.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s66.addTransition(ScannerTransEntry(6 ,'T' ,7));
   s66.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s66.addTransition(ScannerTransEntry(7 ,'E' ,8));
   s66.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s66);

   Scanner s67(INSERT);
   s67.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(2 ,START));
   s67.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s67.addState(ScannerStateEntry(6 ,FINAL));
   s67.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s67.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s67.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s67.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s67.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s67.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s67.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s67.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s67.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s67.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s67.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s67.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s67);

   Scanner s68(IS);
   s68.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s68.addState(ScannerStateEntry(1 ,FINAL));
   s68.addState(ScannerStateEntry(2 ,START));
   s68.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s68.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s68.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s68.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s68);

   Scanner s69(ISOLATION);
   s69.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(2 ,START));
   s69.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s69.addState(ScannerStateEntry(9 ,FINAL));
   s69.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s69.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s69.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s69.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s69.addTransition(ScannerTransEntry(2 ,'I' ,0));
   s69.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s69.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s69.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s69.addTransition(ScannerTransEntry(4 ,'A' ,5));
   s69.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s69.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s69.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s69.addTransition(ScannerTransEntry(6 ,'I' ,7));
   s69.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s69.addTransition(ScannerTransEntry(7 ,'O' ,8));
   s69.addTransition(ScannerTransEntry(7 ,'o' ,8));
   s69.addTransition(ScannerTransEntry(8 ,'N' ,9));
   s69.addTransition(ScannerTransEntry(8 ,'n' ,9));
   _scannerList.Insert(s69);

   Scanner s70(JDBC);
   s70.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s70.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s70.addState(ScannerStateEntry(2 ,START));
   s70.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s70.addState(ScannerStateEntry(4 ,FINAL));
   s70.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s70.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s70.addTransition(ScannerTransEntry(1 ,'B' ,3));
   s70.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s70.addTransition(ScannerTransEntry(2 ,'J' ,0));
   s70.addTransition(ScannerTransEntry(2 ,'j' ,0));
   s70.addTransition(ScannerTransEntry(3 ,'C' ,4));
   s70.addTransition(ScannerTransEntry(3 ,'c' ,4));
   _scannerList.Insert(s70);

   Scanner s71(JOIN);
   s71.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s71.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s71.addState(ScannerStateEntry(2 ,START));
   s71.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s71.addState(ScannerStateEntry(4 ,FINAL));
   s71.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s71.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s71.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s71.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s71.addTransition(ScannerTransEntry(2 ,'J' ,0));
   s71.addTransition(ScannerTransEntry(2 ,'j' ,0));
   s71.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s71.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s71);

   Scanner s72(KEY);
   s72.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s72.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s72.addState(ScannerStateEntry(2 ,START));
   s72.addState(ScannerStateEntry(3 ,FINAL));
   s72.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s72.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s72.addTransition(ScannerTransEntry(1 ,'Y' ,3));
   s72.addTransition(ScannerTransEntry(1 ,'y' ,3));
   s72.addTransition(ScannerTransEntry(2 ,'K' ,0));
   s72.addTransition(ScannerTransEntry(2 ,'k' ,0));
   _scannerList.Insert(s72);

   Scanner s73(LEFT);
   s73.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s73.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s73.addState(ScannerStateEntry(2 ,START));
   s73.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s73.addState(ScannerStateEntry(4 ,FINAL));
   s73.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s73.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s73.addTransition(ScannerTransEntry(1 ,'F' ,3));
   s73.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s73.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s73.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s73.addTransition(ScannerTransEntry(3 ,'T' ,4));
   s73.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s73);

   Scanner s74(LENGTH);
   s74.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(2 ,START));
   s74.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s74.addState(ScannerStateEntry(6 ,FINAL));
   s74.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s74.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s74.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s74.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s74.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s74.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s74.addTransition(ScannerTransEntry(3 ,'G' ,4));
   s74.addTransition(ScannerTransEntry(3 ,'g' ,4));
   s74.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s74.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s74.addTransition(ScannerTransEntry(5 ,'H' ,6));
   s74.addTransition(ScannerTransEntry(5 ,'h' ,6));
   _scannerList.Insert(s74);

   Scanner s75(LIKE);
   s75.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s75.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s75.addState(ScannerStateEntry(2 ,START));
   s75.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s75.addState(ScannerStateEntry(4 ,FINAL));
   s75.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s75.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s75.addTransition(ScannerTransEntry(1 ,'K' ,3));
   s75.addTransition(ScannerTransEntry(1 ,'k' ,3));
   s75.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s75.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s75.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s75.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s75);

   Scanner s76(LIST);
   s76.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s76.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s76.addState(ScannerStateEntry(2 ,START));
   s76.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s76.addState(ScannerStateEntry(4 ,FINAL));
   s76.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s76.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s76.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s76.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s76.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s76.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s76.addTransition(ScannerTransEntry(3 ,'T' ,4));
   s76.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s76);

   Scanner s77(LOAD);
   s77.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s77.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s77.addState(ScannerStateEntry(2 ,START));
   s77.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s77.addState(ScannerStateEntry(4 ,FINAL));
   s77.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s77.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s77.addTransition(ScannerTransEntry(1 ,'A' ,3));
   s77.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s77.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s77.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s77.addTransition(ScannerTransEntry(3 ,'D' ,4));
   s77.addTransition(ScannerTransEntry(3 ,'d' ,4));
   _scannerList.Insert(s77);

   Scanner s78(LOCKS);
   s78.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(2 ,START));
   s78.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s78.addState(ScannerStateEntry(5 ,FINAL));
   s78.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s78.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s78.addTransition(ScannerTransEntry(1 ,'C' ,3));
   s78.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s78.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s78.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s78.addTransition(ScannerTransEntry(3 ,'K' ,4));
   s78.addTransition(ScannerTransEntry(3 ,'k' ,4));
   s78.addTransition(ScannerTransEntry(4 ,'S' ,5));
   s78.addTransition(ScannerTransEntry(4 ,'s' ,5));
   _scannerList.Insert(s78);

   Scanner s79(LONG);
   s79.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s79.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s79.addState(ScannerStateEntry(2 ,START));
   s79.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s79.addState(ScannerStateEntry(4 ,FINAL));
   s79.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s79.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s79.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s79.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s79.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s79.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s79.addTransition(ScannerTransEntry(3 ,'G' ,4));
   s79.addTransition(ScannerTransEntry(3 ,'g' ,4));
   _scannerList.Insert(s79);

   Scanner s80(LOWER);
   s80.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s80.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s80.addState(ScannerStateEntry(2 ,START));
   s80.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s80.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s80.addState(ScannerStateEntry(5 ,FINAL));
   s80.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s80.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s80.addTransition(ScannerTransEntry(1 ,'W' ,3));
   s80.addTransition(ScannerTransEntry(1 ,'w' ,3));
   s80.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s80.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s80.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s80.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s80.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s80.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s80);

   Scanner s81(LTRIM);
   s81.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s81.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s81.addState(ScannerStateEntry(2 ,START));
   s81.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s81.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s81.addState(ScannerStateEntry(5 ,FINAL));
   s81.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s81.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s81.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s81.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s81.addTransition(ScannerTransEntry(2 ,'L' ,0));
   s81.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s81.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s81.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s81.addTransition(ScannerTransEntry(4 ,'M' ,5));
   s81.addTransition(ScannerTransEntry(4 ,'m' ,5));
   _scannerList.Insert(s81);

   Scanner s82(MIN);
   s82.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s82.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s82.addState(ScannerStateEntry(2 ,START));
   s82.addState(ScannerStateEntry(3 ,FINAL));
   s82.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s82.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s82.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s82.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s82.addTransition(ScannerTransEntry(2 ,'M' ,0));
   s82.addTransition(ScannerTransEntry(2 ,'m' ,0));
   _scannerList.Insert(s82);

   Scanner s83(MAX);
   s83.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s83.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s83.addState(ScannerStateEntry(2 ,START));
   s83.addState(ScannerStateEntry(3 ,FINAL));
   s83.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s83.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s83.addTransition(ScannerTransEntry(1 ,'X' ,3));
   s83.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s83.addTransition(ScannerTransEntry(2 ,'M' ,0));
   s83.addTransition(ScannerTransEntry(2 ,'m' ,0));
   _scannerList.Insert(s83);

   Scanner s84(MOD);
   s84.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s84.addState(ScannerStateEntry(2 ,START));
   s84.addState(ScannerStateEntry(3 ,FINAL));
   s84.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s84.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s84.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s84.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s84.addTransition(ScannerTransEntry(2 ,'M' ,0));
   s84.addTransition(ScannerTransEntry(2 ,'m' ,0));
   _scannerList.Insert(s84);

   Scanner s85(MODIFY);
   s85.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(2 ,START));
   s85.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s85.addState(ScannerStateEntry(6 ,FINAL));
   s85.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s85.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s85.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s85.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s85.addTransition(ScannerTransEntry(2 ,'M' ,0));
   s85.addTransition(ScannerTransEntry(2 ,'m' ,0));
   s85.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s85.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s85.addTransition(ScannerTransEntry(4 ,'F' ,5));
   s85.addTransition(ScannerTransEntry(4 ,'f' ,5));
   s85.addTransition(ScannerTransEntry(5 ,'Y' ,6));
   s85.addTransition(ScannerTransEntry(5 ,'y' ,6));
   _scannerList.Insert(s85);

   Scanner s86(NEXTCOUNT);
   s86.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(2 ,START));
   s86.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s86.addState(ScannerStateEntry(9 ,FINAL));
   s86.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s86.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s86.addTransition(ScannerTransEntry(1 ,'X' ,3));
   s86.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s86.addTransition(ScannerTransEntry(2 ,'N' ,0));
   s86.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s86.addTransition(ScannerTransEntry(3 ,'T' ,4));
   s86.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s86.addTransition(ScannerTransEntry(4 ,'C' ,5));
   s86.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s86.addTransition(ScannerTransEntry(5 ,'O' ,6));
   s86.addTransition(ScannerTransEntry(5 ,'o' ,6));
   s86.addTransition(ScannerTransEntry(6 ,'U' ,7));
   s86.addTransition(ScannerTransEntry(6 ,'u' ,7));
   s86.addTransition(ScannerTransEntry(7 ,'N' ,8));
   s86.addTransition(ScannerTransEntry(7 ,'n' ,8));
   s86.addTransition(ScannerTransEntry(8 ,'T' ,9));
   s86.addTransition(ScannerTransEntry(8 ,'t' ,9));
   _scannerList.Insert(s86);

   Scanner s87(NOOP);
   s87.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s87.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s87.addState(ScannerStateEntry(2 ,START));
   s87.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s87.addState(ScannerStateEntry(4 ,FINAL));
   s87.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s87.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s87.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s87.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s87.addTransition(ScannerTransEntry(2 ,'N' ,0));
   s87.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s87.addTransition(ScannerTransEntry(3 ,'P' ,4));
   s87.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s87);

   Scanner s88(NOT);
   s88.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s88.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s88.addState(ScannerStateEntry(2 ,START));
   s88.addState(ScannerStateEntry(3 ,FINAL));
   s88.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s88.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s88.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s88.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s88.addTransition(ScannerTransEntry(2 ,'N' ,0));
   s88.addTransition(ScannerTransEntry(2 ,'n' ,0));
   _scannerList.Insert(s88);

   Scanner s89(NULLTOKEN);
   s89.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s89.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s89.addState(ScannerStateEntry(2 ,START));
   s89.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s89.addState(ScannerStateEntry(4 ,FINAL));
   s89.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s89.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s89.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s89.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s89.addTransition(ScannerTransEntry(2 ,'N' ,0));
   s89.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s89.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s89.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s89);

   Scanner s90(OFF);
   s90.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s90.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s90.addState(ScannerStateEntry(2 ,START));
   s90.addState(ScannerStateEntry(3 ,FINAL));
   s90.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s90.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s90.addTransition(ScannerTransEntry(1 ,'F' ,3));
   s90.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s90.addTransition(ScannerTransEntry(2 ,'O' ,0));
   s90.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s90);

   Scanner s91(ON);
   s91.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s91.addState(ScannerStateEntry(1 ,FINAL));
   s91.addState(ScannerStateEntry(2 ,START));
   s91.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s91.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s91.addTransition(ScannerTransEntry(2 ,'O' ,0));
   s91.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s91);

   Scanner s92(OUTTOK);
   s92.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s92.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s92.addState(ScannerStateEntry(2 ,START));
   s92.addState(ScannerStateEntry(3 ,FINAL));
   s92.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s92.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s92.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s92.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s92.addTransition(ScannerTransEntry(2 ,'O' ,0));
   s92.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s92);

   Scanner s93(OUTER);
   s93.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(2 ,START));
   s93.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s93.addState(ScannerStateEntry(5 ,FINAL));
   s93.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s93.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s93.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s93.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s93.addTransition(ScannerTransEntry(2 ,'O' ,0));
   s93.addTransition(ScannerTransEntry(2 ,'o' ,0));
   s93.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s93.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s93.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s93.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s93);

   Scanner s94(OR);
   s94.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s94.addState(ScannerStateEntry(1 ,FINAL));
   s94.addState(ScannerStateEntry(2 ,START));
   s94.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s94.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s94.addTransition(ScannerTransEntry(2 ,'O' ,0));
   s94.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s94);

   Scanner s95(ORDER);
   s95.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s95.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s95.addState(ScannerStateEntry(2 ,START));
   s95.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s95.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s95.addState(ScannerStateEntry(5 ,FINAL));
   s95.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s95.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s95.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s95.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s95.addTransition(ScannerTransEntry(2 ,'O' ,0));
   s95.addTransition(ScannerTransEntry(2 ,'o' ,0));
   s95.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s95.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s95.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s95.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s95);

   Scanner s96(PLAN);
   s96.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s96.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s96.addState(ScannerStateEntry(2 ,START));
   s96.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s96.addState(ScannerStateEntry(4 ,FINAL));
   s96.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s96.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s96.addTransition(ScannerTransEntry(1 ,'A' ,3));
   s96.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s96.addTransition(ScannerTransEntry(2 ,'P' ,0));
   s96.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s96.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s96.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s96);

   Scanner s97(POOL);
   s97.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s97.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s97.addState(ScannerStateEntry(2 ,START));
   s97.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s97.addState(ScannerStateEntry(4 ,FINAL));
   s97.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s97.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s97.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s97.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s97.addTransition(ScannerTransEntry(2 ,'P' ,0));
   s97.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s97.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s97.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s97);

   Scanner s98(POWER);
   s98.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(2 ,START));
   s98.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s98.addState(ScannerStateEntry(5 ,FINAL));
   s98.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s98.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s98.addTransition(ScannerTransEntry(1 ,'W' ,3));
   s98.addTransition(ScannerTransEntry(1 ,'w' ,3));
   s98.addTransition(ScannerTransEntry(2 ,'P' ,0));
   s98.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s98.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s98.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s98.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s98.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s98);

   Scanner s99(PRIMARY);
   s99.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(2 ,START));
   s99.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s99.addState(ScannerStateEntry(7 ,FINAL));
   s99.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s99.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s99.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s99.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s99.addTransition(ScannerTransEntry(2 ,'P' ,0));
   s99.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s99.addTransition(ScannerTransEntry(3 ,'M' ,4));
   s99.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s99.addTransition(ScannerTransEntry(4 ,'A' ,5));
   s99.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s99.addTransition(ScannerTransEntry(5 ,'R' ,6));
   s99.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s99.addTransition(ScannerTransEntry(6 ,'Y' ,7));
   s99.addTransition(ScannerTransEntry(6 ,'y' ,7));
   _scannerList.Insert(s99);

   Scanner s100(PRINT);
   s100.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(2 ,START));
   s100.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s100.addState(ScannerStateEntry(5 ,FINAL));
   s100.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s100.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s100.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s100.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s100.addTransition(ScannerTransEntry(2 ,'P' ,0));
   s100.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s100.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s100.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s100.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s100.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s100);

   Scanner s101(PROCEDURE);
   s101.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(2 ,START));
   s101.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s101.addState(ScannerStateEntry(9 ,FINAL));
   s101.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s101.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s101.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s101.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s101.addTransition(ScannerTransEntry(2 ,'P' ,0));
   s101.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s101.addTransition(ScannerTransEntry(3 ,'C' ,4));
   s101.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s101.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s101.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s101.addTransition(ScannerTransEntry(5 ,'D' ,6));
   s101.addTransition(ScannerTransEntry(5 ,'d' ,6));
   s101.addTransition(ScannerTransEntry(6 ,'U' ,7));
   s101.addTransition(ScannerTransEntry(6 ,'u' ,7));
   s101.addTransition(ScannerTransEntry(7 ,'R' ,8));
   s101.addTransition(ScannerTransEntry(7 ,'r' ,8));
   s101.addTransition(ScannerTransEntry(8 ,'E' ,9));
   s101.addTransition(ScannerTransEntry(8 ,'e' ,9));
   _scannerList.Insert(s101);

   Scanner s102(QUIT);
   s102.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(2 ,START));
   s102.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s102.addState(ScannerStateEntry(4 ,FINAL));
   s102.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s102.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s102.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s102.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s102.addTransition(ScannerTransEntry(2 ,'Q' ,0));
   s102.addTransition(ScannerTransEntry(2 ,'q' ,0));
   s102.addTransition(ScannerTransEntry(3 ,'T' ,4));
   s102.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s102);

   Scanner s103(RANDSTR);
   s103.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(2 ,START));
   s103.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s103.addState(ScannerStateEntry(7 ,FINAL));
   s103.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s103.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s103.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s103.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s103.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s103.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s103.addTransition(ScannerTransEntry(3 ,'D' ,4));
   s103.addTransition(ScannerTransEntry(3 ,'d' ,4));
   s103.addTransition(ScannerTransEntry(4 ,'S' ,5));
   s103.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s103.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s103.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s103.addTransition(ScannerTransEntry(6 ,'R' ,7));
   s103.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s103);

   Scanner s104(RANDINT);
   s104.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(2 ,START));
   s104.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s104.addState(ScannerStateEntry(7 ,FINAL));
   s104.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s104.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s104.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s104.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s104.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s104.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s104.addTransition(ScannerTransEntry(3 ,'D' ,4));
   s104.addTransition(ScannerTransEntry(3 ,'d' ,4));
   s104.addTransition(ScannerTransEntry(4 ,'I' ,5));
   s104.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s104.addTransition(ScannerTransEntry(5 ,'N' ,6));
   s104.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s104.addTransition(ScannerTransEntry(6 ,'T' ,7));
   s104.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s104);

   Scanner s105(RBSEG);
   s105.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(2 ,START));
   s105.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s105.addState(ScannerStateEntry(5 ,FINAL));
   s105.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s105.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s105.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s105.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s105.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s105.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s105.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s105.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s105.addTransition(ScannerTransEntry(4 ,'G' ,5));
   s105.addTransition(ScannerTransEntry(4 ,'g' ,5));
   _scannerList.Insert(s105);

   Scanner s106(REFERENCES);
   s106.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(2 ,START));
   s106.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s106.addState(ScannerStateEntry(10 ,FINAL));
   s106.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s106.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s106.addTransition(ScannerTransEntry(1 ,'F' ,3));
   s106.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s106.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s106.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s106.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s106.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s106.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s106.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s106.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s106.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s106.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s106.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s106.addTransition(ScannerTransEntry(7 ,'C' ,8));
   s106.addTransition(ScannerTransEntry(7 ,'c' ,8));
   s106.addTransition(ScannerTransEntry(8 ,'E' ,9));
   s106.addTransition(ScannerTransEntry(8 ,'e' ,9));
   s106.addTransition(ScannerTransEntry(9 ,'S' ,10));
   s106.addTransition(ScannerTransEntry(9 ,'s' ,10));
   _scannerList.Insert(s106);

   Scanner s107(RENAME);
   s107.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(2 ,START));
   s107.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s107.addState(ScannerStateEntry(6 ,FINAL));
   s107.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s107.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s107.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s107.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s107.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s107.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s107.addTransition(ScannerTransEntry(3 ,'A' ,4));
   s107.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s107.addTransition(ScannerTransEntry(4 ,'M' ,5));
   s107.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s107.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s107.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s107);

   Scanner s108(REORGANIZE);
   s108.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(2 ,START));
   s108.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s108.addState(ScannerStateEntry(10 ,FINAL));
   s108.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s108.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s108.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s108.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s108.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s108.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s108.addTransition(ScannerTransEntry(3 ,'R' ,4));
   s108.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s108.addTransition(ScannerTransEntry(4 ,'G' ,5));
   s108.addTransition(ScannerTransEntry(4 ,'g' ,5));
   s108.addTransition(ScannerTransEntry(5 ,'A' ,6));
   s108.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s108.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s108.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s108.addTransition(ScannerTransEntry(7 ,'I' ,8));
   s108.addTransition(ScannerTransEntry(7 ,'i' ,8));
   s108.addTransition(ScannerTransEntry(8 ,'Z' ,9));
   s108.addTransition(ScannerTransEntry(8 ,'z' ,9));
   s108.addTransition(ScannerTransEntry(9 ,'E' ,10));
   s108.addTransition(ScannerTransEntry(9 ,'e' ,10));
   _scannerList.Insert(s108);

   Scanner s109(RETURNTOKEN);
   s109.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(2 ,START));
   s109.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s109.addState(ScannerStateEntry(6 ,FINAL));
   s109.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s109.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s109.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s109.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s109.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s109.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s109.addTransition(ScannerTransEntry(3 ,'U' ,4));
   s109.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s109.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s109.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s109.addTransition(ScannerTransEntry(5 ,'N' ,6));
   s109.addTransition(ScannerTransEntry(5 ,'n' ,6));
   _scannerList.Insert(s109);

   Scanner s110(REMOVE);
   s110.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(2 ,START));
   s110.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s110.addState(ScannerStateEntry(6 ,FINAL));
   s110.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s110.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s110.addTransition(ScannerTransEntry(1 ,'M' ,3));
   s110.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s110.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s110.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s110.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s110.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s110.addTransition(ScannerTransEntry(4 ,'V' ,5));
   s110.addTransition(ScannerTransEntry(4 ,'v' ,5));
   s110.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s110.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s110);

   Scanner s111(REPLACE);
   s111.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(2 ,START));
   s111.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s111.addState(ScannerStateEntry(7 ,FINAL));
   s111.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s111.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s111.addTransition(ScannerTransEntry(1 ,'P' ,3));
   s111.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s111.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s111.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s111.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s111.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s111.addTransition(ScannerTransEntry(4 ,'A' ,5));
   s111.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s111.addTransition(ScannerTransEntry(5 ,'C' ,6));
   s111.addTransition(ScannerTransEntry(5 ,'c' ,6));
   s111.addTransition(ScannerTransEntry(6 ,'E' ,7));
   s111.addTransition(ScannerTransEntry(6 ,'e' ,7));
   _scannerList.Insert(s111);

   Scanner s112(RIGHT);
   s112.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(2 ,START));
   s112.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s112.addState(ScannerStateEntry(5 ,FINAL));
   s112.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s112.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s112.addTransition(ScannerTransEntry(1 ,'G' ,3));
   s112.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s112.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s112.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s112.addTransition(ScannerTransEntry(3 ,'H' ,4));
   s112.addTransition(ScannerTransEntry(3 ,'h' ,4));
   s112.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s112.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s112);

   Scanner s113(ROLLBACK);
   s113.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(2 ,START));
   s113.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s113.addState(ScannerStateEntry(8 ,FINAL));
   s113.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s113.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s113.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s113.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s113.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s113.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s113.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s113.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s113.addTransition(ScannerTransEntry(4 ,'B' ,5));
   s113.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s113.addTransition(ScannerTransEntry(5 ,'A' ,6));
   s113.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s113.addTransition(ScannerTransEntry(6 ,'C' ,7));
   s113.addTransition(ScannerTransEntry(6 ,'c' ,7));
   s113.addTransition(ScannerTransEntry(7 ,'K' ,8));
   s113.addTransition(ScannerTransEntry(7 ,'k' ,8));
   _scannerList.Insert(s113);

   Scanner s114(ROUND);
   s114.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(2 ,START));
   s114.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s114.addState(ScannerStateEntry(5 ,FINAL));
   s114.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s114.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s114.addTransition(ScannerTransEntry(1 ,'U' ,3));
   s114.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s114.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s114.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s114.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s114.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s114.addTransition(ScannerTransEntry(4 ,'D' ,5));
   s114.addTransition(ScannerTransEntry(4 ,'d' ,5));
   _scannerList.Insert(s114);

   Scanner s115(ROWLIMIT);
   s115.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(2 ,START));
   s115.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s115.addState(ScannerStateEntry(8 ,FINAL));
   s115.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s115.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s115.addTransition(ScannerTransEntry(1 ,'W' ,3));
   s115.addTransition(ScannerTransEntry(1 ,'w' ,3));
   s115.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s115.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s115.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s115.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s115.addTransition(ScannerTransEntry(4 ,'I' ,5));
   s115.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s115.addTransition(ScannerTransEntry(5 ,'M' ,6));
   s115.addTransition(ScannerTransEntry(5 ,'m' ,6));
   s115.addTransition(ScannerTransEntry(6 ,'I' ,7));
   s115.addTransition(ScannerTransEntry(6 ,'i' ,7));
   s115.addTransition(ScannerTransEntry(7 ,'T' ,8));
   s115.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s115);

   Scanner s116(RTRIM);
   s116.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(2 ,START));
   s116.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s116.addState(ScannerStateEntry(5 ,FINAL));
   s116.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s116.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s116.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s116.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s116.addTransition(ScannerTransEntry(2 ,'R' ,0));
   s116.addTransition(ScannerTransEntry(2 ,'r' ,0));
   s116.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s116.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s116.addTransition(ScannerTransEntry(4 ,'M' ,5));
   s116.addTransition(ScannerTransEntry(4 ,'m' ,5));
   _scannerList.Insert(s116);

   Scanner s117(SELECT);
   s117.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s117.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s117.addState(ScannerStateEntry(2 ,START));
   s117.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s117.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s117.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s117.addState(ScannerStateEntry(6 ,FINAL));
   s117.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s117.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s117.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s117.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s117.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s117.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s117.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s117.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s117.addTransition(ScannerTransEntry(4 ,'C' ,5));
   s117.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s117.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s117.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s117);

   Scanner s118(SET);
   s118.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s118.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s118.addState(ScannerStateEntry(2 ,START));
   s118.addState(ScannerStateEntry(3 ,FINAL));
   s118.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s118.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s118.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s118.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s118.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s118.addTransition(ScannerTransEntry(2 ,'s' ,0));
   _scannerList.Insert(s118);

   Scanner s119(SETCOUNT);
   s119.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(2 ,START));
   s119.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s119.addState(ScannerStateEntry(8 ,FINAL));
   s119.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s119.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s119.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s119.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s119.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s119.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s119.addTransition(ScannerTransEntry(3 ,'C' ,4));
   s119.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s119.addTransition(ScannerTransEntry(4 ,'O' ,5));
   s119.addTransition(ScannerTransEntry(4 ,'o' ,5));
   s119.addTransition(ScannerTransEntry(5 ,'U' ,6));
   s119.addTransition(ScannerTransEntry(5 ,'u' ,6));
   s119.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s119.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s119.addTransition(ScannerTransEntry(7 ,'T' ,8));
   s119.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s119);

   Scanner s120(SHOW);
   s120.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s120.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s120.addState(ScannerStateEntry(2 ,START));
   s120.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s120.addState(ScannerStateEntry(4 ,FINAL));
   s120.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s120.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s120.addTransition(ScannerTransEntry(1 ,'O' ,3));
   s120.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s120.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s120.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s120.addTransition(ScannerTransEntry(3 ,'W' ,4));
   s120.addTransition(ScannerTransEntry(3 ,'w' ,4));
   _scannerList.Insert(s120);

   Scanner s121(SMALLINT);
   s121.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(2 ,START));
   s121.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s121.addState(ScannerStateEntry(8 ,FINAL));
   s121.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s121.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s121.addTransition(ScannerTransEntry(1 ,'A' ,3));
   s121.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s121.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s121.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s121.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s121.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s121.addTransition(ScannerTransEntry(4 ,'L' ,5));
   s121.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s121.addTransition(ScannerTransEntry(5 ,'I' ,6));
   s121.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s121.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s121.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s121.addTransition(ScannerTransEntry(7 ,'T' ,8));
   s121.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s121);

   Scanner s122(START_TOKEN);
   s122.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(2 ,START));
   s122.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s122.addState(ScannerStateEntry(5 ,FINAL));
   s122.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s122.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s122.addTransition(ScannerTransEntry(1 ,'A' ,3));
   s122.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s122.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s122.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s122.addTransition(ScannerTransEntry(3 ,'R' ,4));
   s122.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s122.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s122.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s122);

   Scanner s123(STRING);
   s123.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s123.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s123.addState(ScannerStateEntry(2 ,START));
   s123.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s123.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s123.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s123.addState(ScannerStateEntry(6 ,FINAL));
   s123.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s123.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s123.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s123.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s123.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s123.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s123.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s123.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s123.addTransition(ScannerTransEntry(4 ,'N' ,5));
   s123.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s123.addTransition(ScannerTransEntry(5 ,'G' ,6));
   s123.addTransition(ScannerTransEntry(5 ,'g' ,6));
   _scannerList.Insert(s123);

   Scanner s124(SUBSTR);
   s124.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(2 ,START));
   s124.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s124.addState(ScannerStateEntry(6 ,FINAL));
   s124.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s124.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s124.addTransition(ScannerTransEntry(1 ,'B' ,3));
   s124.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s124.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s124.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s124.addTransition(ScannerTransEntry(3 ,'S' ,4));
   s124.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s124.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s124.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s124.addTransition(ScannerTransEntry(5 ,'R' ,6));
   s124.addTransition(ScannerTransEntry(5 ,'r' ,6));
   _scannerList.Insert(s124);

   Scanner s125(SUM);
   s125.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s125.addState(ScannerStateEntry(2 ,START));
   s125.addState(ScannerStateEntry(3 ,FINAL));
   s125.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s125.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s125.addTransition(ScannerTransEntry(1 ,'M' ,3));
   s125.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s125.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s125.addTransition(ScannerTransEntry(2 ,'s' ,0));
   _scannerList.Insert(s125);

   Scanner s126(SYNC);
   s126.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(2 ,START));
   s126.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s126.addState(ScannerStateEntry(4 ,FINAL));
   s126.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s126.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s126.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s126.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s126.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s126.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s126.addTransition(ScannerTransEntry(3 ,'C' ,4));
   s126.addTransition(ScannerTransEntry(3 ,'c' ,4));
   _scannerList.Insert(s126);

   Scanner s127(SYSDATE);
   s127.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(2 ,START));
   s127.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s127.addState(ScannerStateEntry(7 ,FINAL));
   s127.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s127.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s127.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s127.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s127.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s127.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s127.addTransition(ScannerTransEntry(3 ,'D' ,4));
   s127.addTransition(ScannerTransEntry(3 ,'d' ,4));
   s127.addTransition(ScannerTransEntry(4 ,'A' ,5));
   s127.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s127.addTransition(ScannerTransEntry(5 ,'T' ,6));
   s127.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s127.addTransition(ScannerTransEntry(6 ,'E' ,7));
   s127.addTransition(ScannerTransEntry(6 ,'e' ,7));
   _scannerList.Insert(s127);

   Scanner s128(SYSTEMSPACE);
   s128.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(2 ,START));
   s128.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s128.addState(ScannerStateEntry(11 ,FINAL));
   s128.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s128.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s128.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s128.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s128.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s128.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s128.addTransition(ScannerTransEntry(3 ,'T' ,4));
   s128.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s128.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s128.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s128.addTransition(ScannerTransEntry(5 ,'M' ,6));
   s128.addTransition(ScannerTransEntry(5 ,'m' ,6));
   s128.addTransition(ScannerTransEntry(6 ,'S' ,7));
   s128.addTransition(ScannerTransEntry(6 ,'s' ,7));
   s128.addTransition(ScannerTransEntry(7 ,'P' ,8));
   s128.addTransition(ScannerTransEntry(7 ,'p' ,8));
   s128.addTransition(ScannerTransEntry(8 ,'A' ,9));
   s128.addTransition(ScannerTransEntry(8 ,'a' ,9));
   s128.addTransition(ScannerTransEntry(9 ,'C' ,10));
   s128.addTransition(ScannerTransEntry(9 ,'c' ,10));
   s128.addTransition(ScannerTransEntry(10 ,'E' ,11));
   s128.addTransition(ScannerTransEntry(10 ,'e' ,11));
   _scannerList.Insert(s128);

   Scanner s129(SYSOBJ);
   s129.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(2 ,START));
   s129.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s129.addState(ScannerStateEntry(6 ,FINAL));
   s129.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s129.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s129.addTransition(ScannerTransEntry(1 ,'S' ,3));
   s129.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s129.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s129.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s129.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s129.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s129.addTransition(ScannerTransEntry(4 ,'B' ,5));
   s129.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s129.addTransition(ScannerTransEntry(5 ,'J' ,6));
   s129.addTransition(ScannerTransEntry(5 ,'j' ,6));
   _scannerList.Insert(s129);

   Scanner s130(TABLEINFO);
   s130.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(2 ,START));
   s130.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s130.addState(ScannerStateEntry(9 ,FINAL));
   s130.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s130.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s130.addTransition(ScannerTransEntry(1 ,'B' ,3));
   s130.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s130.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s130.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s130.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s130.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s130.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s130.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s130.addTransition(ScannerTransEntry(5 ,'I' ,6));
   s130.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s130.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s130.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s130.addTransition(ScannerTransEntry(7 ,'F' ,8));
   s130.addTransition(ScannerTransEntry(7 ,'f' ,8));
   s130.addTransition(ScannerTransEntry(8 ,'O' ,9));
   s130.addTransition(ScannerTransEntry(8 ,'o' ,9));
   _scannerList.Insert(s130);

   Scanner s131(TABLE);
   s131.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s131.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s131.addState(ScannerStateEntry(2 ,START));
   s131.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s131.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s131.addState(ScannerStateEntry(5 ,FINAL));
   s131.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s131.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s131.addTransition(ScannerTransEntry(1 ,'B' ,3));
   s131.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s131.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s131.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s131.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s131.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s131.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s131.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s131);

   Scanner s132(TABLESET);
   s132.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(2 ,START));
   s132.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s132.addState(ScannerStateEntry(8 ,FINAL));
   s132.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s132.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s132.addTransition(ScannerTransEntry(1 ,'B' ,3));
   s132.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s132.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s132.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s132.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s132.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s132.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s132.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s132.addTransition(ScannerTransEntry(5 ,'S' ,6));
   s132.addTransition(ScannerTransEntry(5 ,'s' ,6));
   s132.addTransition(ScannerTransEntry(6 ,'E' ,7));
   s132.addTransition(ScannerTransEntry(6 ,'e' ,7));
   s132.addTransition(ScannerTransEntry(7 ,'T' ,8));
   s132.addTransition(ScannerTransEntry(7 ,'t' ,8));
   _scannerList.Insert(s132);

   Scanner s133(THEN);
   s133.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(2 ,START));
   s133.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s133.addState(ScannerStateEntry(4 ,FINAL));
   s133.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s133.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s133.addTransition(ScannerTransEntry(1 ,'E' ,3));
   s133.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s133.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s133.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s133.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s133.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s133);

   Scanner s134(THROW);
   s134.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(2 ,START));
   s134.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s134.addState(ScannerStateEntry(5 ,FINAL));
   s134.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s134.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s134.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s134.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s134.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s134.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s134.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s134.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s134.addTransition(ScannerTransEntry(4 ,'W' ,5));
   s134.addTransition(ScannerTransEntry(4 ,'w' ,5));
   _scannerList.Insert(s134);

   Scanner s135(TINYINT);
   s135.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(2 ,START));
   s135.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s135.addState(ScannerStateEntry(7 ,FINAL));
   s135.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s135.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s135.addTransition(ScannerTransEntry(1 ,'N' ,3));
   s135.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s135.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s135.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s135.addTransition(ScannerTransEntry(3 ,'Y' ,4));
   s135.addTransition(ScannerTransEntry(3 ,'y' ,4));
   s135.addTransition(ScannerTransEntry(4 ,'I' ,5));
   s135.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s135.addTransition(ScannerTransEntry(5 ,'N' ,6));
   s135.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s135.addTransition(ScannerTransEntry(6 ,'T' ,7));
   s135.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s135);

   Scanner s136(TMPOBJ);
   s136.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(2 ,START));
   s136.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s136.addState(ScannerStateEntry(6 ,FINAL));
   s136.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s136.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s136.addTransition(ScannerTransEntry(1 ,'P' ,3));
   s136.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s136.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s136.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s136.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s136.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s136.addTransition(ScannerTransEntry(4 ,'B' ,5));
   s136.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s136.addTransition(ScannerTransEntry(5 ,'J' ,6));
   s136.addTransition(ScannerTransEntry(5 ,'j' ,6));
   _scannerList.Insert(s136);

   Scanner s137(TRANSACTION);
   s137.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(2 ,START));
   s137.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s137.addState(ScannerStateEntry(11 ,FINAL));
   s137.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s137.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s137.addTransition(ScannerTransEntry(1 ,'A' ,3));
   s137.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s137.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s137.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s137.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s137.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s137.addTransition(ScannerTransEntry(4 ,'S' ,5));
   s137.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s137.addTransition(ScannerTransEntry(5 ,'A' ,6));
   s137.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s137.addTransition(ScannerTransEntry(6 ,'C' ,7));
   s137.addTransition(ScannerTransEntry(6 ,'c' ,7));
   s137.addTransition(ScannerTransEntry(7 ,'T' ,8));
   s137.addTransition(ScannerTransEntry(7 ,'t' ,8));
   s137.addTransition(ScannerTransEntry(8 ,'I' ,9));
   s137.addTransition(ScannerTransEntry(8 ,'i' ,9));
   s137.addTransition(ScannerTransEntry(9 ,'O' ,10));
   s137.addTransition(ScannerTransEntry(9 ,'o' ,10));
   s137.addTransition(ScannerTransEntry(10 ,'N' ,11));
   s137.addTransition(ScannerTransEntry(10 ,'n' ,11));
   _scannerList.Insert(s137);

   Scanner s138(STR2INT);
   s138.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(2 ,START));
   s138.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s138.addState(ScannerStateEntry(7 ,FINAL));
   s138.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s138.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s138.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s138.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s138.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s138.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s138.addTransition(ScannerTransEntry(3 ,'2' ,4));
   s138.addTransition(ScannerTransEntry(4 ,'I' ,5));
   s138.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s138.addTransition(ScannerTransEntry(5 ,'N' ,6));
   s138.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s138.addTransition(ScannerTransEntry(6 ,'T' ,7));
   s138.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s138);

   Scanner s139(STR2LONG);
   s139.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(2 ,START));
   s139.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s139.addState(ScannerStateEntry(8 ,FINAL));
   s139.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s139.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s139.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s139.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s139.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s139.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s139.addTransition(ScannerTransEntry(3 ,'2' ,4));
   s139.addTransition(ScannerTransEntry(4 ,'L' ,5));
   s139.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s139.addTransition(ScannerTransEntry(5 ,'O' ,6));
   s139.addTransition(ScannerTransEntry(5 ,'o' ,6));
   s139.addTransition(ScannerTransEntry(6 ,'N' ,7));
   s139.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s139.addTransition(ScannerTransEntry(7 ,'G' ,8));
   s139.addTransition(ScannerTransEntry(7 ,'g' ,8));
   _scannerList.Insert(s139);

   Scanner s140(STR2DATE);
   s140.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(2 ,START));
   s140.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s140.addState(ScannerStateEntry(8 ,FINAL));
   s140.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s140.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s140.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s140.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s140.addTransition(ScannerTransEntry(2 ,'S' ,0));
   s140.addTransition(ScannerTransEntry(2 ,'s' ,0));
   s140.addTransition(ScannerTransEntry(3 ,'2' ,4));
   s140.addTransition(ScannerTransEntry(4 ,'D' ,5));
   s140.addTransition(ScannerTransEntry(4 ,'d' ,5));
   s140.addTransition(ScannerTransEntry(5 ,'A' ,6));
   s140.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s140.addTransition(ScannerTransEntry(6 ,'T' ,7));
   s140.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s140.addTransition(ScannerTransEntry(7 ,'E' ,8));
   s140.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s140);

   Scanner s141(TO);
   s141.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s141.addState(ScannerStateEntry(1 ,FINAL));
   s141.addState(ScannerStateEntry(2 ,START));
   s141.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s141.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s141.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s141.addTransition(ScannerTransEntry(2 ,'t' ,0));
   _scannerList.Insert(s141);

   Scanner s142(TRIM);
   s142.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(2 ,START));
   s142.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s142.addState(ScannerStateEntry(4 ,FINAL));
   s142.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s142.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s142.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s142.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s142.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s142.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s142.addTransition(ScannerTransEntry(3 ,'M' ,4));
   s142.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s142);

   Scanner s143(TRUEVAL);
   s143.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(2 ,START));
   s143.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s143.addState(ScannerStateEntry(4 ,FINAL));
   s143.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s143.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s143.addTransition(ScannerTransEntry(1 ,'U' ,3));
   s143.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s143.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s143.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s143.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s143.addTransition(ScannerTransEntry(3 ,'e' ,4));
   _scannerList.Insert(s143);

   Scanner s144(TRUNC);
   s144.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(2 ,START));
   s144.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s144.addState(ScannerStateEntry(5 ,FINAL));
   s144.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s144.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s144.addTransition(ScannerTransEntry(1 ,'U' ,3));
   s144.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s144.addTransition(ScannerTransEntry(2 ,'T' ,0));
   s144.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s144.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s144.addTransition(ScannerTransEntry(3 ,'n' ,4));
   s144.addTransition(ScannerTransEntry(4 ,'C' ,5));
   s144.addTransition(ScannerTransEntry(4 ,'c' ,5));
   _scannerList.Insert(s144);

   Scanner s145(UNION);
   s145.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s145.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s145.addState(ScannerStateEntry(2 ,START));
   s145.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s145.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s145.addState(ScannerStateEntry(5 ,FINAL));
   s145.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s145.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s145.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s145.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s145.addTransition(ScannerTransEntry(2 ,'U' ,0));
   s145.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s145.addTransition(ScannerTransEntry(3 ,'O' ,4));
   s145.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s145.addTransition(ScannerTransEntry(4 ,'N' ,5));
   s145.addTransition(ScannerTransEntry(4 ,'n' ,5));
   _scannerList.Insert(s145);

   Scanner s146(UNIQUE);
   s146.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(2 ,START));
   s146.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s146.addState(ScannerStateEntry(6 ,FINAL));
   s146.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s146.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s146.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s146.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s146.addTransition(ScannerTransEntry(2 ,'U' ,0));
   s146.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s146.addTransition(ScannerTransEntry(3 ,'Q' ,4));
   s146.addTransition(ScannerTransEntry(3 ,'q' ,4));
   s146.addTransition(ScannerTransEntry(4 ,'U' ,5));
   s146.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s146.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s146.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s146);

   Scanner s147(UPDATE);
   s147.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(2 ,START));
   s147.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s147.addState(ScannerStateEntry(6 ,FINAL));
   s147.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s147.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s147.addTransition(ScannerTransEntry(1 ,'D' ,3));
   s147.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s147.addTransition(ScannerTransEntry(2 ,'U' ,0));
   s147.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s147.addTransition(ScannerTransEntry(3 ,'A' ,4));
   s147.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s147.addTransition(ScannerTransEntry(4 ,'T' ,5));
   s147.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s147.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s147.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s147);

   Scanner s148(UPTIME);
   s148.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(2 ,START));
   s148.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s148.addState(ScannerStateEntry(6 ,FINAL));
   s148.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s148.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s148.addTransition(ScannerTransEntry(1 ,'T' ,3));
   s148.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s148.addTransition(ScannerTransEntry(2 ,'U' ,0));
   s148.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s148.addTransition(ScannerTransEntry(3 ,'I' ,4));
   s148.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s148.addTransition(ScannerTransEntry(4 ,'M' ,5));
   s148.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s148.addTransition(ScannerTransEntry(5 ,'E' ,6));
   s148.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s148);

   Scanner s149(UPPER);
   s149.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(2 ,START));
   s149.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s149.addState(ScannerStateEntry(5 ,FINAL));
   s149.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s149.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s149.addTransition(ScannerTransEntry(1 ,'P' ,3));
   s149.addTransition(ScannerTransEntry(1 ,'p' ,3));
   s149.addTransition(ScannerTransEntry(2 ,'U' ,0));
   s149.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s149.addTransition(ScannerTransEntry(3 ,'E' ,4));
   s149.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s149.addTransition(ScannerTransEntry(4 ,'R' ,5));
   s149.addTransition(ScannerTransEntry(4 ,'r' ,5));
   _scannerList.Insert(s149);

   Scanner s150(VAR);
   s150.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s150.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s150.addState(ScannerStateEntry(2 ,START));
   s150.addState(ScannerStateEntry(3 ,FINAL));
   s150.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s150.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s150.addTransition(ScannerTransEntry(1 ,'R' ,3));
   s150.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s150.addTransition(ScannerTransEntry(2 ,'V' ,0));
   s150.addTransition(ScannerTransEntry(2 ,'v' ,0));
   _scannerList.Insert(s150);

   Scanner s151(VALUES);
   s151.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s151.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s151.addState(ScannerStateEntry(2 ,START));
   s151.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s151.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s151.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s151.addState(ScannerStateEntry(6 ,FINAL));
   s151.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s151.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s151.addTransition(ScannerTransEntry(1 ,'L' ,3));
   s151.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s151.addTransition(ScannerTransEntry(2 ,'V' ,0));
   s151.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s151.addTransition(ScannerTransEntry(3 ,'U' ,4));
   s151.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s151.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s151.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s151.addTransition(ScannerTransEntry(5 ,'S' ,6));
   s151.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s151);

   Scanner s152(VIEW);
   s152.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s152.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s152.addState(ScannerStateEntry(2 ,START));
   s152.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s152.addState(ScannerStateEntry(4 ,FINAL));
   s152.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s152.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s152.addTransition(ScannerTransEntry(1 ,'E' ,3));
   s152.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s152.addTransition(ScannerTransEntry(2 ,'V' ,0));
   s152.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s152.addTransition(ScannerTransEntry(3 ,'W' ,4));
   s152.addTransition(ScannerTransEntry(3 ,'w' ,4));
   _scannerList.Insert(s152);

   Scanner s153(WHEN);
   s153.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s153.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s153.addState(ScannerStateEntry(2 ,START));
   s153.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s153.addState(ScannerStateEntry(4 ,FINAL));
   s153.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s153.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s153.addTransition(ScannerTransEntry(1 ,'E' ,3));
   s153.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s153.addTransition(ScannerTransEntry(2 ,'W' ,0));
   s153.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s153.addTransition(ScannerTransEntry(3 ,'N' ,4));
   s153.addTransition(ScannerTransEntry(3 ,'n' ,4));
   _scannerList.Insert(s153);

   Scanner s154(WHERE);
   s154.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s154.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s154.addState(ScannerStateEntry(2 ,START));
   s154.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s154.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s154.addState(ScannerStateEntry(5 ,FINAL));
   s154.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s154.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s154.addTransition(ScannerTransEntry(1 ,'E' ,3));
   s154.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s154.addTransition(ScannerTransEntry(2 ,'W' ,0));
   s154.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s154.addTransition(ScannerTransEntry(3 ,'R' ,4));
   s154.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s154.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s154.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s154);

   Scanner s155(WHILE);
   s155.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s155.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s155.addState(ScannerStateEntry(2 ,START));
   s155.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s155.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s155.addState(ScannerStateEntry(5 ,FINAL));
   s155.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s155.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s155.addTransition(ScannerTransEntry(1 ,'I' ,3));
   s155.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s155.addTransition(ScannerTransEntry(2 ,'W' ,0));
   s155.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s155.addTransition(ScannerTransEntry(3 ,'L' ,4));
   s155.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s155.addTransition(ScannerTransEntry(4 ,'E' ,5));
   s155.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s155);

   Scanner s156(CONCAT);
   s156.addState(ScannerStateEntry(0 ,START));
   s156.addState(ScannerStateEntry(1 ,FINAL));
   s156.addTransition(ScannerTransEntry(0 ,'|' ,1));
   _scannerList.Insert(s156);

   Scanner s157(EQU);
   s157.addState(ScannerStateEntry(0 ,START));
   s157.addState(ScannerStateEntry(1 ,FINAL));
   s157.addTransition(ScannerTransEntry(0 ,'=' ,1));
   _scannerList.Insert(s157);

   Scanner s158(KSEP);
   s158.addState(ScannerStateEntry(0 ,START));
   s158.addState(ScannerStateEntry(1 ,FINAL));
   s158.addTransition(ScannerTransEntry(0 ,',' ,1));
   _scannerList.Insert(s158);

   Scanner s159(LB);
   s159.addState(ScannerStateEntry(0 ,START));
   s159.addState(ScannerStateEntry(1 ,FINAL));
   s159.addTransition(ScannerTransEntry(0 ,'(' ,1));
   _scannerList.Insert(s159);

   Scanner s160(LT);
   s160.addState(ScannerStateEntry(0 ,START));
   s160.addState(ScannerStateEntry(1 ,FINAL));
   s160.addTransition(ScannerTransEntry(0 ,'<' ,1));
   _scannerList.Insert(s160);

   Scanner s161(MT);
   s161.addState(ScannerStateEntry(0 ,START));
   s161.addState(ScannerStateEntry(1 ,FINAL));
   s161.addTransition(ScannerTransEntry(0 ,'>' ,1));
   _scannerList.Insert(s161);

   Scanner s162(NEGATION);
   s162.addState(ScannerStateEntry(0 ,START));
   s162.addState(ScannerStateEntry(1 ,FINAL));
   s162.addTransition(ScannerTransEntry(0 ,'!' ,1));
   _scannerList.Insert(s162);

   Scanner s163(RB);
   s163.addState(ScannerStateEntry(0 ,START));
   s163.addState(ScannerStateEntry(1 ,FINAL));
   s163.addTransition(ScannerTransEntry(0 ,')' ,1));
   _scannerList.Insert(s163);

   Scanner s164(LAB);
   s164.addState(ScannerStateEntry(0 ,START));
   s164.addState(ScannerStateEntry(1 ,FINAL));
   s164.addTransition(ScannerTransEntry(0 ,'[' ,1));
   _scannerList.Insert(s164);

   Scanner s165(RAB);
   s165.addState(ScannerStateEntry(0 ,START));
   s165.addState(ScannerStateEntry(1 ,FINAL));
   s165.addTransition(ScannerTransEntry(0 ,']' ,1));
   _scannerList.Insert(s165);

   Scanner s166(SEMICOLON);
   s166.addState(ScannerStateEntry(0 ,START));
   s166.addState(ScannerStateEntry(1 ,FINAL));
   s166.addTransition(ScannerTransEntry(0 ,';' ,1));
   _scannerList.Insert(s166);

   Scanner s167(STAR);
   s167.addState(ScannerStateEntry(0 ,START));
   s167.addState(ScannerStateEntry(1 ,FINAL));
   s167.addTransition(ScannerTransEntry(0 ,'*' ,1));
   _scannerList.Insert(s167);

   Scanner s168(DIVISION);
   s168.addState(ScannerStateEntry(0 ,START));
   s168.addState(ScannerStateEntry(1 ,FINAL));
   s168.addTransition(ScannerTransEntry(0 ,'/' ,1));
   _scannerList.Insert(s168);

   Scanner s169(MINUS);
   s169.addState(ScannerStateEntry(0 ,START));
   s169.addState(ScannerStateEntry(1 ,FINAL));
   s169.addTransition(ScannerTransEntry(0 ,'-' ,1));
   _scannerList.Insert(s169);

   Scanner s170(PLUS);
   s170.addState(ScannerStateEntry(0 ,START));
   s170.addState(ScannerStateEntry(1 ,FINAL));
   s170.addTransition(ScannerTransEntry(0 ,'+' ,1));
   _scannerList.Insert(s170);

   Scanner s171(INTVAL);
   s171.addState(ScannerStateEntry(0 ,START));
   s171.addState(ScannerStateEntry(1 ,FINAL));
   s171.addState(ScannerStateEntry(2 ,FINAL));
   s171.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s171.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s171.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s171.addTransition(ScannerTransEntry(1 ,'9' ,1));
   _scannerList.Insert(s171);

   Scanner s172(FLOATVAL);
   s172.addState(ScannerStateEntry(0 ,START));
   s172.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s172.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s172.addState(ScannerStateEntry(3 ,FINAL));
   s172.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s172.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s172.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s172.addTransition(ScannerTransEntry(1 ,'.' ,3));
   s172.addTransition(ScannerTransEntry(2 ,'.' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s172.addTransition(ScannerTransEntry(3 ,'9' ,3));
   _scannerList.Insert(s172);

   Scanner s173(IDENTIFIER);
   s173.addState(ScannerStateEntry(0 ,START));
   s173.addState(ScannerStateEntry(1 ,FINAL));
   s173.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s173.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s173.addTransition(ScannerTransEntry(1 ,'z' ,1));
   _scannerList.Insert(s173);

   Scanner s174(VARREF);
   s174.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s174.addState(ScannerStateEntry(1 ,FINAL));
   s174.addState(ScannerStateEntry(2 ,START));
   s174.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s174.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s174.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s174.addTransition(ScannerTransEntry(2 ,':' ,0));
   _scannerList.Insert(s174);

   Scanner s175(QUALIFIEDOBJ);
   s175.addState(ScannerStateEntry(0 ,START));
   s175.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s175.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s175.addState(ScannerStateEntry(3 ,FINAL));
   s175.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s175.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s175.addTransition(ScannerTransEntry(1 ,'.' ,2));
   s175.addTransition(ScannerTransEntry(2 ,'$' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'A' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'B' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'C' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'D' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'E' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'F' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'G' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'H' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'I' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'J' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'K' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'L' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'M' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'N' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'O' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'P' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'Q' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'R' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'S' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'T' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'U' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'V' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'W' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'X' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'Y' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'Z' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'a' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'b' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'c' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'d' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'e' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'f' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'g' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'h' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'i' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'j' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'k' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'l' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'m' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'n' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'o' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'p' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'q' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'r' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'s' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'t' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'u' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'v' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'w' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'x' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'y' ,3));
   s175.addTransition(ScannerTransEntry(2 ,'z' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'9' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'A' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'B' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'C' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'D' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'E' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'F' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'G' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'H' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'I' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'J' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'K' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'L' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'M' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'N' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'O' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'P' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'Q' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'R' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'S' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'T' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'U' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'V' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'W' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'X' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'Y' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'Z' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'_' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'a' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'b' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'c' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'d' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'e' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'f' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'g' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'h' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'i' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'j' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'k' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'l' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'m' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'n' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'o' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'p' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'q' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'r' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'s' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'t' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'u' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'v' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'w' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'x' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'y' ,3));
   s175.addTransition(ScannerTransEntry(3 ,'z' ,3));
   _scannerList.Insert(s175);

   Scanner s176(QUALIFIEDPRE);
   s176.addState(ScannerStateEntry(0 ,START));
   s176.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s176.addState(ScannerStateEntry(2 ,FINAL));
   s176.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s176.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s176.addTransition(ScannerTransEntry(1 ,'.' ,2));
   _scannerList.Insert(s176);

   Scanner s177(QUALIFIEDTS);
   s177.addState(ScannerStateEntry(0 ,START));
   s177.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s177.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s177.addState(ScannerStateEntry(3 ,FINAL));
   s177.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s177.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s177.addTransition(ScannerTransEntry(1 ,'@' ,2));
   s177.addTransition(ScannerTransEntry(2 ,'A' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'B' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'C' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'D' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'E' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'F' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'G' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'H' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'I' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'J' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'K' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'L' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'M' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'N' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'O' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'P' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'Q' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'R' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'S' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'T' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'U' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'V' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'W' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'X' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'Y' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'Z' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'a' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'b' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'c' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'d' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'e' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'f' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'g' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'h' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'i' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'j' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'k' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'l' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'m' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'n' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'o' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'p' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'q' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'r' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'s' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'t' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'u' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'v' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'w' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'x' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'y' ,3));
   s177.addTransition(ScannerTransEntry(2 ,'z' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'9' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'A' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'B' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'C' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'D' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'E' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'F' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'G' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'H' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'I' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'J' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'K' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'L' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'M' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'N' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'O' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'P' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'Q' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'R' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'S' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'T' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'U' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'V' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'W' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'X' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'Y' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'Z' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'_' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'a' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'b' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'c' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'d' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'e' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'f' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'g' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'h' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'i' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'j' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'k' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'l' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'m' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'n' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'o' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'p' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'q' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'r' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'s' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'t' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'u' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'v' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'w' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'x' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'y' ,3));
   s177.addTransition(ScannerTransEntry(3 ,'z' ,3));
   _scannerList.Insert(s177);

}
void Cego::loadParser0()
{
   _actionMap[834][SEMICOLON] = ActionEntry(REDUCE, 66);
   _actionMap[833][RB] = ActionEntry(SHIFT, 834);
   _actionMap[832][IDENTIFIER] = ActionEntry(SHIFT, 716);
   _jumpMap[832][SimpleAttr] = 715;
   _jumpMap[832][SimpleAttrList] = 833;
   _actionMap[829][LB] = ActionEntry(SHIFT, 832);
   _actionMap[830][ROWLIMIT] = ActionEntry(REDUCE, 236);
   _actionMap[830][UNION] = ActionEntry(REDUCE, 236);
   _actionMap[830][ENDTOKEN] = ActionEntry(REDUCE, 236);
   _actionMap[830][RB] = ActionEntry(REDUCE, 236);
   _actionMap[830][SEMICOLON] = ActionEntry(REDUCE, 236);
   _actionMap[830][KSEP] = ActionEntry(REDUCE, 236);
   _actionMap[831][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[831][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[831][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[831][ORDER] = ActionEntry(REDUCE, 230);
   _actionMap[831][ROWLIMIT] = ActionEntry(REDUCE, 230);
   _actionMap[831][UNION] = ActionEntry(REDUCE, 230);
   _actionMap[831][ENDTOKEN] = ActionEntry(REDUCE, 230);
   _actionMap[831][RB] = ActionEntry(REDUCE, 230);
   _actionMap[831][SEMICOLON] = ActionEntry(REDUCE, 230);
   _actionMap[825][IDENTIFIER] = ActionEntry(SHIFT, 829);
   _actionMap[826][SEMICOLON] = ActionEntry(REDUCE, 78);
   _actionMap[826][RB] = ActionEntry(REDUCE, 78);
   _actionMap[827][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[827][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[827][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[827][ASC] = ActionEntry(SHIFT, 818);
   _actionMap[827][ROWLIMIT] = ActionEntry(REDUCE, 241);
   _actionMap[827][DESC] = ActionEntry(SHIFT, 819);
   _actionMap[827][UNION] = ActionEntry(REDUCE, 241);
   _actionMap[827][ENDTOKEN] = ActionEntry(REDUCE, 241);
   _actionMap[827][RB] = ActionEntry(REDUCE, 241);
   _actionMap[827][SEMICOLON] = ActionEntry(REDUCE, 241);
   _actionMap[827][KSEP] = ActionEntry(REDUCE, 241);
   _jumpMap[827][DefaultOrderOpt] = 817;
   _jumpMap[827][OrderingOpt] = 830;
   _actionMap[828][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[828][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[828][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[828][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[828][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[828][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[828][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[828][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[828][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[828][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[828][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[828][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[828][LEFT] = ActionEntry(SHIFT, 117);
}
void Cego::loadParser1()
{
   _actionMap[828][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[828][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[828][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[828][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[828][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[828][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[828][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[828][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[828][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[828][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[828][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[828][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[828][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[828][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[828][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[828][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[828][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[828][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[828][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[828][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[828][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[828][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[828][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[828][LB] = ActionEntry(SHIFT, 144);
   _actionMap[828][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[828][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[828][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[828][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[828][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[828][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[828][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[828][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[828][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[828][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[828][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[828][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[828][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[828][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[828][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[828][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[828][ObjSpec] = 100;
   _jumpMap[828][Constant] = 99;
   _jumpMap[828][SignedFloat] = 98;
   _jumpMap[828][SignedInt] = 97;
   _jumpMap[828][Attribute] = 96;
   _jumpMap[828][Function] = 95;
   _jumpMap[828][CasePrepare] = 94;
   _jumpMap[828][CaseClause] = 93;
   _jumpMap[828][Factor] = 92;
   _jumpMap[828][Term] = 91;
}
void Cego::loadParser2()
{
   _jumpMap[828][Expr] = 831;
   _actionMap[813][REFERENCES] = ActionEntry(SHIFT, 825);
   _actionMap[814][ELSE] = ActionEntry(REDUCE, 115);
   _actionMap[814][ELSIF] = ActionEntry(REDUCE, 115);
   _actionMap[814][EXCEPTION] = ActionEntry(REDUCE, 115);
   _actionMap[814][END_TOKEN] = ActionEntry(REDUCE, 115);
   _actionMap[814][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[814][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[814][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[814][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[814][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[814][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[814][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[814][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[814][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[814][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[814][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[814][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[814][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[814][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[814][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[814][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[814][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[814][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[814][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[814][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[814][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[814][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[814][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[814][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[814][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[814][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[814][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[814][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[814][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[814][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[814][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[814][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[814][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[814][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[814][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[814][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[814][LB] = ActionEntry(SHIFT, 144);
   _actionMap[814][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[814][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[814][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[814][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[814][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[814][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[814][LAB] = ActionEntry(SHIFT, 145);
}
void Cego::loadParser3()
{
   _actionMap[814][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[814][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[814][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[814][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[814][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[814][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[814][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[814][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[814][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[814][IF] = ActionEntry(SHIFT, 338);
   _actionMap[814][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[814][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[814][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[814][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[814][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[814][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[814][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[814][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[814][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[814][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[814][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[814][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[814][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[814][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[814][ObjSpec] = 100;
   _jumpMap[814][Constant] = 99;
   _jumpMap[814][SignedFloat] = 98;
   _jumpMap[814][SignedInt] = 97;
   _jumpMap[814][Attribute] = 96;
   _jumpMap[814][Function] = 95;
   _jumpMap[814][DeleteStatement] = 334;
   _jumpMap[814][UpdateStatement] = 333;
   _jumpMap[814][InsertStatement] = 332;
   _jumpMap[814][RollbackStatement] = 331;
   _jumpMap[814][CommitStatement] = 330;
   _jumpMap[814][StartStatement] = 329;
   _jumpMap[814][CasePrepare] = 94;
   _jumpMap[814][CaseClause] = 93;
   _jumpMap[814][Factor] = 92;
   _jumpMap[814][Term] = 91;
   _jumpMap[814][Expr] = 328;
   _jumpMap[814][ProcStatement] = 460;
   _jumpMap[814][ProcIfPart] = 326;
   _jumpMap[814][ProcBlockStart] = 325;
   _actionMap[815][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[815][SelectStatement] = 826;
   _actionMap[816][ROWLIMIT] = ActionEntry(REDUCE, 237);
   _actionMap[816][UNION] = ActionEntry(REDUCE, 237);
   _actionMap[816][ENDTOKEN] = ActionEntry(REDUCE, 237);
   _actionMap[816][RB] = ActionEntry(REDUCE, 237);
}
void Cego::loadParser4()
{
   _actionMap[816][SEMICOLON] = ActionEntry(REDUCE, 237);
   _actionMap[816][KSEP] = ActionEntry(REDUCE, 237);
   _actionMap[817][ROWLIMIT] = ActionEntry(REDUCE, 238);
   _actionMap[817][UNION] = ActionEntry(REDUCE, 238);
   _actionMap[817][ENDTOKEN] = ActionEntry(REDUCE, 238);
   _actionMap[817][RB] = ActionEntry(REDUCE, 238);
   _actionMap[817][SEMICOLON] = ActionEntry(REDUCE, 238);
   _actionMap[817][KSEP] = ActionEntry(REDUCE, 238);
   _actionMap[818][ROWLIMIT] = ActionEntry(REDUCE, 240);
   _actionMap[818][UNION] = ActionEntry(REDUCE, 240);
   _actionMap[818][ENDTOKEN] = ActionEntry(REDUCE, 240);
   _actionMap[818][RB] = ActionEntry(REDUCE, 240);
   _actionMap[818][SEMICOLON] = ActionEntry(REDUCE, 240);
   _actionMap[818][KSEP] = ActionEntry(REDUCE, 240);
   _actionMap[819][ROWLIMIT] = ActionEntry(REDUCE, 239);
   _actionMap[819][UNION] = ActionEntry(REDUCE, 239);
   _actionMap[819][ENDTOKEN] = ActionEntry(REDUCE, 239);
   _actionMap[819][RB] = ActionEntry(REDUCE, 239);
   _actionMap[819][SEMICOLON] = ActionEntry(REDUCE, 239);
   _actionMap[819][KSEP] = ActionEntry(REDUCE, 239);
   _actionMap[820][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[820][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[820][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[820][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[820][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[820][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[820][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[820][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[820][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[820][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[820][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[820][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[820][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[820][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[820][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[820][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[820][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[820][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[820][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[820][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[820][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[820][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[820][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[820][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[820][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[820][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[820][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[820][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[820][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[820][BITXOR] = ActionEntry(SHIFT, 105);
}
void Cego::loadParser5()
{
   _actionMap[820][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[820][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[820][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[820][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[820][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[820][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[820][LB] = ActionEntry(SHIFT, 144);
   _actionMap[820][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[820][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[820][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[820][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[820][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[820][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[820][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[820][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[820][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[820][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[820][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[820][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[820][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[820][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[820][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[820][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[820][ObjSpec] = 100;
   _jumpMap[820][Constant] = 99;
   _jumpMap[820][SignedFloat] = 98;
   _jumpMap[820][SignedInt] = 97;
   _jumpMap[820][Attribute] = 96;
   _jumpMap[820][Function] = 95;
   _jumpMap[820][CasePrepare] = 94;
   _jumpMap[820][CaseClause] = 93;
   _jumpMap[820][Factor] = 92;
   _jumpMap[820][Term] = 91;
   _jumpMap[820][Expr] = 827;
   _actionMap[821][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[821][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[821][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[821][EQU] = ActionEntry(SHIFT, 506);
   _actionMap[821][NEGATION] = ActionEntry(SHIFT, 509);
   _actionMap[821][LT] = ActionEntry(SHIFT, 507);
   _actionMap[821][MT] = ActionEntry(SHIFT, 508);
   _jumpMap[821][Comparison] = 828;
   _actionMap[822][KSEP] = ActionEntry(REDUCE, 228);
   _actionMap[822][HAVING] = ActionEntry(REDUCE, 228);
   _actionMap[822][ORDER] = ActionEntry(REDUCE, 228);
   _actionMap[822][ROWLIMIT] = ActionEntry(REDUCE, 228);
   _actionMap[822][UNION] = ActionEntry(REDUCE, 228);
   _actionMap[822][ENDTOKEN] = ActionEntry(REDUCE, 228);
   _actionMap[822][RB] = ActionEntry(REDUCE, 228);
   _actionMap[822][SEMICOLON] = ActionEntry(REDUCE, 228);
}
void Cego::loadParser6()
{
   _actionMap[823][AND] = ActionEntry(SHIFT, 510);
   _actionMap[823][OR] = ActionEntry(SHIFT, 511);
   _actionMap[823][LEFT] = ActionEntry(REDUCE, 213);
   _actionMap[823][RIGHT] = ActionEntry(REDUCE, 213);
   _actionMap[823][INNER] = ActionEntry(REDUCE, 213);
   _actionMap[823][JOIN] = ActionEntry(REDUCE, 213);
   _actionMap[823][RETURNTOKEN] = ActionEntry(REDUCE, 213);
   _actionMap[823][SEMICOLON] = ActionEntry(REDUCE, 213);
   _actionMap[823][RB] = ActionEntry(REDUCE, 213);
   _actionMap[823][ENDTOKEN] = ActionEntry(REDUCE, 213);
   _actionMap[823][UNION] = ActionEntry(REDUCE, 213);
   _actionMap[823][ROWLIMIT] = ActionEntry(REDUCE, 213);
   _actionMap[823][ORDER] = ActionEntry(REDUCE, 213);
   _actionMap[823][GROUP] = ActionEntry(REDUCE, 213);
   _actionMap[823][WHERE] = ActionEntry(REDUCE, 213);
   _actionMap[824][AND] = ActionEntry(SHIFT, 510);
   _actionMap[824][OR] = ActionEntry(SHIFT, 511);
   _actionMap[824][LEFT] = ActionEntry(REDUCE, 214);
   _actionMap[824][RIGHT] = ActionEntry(REDUCE, 214);
   _actionMap[824][INNER] = ActionEntry(REDUCE, 214);
   _actionMap[824][JOIN] = ActionEntry(REDUCE, 214);
   _actionMap[824][RETURNTOKEN] = ActionEntry(REDUCE, 214);
   _actionMap[824][SEMICOLON] = ActionEntry(REDUCE, 214);
   _actionMap[824][RB] = ActionEntry(REDUCE, 214);
   _actionMap[824][ENDTOKEN] = ActionEntry(REDUCE, 214);
   _actionMap[824][UNION] = ActionEntry(REDUCE, 214);
   _actionMap[824][ROWLIMIT] = ActionEntry(REDUCE, 214);
   _actionMap[824][ORDER] = ActionEntry(REDUCE, 214);
   _actionMap[824][GROUP] = ActionEntry(REDUCE, 214);
   _actionMap[824][WHERE] = ActionEntry(REDUCE, 214);
   _actionMap[790][RB] = ActionEntry(SHIFT, 813);
   _actionMap[791][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[791][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[791][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[791][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[791][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[791][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[791][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[791][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[791][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[791][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[791][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[791][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[791][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[791][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[791][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[791][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[791][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[791][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[791][TRUNC] = ActionEntry(SHIFT, 142);
}
void Cego::loadParser7()
{
   _actionMap[791][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[791][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[791][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[791][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[791][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[791][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[791][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[791][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[791][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[791][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[791][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[791][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[791][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[791][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[791][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[791][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[791][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[791][LB] = ActionEntry(SHIFT, 144);
   _actionMap[791][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[791][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[791][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[791][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[791][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[791][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[791][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[791][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[791][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[791][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[791][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[791][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[791][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[791][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[791][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[791][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[791][IF] = ActionEntry(SHIFT, 338);
   _actionMap[791][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[791][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[791][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[791][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[791][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[791][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[791][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[791][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[791][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[791][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[791][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[791][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[791][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[791][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[791][ObjSpec] = 100;
}
void Cego::loadParser8()
{
   _jumpMap[791][Constant] = 99;
   _jumpMap[791][SignedFloat] = 98;
   _jumpMap[791][SignedInt] = 97;
   _jumpMap[791][Attribute] = 96;
   _jumpMap[791][Function] = 95;
   _jumpMap[791][DeleteStatement] = 334;
   _jumpMap[791][UpdateStatement] = 333;
   _jumpMap[791][InsertStatement] = 332;
   _jumpMap[791][RollbackStatement] = 331;
   _jumpMap[791][CommitStatement] = 330;
   _jumpMap[791][StartStatement] = 329;
   _jumpMap[791][CasePrepare] = 94;
   _jumpMap[791][CaseClause] = 93;
   _jumpMap[791][Factor] = 92;
   _jumpMap[791][Term] = 91;
   _jumpMap[791][Expr] = 328;
   _jumpMap[791][ProcStatement] = 327;
   _jumpMap[791][ProcIfPart] = 326;
   _jumpMap[791][ProcBlockStart] = 325;
   _jumpMap[791][ProcStatementList] = 814;
   _actionMap[792][BEGIN] = ActionEntry(REDUCE, 328);
   _actionMap[792][DEFAULT] = ActionEntry(REDUCE, 328);
   _actionMap[792][NULLTOKEN] = ActionEntry(REDUCE, 328);
   _actionMap[792][NOT] = ActionEntry(REDUCE, 328);
   _actionMap[792][KSEP] = ActionEntry(REDUCE, 328);
   _actionMap[792][RB] = ActionEntry(REDUCE, 328);
   _actionMap[792][EQU] = ActionEntry(REDUCE, 328);
   _actionMap[792][SEMICOLON] = ActionEntry(REDUCE, 328);
   _actionMap[793][BEGIN] = ActionEntry(REDUCE, 333);
   _actionMap[793][DEFAULT] = ActionEntry(REDUCE, 333);
   _actionMap[793][NULLTOKEN] = ActionEntry(REDUCE, 333);
   _actionMap[793][NOT] = ActionEntry(REDUCE, 333);
   _actionMap[793][KSEP] = ActionEntry(REDUCE, 333);
   _actionMap[793][RB] = ActionEntry(REDUCE, 333);
   _actionMap[793][EQU] = ActionEntry(REDUCE, 333);
   _actionMap[793][SEMICOLON] = ActionEntry(REDUCE, 333);
   _actionMap[794][BEGIN] = ActionEntry(REDUCE, 334);
   _actionMap[794][DEFAULT] = ActionEntry(REDUCE, 334);
   _actionMap[794][NULLTOKEN] = ActionEntry(REDUCE, 334);
   _actionMap[794][NOT] = ActionEntry(REDUCE, 334);
   _actionMap[794][KSEP] = ActionEntry(REDUCE, 334);
   _actionMap[794][RB] = ActionEntry(REDUCE, 334);
   _actionMap[794][EQU] = ActionEntry(REDUCE, 334);
   _actionMap[794][SEMICOLON] = ActionEntry(REDUCE, 334);
   _actionMap[795][BEGIN] = ActionEntry(REDUCE, 325);
   _actionMap[795][DEFAULT] = ActionEntry(REDUCE, 325);
   _actionMap[795][NULLTOKEN] = ActionEntry(REDUCE, 325);
   _actionMap[795][NOT] = ActionEntry(REDUCE, 325);
   _actionMap[795][KSEP] = ActionEntry(REDUCE, 325);
   _actionMap[795][RB] = ActionEntry(REDUCE, 325);
}
void Cego::loadParser9()
{
   _actionMap[795][EQU] = ActionEntry(REDUCE, 325);
   _actionMap[795][SEMICOLON] = ActionEntry(REDUCE, 325);
   _actionMap[796][SEMICOLON] = ActionEntry(REDUCE, 56);
   _actionMap[797][RB] = ActionEntry(REDUCE, 180);
   _actionMap[798][SEMICOLON] = ActionEntry(REDUCE, 174);
   _actionMap[798][KSEP] = ActionEntry(REDUCE, 174);
   _actionMap[798][RB] = ActionEntry(REDUCE, 174);
   _actionMap[799][LEFT] = ActionEntry(REDUCE, 314);
   _actionMap[799][RIGHT] = ActionEntry(REDUCE, 314);
   _actionMap[799][INNER] = ActionEntry(REDUCE, 314);
   _actionMap[799][JOIN] = ActionEntry(REDUCE, 314);
   _actionMap[799][RETURNTOKEN] = ActionEntry(REDUCE, 314);
   _actionMap[799][SEMICOLON] = ActionEntry(REDUCE, 314);
   _actionMap[799][ENDTOKEN] = ActionEntry(REDUCE, 314);
   _actionMap[799][UNION] = ActionEntry(REDUCE, 314);
   _actionMap[799][ROWLIMIT] = ActionEntry(REDUCE, 314);
   _actionMap[799][ORDER] = ActionEntry(REDUCE, 314);
   _actionMap[799][GROUP] = ActionEntry(REDUCE, 314);
   _actionMap[799][WHERE] = ActionEntry(REDUCE, 314);
   _actionMap[799][THEN] = ActionEntry(REDUCE, 314);
   _actionMap[799][AND] = ActionEntry(REDUCE, 314);
   _actionMap[799][OR] = ActionEntry(REDUCE, 314);
   _actionMap[799][RB] = ActionEntry(REDUCE, 314);
   _actionMap[800][SEMICOLON] = ActionEntry(REDUCE, 202);
   _actionMap[800][RB] = ActionEntry(REDUCE, 202);
   _actionMap[801][ALL] = ActionEntry(SHIFT, 815);
   _actionMap[802][UNION] = ActionEntry(REDUCE, 244);
   _actionMap[802][ENDTOKEN] = ActionEntry(REDUCE, 244);
   _actionMap[802][RB] = ActionEntry(REDUCE, 244);
   _actionMap[802][SEMICOLON] = ActionEntry(REDUCE, 244);
   _actionMap[803][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[803][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[803][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[803][ASC] = ActionEntry(SHIFT, 818);
   _actionMap[803][ROWLIMIT] = ActionEntry(REDUCE, 241);
   _actionMap[803][DESC] = ActionEntry(SHIFT, 819);
   _actionMap[803][UNION] = ActionEntry(REDUCE, 241);
   _actionMap[803][ENDTOKEN] = ActionEntry(REDUCE, 241);
   _actionMap[803][RB] = ActionEntry(REDUCE, 241);
   _actionMap[803][SEMICOLON] = ActionEntry(REDUCE, 241);
   _actionMap[803][KSEP] = ActionEntry(REDUCE, 241);
   _jumpMap[803][DefaultOrderOpt] = 817;
   _jumpMap[803][OrderingOpt] = 816;
   _actionMap[804][KSEP] = ActionEntry(SHIFT, 820);
   _actionMap[804][ROWLIMIT] = ActionEntry(REDUCE, 233);
   _actionMap[804][UNION] = ActionEntry(REDUCE, 233);
   _actionMap[804][ENDTOKEN] = ActionEntry(REDUCE, 233);
   _actionMap[804][RB] = ActionEntry(REDUCE, 233);
   _actionMap[804][SEMICOLON] = ActionEntry(REDUCE, 233);
   _actionMap[805][ORDER] = ActionEntry(REDUCE, 225);
}
void Cego::loadParser10()
{
   _actionMap[805][ROWLIMIT] = ActionEntry(REDUCE, 225);
   _actionMap[805][UNION] = ActionEntry(REDUCE, 225);
   _actionMap[805][ENDTOKEN] = ActionEntry(REDUCE, 225);
   _actionMap[805][RB] = ActionEntry(REDUCE, 225);
   _actionMap[805][SEMICOLON] = ActionEntry(REDUCE, 225);
   _actionMap[806][ORDER] = ActionEntry(REDUCE, 231);
   _actionMap[806][ROWLIMIT] = ActionEntry(REDUCE, 231);
   _actionMap[806][UNION] = ActionEntry(REDUCE, 231);
   _actionMap[806][ENDTOKEN] = ActionEntry(REDUCE, 231);
   _actionMap[806][RB] = ActionEntry(REDUCE, 231);
   _actionMap[806][SEMICOLON] = ActionEntry(REDUCE, 231);
   _actionMap[807][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[807][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[807][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[807][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[807][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[807][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[807][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[807][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[807][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[807][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[807][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[807][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[807][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[807][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[807][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[807][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[807][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[807][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[807][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[807][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[807][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[807][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[807][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[807][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[807][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[807][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[807][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[807][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[807][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[807][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[807][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[807][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[807][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[807][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[807][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[807][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[807][LB] = ActionEntry(SHIFT, 144);
   _actionMap[807][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[807][DATE] = ActionEntry(SHIFT, 109);
}
void Cego::loadParser11()
{
   _actionMap[807][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[807][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[807][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[807][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[807][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[807][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[807][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[807][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[807][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[807][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[807][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[807][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[807][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[807][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[807][ObjSpec] = 100;
   _jumpMap[807][Constant] = 99;
   _jumpMap[807][SignedFloat] = 98;
   _jumpMap[807][SignedInt] = 97;
   _jumpMap[807][Attribute] = 96;
   _jumpMap[807][Function] = 95;
   _jumpMap[807][CasePrepare] = 94;
   _jumpMap[807][CaseClause] = 93;
   _jumpMap[807][Factor] = 92;
   _jumpMap[807][Term] = 91;
   _jumpMap[807][Expr] = 821;
   _actionMap[808][IDENTIFIER] = ActionEntry(SHIFT, 783);
   _actionMap[808][QUALIFIEDOBJ] = ActionEntry(SHIFT, 784);
   _actionMap[808][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _jumpMap[808][Attribute] = 822;
   _actionMap[809][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[809][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[809][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[809][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[809][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[809][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[809][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[809][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[809][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[809][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[809][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[809][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[809][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[809][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[809][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[809][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[809][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[809][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[809][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[809][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[809][STR2LONG] = ActionEntry(SHIFT, 138);
}
void Cego::loadParser12()
{
   _actionMap[809][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[809][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[809][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[809][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[809][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[809][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[809][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[809][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[809][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[809][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[809][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[809][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[809][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[809][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[809][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[809][LB] = ActionEntry(SHIFT, 374);
   _actionMap[809][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[809][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[809][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[809][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[809][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[809][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[809][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[809][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[809][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[809][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[809][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[809][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[809][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[809][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[809][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[809][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[809][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[809][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[809][ObjSpec] = 100;
   _jumpMap[809][Constant] = 99;
   _jumpMap[809][SignedFloat] = 98;
   _jumpMap[809][SignedInt] = 97;
   _jumpMap[809][Attribute] = 96;
   _jumpMap[809][QueryPredicate] = 371;
   _jumpMap[809][QueryCondition] = 823;
   _jumpMap[809][Function] = 95;
   _jumpMap[809][CasePrepare] = 94;
   _jumpMap[809][CaseClause] = 93;
   _jumpMap[809][Factor] = 92;
   _jumpMap[809][Term] = 91;
   _jumpMap[809][Expr] = 369;
   _actionMap[810][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[810][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[810][INTVAL] = ActionEntry(SHIFT, 147);
}
void Cego::loadParser13()
{
   _actionMap[810][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[810][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[810][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[810][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[810][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[810][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[810][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[810][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[810][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[810][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[810][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[810][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[810][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[810][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[810][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[810][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[810][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[810][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[810][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[810][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[810][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[810][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[810][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[810][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[810][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[810][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[810][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[810][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[810][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[810][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[810][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[810][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[810][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[810][LB] = ActionEntry(SHIFT, 374);
   _actionMap[810][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[810][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[810][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[810][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[810][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[810][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[810][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[810][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[810][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[810][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[810][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[810][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[810][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[810][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[810][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[810][MAX] = ActionEntry(SHIFT, 122);
}
void Cego::loadParser14()
{
   _actionMap[810][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[810][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[810][ObjSpec] = 100;
   _jumpMap[810][Constant] = 99;
   _jumpMap[810][SignedFloat] = 98;
   _jumpMap[810][SignedInt] = 97;
   _jumpMap[810][Attribute] = 96;
   _jumpMap[810][QueryPredicate] = 371;
   _jumpMap[810][QueryCondition] = 824;
   _jumpMap[810][Function] = 95;
   _jumpMap[810][CasePrepare] = 94;
   _jumpMap[810][CaseClause] = 93;
   _jumpMap[810][Factor] = 92;
   _jumpMap[810][Term] = 91;
   _jumpMap[810][Expr] = 369;
   _actionMap[811][SEMICOLON] = ActionEntry(REDUCE, 253);
   _actionMap[811][KSEP] = ActionEntry(REDUCE, 253);
   _actionMap[812][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[812][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[812][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[812][SEMICOLON] = ActionEntry(REDUCE, 255);
   _actionMap[812][KSEP] = ActionEntry(REDUCE, 255);
   _actionMap[750][AND] = ActionEntry(SHIFT, 510);
   _actionMap[750][OR] = ActionEntry(SHIFT, 511);
   _actionMap[750][SEMICOLON] = ActionEntry(REDUCE, 67);
   _actionMap[751][IDENTIFIER] = ActionEntry(SHIFT, 716);
   _jumpMap[751][SimpleAttr] = 715;
   _jumpMap[751][SimpleAttrList] = 790;
   _actionMap[752][SEMICOLON] = ActionEntry(REDUCE, 265);
   _actionMap[752][KSEP] = ActionEntry(REDUCE, 265);
   _actionMap[753][THEN] = ActionEntry(SHIFT, 791);
   _actionMap[754][THEN] = ActionEntry(REDUCE, 120);
   _actionMap[755][END_TOKEN] = ActionEntry(REDUCE, 125);
   _actionMap[755][ELSE] = ActionEntry(REDUCE, 125);
   _actionMap[755][ELSIF] = ActionEntry(REDUCE, 125);
   _actionMap[756][BEGIN] = ActionEntry(REDUCE, 139);
   _actionMap[756][THEN] = ActionEntry(REDUCE, 139);
   _actionMap[756][OR] = ActionEntry(REDUCE, 139);
   _actionMap[756][AND] = ActionEntry(REDUCE, 139);
   _actionMap[756][RB] = ActionEntry(REDUCE, 139);
   _actionMap[757][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[757][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[757][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[757][SEMICOLON] = ActionEntry(REDUCE, 99);
   _actionMap[758][RB] = ActionEntry(SHIFT, 792);
   _actionMap[759][RB] = ActionEntry(SHIFT, 793);
   _actionMap[760][RB] = ActionEntry(SHIFT, 794);
   _actionMap[761][RB] = ActionEntry(SHIFT, 795);
   _actionMap[762][SEMICOLON] = ActionEntry(REDUCE, 131);
   _actionMap[763][RB] = ActionEntry(SHIFT, 796);
}
void Cego::loadParser15()
{
   _actionMap[764][SEMICOLON] = ActionEntry(REDUCE, 55);
   _actionMap[765][IDENTIFIER] = ActionEntry(SHIFT, 716);
   _jumpMap[765][SimpleAttr] = 715;
   _jumpMap[765][SimpleAttrList] = 797;
   _actionMap[766][SEMICOLON] = ActionEntry(REDUCE, 172);
   _actionMap[766][KSEP] = ActionEntry(REDUCE, 172);
   _actionMap[766][RB] = ActionEntry(REDUCE, 172);
   _actionMap[767][SEMICOLON] = ActionEntry(REDUCE, 175);
   _actionMap[767][KSEP] = ActionEntry(REDUCE, 175);
   _actionMap[767][RB] = ActionEntry(REDUCE, 175);
   _actionMap[768][NULLTOKEN] = ActionEntry(SHIFT, 798);
   _actionMap[769][SEMICOLON] = ActionEntry(REDUCE, 173);
   _actionMap[769][KSEP] = ActionEntry(REDUCE, 173);
   _actionMap[769][RB] = ActionEntry(REDUCE, 173);
   _actionMap[770][NULLTOKEN] = ActionEntry(REDUCE, 177);
   _actionMap[770][NOT] = ActionEntry(REDUCE, 177);
   _actionMap[770][KSEP] = ActionEntry(REDUCE, 177);
   _actionMap[770][SEMICOLON] = ActionEntry(REDUCE, 177);
   _actionMap[770][RB] = ActionEntry(REDUCE, 177);
   _actionMap[771][LONG] = ActionEntry(SHIFT, 277);
   _actionMap[771][BIGINT] = ActionEntry(SHIFT, 273);
   _actionMap[771][SMALLINT] = ActionEntry(SHIFT, 278);
   _actionMap[771][TINYINT] = ActionEntry(SHIFT, 279);
   _actionMap[771][DOUBLE] = ActionEntry(SHIFT, 275);
   _actionMap[771][DECIMAL] = ActionEntry(SHIFT, 274);
   _actionMap[771][FIXED] = ActionEntry(SHIFT, 276);
   _actionMap[772][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[772][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[772][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[772][KSEP] = ActionEntry(REDUCE, 200);
   _actionMap[772][RB] = ActionEntry(REDUCE, 200);
   _actionMap[773][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[773][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[773][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[773][LEFT] = ActionEntry(REDUCE, 316);
   _actionMap[773][RIGHT] = ActionEntry(REDUCE, 316);
   _actionMap[773][INNER] = ActionEntry(REDUCE, 316);
   _actionMap[773][JOIN] = ActionEntry(REDUCE, 316);
   _actionMap[773][RETURNTOKEN] = ActionEntry(REDUCE, 316);
   _actionMap[773][SEMICOLON] = ActionEntry(REDUCE, 316);
   _actionMap[773][ENDTOKEN] = ActionEntry(REDUCE, 316);
   _actionMap[773][UNION] = ActionEntry(REDUCE, 316);
   _actionMap[773][ROWLIMIT] = ActionEntry(REDUCE, 316);
   _actionMap[773][ORDER] = ActionEntry(REDUCE, 316);
   _actionMap[773][GROUP] = ActionEntry(REDUCE, 316);
   _actionMap[773][WHERE] = ActionEntry(REDUCE, 316);
   _actionMap[773][THEN] = ActionEntry(REDUCE, 316);
   _actionMap[773][AND] = ActionEntry(REDUCE, 316);
   _actionMap[773][OR] = ActionEntry(REDUCE, 316);
   _actionMap[773][RB] = ActionEntry(REDUCE, 316);
}
void Cego::loadParser16()
{
   _actionMap[774][LEFT] = ActionEntry(REDUCE, 313);
   _actionMap[774][RIGHT] = ActionEntry(REDUCE, 313);
   _actionMap[774][INNER] = ActionEntry(REDUCE, 313);
   _actionMap[774][JOIN] = ActionEntry(REDUCE, 313);
   _actionMap[774][RETURNTOKEN] = ActionEntry(REDUCE, 313);
   _actionMap[774][SEMICOLON] = ActionEntry(REDUCE, 313);
   _actionMap[774][ENDTOKEN] = ActionEntry(REDUCE, 313);
   _actionMap[774][UNION] = ActionEntry(REDUCE, 313);
   _actionMap[774][ROWLIMIT] = ActionEntry(REDUCE, 313);
   _actionMap[774][ORDER] = ActionEntry(REDUCE, 313);
   _actionMap[774][GROUP] = ActionEntry(REDUCE, 313);
   _actionMap[774][WHERE] = ActionEntry(REDUCE, 313);
   _actionMap[774][THEN] = ActionEntry(REDUCE, 313);
   _actionMap[774][AND] = ActionEntry(REDUCE, 313);
   _actionMap[774][OR] = ActionEntry(REDUCE, 313);
   _actionMap[774][RB] = ActionEntry(REDUCE, 313);
   _actionMap[775][RB] = ActionEntry(SHIFT, 799);
   _actionMap[776][KSEP] = ActionEntry(REDUCE, 166);
   _actionMap[776][RB] = ActionEntry(REDUCE, 166);
   _actionMap[777][UNION] = ActionEntry(SHIFT, 801);
   _actionMap[777][SEMICOLON] = ActionEntry(REDUCE, 79);
   _actionMap[777][RB] = ActionEntry(REDUCE, 79);
   _jumpMap[777][UnionAllOpt] = 800;
   _actionMap[778][UNION] = ActionEntry(REDUCE, 245);
   _actionMap[778][ENDTOKEN] = ActionEntry(REDUCE, 245);
   _actionMap[778][RB] = ActionEntry(REDUCE, 245);
   _actionMap[778][SEMICOLON] = ActionEntry(REDUCE, 245);
   _actionMap[779][INTVAL] = ActionEntry(SHIFT, 802);
   _actionMap[780][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[780][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[780][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[780][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[780][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[780][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[780][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[780][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[780][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[780][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[780][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[780][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[780][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[780][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[780][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[780][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[780][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[780][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[780][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[780][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[780][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[780][STR2DATE] = ActionEntry(SHIFT, 139);
}
void Cego::loadParser17()
{
   _actionMap[780][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[780][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[780][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[780][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[780][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[780][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[780][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[780][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[780][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[780][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[780][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[780][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[780][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[780][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[780][LB] = ActionEntry(SHIFT, 144);
   _actionMap[780][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[780][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[780][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[780][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[780][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[780][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[780][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[780][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[780][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[780][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[780][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[780][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[780][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[780][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[780][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[780][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[780][ObjSpec] = 100;
   _jumpMap[780][Constant] = 99;
   _jumpMap[780][SignedFloat] = 98;
   _jumpMap[780][SignedInt] = 97;
   _jumpMap[780][Attribute] = 96;
   _jumpMap[780][Function] = 95;
   _jumpMap[780][OrderingList] = 804;
   _jumpMap[780][CasePrepare] = 94;
   _jumpMap[780][CaseClause] = 93;
   _jumpMap[780][Factor] = 92;
   _jumpMap[780][Term] = 91;
   _jumpMap[780][Expr] = 803;
   _actionMap[781][KSEP] = ActionEntry(SHIFT, 808);
   _actionMap[781][ORDER] = ActionEntry(REDUCE, 232);
   _actionMap[781][HAVING] = ActionEntry(SHIFT, 807);
   _actionMap[781][ROWLIMIT] = ActionEntry(REDUCE, 232);
   _actionMap[781][UNION] = ActionEntry(REDUCE, 232);
   _actionMap[781][ENDTOKEN] = ActionEntry(REDUCE, 232);
   _actionMap[781][RB] = ActionEntry(REDUCE, 232);
}
void Cego::loadParser18()
{
   _actionMap[781][SEMICOLON] = ActionEntry(REDUCE, 232);
   _jumpMap[781][NoHaving] = 806;
   _jumpMap[781][HavingClause] = 805;
   _actionMap[782][KSEP] = ActionEntry(REDUCE, 229);
   _actionMap[782][HAVING] = ActionEntry(REDUCE, 229);
   _actionMap[782][ORDER] = ActionEntry(REDUCE, 229);
   _actionMap[782][ROWLIMIT] = ActionEntry(REDUCE, 229);
   _actionMap[782][UNION] = ActionEntry(REDUCE, 229);
   _actionMap[782][ENDTOKEN] = ActionEntry(REDUCE, 229);
   _actionMap[782][RB] = ActionEntry(REDUCE, 229);
   _actionMap[782][SEMICOLON] = ActionEntry(REDUCE, 229);
   _actionMap[783][KSEP] = ActionEntry(REDUCE, 342);
   _actionMap[783][HAVING] = ActionEntry(REDUCE, 342);
   _actionMap[783][ORDER] = ActionEntry(REDUCE, 342);
   _actionMap[783][ROWLIMIT] = ActionEntry(REDUCE, 342);
   _actionMap[783][UNION] = ActionEntry(REDUCE, 342);
   _actionMap[783][ENDTOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[783][RB] = ActionEntry(REDUCE, 342);
   _actionMap[783][SEMICOLON] = ActionEntry(REDUCE, 342);
   _actionMap[784][KSEP] = ActionEntry(REDUCE, 343);
   _actionMap[784][HAVING] = ActionEntry(REDUCE, 343);
   _actionMap[784][ORDER] = ActionEntry(REDUCE, 343);
   _actionMap[784][ROWLIMIT] = ActionEntry(REDUCE, 343);
   _actionMap[784][UNION] = ActionEntry(REDUCE, 343);
   _actionMap[784][ENDTOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[784][RB] = ActionEntry(REDUCE, 343);
   _actionMap[784][SEMICOLON] = ActionEntry(REDUCE, 343);
   _actionMap[785][AND] = ActionEntry(SHIFT, 510);
   _actionMap[785][OR] = ActionEntry(SHIFT, 511);
   _actionMap[785][LEFT] = ActionEntry(REDUCE, 212);
   _actionMap[785][RIGHT] = ActionEntry(REDUCE, 212);
   _actionMap[785][INNER] = ActionEntry(REDUCE, 212);
   _actionMap[785][JOIN] = ActionEntry(REDUCE, 212);
   _actionMap[785][RETURNTOKEN] = ActionEntry(REDUCE, 212);
   _actionMap[785][SEMICOLON] = ActionEntry(REDUCE, 212);
   _actionMap[785][RB] = ActionEntry(REDUCE, 212);
   _actionMap[785][ENDTOKEN] = ActionEntry(REDUCE, 212);
   _actionMap[785][UNION] = ActionEntry(REDUCE, 212);
   _actionMap[785][ROWLIMIT] = ActionEntry(REDUCE, 212);
   _actionMap[785][ORDER] = ActionEntry(REDUCE, 212);
   _actionMap[785][GROUP] = ActionEntry(REDUCE, 212);
   _actionMap[785][WHERE] = ActionEntry(REDUCE, 212);
   _actionMap[786][ON] = ActionEntry(SHIFT, 744);
   _jumpMap[786][JoinTableOn] = 809;
   _actionMap[787][ON] = ActionEntry(SHIFT, 744);
   _jumpMap[787][JoinTableOn] = 810;
   _actionMap[788][VARREF] = ActionEntry(SHIFT, 749);
   _jumpMap[788][ReturnVar] = 811;
   _actionMap[789][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[789][MINUS] = ActionEntry(SHIFT, 146);
}
void Cego::loadParser19()
{
   _actionMap[789][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[789][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[789][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[789][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[789][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[789][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[789][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[789][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[789][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[789][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[789][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[789][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[789][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[789][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[789][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[789][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[789][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[789][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[789][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[789][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[789][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[789][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[789][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[789][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[789][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[789][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[789][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[789][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[789][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[789][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[789][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[789][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[789][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[789][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[789][LB] = ActionEntry(SHIFT, 144);
   _actionMap[789][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[789][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[789][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[789][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[789][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[789][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[789][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[789][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[789][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[789][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[789][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[789][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[789][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[789][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[789][MIN] = ActionEntry(SHIFT, 121);
}
void Cego::loadParser20()
{
   _actionMap[789][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[789][ObjSpec] = 100;
   _jumpMap[789][Constant] = 99;
   _jumpMap[789][SignedFloat] = 98;
   _jumpMap[789][SignedInt] = 97;
   _jumpMap[789][Attribute] = 96;
   _jumpMap[789][Function] = 95;
   _jumpMap[789][CasePrepare] = 94;
   _jumpMap[789][CaseClause] = 93;
   _jumpMap[789][Factor] = 92;
   _jumpMap[789][Term] = 91;
   _jumpMap[789][Expr] = 812;
   _actionMap[690][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[690][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[690][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[690][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[690][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[690][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[690][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[690][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[690][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[690][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[690][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[690][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[690][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[690][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[690][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[690][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[690][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[690][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[690][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[690][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[690][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[690][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[690][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[690][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[690][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[690][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[690][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[690][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[690][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[690][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[690][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[690][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[690][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[690][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[690][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[690][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[690][LB] = ActionEntry(SHIFT, 374);
   _actionMap[690][STRINGVAL] = ActionEntry(SHIFT, 101);
}
void Cego::loadParser21()
{
   _actionMap[690][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[690][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[690][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[690][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[690][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[690][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[690][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[690][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[690][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[690][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[690][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[690][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[690][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[690][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[690][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[690][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[690][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[690][ObjSpec] = 100;
   _jumpMap[690][Constant] = 99;
   _jumpMap[690][SignedFloat] = 98;
   _jumpMap[690][SignedInt] = 97;
   _jumpMap[690][Attribute] = 96;
   _jumpMap[690][QueryPredicate] = 371;
   _jumpMap[690][QueryCondition] = 750;
   _jumpMap[690][Function] = 95;
   _jumpMap[690][CasePrepare] = 94;
   _jumpMap[690][CaseClause] = 93;
   _jumpMap[690][Factor] = 92;
   _jumpMap[690][Term] = 91;
   _jumpMap[690][Expr] = 369;
   _actionMap[691][LB] = ActionEntry(SHIFT, 751);
   _actionMap[692][IDENTIFIER] = ActionEntry(SHIFT, 752);
   _actionMap[693][SEMICOLON] = ActionEntry(REDUCE, 30);
   _actionMap[694][IDENTIFIER] = ActionEntry(SHIFT, 754);
   _jumpMap[694][ProcExceptionType] = 753;
   _actionMap[695][END_TOKEN] = ActionEntry(REDUCE, 126);
   _actionMap[696][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[696][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[696][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[696][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[696][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[696][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[696][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[696][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[696][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[696][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[696][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[696][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[696][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[696][RIGHT] = ActionEntry(SHIFT, 130);
}
void Cego::loadParser22()
{
   _actionMap[696][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[696][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[696][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[696][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[696][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[696][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[696][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[696][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[696][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[696][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[696][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[696][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[696][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[696][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[696][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[696][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[696][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[696][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[696][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[696][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[696][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[696][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[696][LB] = ActionEntry(SHIFT, 144);
   _actionMap[696][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[696][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[696][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[696][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[696][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[696][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[696][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[696][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[696][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[696][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[696][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[696][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[696][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[696][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[696][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[696][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[696][IF] = ActionEntry(SHIFT, 338);
   _actionMap[696][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[696][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[696][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[696][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[696][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[696][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[696][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[696][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[696][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[696][CLOSE] = ActionEntry(SHIFT, 336);
}
void Cego::loadParser23()
{
   _actionMap[696][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[696][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[696][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[696][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[696][ObjSpec] = 100;
   _jumpMap[696][Constant] = 99;
   _jumpMap[696][SignedFloat] = 98;
   _jumpMap[696][SignedInt] = 97;
   _jumpMap[696][Attribute] = 96;
   _jumpMap[696][Function] = 95;
   _jumpMap[696][DeleteStatement] = 334;
   _jumpMap[696][UpdateStatement] = 333;
   _jumpMap[696][InsertStatement] = 332;
   _jumpMap[696][RollbackStatement] = 331;
   _jumpMap[696][CommitStatement] = 330;
   _jumpMap[696][StartStatement] = 329;
   _jumpMap[696][CasePrepare] = 94;
   _jumpMap[696][CaseClause] = 93;
   _jumpMap[696][Factor] = 92;
   _jumpMap[696][Term] = 91;
   _jumpMap[696][Expr] = 328;
   _jumpMap[696][ProcStatement] = 327;
   _jumpMap[696][ProcIfPart] = 326;
   _jumpMap[696][ProcBlockStart] = 325;
   _jumpMap[696][ProcStatementList] = 324;
   _jumpMap[696][ProcStmtBlock] = 755;
   _actionMap[697][SEMICOLON] = ActionEntry(REDUCE, 94);
   _actionMap[698][END_TOKEN] = ActionEntry(REDUCE, 122);
   _actionMap[698][ELSE] = ActionEntry(REDUCE, 122);
   _actionMap[698][ELSIF] = ActionEntry(REDUCE, 122);
   _actionMap[699][BEGIN] = ActionEntry(REDUCE, 134);
   _actionMap[699][RB] = ActionEntry(REDUCE, 134);
   _actionMap[699][AND] = ActionEntry(REDUCE, 134);
   _actionMap[699][OR] = ActionEntry(REDUCE, 134);
   _actionMap[699][THEN] = ActionEntry(REDUCE, 134);
   _actionMap[700][BEGIN] = ActionEntry(REDUCE, 133);
   _actionMap[700][RB] = ActionEntry(REDUCE, 133);
   _actionMap[700][AND] = ActionEntry(REDUCE, 133);
   _actionMap[700][OR] = ActionEntry(REDUCE, 133);
   _actionMap[700][THEN] = ActionEntry(REDUCE, 133);
   _actionMap[701][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[701][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[701][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[701][BEGIN] = ActionEntry(REDUCE, 137);
   _actionMap[701][THEN] = ActionEntry(REDUCE, 137);
   _actionMap[701][OR] = ActionEntry(REDUCE, 137);
   _actionMap[701][AND] = ActionEntry(REDUCE, 137);
   _actionMap[701][RB] = ActionEntry(REDUCE, 137);
   _actionMap[702][NULLTOKEN] = ActionEntry(SHIFT, 756);
   _actionMap[703][BEGIN] = ActionEntry(REDUCE, 138);
}
void Cego::loadParser24()
{
   _actionMap[703][THEN] = ActionEntry(REDUCE, 138);
   _actionMap[703][OR] = ActionEntry(REDUCE, 138);
   _actionMap[703][AND] = ActionEntry(REDUCE, 138);
   _actionMap[703][RB] = ActionEntry(REDUCE, 138);
   _actionMap[704][BEGIN] = ActionEntry(REDUCE, 136);
   _actionMap[704][RB] = ActionEntry(REDUCE, 136);
   _actionMap[704][AND] = ActionEntry(REDUCE, 136);
   _actionMap[704][OR] = ActionEntry(REDUCE, 136);
   _actionMap[704][THEN] = ActionEntry(REDUCE, 136);
   _actionMap[705][SEMICOLON] = ActionEntry(REDUCE, 93);
   _actionMap[706][SEMICOLON] = ActionEntry(REDUCE, 100);
   _actionMap[707][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[707][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[707][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[707][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[707][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[707][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[707][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[707][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[707][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[707][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[707][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[707][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[707][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[707][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[707][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[707][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[707][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[707][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[707][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[707][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[707][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[707][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[707][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[707][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[707][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[707][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[707][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[707][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[707][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[707][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[707][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[707][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[707][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[707][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[707][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[707][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[707][LB] = ActionEntry(SHIFT, 144);
   _actionMap[707][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[707][DATE] = ActionEntry(SHIFT, 109);
}
void Cego::loadParser25()
{
   _actionMap[707][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[707][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[707][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[707][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[707][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[707][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[707][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[707][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[707][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[707][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[707][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[707][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[707][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[707][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[707][ObjSpec] = 100;
   _jumpMap[707][Constant] = 99;
   _jumpMap[707][SignedFloat] = 98;
   _jumpMap[707][SignedInt] = 97;
   _jumpMap[707][Attribute] = 96;
   _jumpMap[707][Function] = 95;
   _jumpMap[707][CasePrepare] = 94;
   _jumpMap[707][CaseClause] = 93;
   _jumpMap[707][Factor] = 92;
   _jumpMap[707][Term] = 91;
   _jumpMap[707][Expr] = 757;
   _actionMap[708][INTVAL] = ActionEntry(SHIFT, 758);
   _actionMap[709][INTVAL] = ActionEntry(SHIFT, 759);
   _actionMap[710][INTVAL] = ActionEntry(SHIFT, 760);
   _actionMap[711][INTVAL] = ActionEntry(SHIFT, 761);
   _actionMap[712][END_TOKEN] = ActionEntry(SHIFT, 762);
   _actionMap[713][IDENTIFIER] = ActionEntry(SHIFT, 716);
   _jumpMap[713][SimpleAttr] = 715;
   _jumpMap[713][SimpleAttrList] = 763;
   _actionMap[714][RB] = ActionEntry(SHIFT, 764);
   _actionMap[715][KSEP] = ActionEntry(SHIFT, 765);
   _actionMap[715][RB] = ActionEntry(REDUCE, 181);
   _actionMap[716][RB] = ActionEntry(REDUCE, 182);
   _actionMap[716][KSEP] = ActionEntry(REDUCE, 182);
   _actionMap[717][KSEP] = ActionEntry(REDUCE, 86);
   _actionMap[717][RB] = ActionEntry(REDUCE, 86);
   _actionMap[718][BEGIN] = ActionEntry(REDUCE, 82);
   _actionMap[719][KSEP] = ActionEntry(REDUCE, 88);
   _actionMap[719][RB] = ActionEntry(REDUCE, 88);
   _actionMap[720][KSEP] = ActionEntry(REDUCE, 89);
   _actionMap[720][RB] = ActionEntry(REDUCE, 89);
   _actionMap[721][KSEP] = ActionEntry(REDUCE, 168);
   _actionMap[721][RB] = ActionEntry(REDUCE, 168);
   _actionMap[722][SEMICOLON] = ActionEntry(REDUCE, 176);
   _actionMap[722][NULLTOKEN] = ActionEntry(SHIFT, 769);
   _actionMap[722][NOT] = ActionEntry(SHIFT, 768);
}
void Cego::loadParser26()
{
   _actionMap[722][KSEP] = ActionEntry(REDUCE, 176);
   _actionMap[722][RB] = ActionEntry(REDUCE, 176);
   _jumpMap[722][DefaultNullOpt] = 767;
   _jumpMap[722][NullOpt] = 766;
   _actionMap[723][NULLTOKEN] = ActionEntry(REDUCE, 178);
   _actionMap[723][NOT] = ActionEntry(REDUCE, 178);
   _actionMap[723][KSEP] = ActionEntry(REDUCE, 178);
   _actionMap[723][SEMICOLON] = ActionEntry(REDUCE, 178);
   _actionMap[723][RB] = ActionEntry(REDUCE, 178);
   _actionMap[724][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[724][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[724][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[724][LB] = ActionEntry(SHIFT, 771);
   _actionMap[724][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[724][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[724][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[724][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[724][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[724][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[724][LAB] = ActionEntry(SHIFT, 145);
   _jumpMap[724][Constant] = 770;
   _jumpMap[724][SignedFloat] = 98;
   _jumpMap[724][SignedInt] = 97;
   _actionMap[725][SEMICOLON] = ActionEntry(REDUCE, 195);
   _actionMap[725][KSEP] = ActionEntry(REDUCE, 195);
   _actionMap[726][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[726][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[726][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[726][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[726][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[726][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[726][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[726][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[726][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[726][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[726][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[726][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[726][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[726][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[726][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[726][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[726][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[726][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[726][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[726][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[726][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[726][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[726][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[726][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[726][MOD] = ActionEntry(SHIFT, 123);
}
void Cego::loadParser27()
{
   _actionMap[726][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[726][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[726][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[726][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[726][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[726][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[726][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[726][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[726][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[726][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[726][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[726][LB] = ActionEntry(SHIFT, 144);
   _actionMap[726][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[726][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[726][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[726][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[726][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[726][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[726][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[726][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[726][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[726][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[726][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[726][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[726][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[726][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[726][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[726][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[726][ObjSpec] = 100;
   _jumpMap[726][Constant] = 99;
   _jumpMap[726][SignedFloat] = 98;
   _jumpMap[726][SignedInt] = 97;
   _jumpMap[726][Attribute] = 96;
   _jumpMap[726][Function] = 95;
   _jumpMap[726][CasePrepare] = 94;
   _jumpMap[726][CaseClause] = 93;
   _jumpMap[726][Factor] = 92;
   _jumpMap[726][Term] = 91;
   _jumpMap[726][Expr] = 772;
   _actionMap[727][SEMICOLON] = ActionEntry(REDUCE, 197);
   _actionMap[727][KSEP] = ActionEntry(REDUCE, 197);
   _actionMap[728][KSEP] = ActionEntry(REDUCE, 198);
   _actionMap[728][RB] = ActionEntry(REDUCE, 198);
   _actionMap[729][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[729][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[729][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[729][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[729][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[729][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[729][ROUND] = ActionEntry(SHIFT, 131);
}
void Cego::loadParser28()
{
   _actionMap[729][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[729][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[729][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[729][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[729][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[729][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[729][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[729][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[729][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[729][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[729][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[729][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[729][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[729][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[729][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[729][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[729][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[729][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[729][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[729][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[729][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[729][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[729][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[729][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[729][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[729][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[729][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[729][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[729][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[729][LB] = ActionEntry(SHIFT, 144);
   _actionMap[729][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[729][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[729][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[729][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[729][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[729][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[729][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[729][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[729][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[729][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[729][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[729][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[729][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[729][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[729][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[729][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[729][ObjSpec] = 100;
   _jumpMap[729][Constant] = 99;
   _jumpMap[729][SignedFloat] = 98;
   _jumpMap[729][SignedInt] = 97;
}
void Cego::loadParser29()
{
   _jumpMap[729][Attribute] = 96;
   _jumpMap[729][Function] = 95;
   _jumpMap[729][CasePrepare] = 94;
   _jumpMap[729][CaseClause] = 93;
   _jumpMap[729][Factor] = 92;
   _jumpMap[729][Term] = 91;
   _jumpMap[729][Expr] = 773;
   _actionMap[730][RB] = ActionEntry(SHIFT, 774);
   _actionMap[731][LEFT] = ActionEntry(REDUCE, 318);
   _actionMap[731][RIGHT] = ActionEntry(REDUCE, 318);
   _actionMap[731][INNER] = ActionEntry(REDUCE, 318);
   _actionMap[731][JOIN] = ActionEntry(REDUCE, 318);
   _actionMap[731][RETURNTOKEN] = ActionEntry(REDUCE, 318);
   _actionMap[731][SEMICOLON] = ActionEntry(REDUCE, 318);
   _actionMap[731][ENDTOKEN] = ActionEntry(REDUCE, 318);
   _actionMap[731][UNION] = ActionEntry(REDUCE, 318);
   _actionMap[731][ROWLIMIT] = ActionEntry(REDUCE, 318);
   _actionMap[731][ORDER] = ActionEntry(REDUCE, 318);
   _actionMap[731][GROUP] = ActionEntry(REDUCE, 318);
   _actionMap[731][WHERE] = ActionEntry(REDUCE, 318);
   _actionMap[731][THEN] = ActionEntry(REDUCE, 318);
   _actionMap[731][AND] = ActionEntry(REDUCE, 318);
   _actionMap[731][OR] = ActionEntry(REDUCE, 318);
   _actionMap[731][RB] = ActionEntry(REDUCE, 318);
   _actionMap[732][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[732][SelectStatement] = 775;
   _actionMap[733][LEFT] = ActionEntry(REDUCE, 320);
   _actionMap[733][RIGHT] = ActionEntry(REDUCE, 320);
   _actionMap[733][INNER] = ActionEntry(REDUCE, 320);
   _actionMap[733][JOIN] = ActionEntry(REDUCE, 320);
   _actionMap[733][RETURNTOKEN] = ActionEntry(REDUCE, 320);
   _actionMap[733][SEMICOLON] = ActionEntry(REDUCE, 320);
   _actionMap[733][ENDTOKEN] = ActionEntry(REDUCE, 320);
   _actionMap[733][UNION] = ActionEntry(REDUCE, 320);
   _actionMap[733][ROWLIMIT] = ActionEntry(REDUCE, 320);
   _actionMap[733][ORDER] = ActionEntry(REDUCE, 320);
   _actionMap[733][GROUP] = ActionEntry(REDUCE, 320);
   _actionMap[733][WHERE] = ActionEntry(REDUCE, 320);
   _actionMap[733][THEN] = ActionEntry(REDUCE, 320);
   _actionMap[733][AND] = ActionEntry(REDUCE, 320);
   _actionMap[733][OR] = ActionEntry(REDUCE, 320);
   _actionMap[733][RB] = ActionEntry(REDUCE, 320);
   _actionMap[734][THEN] = ActionEntry(REDUCE, 312);
   _actionMap[734][LEFT] = ActionEntry(REDUCE, 312);
   _actionMap[734][RIGHT] = ActionEntry(REDUCE, 312);
   _actionMap[734][INNER] = ActionEntry(REDUCE, 312);
   _actionMap[734][JOIN] = ActionEntry(REDUCE, 312);
   _actionMap[734][RETURNTOKEN] = ActionEntry(REDUCE, 312);
   _actionMap[734][SEMICOLON] = ActionEntry(REDUCE, 312);
   _actionMap[734][RB] = ActionEntry(REDUCE, 312);
}
void Cego::loadParser30()
{
   _actionMap[734][ENDTOKEN] = ActionEntry(REDUCE, 312);
   _actionMap[734][UNION] = ActionEntry(REDUCE, 312);
   _actionMap[734][ROWLIMIT] = ActionEntry(REDUCE, 312);
   _actionMap[734][ORDER] = ActionEntry(REDUCE, 312);
   _actionMap[734][GROUP] = ActionEntry(REDUCE, 312);
   _actionMap[734][WHERE] = ActionEntry(REDUCE, 312);
   _actionMap[734][AND] = ActionEntry(REDUCE, 312);
   _actionMap[734][OR] = ActionEntry(REDUCE, 312);
   _actionMap[735][WHEN] = ActionEntry(REDUCE, 359);
   _actionMap[735][ELSE] = ActionEntry(REDUCE, 359);
   _actionMap[735][LEFT] = ActionEntry(REDUCE, 359);
   _actionMap[735][RIGHT] = ActionEntry(REDUCE, 359);
   _actionMap[735][INNER] = ActionEntry(REDUCE, 359);
   _actionMap[735][JOIN] = ActionEntry(REDUCE, 359);
   _actionMap[735][RETURNTOKEN] = ActionEntry(REDUCE, 359);
   _actionMap[735][ORDER] = ActionEntry(REDUCE, 359);
   _actionMap[735][GROUP] = ActionEntry(REDUCE, 359);
   _actionMap[735][WHERE] = ActionEntry(REDUCE, 359);
   _actionMap[735][NULLTOKEN] = ActionEntry(REDUCE, 359);
   _actionMap[735][FROM] = ActionEntry(REDUCE, 359);
   _actionMap[735][AS] = ActionEntry(REDUCE, 359);
   _actionMap[735][END_TOKEN] = ActionEntry(REDUCE, 359);
   _actionMap[735][BEGIN] = ActionEntry(REDUCE, 359);
   _actionMap[735][THEN] = ActionEntry(REDUCE, 359);
   _actionMap[735][OR] = ActionEntry(REDUCE, 359);
   _actionMap[735][AND] = ActionEntry(REDUCE, 359);
   _actionMap[735][INTOK] = ActionEntry(REDUCE, 359);
   _actionMap[735][NOT] = ActionEntry(REDUCE, 359);
   _actionMap[735][BETWEEN] = ActionEntry(REDUCE, 359);
   _actionMap[735][IS] = ActionEntry(REDUCE, 359);
   _actionMap[735][LIKE] = ActionEntry(REDUCE, 359);
   _actionMap[735][MT] = ActionEntry(REDUCE, 359);
   _actionMap[735][LT] = ActionEntry(REDUCE, 359);
   _actionMap[735][NEGATION] = ActionEntry(REDUCE, 359);
   _actionMap[735][EQU] = ActionEntry(REDUCE, 359);
   _actionMap[735][RB] = ActionEntry(REDUCE, 359);
   _actionMap[735][ENDTOKEN] = ActionEntry(REDUCE, 359);
   _actionMap[735][UNION] = ActionEntry(REDUCE, 359);
   _actionMap[735][ROWLIMIT] = ActionEntry(REDUCE, 359);
   _actionMap[735][KSEP] = ActionEntry(REDUCE, 359);
   _actionMap[735][ASC] = ActionEntry(REDUCE, 359);
   _actionMap[735][DESC] = ActionEntry(REDUCE, 359);
   _actionMap[735][SEMICOLON] = ActionEntry(REDUCE, 359);
   _actionMap[735][PLUS] = ActionEntry(REDUCE, 359);
   _actionMap[735][MINUS] = ActionEntry(REDUCE, 359);
   _actionMap[735][DIVISION] = ActionEntry(REDUCE, 359);
   _actionMap[735][STAR] = ActionEntry(REDUCE, 359);
   _actionMap[735][CONCAT] = ActionEntry(REDUCE, 359);
   _actionMap[736][VARREF] = ActionEntry(SHIFT, 776);
   _actionMap[737][WHEN] = ActionEntry(REDUCE, 149);
}
void Cego::loadParser31()
{
   _actionMap[737][ELSE] = ActionEntry(REDUCE, 149);
   _actionMap[737][LEFT] = ActionEntry(REDUCE, 149);
   _actionMap[737][RIGHT] = ActionEntry(REDUCE, 149);
   _actionMap[737][INNER] = ActionEntry(REDUCE, 149);
   _actionMap[737][JOIN] = ActionEntry(REDUCE, 149);
   _actionMap[737][RETURNTOKEN] = ActionEntry(REDUCE, 149);
   _actionMap[737][ORDER] = ActionEntry(REDUCE, 149);
   _actionMap[737][GROUP] = ActionEntry(REDUCE, 149);
   _actionMap[737][WHERE] = ActionEntry(REDUCE, 149);
   _actionMap[737][AS] = ActionEntry(REDUCE, 149);
   _actionMap[737][FROM] = ActionEntry(REDUCE, 149);
   _actionMap[737][END_TOKEN] = ActionEntry(REDUCE, 149);
   _actionMap[737][BEGIN] = ActionEntry(REDUCE, 149);
   _actionMap[737][THEN] = ActionEntry(REDUCE, 149);
   _actionMap[737][OR] = ActionEntry(REDUCE, 149);
   _actionMap[737][AND] = ActionEntry(REDUCE, 149);
   _actionMap[737][LIKE] = ActionEntry(REDUCE, 149);
   _actionMap[737][IS] = ActionEntry(REDUCE, 149);
   _actionMap[737][BETWEEN] = ActionEntry(REDUCE, 149);
   _actionMap[737][NOT] = ActionEntry(REDUCE, 149);
   _actionMap[737][INTOK] = ActionEntry(REDUCE, 149);
   _actionMap[737][EQU] = ActionEntry(REDUCE, 149);
   _actionMap[737][NEGATION] = ActionEntry(REDUCE, 149);
   _actionMap[737][LT] = ActionEntry(REDUCE, 149);
   _actionMap[737][MT] = ActionEntry(REDUCE, 149);
   _actionMap[737][DESC] = ActionEntry(REDUCE, 149);
   _actionMap[737][ASC] = ActionEntry(REDUCE, 149);
   _actionMap[737][KSEP] = ActionEntry(REDUCE, 149);
   _actionMap[737][ROWLIMIT] = ActionEntry(REDUCE, 149);
   _actionMap[737][UNION] = ActionEntry(REDUCE, 149);
   _actionMap[737][ENDTOKEN] = ActionEntry(REDUCE, 149);
   _actionMap[737][RB] = ActionEntry(REDUCE, 149);
   _actionMap[737][SEMICOLON] = ActionEntry(REDUCE, 149);
   _actionMap[737][CONCAT] = ActionEntry(REDUCE, 149);
   _actionMap[737][STAR] = ActionEntry(REDUCE, 149);
   _actionMap[737][DIVISION] = ActionEntry(REDUCE, 149);
   _actionMap[737][MINUS] = ActionEntry(REDUCE, 149);
   _actionMap[737][PLUS] = ActionEntry(REDUCE, 149);
   _actionMap[738][WHEN] = ActionEntry(REDUCE, 301);
   _actionMap[738][ELSE] = ActionEntry(REDUCE, 301);
   _actionMap[738][LEFT] = ActionEntry(REDUCE, 301);
   _actionMap[738][RIGHT] = ActionEntry(REDUCE, 301);
   _actionMap[738][INNER] = ActionEntry(REDUCE, 301);
   _actionMap[738][JOIN] = ActionEntry(REDUCE, 301);
   _actionMap[738][RETURNTOKEN] = ActionEntry(REDUCE, 301);
   _actionMap[738][ORDER] = ActionEntry(REDUCE, 301);
   _actionMap[738][GROUP] = ActionEntry(REDUCE, 301);
   _actionMap[738][WHERE] = ActionEntry(REDUCE, 301);
   _actionMap[738][FROM] = ActionEntry(REDUCE, 301);
   _actionMap[738][AS] = ActionEntry(REDUCE, 301);
}
void Cego::loadParser32()
{
   _actionMap[738][END_TOKEN] = ActionEntry(REDUCE, 301);
   _actionMap[738][BEGIN] = ActionEntry(REDUCE, 301);
   _actionMap[738][THEN] = ActionEntry(REDUCE, 301);
   _actionMap[738][OR] = ActionEntry(REDUCE, 301);
   _actionMap[738][AND] = ActionEntry(REDUCE, 301);
   _actionMap[738][INTOK] = ActionEntry(REDUCE, 301);
   _actionMap[738][NOT] = ActionEntry(REDUCE, 301);
   _actionMap[738][BETWEEN] = ActionEntry(REDUCE, 301);
   _actionMap[738][IS] = ActionEntry(REDUCE, 301);
   _actionMap[738][LIKE] = ActionEntry(REDUCE, 301);
   _actionMap[738][MT] = ActionEntry(REDUCE, 301);
   _actionMap[738][LT] = ActionEntry(REDUCE, 301);
   _actionMap[738][NEGATION] = ActionEntry(REDUCE, 301);
   _actionMap[738][EQU] = ActionEntry(REDUCE, 301);
   _actionMap[738][RB] = ActionEntry(REDUCE, 301);
   _actionMap[738][ENDTOKEN] = ActionEntry(REDUCE, 301);
   _actionMap[738][UNION] = ActionEntry(REDUCE, 301);
   _actionMap[738][ROWLIMIT] = ActionEntry(REDUCE, 301);
   _actionMap[738][KSEP] = ActionEntry(REDUCE, 301);
   _actionMap[738][ASC] = ActionEntry(REDUCE, 301);
   _actionMap[738][DESC] = ActionEntry(REDUCE, 301);
   _actionMap[738][SEMICOLON] = ActionEntry(REDUCE, 301);
   _actionMap[738][PLUS] = ActionEntry(REDUCE, 301);
   _actionMap[738][MINUS] = ActionEntry(REDUCE, 301);
   _actionMap[738][DIVISION] = ActionEntry(REDUCE, 301);
   _actionMap[738][STAR] = ActionEntry(REDUCE, 301);
   _actionMap[738][CONCAT] = ActionEntry(REDUCE, 301);
   _actionMap[739][SEMICOLON] = ActionEntry(REDUCE, 246);
   _actionMap[739][RB] = ActionEntry(REDUCE, 246);
   _actionMap[739][ENDTOKEN] = ActionEntry(REDUCE, 246);
   _actionMap[739][UNION] = ActionEntry(REDUCE, 246);
   _actionMap[739][ROWLIMIT] = ActionEntry(SHIFT, 779);
   _jumpMap[739][NoLimit] = 778;
   _jumpMap[739][LimitOpt] = 777;
   _actionMap[740][ROWLIMIT] = ActionEntry(REDUCE, 234);
   _actionMap[740][UNION] = ActionEntry(REDUCE, 234);
   _actionMap[740][ENDTOKEN] = ActionEntry(REDUCE, 234);
   _actionMap[740][RB] = ActionEntry(REDUCE, 234);
   _actionMap[740][SEMICOLON] = ActionEntry(REDUCE, 234);
   _actionMap[741][BY] = ActionEntry(SHIFT, 780);
   _actionMap[742][IDENTIFIER] = ActionEntry(SHIFT, 783);
   _actionMap[742][QUALIFIEDOBJ] = ActionEntry(SHIFT, 784);
   _actionMap[742][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _jumpMap[742][Attribute] = 782;
   _jumpMap[742][GroupList] = 781;
   _actionMap[743][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[743][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[743][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[743][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[743][RTRIM] = ActionEntry(SHIFT, 132);
}
void Cego::loadParser33()
{
   _actionMap[743][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[743][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[743][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[743][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[743][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[743][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[743][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[743][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[743][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[743][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[743][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[743][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[743][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[743][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[743][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[743][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[743][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[743][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[743][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[743][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[743][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[743][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[743][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[743][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[743][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[743][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[743][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[743][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[743][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[743][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[743][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[743][LB] = ActionEntry(SHIFT, 374);
   _actionMap[743][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[743][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[743][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[743][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[743][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[743][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[743][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[743][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[743][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[743][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[743][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[743][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[743][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[743][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[743][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[743][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[743][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[743][NOT] = ActionEntry(SHIFT, 373);
}
void Cego::loadParser34()
{
   _jumpMap[743][ObjSpec] = 100;
   _jumpMap[743][Constant] = 99;
   _jumpMap[743][SignedFloat] = 98;
   _jumpMap[743][SignedInt] = 97;
   _jumpMap[743][Attribute] = 96;
   _jumpMap[743][QueryPredicate] = 371;
   _jumpMap[743][QueryCondition] = 785;
   _jumpMap[743][Function] = 95;
   _jumpMap[743][CasePrepare] = 94;
   _jumpMap[743][CaseClause] = 93;
   _jumpMap[743][Factor] = 92;
   _jumpMap[743][Term] = 91;
   _jumpMap[743][Expr] = 369;
   _actionMap[744][EXISTS] = ActionEntry(REDUCE, 221);
   _actionMap[744][LB] = ActionEntry(REDUCE, 221);
   _actionMap[744][NOT] = ActionEntry(REDUCE, 221);
   _actionMap[744][VARREF] = ActionEntry(REDUCE, 221);
   _actionMap[744][FETCH] = ActionEntry(REDUCE, 221);
   _actionMap[744][COUNT] = ActionEntry(REDUCE, 221);
   _actionMap[744][SUM] = ActionEntry(REDUCE, 221);
   _actionMap[744][AVG] = ActionEntry(REDUCE, 221);
   _actionMap[744][MIN] = ActionEntry(REDUCE, 221);
   _actionMap[744][MAX] = ActionEntry(REDUCE, 221);
   _actionMap[744][CASE] = ActionEntry(REDUCE, 221);
   _actionMap[744][TRIM] = ActionEntry(REDUCE, 221);
   _actionMap[744][RTRIM] = ActionEntry(REDUCE, 221);
   _actionMap[744][LTRIM] = ActionEntry(REDUCE, 221);
   _actionMap[744][ROUND] = ActionEntry(REDUCE, 221);
   _actionMap[744][DATE2STR] = ActionEntry(REDUCE, 221);
   _actionMap[744][DATE2INT] = ActionEntry(REDUCE, 221);
   _actionMap[744][INT2DATE] = ActionEntry(REDUCE, 221);
   _actionMap[744][LOWER] = ActionEntry(REDUCE, 221);
   _actionMap[744][UPPER] = ActionEntry(REDUCE, 221);
   _actionMap[744][LEFT] = ActionEntry(REDUCE, 221);
   _actionMap[744][RIGHT] = ActionEntry(REDUCE, 221);
   _actionMap[744][GETPOS] = ActionEntry(REDUCE, 221);
   _actionMap[744][SUBSTR] = ActionEntry(REDUCE, 221);
   _actionMap[744][REPLACE] = ActionEntry(REDUCE, 221);
   _actionMap[744][LENGTH] = ActionEntry(REDUCE, 221);
   _actionMap[744][TRUNC] = ActionEntry(REDUCE, 221);
   _actionMap[744][STR2INT] = ActionEntry(REDUCE, 221);
   _actionMap[744][STR2LONG] = ActionEntry(REDUCE, 221);
   _actionMap[744][STR2DATE] = ActionEntry(REDUCE, 221);
   _actionMap[744][RANDSTR] = ActionEntry(REDUCE, 221);
   _actionMap[744][RANDINT] = ActionEntry(REDUCE, 221);
   _actionMap[744][MOD] = ActionEntry(REDUCE, 221);
   _actionMap[744][DIV] = ActionEntry(REDUCE, 221);
   _actionMap[744][POWER] = ActionEntry(REDUCE, 221);
   _actionMap[744][BITAND] = ActionEntry(REDUCE, 221);
   _actionMap[744][BITOR] = ActionEntry(REDUCE, 221);
}
void Cego::loadParser35()
{
   _actionMap[744][BITXOR] = ActionEntry(REDUCE, 221);
   _actionMap[744][BLOBSIZE] = ActionEntry(REDUCE, 221);
   _actionMap[744][NEXTCOUNT] = ActionEntry(REDUCE, 221);
   _actionMap[744][SETCOUNT] = ActionEntry(REDUCE, 221);
   _actionMap[744][IDENTIFIER] = ActionEntry(REDUCE, 221);
   _actionMap[744][QUALIFIEDOBJ] = ActionEntry(REDUCE, 221);
   _actionMap[744][QUALIFIEDTS] = ActionEntry(REDUCE, 221);
   _actionMap[744][QUALIFIEDPRE] = ActionEntry(REDUCE, 221);
   _actionMap[744][STRINGVAL] = ActionEntry(REDUCE, 221);
   _actionMap[744][DATE] = ActionEntry(REDUCE, 221);
   _actionMap[744][SYSDATE] = ActionEntry(REDUCE, 221);
   _actionMap[744][NULLTOKEN] = ActionEntry(REDUCE, 221);
   _actionMap[744][TRUEVAL] = ActionEntry(REDUCE, 221);
   _actionMap[744][FALSEVAL] = ActionEntry(REDUCE, 221);
   _actionMap[744][LAB] = ActionEntry(REDUCE, 221);
   _actionMap[744][FLOATVAL] = ActionEntry(REDUCE, 221);
   _actionMap[744][MINUS] = ActionEntry(REDUCE, 221);
   _actionMap[744][INTVAL] = ActionEntry(REDUCE, 221);
   _actionMap[745][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[745][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[745][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[745][ObjSpec] = 438;
   _jumpMap[745][Table] = 786;
   _actionMap[746][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[746][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[746][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[746][ObjSpec] = 438;
   _jumpMap[746][Table] = 787;
   _actionMap[747][KSEP] = ActionEntry(SHIFT, 788);
   _actionMap[747][SEMICOLON] = ActionEntry(REDUCE, 251);
   _actionMap[748][SEMICOLON] = ActionEntry(REDUCE, 254);
   _actionMap[748][KSEP] = ActionEntry(REDUCE, 254);
   _actionMap[749][EQU] = ActionEntry(SHIFT, 789);
   _actionMap[590][SEMICOLON] = ActionEntry(REDUCE, 260);
   _actionMap[591][COLUMN] = ActionEntry(SHIFT, 451);
   _actionMap[592][ON] = ActionEntry(SHIFT, 690);
   _actionMap[593][SEMICOLON] = ActionEntry(REDUCE, 263);
   _actionMap[593][KSEP] = ActionEntry(REDUCE, 263);
   _actionMap[594][IDENTIFIER] = ActionEntry(SHIFT, 691);
   _actionMap[595][SEMICOLON] = ActionEntry(REDUCE, 262);
   _actionMap[595][KSEP] = ActionEntry(REDUCE, 262);
   _actionMap[596][SEMICOLON] = ActionEntry(REDUCE, 264);
   _actionMap[596][KSEP] = ActionEntry(REDUCE, 264);
   _actionMap[597][TO] = ActionEntry(SHIFT, 692);
   _actionMap[598][IDENTIFIER] = ActionEntry(SHIFT, 693);
   _actionMap[599][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[599][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[599][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[599][KSEP] = ActionEntry(REDUCE, 118);
   _actionMap[599][RB] = ActionEntry(REDUCE, 118);
}
void Cego::loadParser36()
{
   _actionMap[600][ELSE] = ActionEntry(REDUCE, 113);
   _actionMap[600][ELSIF] = ActionEntry(REDUCE, 113);
   _actionMap[600][EXCEPTION] = ActionEntry(REDUCE, 113);
   _actionMap[600][END_TOKEN] = ActionEntry(REDUCE, 113);
   _actionMap[601][WHEN] = ActionEntry(SHIFT, 694);
   _actionMap[602][EXCEPTION] = ActionEntry(REDUCE, 91);
   _actionMap[602][END_TOKEN] = ActionEntry(REDUCE, 91);
   _actionMap[602][ELSE] = ActionEntry(REDUCE, 91);
   _actionMap[602][ELSIF] = ActionEntry(REDUCE, 91);
   _actionMap[602][VAR] = ActionEntry(REDUCE, 91);
   _actionMap[602][CURSOR] = ActionEntry(REDUCE, 91);
   _actionMap[602][CLOSE] = ActionEntry(REDUCE, 91);
   _actionMap[602][VARREF] = ActionEntry(REDUCE, 91);
   _actionMap[602][NOOP] = ActionEntry(REDUCE, 91);
   _actionMap[602][THROW] = ActionEntry(REDUCE, 91);
   _actionMap[602][RETURNTOKEN] = ActionEntry(REDUCE, 91);
   _actionMap[602][WHILE] = ActionEntry(REDUCE, 91);
   _actionMap[602][IF] = ActionEntry(REDUCE, 91);
   _actionMap[602][BEGIN] = ActionEntry(REDUCE, 91);
   _actionMap[602][ROLLBACK] = ActionEntry(REDUCE, 91);
   _actionMap[602][COMMIT] = ActionEntry(REDUCE, 91);
   _actionMap[602][START_TOKEN] = ActionEntry(REDUCE, 91);
   _actionMap[602][UPDATE] = ActionEntry(REDUCE, 91);
   _actionMap[602][DELETETOK] = ActionEntry(REDUCE, 91);
   _actionMap[602][INSERT] = ActionEntry(REDUCE, 91);
   _actionMap[602][FETCH] = ActionEntry(REDUCE, 91);
   _actionMap[602][LB] = ActionEntry(REDUCE, 91);
   _actionMap[602][COUNT] = ActionEntry(REDUCE, 91);
   _actionMap[602][SUM] = ActionEntry(REDUCE, 91);
   _actionMap[602][AVG] = ActionEntry(REDUCE, 91);
   _actionMap[602][MIN] = ActionEntry(REDUCE, 91);
   _actionMap[602][MAX] = ActionEntry(REDUCE, 91);
   _actionMap[602][CASE] = ActionEntry(REDUCE, 91);
   _actionMap[602][TRIM] = ActionEntry(REDUCE, 91);
   _actionMap[602][RTRIM] = ActionEntry(REDUCE, 91);
   _actionMap[602][LTRIM] = ActionEntry(REDUCE, 91);
   _actionMap[602][ROUND] = ActionEntry(REDUCE, 91);
   _actionMap[602][DATE2STR] = ActionEntry(REDUCE, 91);
   _actionMap[602][DATE2INT] = ActionEntry(REDUCE, 91);
   _actionMap[602][INT2DATE] = ActionEntry(REDUCE, 91);
   _actionMap[602][LOWER] = ActionEntry(REDUCE, 91);
   _actionMap[602][UPPER] = ActionEntry(REDUCE, 91);
   _actionMap[602][LEFT] = ActionEntry(REDUCE, 91);
   _actionMap[602][RIGHT] = ActionEntry(REDUCE, 91);
   _actionMap[602][GETPOS] = ActionEntry(REDUCE, 91);
   _actionMap[602][SUBSTR] = ActionEntry(REDUCE, 91);
   _actionMap[602][REPLACE] = ActionEntry(REDUCE, 91);
   _actionMap[602][LENGTH] = ActionEntry(REDUCE, 91);
   _actionMap[602][TRUNC] = ActionEntry(REDUCE, 91);
   _actionMap[602][STR2INT] = ActionEntry(REDUCE, 91);
}
void Cego::loadParser37()
{
   _actionMap[602][STR2LONG] = ActionEntry(REDUCE, 91);
   _actionMap[602][STR2DATE] = ActionEntry(REDUCE, 91);
   _actionMap[602][RANDSTR] = ActionEntry(REDUCE, 91);
   _actionMap[602][RANDINT] = ActionEntry(REDUCE, 91);
   _actionMap[602][MOD] = ActionEntry(REDUCE, 91);
   _actionMap[602][DIV] = ActionEntry(REDUCE, 91);
   _actionMap[602][POWER] = ActionEntry(REDUCE, 91);
   _actionMap[602][BITAND] = ActionEntry(REDUCE, 91);
   _actionMap[602][BITOR] = ActionEntry(REDUCE, 91);
   _actionMap[602][BITXOR] = ActionEntry(REDUCE, 91);
   _actionMap[602][BLOBSIZE] = ActionEntry(REDUCE, 91);
   _actionMap[602][NEXTCOUNT] = ActionEntry(REDUCE, 91);
   _actionMap[602][SETCOUNT] = ActionEntry(REDUCE, 91);
   _actionMap[602][IDENTIFIER] = ActionEntry(REDUCE, 91);
   _actionMap[602][QUALIFIEDOBJ] = ActionEntry(REDUCE, 91);
   _actionMap[602][QUALIFIEDTS] = ActionEntry(REDUCE, 91);
   _actionMap[602][QUALIFIEDPRE] = ActionEntry(REDUCE, 91);
   _actionMap[602][STRINGVAL] = ActionEntry(REDUCE, 91);
   _actionMap[602][DATE] = ActionEntry(REDUCE, 91);
   _actionMap[602][SYSDATE] = ActionEntry(REDUCE, 91);
   _actionMap[602][NULLTOKEN] = ActionEntry(REDUCE, 91);
   _actionMap[602][TRUEVAL] = ActionEntry(REDUCE, 91);
   _actionMap[602][FALSEVAL] = ActionEntry(REDUCE, 91);
   _actionMap[602][LAB] = ActionEntry(REDUCE, 91);
   _actionMap[602][FLOATVAL] = ActionEntry(REDUCE, 91);
   _actionMap[602][MINUS] = ActionEntry(REDUCE, 91);
   _actionMap[602][INTVAL] = ActionEntry(REDUCE, 91);
   _actionMap[603][SEMICOLON] = ActionEntry(REDUCE, 111);
   _actionMap[604][END_TOKEN] = ActionEntry(SHIFT, 607);
   _actionMap[605][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[605][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[605][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[605][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[605][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[605][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[605][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[605][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[605][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[605][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[605][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[605][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[605][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[605][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[605][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[605][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[605][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[605][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[605][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[605][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[605][STR2LONG] = ActionEntry(SHIFT, 138);
}
void Cego::loadParser38()
{
   _actionMap[605][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[605][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[605][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[605][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[605][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[605][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[605][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[605][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[605][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[605][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[605][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[605][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[605][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[605][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[605][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[605][LB] = ActionEntry(SHIFT, 144);
   _actionMap[605][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[605][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[605][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[605][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[605][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[605][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[605][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[605][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[605][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[605][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[605][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[605][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[605][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[605][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[605][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[605][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[605][IF] = ActionEntry(SHIFT, 338);
   _actionMap[605][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[605][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[605][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[605][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[605][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[605][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[605][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[605][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[605][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[605][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[605][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[605][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[605][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[605][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[605][ObjSpec] = 100;
   _jumpMap[605][Constant] = 99;
   _jumpMap[605][SignedFloat] = 98;
}
void Cego::loadParser39()
{
   _jumpMap[605][SignedInt] = 97;
   _jumpMap[605][Attribute] = 96;
   _jumpMap[605][Function] = 95;
   _jumpMap[605][DeleteStatement] = 334;
   _jumpMap[605][UpdateStatement] = 333;
   _jumpMap[605][InsertStatement] = 332;
   _jumpMap[605][RollbackStatement] = 331;
   _jumpMap[605][CommitStatement] = 330;
   _jumpMap[605][StartStatement] = 329;
   _jumpMap[605][CasePrepare] = 94;
   _jumpMap[605][CaseClause] = 93;
   _jumpMap[605][Factor] = 92;
   _jumpMap[605][Term] = 91;
   _jumpMap[605][Expr] = 328;
   _jumpMap[605][ProcStatement] = 327;
   _jumpMap[605][ProcIfPart] = 326;
   _jumpMap[605][ProcBlockStart] = 325;
   _jumpMap[605][ProcStatementList] = 324;
   _jumpMap[605][ProcStmtBlock] = 695;
   _actionMap[606][VAR] = ActionEntry(REDUCE, 128);
   _actionMap[606][CURSOR] = ActionEntry(REDUCE, 128);
   _actionMap[606][CLOSE] = ActionEntry(REDUCE, 128);
   _actionMap[606][VARREF] = ActionEntry(REDUCE, 128);
   _actionMap[606][NOOP] = ActionEntry(REDUCE, 128);
   _actionMap[606][THROW] = ActionEntry(REDUCE, 128);
   _actionMap[606][RETURNTOKEN] = ActionEntry(REDUCE, 128);
   _actionMap[606][WHILE] = ActionEntry(REDUCE, 128);
   _actionMap[606][IF] = ActionEntry(REDUCE, 128);
   _actionMap[606][BEGIN] = ActionEntry(REDUCE, 128);
   _actionMap[606][ROLLBACK] = ActionEntry(REDUCE, 128);
   _actionMap[606][COMMIT] = ActionEntry(REDUCE, 128);
   _actionMap[606][START_TOKEN] = ActionEntry(REDUCE, 128);
   _actionMap[606][UPDATE] = ActionEntry(REDUCE, 128);
   _actionMap[606][DELETETOK] = ActionEntry(REDUCE, 128);
   _actionMap[606][INSERT] = ActionEntry(REDUCE, 128);
   _actionMap[606][FETCH] = ActionEntry(REDUCE, 128);
   _actionMap[606][LB] = ActionEntry(REDUCE, 128);
   _actionMap[606][COUNT] = ActionEntry(REDUCE, 128);
   _actionMap[606][SUM] = ActionEntry(REDUCE, 128);
   _actionMap[606][AVG] = ActionEntry(REDUCE, 128);
   _actionMap[606][MIN] = ActionEntry(REDUCE, 128);
   _actionMap[606][MAX] = ActionEntry(REDUCE, 128);
   _actionMap[606][CASE] = ActionEntry(REDUCE, 128);
   _actionMap[606][TRIM] = ActionEntry(REDUCE, 128);
   _actionMap[606][RTRIM] = ActionEntry(REDUCE, 128);
   _actionMap[606][LTRIM] = ActionEntry(REDUCE, 128);
   _actionMap[606][ROUND] = ActionEntry(REDUCE, 128);
   _actionMap[606][DATE2STR] = ActionEntry(REDUCE, 128);
   _actionMap[606][DATE2INT] = ActionEntry(REDUCE, 128);
   _actionMap[606][INT2DATE] = ActionEntry(REDUCE, 128);
}
void Cego::loadParser40()
{
   _actionMap[606][LOWER] = ActionEntry(REDUCE, 128);
   _actionMap[606][UPPER] = ActionEntry(REDUCE, 128);
   _actionMap[606][LEFT] = ActionEntry(REDUCE, 128);
   _actionMap[606][RIGHT] = ActionEntry(REDUCE, 128);
   _actionMap[606][GETPOS] = ActionEntry(REDUCE, 128);
   _actionMap[606][SUBSTR] = ActionEntry(REDUCE, 128);
   _actionMap[606][REPLACE] = ActionEntry(REDUCE, 128);
   _actionMap[606][LENGTH] = ActionEntry(REDUCE, 128);
   _actionMap[606][TRUNC] = ActionEntry(REDUCE, 128);
   _actionMap[606][STR2INT] = ActionEntry(REDUCE, 128);
   _actionMap[606][STR2LONG] = ActionEntry(REDUCE, 128);
   _actionMap[606][STR2DATE] = ActionEntry(REDUCE, 128);
   _actionMap[606][RANDSTR] = ActionEntry(REDUCE, 128);
   _actionMap[606][RANDINT] = ActionEntry(REDUCE, 128);
   _actionMap[606][MOD] = ActionEntry(REDUCE, 128);
   _actionMap[606][DIV] = ActionEntry(REDUCE, 128);
   _actionMap[606][POWER] = ActionEntry(REDUCE, 128);
   _actionMap[606][BITAND] = ActionEntry(REDUCE, 128);
   _actionMap[606][BITOR] = ActionEntry(REDUCE, 128);
   _actionMap[606][BITXOR] = ActionEntry(REDUCE, 128);
   _actionMap[606][BLOBSIZE] = ActionEntry(REDUCE, 128);
   _actionMap[606][NEXTCOUNT] = ActionEntry(REDUCE, 128);
   _actionMap[606][SETCOUNT] = ActionEntry(REDUCE, 128);
   _actionMap[606][IDENTIFIER] = ActionEntry(REDUCE, 128);
   _actionMap[606][QUALIFIEDOBJ] = ActionEntry(REDUCE, 128);
   _actionMap[606][QUALIFIEDTS] = ActionEntry(REDUCE, 128);
   _actionMap[606][QUALIFIEDPRE] = ActionEntry(REDUCE, 128);
   _actionMap[606][STRINGVAL] = ActionEntry(REDUCE, 128);
   _actionMap[606][DATE] = ActionEntry(REDUCE, 128);
   _actionMap[606][SYSDATE] = ActionEntry(REDUCE, 128);
   _actionMap[606][NULLTOKEN] = ActionEntry(REDUCE, 128);
   _actionMap[606][TRUEVAL] = ActionEntry(REDUCE, 128);
   _actionMap[606][FALSEVAL] = ActionEntry(REDUCE, 128);
   _actionMap[606][LAB] = ActionEntry(REDUCE, 128);
   _actionMap[606][FLOATVAL] = ActionEntry(REDUCE, 128);
   _actionMap[606][MINUS] = ActionEntry(REDUCE, 128);
   _actionMap[606][INTVAL] = ActionEntry(REDUCE, 128);
   _actionMap[607][SEMICOLON] = ActionEntry(REDUCE, 121);
   _actionMap[608][END_TOKEN] = ActionEntry(REDUCE, 123);
   _actionMap[608][ELSE] = ActionEntry(REDUCE, 123);
   _actionMap[609][THEN] = ActionEntry(SHIFT, 696);
   _actionMap[610][OR] = ActionEntry(SHIFT, 614);
   _actionMap[610][AND] = ActionEntry(SHIFT, 613);
   _actionMap[610][THEN] = ActionEntry(REDUCE, 130);
   _actionMap[611][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[611][SelectStatement] = 697;
   _actionMap[612][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[612][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[612][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[612][TRIM] = ActionEntry(SHIFT, 140);
}
void Cego::loadParser41()
{
   _actionMap[612][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[612][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[612][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[612][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[612][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[612][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[612][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[612][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[612][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[612][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[612][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[612][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[612][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[612][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[612][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[612][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[612][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[612][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[612][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[612][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[612][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[612][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[612][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[612][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[612][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[612][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[612][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[612][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[612][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[612][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[612][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[612][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[612][LB] = ActionEntry(SHIFT, 144);
   _actionMap[612][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[612][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[612][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[612][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[612][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[612][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[612][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[612][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[612][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[612][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[612][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[612][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[612][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[612][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[612][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[612][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[612][IF] = ActionEntry(SHIFT, 338);
}
void Cego::loadParser42()
{
   _actionMap[612][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[612][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[612][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[612][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[612][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[612][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[612][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[612][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[612][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[612][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[612][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[612][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[612][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[612][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[612][ObjSpec] = 100;
   _jumpMap[612][Constant] = 99;
   _jumpMap[612][SignedFloat] = 98;
   _jumpMap[612][SignedInt] = 97;
   _jumpMap[612][Attribute] = 96;
   _jumpMap[612][Function] = 95;
   _jumpMap[612][DeleteStatement] = 334;
   _jumpMap[612][UpdateStatement] = 333;
   _jumpMap[612][InsertStatement] = 332;
   _jumpMap[612][RollbackStatement] = 331;
   _jumpMap[612][CommitStatement] = 330;
   _jumpMap[612][StartStatement] = 329;
   _jumpMap[612][CasePrepare] = 94;
   _jumpMap[612][CaseClause] = 93;
   _jumpMap[612][Factor] = 92;
   _jumpMap[612][Term] = 91;
   _jumpMap[612][Expr] = 328;
   _jumpMap[612][ProcStatement] = 327;
   _jumpMap[612][ProcIfPart] = 326;
   _jumpMap[612][ProcBlockStart] = 325;
   _jumpMap[612][ProcStatementList] = 324;
   _jumpMap[612][ProcStmtBlock] = 698;
   _actionMap[613][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[613][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[613][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[613][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[613][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[613][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[613][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[613][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[613][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[613][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[613][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[613][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[613][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[613][RIGHT] = ActionEntry(SHIFT, 130);
}
void Cego::loadParser43()
{
   _actionMap[613][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[613][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[613][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[613][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[613][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[613][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[613][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[613][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[613][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[613][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[613][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[613][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[613][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[613][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[613][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[613][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[613][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[613][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[613][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[613][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[613][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[613][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[613][LB] = ActionEntry(SHIFT, 472);
   _actionMap[613][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[613][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[613][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[613][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[613][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[613][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[613][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[613][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[613][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[613][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[613][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[613][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[613][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[613][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[613][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[613][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[613][ObjSpec] = 100;
   _jumpMap[613][Constant] = 99;
   _jumpMap[613][SignedFloat] = 98;
   _jumpMap[613][SignedInt] = 97;
   _jumpMap[613][Attribute] = 96;
   _jumpMap[613][Function] = 95;
   _jumpMap[613][CasePrepare] = 94;
   _jumpMap[613][CaseClause] = 93;
   _jumpMap[613][Factor] = 92;
   _jumpMap[613][Term] = 91;
   _jumpMap[613][Expr] = 471;
}
void Cego::loadParser44()
{
   _jumpMap[613][ProcPredicate] = 699;
   _actionMap[614][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[614][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[614][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[614][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[614][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[614][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[614][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[614][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[614][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[614][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[614][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[614][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[614][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[614][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[614][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[614][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[614][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[614][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[614][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[614][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[614][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[614][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[614][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[614][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[614][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[614][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[614][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[614][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[614][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[614][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[614][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[614][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[614][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[614][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[614][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[614][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[614][LB] = ActionEntry(SHIFT, 472);
   _actionMap[614][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[614][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[614][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[614][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[614][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[614][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[614][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[614][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[614][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[614][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[614][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[614][COUNT] = ActionEntry(SHIFT, 108);
}
void Cego::loadParser45()
{
   _actionMap[614][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[614][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[614][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[614][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[614][ObjSpec] = 100;
   _jumpMap[614][Constant] = 99;
   _jumpMap[614][SignedFloat] = 98;
   _jumpMap[614][SignedInt] = 97;
   _jumpMap[614][Attribute] = 96;
   _jumpMap[614][Function] = 95;
   _jumpMap[614][CasePrepare] = 94;
   _jumpMap[614][CaseClause] = 93;
   _jumpMap[614][Factor] = 92;
   _jumpMap[614][Term] = 91;
   _jumpMap[614][Expr] = 471;
   _jumpMap[614][ProcPredicate] = 700;
   _actionMap[615][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[615][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[615][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[615][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[615][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[615][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[615][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[615][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[615][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[615][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[615][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[615][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[615][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[615][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[615][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[615][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[615][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[615][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[615][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[615][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[615][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[615][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[615][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[615][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[615][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[615][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[615][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[615][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[615][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[615][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[615][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[615][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[615][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[615][IDENTIFIER] = ActionEntry(SHIFT, 149);
}
void Cego::loadParser46()
{
   _actionMap[615][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[615][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[615][LB] = ActionEntry(SHIFT, 144);
   _actionMap[615][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[615][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[615][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[615][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[615][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[615][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[615][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[615][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[615][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[615][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[615][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[615][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[615][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[615][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[615][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[615][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[615][ObjSpec] = 100;
   _jumpMap[615][Constant] = 99;
   _jumpMap[615][SignedFloat] = 98;
   _jumpMap[615][SignedInt] = 97;
   _jumpMap[615][Attribute] = 96;
   _jumpMap[615][Function] = 95;
   _jumpMap[615][CasePrepare] = 94;
   _jumpMap[615][CaseClause] = 93;
   _jumpMap[615][Factor] = 92;
   _jumpMap[615][Term] = 91;
   _jumpMap[615][Expr] = 701;
   _actionMap[616][NOT] = ActionEntry(SHIFT, 702);
   _actionMap[616][NULLTOKEN] = ActionEntry(SHIFT, 703);
   _actionMap[617][RB] = ActionEntry(SHIFT, 704);
   _actionMap[617][OR] = ActionEntry(SHIFT, 614);
   _actionMap[617][AND] = ActionEntry(SHIFT, 613);
   _actionMap[618][RB] = ActionEntry(SHIFT, 418);
   _actionMap[618][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[618][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[618][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[618][IS] = ActionEntry(SHIFT, 616);
   _actionMap[618][EQU] = ActionEntry(SHIFT, 506);
   _actionMap[618][NEGATION] = ActionEntry(SHIFT, 509);
   _actionMap[618][LT] = ActionEntry(SHIFT, 507);
   _actionMap[618][MT] = ActionEntry(SHIFT, 508);
   _jumpMap[618][Comparison] = 615;
   _actionMap[619][SEMICOLON] = ActionEntry(REDUCE, 101);
   _actionMap[619][EQU] = ActionEntry(SHIFT, 707);
   _jumpMap[619][ProcNoAssignment] = 706;
   _jumpMap[619][ProcInitialAssignment] = 705;
   _actionMap[620][LB] = ActionEntry(SHIFT, 708);
}
void Cego::loadParser47()
{
   _actionMap[621][BEGIN] = ActionEntry(REDUCE, 335);
   _actionMap[621][DEFAULT] = ActionEntry(REDUCE, 335);
   _actionMap[621][NULLTOKEN] = ActionEntry(REDUCE, 335);
   _actionMap[621][NOT] = ActionEntry(REDUCE, 335);
   _actionMap[621][KSEP] = ActionEntry(REDUCE, 335);
   _actionMap[621][RB] = ActionEntry(REDUCE, 335);
   _actionMap[621][EQU] = ActionEntry(REDUCE, 335);
   _actionMap[621][SEMICOLON] = ActionEntry(REDUCE, 335);
   _actionMap[622][BEGIN] = ActionEntry(REDUCE, 327);
   _actionMap[622][DEFAULT] = ActionEntry(REDUCE, 327);
   _actionMap[622][NULLTOKEN] = ActionEntry(REDUCE, 327);
   _actionMap[622][NOT] = ActionEntry(REDUCE, 327);
   _actionMap[622][KSEP] = ActionEntry(REDUCE, 327);
   _actionMap[622][RB] = ActionEntry(REDUCE, 327);
   _actionMap[622][EQU] = ActionEntry(REDUCE, 327);
   _actionMap[622][SEMICOLON] = ActionEntry(REDUCE, 327);
   _actionMap[623][BEGIN] = ActionEntry(REDUCE, 326);
   _actionMap[623][DEFAULT] = ActionEntry(REDUCE, 326);
   _actionMap[623][NULLTOKEN] = ActionEntry(REDUCE, 326);
   _actionMap[623][NOT] = ActionEntry(REDUCE, 326);
   _actionMap[623][KSEP] = ActionEntry(REDUCE, 326);
   _actionMap[623][RB] = ActionEntry(REDUCE, 326);
   _actionMap[623][EQU] = ActionEntry(REDUCE, 326);
   _actionMap[623][SEMICOLON] = ActionEntry(REDUCE, 326);
   _actionMap[624][LB] = ActionEntry(SHIFT, 709);
   _actionMap[625][BEGIN] = ActionEntry(REDUCE, 330);
   _actionMap[625][DEFAULT] = ActionEntry(REDUCE, 330);
   _actionMap[625][NULLTOKEN] = ActionEntry(REDUCE, 330);
   _actionMap[625][NOT] = ActionEntry(REDUCE, 330);
   _actionMap[625][KSEP] = ActionEntry(REDUCE, 330);
   _actionMap[625][RB] = ActionEntry(REDUCE, 330);
   _actionMap[625][EQU] = ActionEntry(REDUCE, 330);
   _actionMap[625][SEMICOLON] = ActionEntry(REDUCE, 330);
   _actionMap[626][LB] = ActionEntry(SHIFT, 710);
   _actionMap[627][BEGIN] = ActionEntry(REDUCE, 329);
   _actionMap[627][DEFAULT] = ActionEntry(REDUCE, 329);
   _actionMap[627][NULLTOKEN] = ActionEntry(REDUCE, 329);
   _actionMap[627][NOT] = ActionEntry(REDUCE, 329);
   _actionMap[627][KSEP] = ActionEntry(REDUCE, 329);
   _actionMap[627][RB] = ActionEntry(REDUCE, 329);
   _actionMap[627][EQU] = ActionEntry(REDUCE, 329);
   _actionMap[627][SEMICOLON] = ActionEntry(REDUCE, 329);
   _actionMap[628][BEGIN] = ActionEntry(REDUCE, 323);
   _actionMap[628][DEFAULT] = ActionEntry(REDUCE, 323);
   _actionMap[628][NULLTOKEN] = ActionEntry(REDUCE, 323);
   _actionMap[628][NOT] = ActionEntry(REDUCE, 323);
   _actionMap[628][KSEP] = ActionEntry(REDUCE, 323);
   _actionMap[628][RB] = ActionEntry(REDUCE, 323);
   _actionMap[628][EQU] = ActionEntry(REDUCE, 323);
   _actionMap[628][SEMICOLON] = ActionEntry(REDUCE, 323);
}
void Cego::loadParser48()
{
   _actionMap[629][BEGIN] = ActionEntry(REDUCE, 324);
   _actionMap[629][DEFAULT] = ActionEntry(REDUCE, 324);
   _actionMap[629][NULLTOKEN] = ActionEntry(REDUCE, 324);
   _actionMap[629][NOT] = ActionEntry(REDUCE, 324);
   _actionMap[629][KSEP] = ActionEntry(REDUCE, 324);
   _actionMap[629][RB] = ActionEntry(REDUCE, 324);
   _actionMap[629][EQU] = ActionEntry(REDUCE, 324);
   _actionMap[629][SEMICOLON] = ActionEntry(REDUCE, 324);
   _actionMap[630][BEGIN] = ActionEntry(REDUCE, 331);
   _actionMap[630][DEFAULT] = ActionEntry(REDUCE, 331);
   _actionMap[630][NULLTOKEN] = ActionEntry(REDUCE, 331);
   _actionMap[630][NOT] = ActionEntry(REDUCE, 331);
   _actionMap[630][KSEP] = ActionEntry(REDUCE, 331);
   _actionMap[630][RB] = ActionEntry(REDUCE, 331);
   _actionMap[630][EQU] = ActionEntry(REDUCE, 331);
   _actionMap[630][SEMICOLON] = ActionEntry(REDUCE, 331);
   _actionMap[631][LB] = ActionEntry(SHIFT, 711);
   _actionMap[632][BEGIN] = ActionEntry(REDUCE, 332);
   _actionMap[632][DEFAULT] = ActionEntry(REDUCE, 332);
   _actionMap[632][NULLTOKEN] = ActionEntry(REDUCE, 332);
   _actionMap[632][NOT] = ActionEntry(REDUCE, 332);
   _actionMap[632][KSEP] = ActionEntry(REDUCE, 332);
   _actionMap[632][RB] = ActionEntry(REDUCE, 332);
   _actionMap[632][EQU] = ActionEntry(REDUCE, 332);
   _actionMap[632][SEMICOLON] = ActionEntry(REDUCE, 332);
   _actionMap[633][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[633][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[633][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[633][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[633][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[633][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[633][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[633][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[633][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[633][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[633][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[633][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[633][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[633][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[633][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[633][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[633][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[633][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[633][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[633][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[633][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[633][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[633][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[633][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[633][MOD] = ActionEntry(SHIFT, 123);
}
void Cego::loadParser49()
{
   _actionMap[633][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[633][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[633][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[633][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[633][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[633][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[633][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[633][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[633][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[633][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[633][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[633][LB] = ActionEntry(SHIFT, 144);
   _actionMap[633][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[633][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[633][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[633][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[633][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[633][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[633][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[633][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[633][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[633][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[633][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[633][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[633][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[633][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[633][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[633][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[633][IF] = ActionEntry(SHIFT, 338);
   _actionMap[633][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[633][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[633][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[633][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[633][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[633][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[633][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[633][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[633][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[633][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[633][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[633][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[633][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[633][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[633][ObjSpec] = 100;
   _jumpMap[633][Constant] = 99;
   _jumpMap[633][SignedFloat] = 98;
   _jumpMap[633][SignedInt] = 97;
   _jumpMap[633][Attribute] = 96;
   _jumpMap[633][Function] = 95;
   _jumpMap[633][DeleteStatement] = 334;
}
void Cego::loadParser50()
{
   _jumpMap[633][UpdateStatement] = 333;
   _jumpMap[633][InsertStatement] = 332;
   _jumpMap[633][RollbackStatement] = 331;
   _jumpMap[633][CommitStatement] = 330;
   _jumpMap[633][StartStatement] = 329;
   _jumpMap[633][CasePrepare] = 94;
   _jumpMap[633][CaseClause] = 93;
   _jumpMap[633][Factor] = 92;
   _jumpMap[633][Term] = 91;
   _jumpMap[633][Expr] = 328;
   _jumpMap[633][ProcStatement] = 327;
   _jumpMap[633][ProcIfPart] = 326;
   _jumpMap[633][ProcBlockStart] = 325;
   _jumpMap[633][ProcStatementList] = 324;
   _jumpMap[633][ProcStmtBlock] = 712;
   _actionMap[634][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[634][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[634][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[634][SEMICOLON] = ActionEntry(REDUCE, 96);
   _actionMap[635][LB] = ActionEntry(SHIFT, 713);
   _actionMap[636][IDENTIFIER] = ActionEntry(SHIFT, 716);
   _jumpMap[636][SimpleAttr] = 715;
   _jumpMap[636][SimpleAttrList] = 714;
   _actionMap[637][IDENTIFIER] = ActionEntry(SHIFT, 485);
   _jumpMap[637][ProcArg] = 717;
   _actionMap[638][BEGIN] = ActionEntry(REDUCE, 80);
   _actionMap[639][INT] = ActionEntry(SHIFT, 628);
   _actionMap[639][LONG] = ActionEntry(SHIFT, 629);
   _actionMap[639][STRING] = ActionEntry(SHIFT, 631);
   _actionMap[639][DATETIME] = ActionEntry(SHIFT, 623);
   _actionMap[639][BOOL] = ActionEntry(SHIFT, 622);
   _actionMap[639][BIGINT] = ActionEntry(SHIFT, 620);
   _actionMap[639][FLOAT] = ActionEntry(SHIFT, 627);
   _actionMap[639][DOUBLE] = ActionEntry(SHIFT, 625);
   _actionMap[639][SMALLINT] = ActionEntry(SHIFT, 630);
   _actionMap[639][TINYINT] = ActionEntry(SHIFT, 632);
   _actionMap[639][DECIMAL] = ActionEntry(SHIFT, 624);
   _actionMap[639][FIXED] = ActionEntry(SHIFT, 626);
   _actionMap[639][BLOB] = ActionEntry(SHIFT, 621);
   _jumpMap[639][DataTypeProd] = 718;
   _actionMap[640][INT] = ActionEntry(SHIFT, 628);
   _actionMap[640][LONG] = ActionEntry(SHIFT, 629);
   _actionMap[640][STRING] = ActionEntry(SHIFT, 631);
   _actionMap[640][DATETIME] = ActionEntry(SHIFT, 623);
   _actionMap[640][BOOL] = ActionEntry(SHIFT, 622);
   _actionMap[640][BIGINT] = ActionEntry(SHIFT, 620);
   _actionMap[640][FLOAT] = ActionEntry(SHIFT, 627);
   _actionMap[640][DOUBLE] = ActionEntry(SHIFT, 625);
   _actionMap[640][SMALLINT] = ActionEntry(SHIFT, 630);
   _actionMap[640][TINYINT] = ActionEntry(SHIFT, 632);
}
void Cego::loadParser51()
{
   _actionMap[640][DECIMAL] = ActionEntry(SHIFT, 624);
   _actionMap[640][FIXED] = ActionEntry(SHIFT, 626);
   _actionMap[640][BLOB] = ActionEntry(SHIFT, 621);
   _jumpMap[640][DataTypeProd] = 719;
   _actionMap[641][INT] = ActionEntry(SHIFT, 628);
   _actionMap[641][LONG] = ActionEntry(SHIFT, 629);
   _actionMap[641][STRING] = ActionEntry(SHIFT, 631);
   _actionMap[641][DATETIME] = ActionEntry(SHIFT, 623);
   _actionMap[641][BOOL] = ActionEntry(SHIFT, 622);
   _actionMap[641][BIGINT] = ActionEntry(SHIFT, 620);
   _actionMap[641][FLOAT] = ActionEntry(SHIFT, 627);
   _actionMap[641][DOUBLE] = ActionEntry(SHIFT, 625);
   _actionMap[641][SMALLINT] = ActionEntry(SHIFT, 630);
   _actionMap[641][TINYINT] = ActionEntry(SHIFT, 632);
   _actionMap[641][DECIMAL] = ActionEntry(SHIFT, 624);
   _actionMap[641][FIXED] = ActionEntry(SHIFT, 626);
   _actionMap[641][BLOB] = ActionEntry(SHIFT, 621);
   _jumpMap[641][DataTypeProd] = 720;
   _actionMap[642][IDENTIFIER] = ActionEntry(SHIFT, 490);
   _actionMap[642][PRIMARY] = ActionEntry(SHIFT, 489);
   _jumpMap[642][ColumnDesc] = 488;
   _jumpMap[642][KeyColumn] = 721;
   _actionMap[643][SEMICOLON] = ActionEntry(REDUCE, 54);
   _actionMap[644][KSEP] = ActionEntry(REDUCE, 170);
   _actionMap[644][RB] = ActionEntry(REDUCE, 170);
   _actionMap[645][RB] = ActionEntry(REDUCE, 179);
   _actionMap[645][SEMICOLON] = ActionEntry(REDUCE, 179);
   _actionMap[645][KSEP] = ActionEntry(REDUCE, 179);
   _actionMap[645][NOT] = ActionEntry(REDUCE, 179);
   _actionMap[645][NULLTOKEN] = ActionEntry(REDUCE, 179);
   _actionMap[645][DEFAULT] = ActionEntry(SHIFT, 724);
   _jumpMap[645][DefaultDefOpt] = 723;
   _jumpMap[645][DefaultOpt] = 722;
   _actionMap[646][LB] = ActionEntry(SHIFT, 495);
   _jumpMap[646][InsertValueSpec] = 725;
   _actionMap[647][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[647][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[647][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[647][KSEP] = ActionEntry(REDUCE, 201);
   _actionMap[647][RB] = ActionEntry(REDUCE, 201);
   _actionMap[648][RB] = ActionEntry(SHIFT, 727);
   _actionMap[648][KSEP] = ActionEntry(SHIFT, 726);
   _actionMap[649][IDENTIFIER] = ActionEntry(SHIFT, 728);
   _actionMap[650][SELECT] = ActionEntry(REDUCE, 192);
   _actionMap[650][VALUES] = ActionEntry(REDUCE, 192);
   _actionMap[651][WHEN] = ActionEntry(REDUCE, 161);
   _actionMap[651][ELSE] = ActionEntry(REDUCE, 161);
   _actionMap[651][LEFT] = ActionEntry(REDUCE, 161);
   _actionMap[651][RIGHT] = ActionEntry(REDUCE, 161);
   _actionMap[651][INNER] = ActionEntry(REDUCE, 161);
}
void Cego::loadParser52()
{
   _actionMap[651][JOIN] = ActionEntry(REDUCE, 161);
   _actionMap[651][RETURNTOKEN] = ActionEntry(REDUCE, 161);
   _actionMap[651][ORDER] = ActionEntry(REDUCE, 161);
   _actionMap[651][GROUP] = ActionEntry(REDUCE, 161);
   _actionMap[651][WHERE] = ActionEntry(REDUCE, 161);
   _actionMap[651][BEGIN] = ActionEntry(REDUCE, 161);
   _actionMap[651][THEN] = ActionEntry(REDUCE, 161);
   _actionMap[651][OR] = ActionEntry(REDUCE, 161);
   _actionMap[651][FROM] = ActionEntry(REDUCE, 161);
   _actionMap[651][AS] = ActionEntry(REDUCE, 161);
   _actionMap[651][END_TOKEN] = ActionEntry(REDUCE, 161);
   _actionMap[651][AND] = ActionEntry(REDUCE, 161);
   _actionMap[651][INTOK] = ActionEntry(REDUCE, 161);
   _actionMap[651][NOT] = ActionEntry(REDUCE, 161);
   _actionMap[651][BETWEEN] = ActionEntry(REDUCE, 161);
   _actionMap[651][IS] = ActionEntry(REDUCE, 161);
   _actionMap[651][LIKE] = ActionEntry(REDUCE, 161);
   _actionMap[651][MT] = ActionEntry(REDUCE, 161);
   _actionMap[651][LT] = ActionEntry(REDUCE, 161);
   _actionMap[651][NEGATION] = ActionEntry(REDUCE, 161);
   _actionMap[651][EQU] = ActionEntry(REDUCE, 161);
   _actionMap[651][RB] = ActionEntry(REDUCE, 161);
   _actionMap[651][ENDTOKEN] = ActionEntry(REDUCE, 161);
   _actionMap[651][UNION] = ActionEntry(REDUCE, 161);
   _actionMap[651][ROWLIMIT] = ActionEntry(REDUCE, 161);
   _actionMap[651][KSEP] = ActionEntry(REDUCE, 161);
   _actionMap[651][ASC] = ActionEntry(REDUCE, 161);
   _actionMap[651][DESC] = ActionEntry(REDUCE, 161);
   _actionMap[651][SEMICOLON] = ActionEntry(REDUCE, 161);
   _actionMap[651][PLUS] = ActionEntry(REDUCE, 161);
   _actionMap[651][MINUS] = ActionEntry(REDUCE, 161);
   _actionMap[651][DIVISION] = ActionEntry(REDUCE, 161);
   _actionMap[651][STAR] = ActionEntry(REDUCE, 161);
   _actionMap[651][CONCAT] = ActionEntry(REDUCE, 161);
   _actionMap[652][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[652][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[652][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[652][LEFT] = ActionEntry(REDUCE, 315);
   _actionMap[652][RIGHT] = ActionEntry(REDUCE, 315);
   _actionMap[652][INNER] = ActionEntry(REDUCE, 315);
   _actionMap[652][JOIN] = ActionEntry(REDUCE, 315);
   _actionMap[652][RETURNTOKEN] = ActionEntry(REDUCE, 315);
   _actionMap[652][SEMICOLON] = ActionEntry(REDUCE, 315);
   _actionMap[652][ENDTOKEN] = ActionEntry(REDUCE, 315);
   _actionMap[652][UNION] = ActionEntry(REDUCE, 315);
   _actionMap[652][ROWLIMIT] = ActionEntry(REDUCE, 315);
   _actionMap[652][ORDER] = ActionEntry(REDUCE, 315);
   _actionMap[652][GROUP] = ActionEntry(REDUCE, 315);
   _actionMap[652][WHERE] = ActionEntry(REDUCE, 315);
   _actionMap[652][THEN] = ActionEntry(REDUCE, 315);
}
void Cego::loadParser53()
{
   _actionMap[652][AND] = ActionEntry(REDUCE, 315);
   _actionMap[652][OR] = ActionEntry(REDUCE, 315);
   _actionMap[652][RB] = ActionEntry(REDUCE, 315);
   _actionMap[653][AND] = ActionEntry(SHIFT, 729);
   _actionMap[653][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[653][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[653][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[654][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[654][SelectStatement] = 730;
   _actionMap[655][NULLTOKEN] = ActionEntry(SHIFT, 731);
   _actionMap[656][LEFT] = ActionEntry(REDUCE, 317);
   _actionMap[656][RIGHT] = ActionEntry(REDUCE, 317);
   _actionMap[656][INNER] = ActionEntry(REDUCE, 317);
   _actionMap[656][JOIN] = ActionEntry(REDUCE, 317);
   _actionMap[656][RETURNTOKEN] = ActionEntry(REDUCE, 317);
   _actionMap[656][SEMICOLON] = ActionEntry(REDUCE, 317);
   _actionMap[656][ENDTOKEN] = ActionEntry(REDUCE, 317);
   _actionMap[656][UNION] = ActionEntry(REDUCE, 317);
   _actionMap[656][ROWLIMIT] = ActionEntry(REDUCE, 317);
   _actionMap[656][ORDER] = ActionEntry(REDUCE, 317);
   _actionMap[656][GROUP] = ActionEntry(REDUCE, 317);
   _actionMap[656][WHERE] = ActionEntry(REDUCE, 317);
   _actionMap[656][THEN] = ActionEntry(REDUCE, 317);
   _actionMap[656][AND] = ActionEntry(REDUCE, 317);
   _actionMap[656][OR] = ActionEntry(REDUCE, 317);
   _actionMap[656][RB] = ActionEntry(REDUCE, 317);
   _actionMap[657][LEFT] = ActionEntry(REDUCE, 319);
   _actionMap[657][RIGHT] = ActionEntry(REDUCE, 319);
   _actionMap[657][INNER] = ActionEntry(REDUCE, 319);
   _actionMap[657][JOIN] = ActionEntry(REDUCE, 319);
   _actionMap[657][RETURNTOKEN] = ActionEntry(REDUCE, 319);
   _actionMap[657][SEMICOLON] = ActionEntry(REDUCE, 319);
   _actionMap[657][ENDTOKEN] = ActionEntry(REDUCE, 319);
   _actionMap[657][UNION] = ActionEntry(REDUCE, 319);
   _actionMap[657][ROWLIMIT] = ActionEntry(REDUCE, 319);
   _actionMap[657][ORDER] = ActionEntry(REDUCE, 319);
   _actionMap[657][GROUP] = ActionEntry(REDUCE, 319);
   _actionMap[657][WHERE] = ActionEntry(REDUCE, 319);
   _actionMap[657][THEN] = ActionEntry(REDUCE, 319);
   _actionMap[657][AND] = ActionEntry(REDUCE, 319);
   _actionMap[657][OR] = ActionEntry(REDUCE, 319);
   _actionMap[657][RB] = ActionEntry(REDUCE, 319);
   _actionMap[658][LB] = ActionEntry(SHIFT, 732);
   _actionMap[659][STRINGVAL] = ActionEntry(SHIFT, 733);
   _actionMap[660][VARREF] = ActionEntry(REDUCE, 340);
   _actionMap[660][FETCH] = ActionEntry(REDUCE, 340);
   _actionMap[660][LB] = ActionEntry(REDUCE, 340);
   _actionMap[660][COUNT] = ActionEntry(REDUCE, 340);
   _actionMap[660][SUM] = ActionEntry(REDUCE, 340);
   _actionMap[660][AVG] = ActionEntry(REDUCE, 340);
}
void Cego::loadParser54()
{
   _actionMap[660][MIN] = ActionEntry(REDUCE, 340);
   _actionMap[660][MAX] = ActionEntry(REDUCE, 340);
   _actionMap[660][CASE] = ActionEntry(REDUCE, 340);
   _actionMap[660][TRIM] = ActionEntry(REDUCE, 340);
   _actionMap[660][RTRIM] = ActionEntry(REDUCE, 340);
   _actionMap[660][LTRIM] = ActionEntry(REDUCE, 340);
   _actionMap[660][ROUND] = ActionEntry(REDUCE, 340);
   _actionMap[660][DATE2STR] = ActionEntry(REDUCE, 340);
   _actionMap[660][DATE2INT] = ActionEntry(REDUCE, 340);
   _actionMap[660][INT2DATE] = ActionEntry(REDUCE, 340);
   _actionMap[660][LOWER] = ActionEntry(REDUCE, 340);
   _actionMap[660][UPPER] = ActionEntry(REDUCE, 340);
   _actionMap[660][LEFT] = ActionEntry(REDUCE, 340);
   _actionMap[660][RIGHT] = ActionEntry(REDUCE, 340);
   _actionMap[660][GETPOS] = ActionEntry(REDUCE, 340);
   _actionMap[660][SUBSTR] = ActionEntry(REDUCE, 340);
   _actionMap[660][REPLACE] = ActionEntry(REDUCE, 340);
   _actionMap[660][LENGTH] = ActionEntry(REDUCE, 340);
   _actionMap[660][TRUNC] = ActionEntry(REDUCE, 340);
   _actionMap[660][STR2INT] = ActionEntry(REDUCE, 340);
   _actionMap[660][STR2LONG] = ActionEntry(REDUCE, 340);
   _actionMap[660][STR2DATE] = ActionEntry(REDUCE, 340);
   _actionMap[660][RANDSTR] = ActionEntry(REDUCE, 340);
   _actionMap[660][RANDINT] = ActionEntry(REDUCE, 340);
   _actionMap[660][MOD] = ActionEntry(REDUCE, 340);
   _actionMap[660][DIV] = ActionEntry(REDUCE, 340);
   _actionMap[660][POWER] = ActionEntry(REDUCE, 340);
   _actionMap[660][BITAND] = ActionEntry(REDUCE, 340);
   _actionMap[660][BITOR] = ActionEntry(REDUCE, 340);
   _actionMap[660][BITXOR] = ActionEntry(REDUCE, 340);
   _actionMap[660][BLOBSIZE] = ActionEntry(REDUCE, 340);
   _actionMap[660][NEXTCOUNT] = ActionEntry(REDUCE, 340);
   _actionMap[660][SETCOUNT] = ActionEntry(REDUCE, 340);
   _actionMap[660][IDENTIFIER] = ActionEntry(REDUCE, 340);
   _actionMap[660][QUALIFIEDOBJ] = ActionEntry(REDUCE, 340);
   _actionMap[660][QUALIFIEDTS] = ActionEntry(REDUCE, 340);
   _actionMap[660][QUALIFIEDPRE] = ActionEntry(REDUCE, 340);
   _actionMap[660][STRINGVAL] = ActionEntry(REDUCE, 340);
   _actionMap[660][DATE] = ActionEntry(REDUCE, 340);
   _actionMap[660][SYSDATE] = ActionEntry(REDUCE, 340);
   _actionMap[660][NULLTOKEN] = ActionEntry(REDUCE, 340);
   _actionMap[660][TRUEVAL] = ActionEntry(REDUCE, 340);
   _actionMap[660][FALSEVAL] = ActionEntry(REDUCE, 340);
   _actionMap[660][LAB] = ActionEntry(REDUCE, 340);
   _actionMap[660][FLOATVAL] = ActionEntry(REDUCE, 340);
   _actionMap[660][MINUS] = ActionEntry(REDUCE, 340);
   _actionMap[660][INTVAL] = ActionEntry(REDUCE, 340);
   _actionMap[661][VARREF] = ActionEntry(REDUCE, 341);
   _actionMap[661][FETCH] = ActionEntry(REDUCE, 341);
   _actionMap[661][LB] = ActionEntry(REDUCE, 341);
}
void Cego::loadParser55()
{
   _actionMap[661][COUNT] = ActionEntry(REDUCE, 341);
   _actionMap[661][SUM] = ActionEntry(REDUCE, 341);
   _actionMap[661][AVG] = ActionEntry(REDUCE, 341);
   _actionMap[661][MIN] = ActionEntry(REDUCE, 341);
   _actionMap[661][MAX] = ActionEntry(REDUCE, 341);
   _actionMap[661][CASE] = ActionEntry(REDUCE, 341);
   _actionMap[661][TRIM] = ActionEntry(REDUCE, 341);
   _actionMap[661][RTRIM] = ActionEntry(REDUCE, 341);
   _actionMap[661][LTRIM] = ActionEntry(REDUCE, 341);
   _actionMap[661][ROUND] = ActionEntry(REDUCE, 341);
   _actionMap[661][DATE2STR] = ActionEntry(REDUCE, 341);
   _actionMap[661][DATE2INT] = ActionEntry(REDUCE, 341);
   _actionMap[661][INT2DATE] = ActionEntry(REDUCE, 341);
   _actionMap[661][LOWER] = ActionEntry(REDUCE, 341);
   _actionMap[661][UPPER] = ActionEntry(REDUCE, 341);
   _actionMap[661][LEFT] = ActionEntry(REDUCE, 341);
   _actionMap[661][RIGHT] = ActionEntry(REDUCE, 341);
   _actionMap[661][GETPOS] = ActionEntry(REDUCE, 341);
   _actionMap[661][SUBSTR] = ActionEntry(REDUCE, 341);
   _actionMap[661][REPLACE] = ActionEntry(REDUCE, 341);
   _actionMap[661][LENGTH] = ActionEntry(REDUCE, 341);
   _actionMap[661][TRUNC] = ActionEntry(REDUCE, 341);
   _actionMap[661][STR2INT] = ActionEntry(REDUCE, 341);
   _actionMap[661][STR2LONG] = ActionEntry(REDUCE, 341);
   _actionMap[661][STR2DATE] = ActionEntry(REDUCE, 341);
   _actionMap[661][RANDSTR] = ActionEntry(REDUCE, 341);
   _actionMap[661][RANDINT] = ActionEntry(REDUCE, 341);
   _actionMap[661][MOD] = ActionEntry(REDUCE, 341);
   _actionMap[661][DIV] = ActionEntry(REDUCE, 341);
   _actionMap[661][POWER] = ActionEntry(REDUCE, 341);
   _actionMap[661][BITAND] = ActionEntry(REDUCE, 341);
   _actionMap[661][BITOR] = ActionEntry(REDUCE, 341);
   _actionMap[661][BITXOR] = ActionEntry(REDUCE, 341);
   _actionMap[661][BLOBSIZE] = ActionEntry(REDUCE, 341);
   _actionMap[661][NEXTCOUNT] = ActionEntry(REDUCE, 341);
   _actionMap[661][SETCOUNT] = ActionEntry(REDUCE, 341);
   _actionMap[661][IDENTIFIER] = ActionEntry(REDUCE, 341);
   _actionMap[661][QUALIFIEDOBJ] = ActionEntry(REDUCE, 341);
   _actionMap[661][QUALIFIEDTS] = ActionEntry(REDUCE, 341);
   _actionMap[661][QUALIFIEDPRE] = ActionEntry(REDUCE, 341);
   _actionMap[661][STRINGVAL] = ActionEntry(REDUCE, 341);
   _actionMap[661][DATE] = ActionEntry(REDUCE, 341);
   _actionMap[661][SYSDATE] = ActionEntry(REDUCE, 341);
   _actionMap[661][NULLTOKEN] = ActionEntry(REDUCE, 341);
   _actionMap[661][TRUEVAL] = ActionEntry(REDUCE, 341);
   _actionMap[661][FALSEVAL] = ActionEntry(REDUCE, 341);
   _actionMap[661][LAB] = ActionEntry(REDUCE, 341);
   _actionMap[661][FLOATVAL] = ActionEntry(REDUCE, 341);
   _actionMap[661][MINUS] = ActionEntry(REDUCE, 341);
   _actionMap[661][INTVAL] = ActionEntry(REDUCE, 341);
}
void Cego::loadParser56()
{
   _actionMap[662][VARREF] = ActionEntry(REDUCE, 337);
   _actionMap[662][FETCH] = ActionEntry(REDUCE, 337);
   _actionMap[662][LB] = ActionEntry(REDUCE, 337);
   _actionMap[662][COUNT] = ActionEntry(REDUCE, 337);
   _actionMap[662][SUM] = ActionEntry(REDUCE, 337);
   _actionMap[662][AVG] = ActionEntry(REDUCE, 337);
   _actionMap[662][MIN] = ActionEntry(REDUCE, 337);
   _actionMap[662][MAX] = ActionEntry(REDUCE, 337);
   _actionMap[662][CASE] = ActionEntry(REDUCE, 337);
   _actionMap[662][TRIM] = ActionEntry(REDUCE, 337);
   _actionMap[662][RTRIM] = ActionEntry(REDUCE, 337);
   _actionMap[662][LTRIM] = ActionEntry(REDUCE, 337);
   _actionMap[662][ROUND] = ActionEntry(REDUCE, 337);
   _actionMap[662][DATE2STR] = ActionEntry(REDUCE, 337);
   _actionMap[662][DATE2INT] = ActionEntry(REDUCE, 337);
   _actionMap[662][INT2DATE] = ActionEntry(REDUCE, 337);
   _actionMap[662][LOWER] = ActionEntry(REDUCE, 337);
   _actionMap[662][UPPER] = ActionEntry(REDUCE, 337);
   _actionMap[662][LEFT] = ActionEntry(REDUCE, 337);
   _actionMap[662][RIGHT] = ActionEntry(REDUCE, 337);
   _actionMap[662][GETPOS] = ActionEntry(REDUCE, 337);
   _actionMap[662][SUBSTR] = ActionEntry(REDUCE, 337);
   _actionMap[662][REPLACE] = ActionEntry(REDUCE, 337);
   _actionMap[662][LENGTH] = ActionEntry(REDUCE, 337);
   _actionMap[662][TRUNC] = ActionEntry(REDUCE, 337);
   _actionMap[662][STR2INT] = ActionEntry(REDUCE, 337);
   _actionMap[662][STR2LONG] = ActionEntry(REDUCE, 337);
   _actionMap[662][STR2DATE] = ActionEntry(REDUCE, 337);
   _actionMap[662][RANDSTR] = ActionEntry(REDUCE, 337);
   _actionMap[662][RANDINT] = ActionEntry(REDUCE, 337);
   _actionMap[662][MOD] = ActionEntry(REDUCE, 337);
   _actionMap[662][DIV] = ActionEntry(REDUCE, 337);
   _actionMap[662][POWER] = ActionEntry(REDUCE, 337);
   _actionMap[662][BITAND] = ActionEntry(REDUCE, 337);
   _actionMap[662][BITOR] = ActionEntry(REDUCE, 337);
   _actionMap[662][BITXOR] = ActionEntry(REDUCE, 337);
   _actionMap[662][BLOBSIZE] = ActionEntry(REDUCE, 337);
   _actionMap[662][NEXTCOUNT] = ActionEntry(REDUCE, 337);
   _actionMap[662][SETCOUNT] = ActionEntry(REDUCE, 337);
   _actionMap[662][IDENTIFIER] = ActionEntry(REDUCE, 337);
   _actionMap[662][QUALIFIEDOBJ] = ActionEntry(REDUCE, 337);
   _actionMap[662][QUALIFIEDTS] = ActionEntry(REDUCE, 337);
   _actionMap[662][QUALIFIEDPRE] = ActionEntry(REDUCE, 337);
   _actionMap[662][STRINGVAL] = ActionEntry(REDUCE, 337);
   _actionMap[662][DATE] = ActionEntry(REDUCE, 337);
   _actionMap[662][SYSDATE] = ActionEntry(REDUCE, 337);
   _actionMap[662][NULLTOKEN] = ActionEntry(REDUCE, 337);
   _actionMap[662][TRUEVAL] = ActionEntry(REDUCE, 337);
   _actionMap[662][FALSEVAL] = ActionEntry(REDUCE, 337);
   _actionMap[662][LAB] = ActionEntry(REDUCE, 337);
}
void Cego::loadParser57()
{
   _actionMap[662][FLOATVAL] = ActionEntry(REDUCE, 337);
   _actionMap[662][MINUS] = ActionEntry(REDUCE, 337);
   _actionMap[662][INTVAL] = ActionEntry(REDUCE, 337);
   _actionMap[663][THEN] = ActionEntry(REDUCE, 309);
   _actionMap[663][LEFT] = ActionEntry(REDUCE, 309);
   _actionMap[663][RIGHT] = ActionEntry(REDUCE, 309);
   _actionMap[663][INNER] = ActionEntry(REDUCE, 309);
   _actionMap[663][JOIN] = ActionEntry(REDUCE, 309);
   _actionMap[663][RETURNTOKEN] = ActionEntry(REDUCE, 309);
   _actionMap[663][SEMICOLON] = ActionEntry(REDUCE, 309);
   _actionMap[663][RB] = ActionEntry(REDUCE, 309);
   _actionMap[663][ENDTOKEN] = ActionEntry(REDUCE, 309);
   _actionMap[663][UNION] = ActionEntry(REDUCE, 309);
   _actionMap[663][ROWLIMIT] = ActionEntry(REDUCE, 309);
   _actionMap[663][ORDER] = ActionEntry(REDUCE, 309);
   _actionMap[663][GROUP] = ActionEntry(REDUCE, 309);
   _actionMap[663][WHERE] = ActionEntry(REDUCE, 309);
   _actionMap[663][OR] = ActionEntry(REDUCE, 309);
   _actionMap[663][AND] = ActionEntry(REDUCE, 309);
   _actionMap[664][THEN] = ActionEntry(REDUCE, 310);
   _actionMap[664][LEFT] = ActionEntry(REDUCE, 310);
   _actionMap[664][RIGHT] = ActionEntry(REDUCE, 310);
   _actionMap[664][INNER] = ActionEntry(REDUCE, 310);
   _actionMap[664][JOIN] = ActionEntry(REDUCE, 310);
   _actionMap[664][RETURNTOKEN] = ActionEntry(REDUCE, 310);
   _actionMap[664][SEMICOLON] = ActionEntry(REDUCE, 310);
   _actionMap[664][RB] = ActionEntry(REDUCE, 310);
   _actionMap[664][ENDTOKEN] = ActionEntry(REDUCE, 310);
   _actionMap[664][UNION] = ActionEntry(REDUCE, 310);
   _actionMap[664][ROWLIMIT] = ActionEntry(REDUCE, 310);
   _actionMap[664][ORDER] = ActionEntry(REDUCE, 310);
   _actionMap[664][GROUP] = ActionEntry(REDUCE, 310);
   _actionMap[664][WHERE] = ActionEntry(REDUCE, 310);
   _actionMap[664][OR] = ActionEntry(REDUCE, 310);
   _actionMap[664][AND] = ActionEntry(REDUCE, 310);
   _actionMap[665][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[665][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[665][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[665][WHEN] = ActionEntry(REDUCE, 164);
   _actionMap[665][ELSE] = ActionEntry(REDUCE, 164);
   _actionMap[666][RB] = ActionEntry(SHIFT, 734);
   _actionMap[667][THEN] = ActionEntry(REDUCE, 321);
   _actionMap[667][LEFT] = ActionEntry(REDUCE, 321);
   _actionMap[667][RIGHT] = ActionEntry(REDUCE, 321);
   _actionMap[667][INNER] = ActionEntry(REDUCE, 321);
   _actionMap[667][JOIN] = ActionEntry(REDUCE, 321);
   _actionMap[667][RETURNTOKEN] = ActionEntry(REDUCE, 321);
   _actionMap[667][SEMICOLON] = ActionEntry(REDUCE, 321);
   _actionMap[667][RB] = ActionEntry(REDUCE, 321);
   _actionMap[667][ENDTOKEN] = ActionEntry(REDUCE, 321);
}
void Cego::loadParser58()
{
   _actionMap[667][UNION] = ActionEntry(REDUCE, 321);
   _actionMap[667][ROWLIMIT] = ActionEntry(REDUCE, 321);
   _actionMap[667][ORDER] = ActionEntry(REDUCE, 321);
   _actionMap[667][GROUP] = ActionEntry(REDUCE, 321);
   _actionMap[667][WHERE] = ActionEntry(REDUCE, 321);
   _actionMap[667][AND] = ActionEntry(REDUCE, 321);
   _actionMap[667][OR] = ActionEntry(REDUCE, 321);
   _actionMap[668][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[668][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[668][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[668][KSEP] = ActionEntry(REDUCE, 304);
   _actionMap[668][RB] = ActionEntry(REDUCE, 304);
   _actionMap[669][RB] = ActionEntry(SHIFT, 735);
   _actionMap[670][RB] = ActionEntry(REDUCE, 366);
   _actionMap[671][RB] = ActionEntry(SHIFT, 737);
   _actionMap[671][KSEP] = ActionEntry(SHIFT, 736);
   _actionMap[672][KSEP] = ActionEntry(REDUCE, 167);
   _actionMap[672][RB] = ActionEntry(REDUCE, 167);
   _actionMap[673][RB] = ActionEntry(SHIFT, 738);
   _actionMap[673][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[673][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[673][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[674][WHEN] = ActionEntry(REDUCE, 364);
   _actionMap[674][ELSE] = ActionEntry(REDUCE, 364);
   _actionMap[674][LEFT] = ActionEntry(REDUCE, 364);
   _actionMap[674][RIGHT] = ActionEntry(REDUCE, 364);
   _actionMap[674][INNER] = ActionEntry(REDUCE, 364);
   _actionMap[674][JOIN] = ActionEntry(REDUCE, 364);
   _actionMap[674][RETURNTOKEN] = ActionEntry(REDUCE, 364);
   _actionMap[674][ORDER] = ActionEntry(REDUCE, 364);
   _actionMap[674][GROUP] = ActionEntry(REDUCE, 364);
   _actionMap[674][WHERE] = ActionEntry(REDUCE, 364);
   _actionMap[674][FROM] = ActionEntry(REDUCE, 364);
   _actionMap[674][AS] = ActionEntry(REDUCE, 364);
   _actionMap[674][END_TOKEN] = ActionEntry(REDUCE, 364);
   _actionMap[674][BEGIN] = ActionEntry(REDUCE, 364);
   _actionMap[674][THEN] = ActionEntry(REDUCE, 364);
   _actionMap[674][OR] = ActionEntry(REDUCE, 364);
   _actionMap[674][AND] = ActionEntry(REDUCE, 364);
   _actionMap[674][NULLTOKEN] = ActionEntry(REDUCE, 364);
   _actionMap[674][INTOK] = ActionEntry(REDUCE, 364);
   _actionMap[674][NOT] = ActionEntry(REDUCE, 364);
   _actionMap[674][BETWEEN] = ActionEntry(REDUCE, 364);
   _actionMap[674][IS] = ActionEntry(REDUCE, 364);
   _actionMap[674][LIKE] = ActionEntry(REDUCE, 364);
   _actionMap[674][MT] = ActionEntry(REDUCE, 364);
   _actionMap[674][LT] = ActionEntry(REDUCE, 364);
   _actionMap[674][NEGATION] = ActionEntry(REDUCE, 364);
   _actionMap[674][EQU] = ActionEntry(REDUCE, 364);
   _actionMap[674][RB] = ActionEntry(REDUCE, 364);
}
void Cego::loadParser59()
{
   _actionMap[674][ENDTOKEN] = ActionEntry(REDUCE, 364);
   _actionMap[674][UNION] = ActionEntry(REDUCE, 364);
   _actionMap[674][ROWLIMIT] = ActionEntry(REDUCE, 364);
   _actionMap[674][KSEP] = ActionEntry(REDUCE, 364);
   _actionMap[674][ASC] = ActionEntry(REDUCE, 364);
   _actionMap[674][DESC] = ActionEntry(REDUCE, 364);
   _actionMap[674][SEMICOLON] = ActionEntry(REDUCE, 364);
   _actionMap[674][PLUS] = ActionEntry(REDUCE, 364);
   _actionMap[674][MINUS] = ActionEntry(REDUCE, 364);
   _actionMap[674][DIVISION] = ActionEntry(REDUCE, 364);
   _actionMap[674][STAR] = ActionEntry(REDUCE, 364);
   _actionMap[674][CONCAT] = ActionEntry(REDUCE, 364);
   _actionMap[675][SEMICOLON] = ActionEntry(REDUCE, 235);
   _actionMap[675][RB] = ActionEntry(REDUCE, 235);
   _actionMap[675][ENDTOKEN] = ActionEntry(REDUCE, 235);
   _actionMap[675][UNION] = ActionEntry(REDUCE, 235);
   _actionMap[675][ROWLIMIT] = ActionEntry(REDUCE, 235);
   _actionMap[675][ORDER] = ActionEntry(SHIFT, 741);
   _jumpMap[675][NoOrdering] = 740;
   _jumpMap[675][OrderingClause] = 739;
   _actionMap[676][ORDER] = ActionEntry(REDUCE, 226);
   _actionMap[676][ROWLIMIT] = ActionEntry(REDUCE, 226);
   _actionMap[676][UNION] = ActionEntry(REDUCE, 226);
   _actionMap[676][ENDTOKEN] = ActionEntry(REDUCE, 226);
   _actionMap[676][RB] = ActionEntry(REDUCE, 226);
   _actionMap[676][SEMICOLON] = ActionEntry(REDUCE, 226);
   _actionMap[677][BY] = ActionEntry(SHIFT, 742);
   _actionMap[678][ON] = ActionEntry(SHIFT, 744);
   _jumpMap[678][JoinTableOn] = 743;
   _actionMap[679][IDENTIFIER] = ActionEntry(REDUCE, 215);
   _actionMap[679][QUALIFIEDOBJ] = ActionEntry(REDUCE, 215);
   _actionMap[679][QUALIFIEDTS] = ActionEntry(REDUCE, 215);
   _actionMap[680][JOIN] = ActionEntry(SHIFT, 745);
   _actionMap[681][JOIN] = ActionEntry(SHIFT, 746);
   _actionMap[682][RETURNTOKEN] = ActionEntry(REDUCE, 217);
   _actionMap[682][SEMICOLON] = ActionEntry(REDUCE, 217);
   _actionMap[682][RB] = ActionEntry(REDUCE, 217);
   _actionMap[682][ENDTOKEN] = ActionEntry(REDUCE, 217);
   _actionMap[682][UNION] = ActionEntry(REDUCE, 217);
   _actionMap[682][ROWLIMIT] = ActionEntry(REDUCE, 217);
   _actionMap[682][ORDER] = ActionEntry(REDUCE, 217);
   _actionMap[682][GROUP] = ActionEntry(REDUCE, 217);
   _actionMap[682][WHERE] = ActionEntry(REDUCE, 217);
   _actionMap[683][KSEP] = ActionEntry(SHIFT, 581);
   _actionMap[683][RETURNTOKEN] = ActionEntry(REDUCE, 218);
   _actionMap[683][SEMICOLON] = ActionEntry(REDUCE, 218);
   _actionMap[683][RB] = ActionEntry(REDUCE, 218);
   _actionMap[683][ENDTOKEN] = ActionEntry(REDUCE, 218);
   _actionMap[683][UNION] = ActionEntry(REDUCE, 218);
   _actionMap[683][ROWLIMIT] = ActionEntry(REDUCE, 218);
}
void Cego::loadParser60()
{
   _actionMap[683][ORDER] = ActionEntry(REDUCE, 218);
   _actionMap[683][GROUP] = ActionEntry(REDUCE, 218);
   _actionMap[683][WHERE] = ActionEntry(REDUCE, 218);
   _actionMap[684][SEMICOLON] = ActionEntry(REDUCE, 247);
   _actionMap[685][VARREF] = ActionEntry(SHIFT, 749);
   _jumpMap[685][ReturnVar] = 748;
   _jumpMap[685][ReturnVarList] = 747;
   _actionMap[686][KSEP] = ActionEntry(REDUCE, 248);
   _actionMap[686][WHERE] = ActionEntry(REDUCE, 248);
   _actionMap[686][GROUP] = ActionEntry(REDUCE, 248);
   _actionMap[686][ORDER] = ActionEntry(REDUCE, 248);
   _actionMap[686][ROWLIMIT] = ActionEntry(REDUCE, 248);
   _actionMap[686][UNION] = ActionEntry(REDUCE, 248);
   _actionMap[686][ENDTOKEN] = ActionEntry(REDUCE, 248);
   _actionMap[686][RB] = ActionEntry(REDUCE, 248);
   _actionMap[686][SEMICOLON] = ActionEntry(REDUCE, 248);
   _actionMap[686][RETURNTOKEN] = ActionEntry(REDUCE, 248);
   _actionMap[687][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[687][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[687][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[687][KSEP] = ActionEntry(REDUCE, 250);
   _actionMap[687][WHERE] = ActionEntry(REDUCE, 250);
   _actionMap[687][GROUP] = ActionEntry(REDUCE, 250);
   _actionMap[687][ORDER] = ActionEntry(REDUCE, 250);
   _actionMap[687][ROWLIMIT] = ActionEntry(REDUCE, 250);
   _actionMap[687][UNION] = ActionEntry(REDUCE, 250);
   _actionMap[687][ENDTOKEN] = ActionEntry(REDUCE, 250);
   _actionMap[687][RB] = ActionEntry(REDUCE, 250);
   _actionMap[687][SEMICOLON] = ActionEntry(REDUCE, 250);
   _actionMap[687][RETURNTOKEN] = ActionEntry(REDUCE, 250);
   _actionMap[688][RB] = ActionEntry(SHIFT, 689);
   _actionMap[689][SEMICOLON] = ActionEntry(REDUCE, 53);
   _actionMap[449][DROP] = ActionEntry(SHIFT, 315);
   _actionMap[449][ADD] = ActionEntry(SHIFT, 591);
   _actionMap[449][MODIFY] = ActionEntry(SHIFT, 316);
   _actionMap[449][RENAME] = ActionEntry(SHIFT, 317);
   _jumpMap[449][AlterOption] = 313;
   _jumpMap[449][AlterList] = 590;
   _actionMap[450][IDENTIFIER] = ActionEntry(SHIFT, 592);
   _actionMap[451][IDENTIFIER] = ActionEntry(SHIFT, 490);
   _jumpMap[451][ColumnDesc] = 593;
   _actionMap[452][KEY] = ActionEntry(SHIFT, 594);
   _actionMap[453][IDENTIFIER] = ActionEntry(SHIFT, 595);
   _actionMap[454][IDENTIFIER] = ActionEntry(SHIFT, 490);
   _jumpMap[454][ColumnDesc] = 596;
   _actionMap[455][IDENTIFIER] = ActionEntry(SHIFT, 597);
   _actionMap[456][FOR] = ActionEntry(SHIFT, 598);
   _actionMap[457][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[457][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[457][INTVAL] = ActionEntry(SHIFT, 147);
}
void Cego::loadParser61()
{
   _actionMap[457][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[457][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[457][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[457][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[457][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[457][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[457][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[457][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[457][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[457][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[457][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[457][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[457][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[457][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[457][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[457][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[457][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[457][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[457][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[457][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[457][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[457][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[457][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[457][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[457][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[457][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[457][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[457][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[457][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[457][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[457][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[457][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[457][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[457][LB] = ActionEntry(SHIFT, 144);
   _actionMap[457][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[457][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[457][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[457][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[457][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[457][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[457][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[457][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[457][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[457][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[457][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[457][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[457][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[457][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[457][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[457][MAX] = ActionEntry(SHIFT, 122);
}
void Cego::loadParser62()
{
   _jumpMap[457][ObjSpec] = 100;
   _jumpMap[457][Constant] = 99;
   _jumpMap[457][SignedFloat] = 98;
   _jumpMap[457][SignedInt] = 97;
   _jumpMap[457][Attribute] = 96;
   _jumpMap[457][Function] = 95;
   _jumpMap[457][CasePrepare] = 94;
   _jumpMap[457][CaseClause] = 93;
   _jumpMap[457][Factor] = 92;
   _jumpMap[457][Term] = 91;
   _jumpMap[457][Expr] = 599;
   _actionMap[458][SEMICOLON] = ActionEntry(REDUCE, 81);
   _actionMap[459][ELSE] = ActionEntry(REDUCE, 90);
   _actionMap[459][ELSIF] = ActionEntry(REDUCE, 90);
   _actionMap[459][END_TOKEN] = ActionEntry(REDUCE, 90);
   _actionMap[459][EXCEPTION] = ActionEntry(SHIFT, 601);
   _jumpMap[459][ProcExceptionStmt] = 600;
   _actionMap[460][SEMICOLON] = ActionEntry(SHIFT, 602);
   _actionMap[461][END_TOKEN] = ActionEntry(SHIFT, 603);
   _actionMap[462][ELSE] = ActionEntry(SHIFT, 606);
   _actionMap[462][END_TOKEN] = ActionEntry(REDUCE, 127);
   _jumpMap[462][ProcElsePart] = 605;
   _jumpMap[462][ProcElseOpt] = 604;
   _actionMap[463][ELSIF] = ActionEntry(SHIFT, 464);
   _actionMap[463][END_TOKEN] = ActionEntry(REDUCE, 124);
   _actionMap[463][ELSE] = ActionEntry(REDUCE, 124);
   _jumpMap[463][ProcElsIfOpt] = 463;
   _jumpMap[463][ProcElsIfList] = 608;
   _actionMap[464][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[464][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[464][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[464][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[464][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[464][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[464][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[464][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[464][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[464][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[464][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[464][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[464][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[464][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[464][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[464][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[464][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[464][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[464][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[464][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[464][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[464][STR2DATE] = ActionEntry(SHIFT, 139);
}
void Cego::loadParser63()
{
   _actionMap[464][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[464][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[464][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[464][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[464][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[464][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[464][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[464][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[464][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[464][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[464][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[464][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[464][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[464][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[464][LB] = ActionEntry(SHIFT, 472);
   _actionMap[464][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[464][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[464][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[464][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[464][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[464][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[464][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[464][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[464][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[464][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[464][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[464][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[464][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[464][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[464][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[464][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[464][ObjSpec] = 100;
   _jumpMap[464][Constant] = 99;
   _jumpMap[464][SignedFloat] = 98;
   _jumpMap[464][SignedInt] = 97;
   _jumpMap[464][Attribute] = 96;
   _jumpMap[464][Function] = 95;
   _jumpMap[464][CasePrepare] = 94;
   _jumpMap[464][CaseClause] = 93;
   _jumpMap[464][Factor] = 92;
   _jumpMap[464][Term] = 91;
   _jumpMap[464][Expr] = 471;
   _jumpMap[464][ProcPredicate] = 470;
   _jumpMap[464][ProcCondition] = 610;
   _jumpMap[464][ProcElsIfCondition] = 609;
   _actionMap[465][EXCEPTION] = ActionEntry(REDUCE, 92);
   _actionMap[465][END_TOKEN] = ActionEntry(REDUCE, 92);
   _actionMap[465][ELSE] = ActionEntry(REDUCE, 92);
   _actionMap[465][ELSIF] = ActionEntry(REDUCE, 92);
   _actionMap[465][VAR] = ActionEntry(REDUCE, 92);
}
void Cego::loadParser64()
{
   _actionMap[465][CURSOR] = ActionEntry(REDUCE, 92);
   _actionMap[465][CLOSE] = ActionEntry(REDUCE, 92);
   _actionMap[465][VARREF] = ActionEntry(REDUCE, 92);
   _actionMap[465][NOOP] = ActionEntry(REDUCE, 92);
   _actionMap[465][THROW] = ActionEntry(REDUCE, 92);
   _actionMap[465][RETURNTOKEN] = ActionEntry(REDUCE, 92);
   _actionMap[465][WHILE] = ActionEntry(REDUCE, 92);
   _actionMap[465][IF] = ActionEntry(REDUCE, 92);
   _actionMap[465][BEGIN] = ActionEntry(REDUCE, 92);
   _actionMap[465][ROLLBACK] = ActionEntry(REDUCE, 92);
   _actionMap[465][COMMIT] = ActionEntry(REDUCE, 92);
   _actionMap[465][START_TOKEN] = ActionEntry(REDUCE, 92);
   _actionMap[465][UPDATE] = ActionEntry(REDUCE, 92);
   _actionMap[465][DELETETOK] = ActionEntry(REDUCE, 92);
   _actionMap[465][INSERT] = ActionEntry(REDUCE, 92);
   _actionMap[465][FETCH] = ActionEntry(REDUCE, 92);
   _actionMap[465][LB] = ActionEntry(REDUCE, 92);
   _actionMap[465][COUNT] = ActionEntry(REDUCE, 92);
   _actionMap[465][SUM] = ActionEntry(REDUCE, 92);
   _actionMap[465][AVG] = ActionEntry(REDUCE, 92);
   _actionMap[465][MIN] = ActionEntry(REDUCE, 92);
   _actionMap[465][MAX] = ActionEntry(REDUCE, 92);
   _actionMap[465][CASE] = ActionEntry(REDUCE, 92);
   _actionMap[465][TRIM] = ActionEntry(REDUCE, 92);
   _actionMap[465][RTRIM] = ActionEntry(REDUCE, 92);
   _actionMap[465][LTRIM] = ActionEntry(REDUCE, 92);
   _actionMap[465][ROUND] = ActionEntry(REDUCE, 92);
   _actionMap[465][DATE2STR] = ActionEntry(REDUCE, 92);
   _actionMap[465][DATE2INT] = ActionEntry(REDUCE, 92);
   _actionMap[465][INT2DATE] = ActionEntry(REDUCE, 92);
   _actionMap[465][LOWER] = ActionEntry(REDUCE, 92);
   _actionMap[465][UPPER] = ActionEntry(REDUCE, 92);
   _actionMap[465][LEFT] = ActionEntry(REDUCE, 92);
   _actionMap[465][RIGHT] = ActionEntry(REDUCE, 92);
   _actionMap[465][GETPOS] = ActionEntry(REDUCE, 92);
   _actionMap[465][SUBSTR] = ActionEntry(REDUCE, 92);
   _actionMap[465][REPLACE] = ActionEntry(REDUCE, 92);
   _actionMap[465][LENGTH] = ActionEntry(REDUCE, 92);
   _actionMap[465][TRUNC] = ActionEntry(REDUCE, 92);
   _actionMap[465][STR2INT] = ActionEntry(REDUCE, 92);
   _actionMap[465][STR2LONG] = ActionEntry(REDUCE, 92);
   _actionMap[465][STR2DATE] = ActionEntry(REDUCE, 92);
   _actionMap[465][RANDSTR] = ActionEntry(REDUCE, 92);
   _actionMap[465][RANDINT] = ActionEntry(REDUCE, 92);
   _actionMap[465][MOD] = ActionEntry(REDUCE, 92);
   _actionMap[465][DIV] = ActionEntry(REDUCE, 92);
   _actionMap[465][POWER] = ActionEntry(REDUCE, 92);
   _actionMap[465][BITAND] = ActionEntry(REDUCE, 92);
   _actionMap[465][BITOR] = ActionEntry(REDUCE, 92);
   _actionMap[465][BITXOR] = ActionEntry(REDUCE, 92);
}
void Cego::loadParser65()
{
   _actionMap[465][BLOBSIZE] = ActionEntry(REDUCE, 92);
   _actionMap[465][NEXTCOUNT] = ActionEntry(REDUCE, 92);
   _actionMap[465][SETCOUNT] = ActionEntry(REDUCE, 92);
   _actionMap[465][IDENTIFIER] = ActionEntry(REDUCE, 92);
   _actionMap[465][QUALIFIEDOBJ] = ActionEntry(REDUCE, 92);
   _actionMap[465][QUALIFIEDTS] = ActionEntry(REDUCE, 92);
   _actionMap[465][QUALIFIEDPRE] = ActionEntry(REDUCE, 92);
   _actionMap[465][STRINGVAL] = ActionEntry(REDUCE, 92);
   _actionMap[465][DATE] = ActionEntry(REDUCE, 92);
   _actionMap[465][SYSDATE] = ActionEntry(REDUCE, 92);
   _actionMap[465][NULLTOKEN] = ActionEntry(REDUCE, 92);
   _actionMap[465][TRUEVAL] = ActionEntry(REDUCE, 92);
   _actionMap[465][FALSEVAL] = ActionEntry(REDUCE, 92);
   _actionMap[465][LAB] = ActionEntry(REDUCE, 92);
   _actionMap[465][FLOATVAL] = ActionEntry(REDUCE, 92);
   _actionMap[465][MINUS] = ActionEntry(REDUCE, 92);
   _actionMap[465][INTVAL] = ActionEntry(REDUCE, 92);
   _actionMap[466][SEMICOLON] = ActionEntry(REDUCE, 95);
   _actionMap[467][AS] = ActionEntry(SHIFT, 611);
   _actionMap[468][THEN] = ActionEntry(SHIFT, 612);
   _actionMap[469][OR] = ActionEntry(SHIFT, 614);
   _actionMap[469][AND] = ActionEntry(SHIFT, 613);
   _actionMap[469][THEN] = ActionEntry(REDUCE, 129);
   _actionMap[470][BEGIN] = ActionEntry(REDUCE, 135);
   _actionMap[470][RB] = ActionEntry(REDUCE, 135);
   _actionMap[470][AND] = ActionEntry(REDUCE, 135);
   _actionMap[470][OR] = ActionEntry(REDUCE, 135);
   _actionMap[470][THEN] = ActionEntry(REDUCE, 135);
   _actionMap[471][IS] = ActionEntry(SHIFT, 616);
   _actionMap[471][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[471][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[471][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[471][EQU] = ActionEntry(SHIFT, 506);
   _actionMap[471][NEGATION] = ActionEntry(SHIFT, 509);
   _actionMap[471][LT] = ActionEntry(SHIFT, 507);
   _actionMap[471][MT] = ActionEntry(SHIFT, 508);
   _jumpMap[471][Comparison] = 615;
   _actionMap[472][LONG] = ActionEntry(SHIFT, 277);
   _actionMap[472][BIGINT] = ActionEntry(SHIFT, 273);
   _actionMap[472][SMALLINT] = ActionEntry(SHIFT, 278);
   _actionMap[472][TINYINT] = ActionEntry(SHIFT, 279);
   _actionMap[472][DOUBLE] = ActionEntry(SHIFT, 275);
   _actionMap[472][DECIMAL] = ActionEntry(SHIFT, 274);
   _actionMap[472][FIXED] = ActionEntry(SHIFT, 276);
   _actionMap[472][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[472][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[472][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[472][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[472][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[472][LTRIM] = ActionEntry(SHIFT, 120);
}
void Cego::loadParser66()
{
   _actionMap[472][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[472][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[472][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[472][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[472][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[472][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[472][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[472][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[472][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[472][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[472][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[472][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[472][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[472][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[472][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[472][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[472][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[472][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[472][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[472][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[472][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[472][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[472][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[472][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[472][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[472][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[472][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[472][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[472][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[472][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[472][LB] = ActionEntry(SHIFT, 472);
   _actionMap[472][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[472][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[472][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[472][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[472][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[472][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[472][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[472][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[472][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[472][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[472][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[472][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[472][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[472][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[472][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[472][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[472][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[472][ObjSpec] = 100;
   _jumpMap[472][Constant] = 99;
}
void Cego::loadParser67()
{
   _jumpMap[472][SignedFloat] = 98;
   _jumpMap[472][SignedInt] = 97;
   _jumpMap[472][Attribute] = 96;
   _jumpMap[472][Function] = 95;
   _jumpMap[472][SelectStatement] = 272;
   _jumpMap[472][CasePrepare] = 94;
   _jumpMap[472][CaseClause] = 93;
   _jumpMap[472][Factor] = 92;
   _jumpMap[472][Term] = 91;
   _jumpMap[472][Expr] = 618;
   _jumpMap[472][ProcPredicate] = 470;
   _jumpMap[472][ProcCondition] = 617;
   _actionMap[473][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[473][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[473][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[473][SEMICOLON] = ActionEntry(REDUCE, 110);
   _actionMap[474][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[474][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[474][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[474][SEMICOLON] = ActionEntry(REDUCE, 102);
   _actionMap[475][INT] = ActionEntry(SHIFT, 628);
   _actionMap[475][LONG] = ActionEntry(SHIFT, 629);
   _actionMap[475][STRING] = ActionEntry(SHIFT, 631);
   _actionMap[475][DATETIME] = ActionEntry(SHIFT, 623);
   _actionMap[475][BOOL] = ActionEntry(SHIFT, 622);
   _actionMap[475][BIGINT] = ActionEntry(SHIFT, 620);
   _actionMap[475][FLOAT] = ActionEntry(SHIFT, 627);
   _actionMap[475][DOUBLE] = ActionEntry(SHIFT, 625);
   _actionMap[475][SMALLINT] = ActionEntry(SHIFT, 630);
   _actionMap[475][TINYINT] = ActionEntry(SHIFT, 632);
   _actionMap[475][DECIMAL] = ActionEntry(SHIFT, 624);
   _actionMap[475][FIXED] = ActionEntry(SHIFT, 626);
   _actionMap[475][BLOB] = ActionEntry(SHIFT, 621);
   _jumpMap[475][DataTypeProd] = 619;
   _actionMap[476][BEGIN] = ActionEntry(SHIFT, 633);
   _actionMap[477][OR] = ActionEntry(SHIFT, 614);
   _actionMap[477][AND] = ActionEntry(SHIFT, 613);
   _actionMap[477][BEGIN] = ActionEntry(REDUCE, 132);
   _actionMap[478][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[478][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[478][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[478][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[478][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[478][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[478][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[478][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[478][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[478][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[478][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[478][UPPER] = ActionEntry(SHIFT, 143);
}
void Cego::loadParser68()
{
   _actionMap[478][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[478][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[478][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[478][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[478][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[478][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[478][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[478][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[478][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[478][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[478][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[478][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[478][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[478][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[478][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[478][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[478][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[478][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[478][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[478][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[478][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[478][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[478][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[478][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[478][LB] = ActionEntry(SHIFT, 144);
   _actionMap[478][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[478][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[478][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[478][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[478][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[478][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[478][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[478][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[478][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[478][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[478][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[478][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[478][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[478][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[478][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[478][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[478][ObjSpec] = 100;
   _jumpMap[478][Constant] = 99;
   _jumpMap[478][SignedFloat] = 98;
   _jumpMap[478][SignedInt] = 97;
   _jumpMap[478][Attribute] = 96;
   _jumpMap[478][Function] = 95;
   _jumpMap[478][CasePrepare] = 94;
   _jumpMap[478][CaseClause] = 93;
   _jumpMap[478][Factor] = 92;
}
void Cego::loadParser69()
{
   _jumpMap[478][Term] = 91;
   _jumpMap[478][Expr] = 634;
   _actionMap[479][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[479][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[479][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[479][ObjSpec] = 635;
   _actionMap[480][LB] = ActionEntry(SHIFT, 636);
   _actionMap[481][RB] = ActionEntry(SHIFT, 484);
   _actionMap[482][KSEP] = ActionEntry(SHIFT, 637);
   _actionMap[482][RB] = ActionEntry(REDUCE, 84);
   _actionMap[483][KSEP] = ActionEntry(REDUCE, 87);
   _actionMap[483][RB] = ActionEntry(REDUCE, 87);
   _actionMap[484][RETURNTOKEN] = ActionEntry(SHIFT, 639);
   _actionMap[484][BEGIN] = ActionEntry(REDUCE, 83);
   _jumpMap[484][ReturnOpt] = 638;
   _actionMap[485][INTOK] = ActionEntry(SHIFT, 640);
   _actionMap[485][OUTTOK] = ActionEntry(SHIFT, 641);
   _actionMap[486][RB] = ActionEntry(SHIFT, 643);
   _actionMap[486][KSEP] = ActionEntry(SHIFT, 642);
   _actionMap[487][KSEP] = ActionEntry(REDUCE, 169);
   _actionMap[487][RB] = ActionEntry(REDUCE, 169);
   _actionMap[488][KSEP] = ActionEntry(REDUCE, 171);
   _actionMap[488][RB] = ActionEntry(REDUCE, 171);
   _actionMap[489][IDENTIFIER] = ActionEntry(SHIFT, 490);
   _jumpMap[489][ColumnDesc] = 644;
   _actionMap[490][INT] = ActionEntry(SHIFT, 628);
   _actionMap[490][LONG] = ActionEntry(SHIFT, 629);
   _actionMap[490][STRING] = ActionEntry(SHIFT, 631);
   _actionMap[490][DATETIME] = ActionEntry(SHIFT, 623);
   _actionMap[490][BOOL] = ActionEntry(SHIFT, 622);
   _actionMap[490][BIGINT] = ActionEntry(SHIFT, 620);
   _actionMap[490][FLOAT] = ActionEntry(SHIFT, 627);
   _actionMap[490][DOUBLE] = ActionEntry(SHIFT, 625);
   _actionMap[490][SMALLINT] = ActionEntry(SHIFT, 630);
   _actionMap[490][TINYINT] = ActionEntry(SHIFT, 632);
   _actionMap[490][DECIMAL] = ActionEntry(SHIFT, 624);
   _actionMap[490][FIXED] = ActionEntry(SHIFT, 626);
   _actionMap[490][BLOB] = ActionEntry(SHIFT, 621);
   _jumpMap[490][DataTypeProd] = 645;
   _actionMap[491][SEMICOLON] = ActionEntry(REDUCE, 48);
   _actionMap[492][AND] = ActionEntry(SHIFT, 510);
   _actionMap[492][OR] = ActionEntry(SHIFT, 511);
   _actionMap[492][RETURNTOKEN] = ActionEntry(REDUCE, 306);
   _actionMap[492][GROUP] = ActionEntry(REDUCE, 306);
   _actionMap[492][ORDER] = ActionEntry(REDUCE, 306);
   _actionMap[492][ROWLIMIT] = ActionEntry(REDUCE, 306);
   _actionMap[492][UNION] = ActionEntry(REDUCE, 306);
   _actionMap[492][ENDTOKEN] = ActionEntry(REDUCE, 306);
   _actionMap[492][RB] = ActionEntry(REDUCE, 306);
   _actionMap[492][SEMICOLON] = ActionEntry(REDUCE, 306);
}
void Cego::loadParser70()
{
   _actionMap[493][KSEP] = ActionEntry(SHIFT, 646);
   _actionMap[493][SEMICOLON] = ActionEntry(REDUCE, 190);
   _actionMap[494][SEMICOLON] = ActionEntry(REDUCE, 196);
   _actionMap[494][KSEP] = ActionEntry(REDUCE, 196);
   _actionMap[495][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[495][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[495][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[495][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[495][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[495][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[495][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[495][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[495][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[495][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[495][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[495][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[495][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[495][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[495][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[495][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[495][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[495][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[495][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[495][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[495][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[495][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[495][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[495][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[495][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[495][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[495][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[495][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[495][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[495][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[495][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[495][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[495][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[495][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[495][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[495][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[495][LB] = ActionEntry(SHIFT, 144);
   _actionMap[495][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[495][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[495][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[495][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[495][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[495][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[495][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[495][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[495][CASE] = ActionEntry(SHIFT, 107);
}
void Cego::loadParser71()
{
   _actionMap[495][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[495][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[495][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[495][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[495][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[495][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[495][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[495][ObjSpec] = 100;
   _jumpMap[495][Constant] = 99;
   _jumpMap[495][SignedFloat] = 98;
   _jumpMap[495][SignedInt] = 97;
   _jumpMap[495][Attribute] = 96;
   _jumpMap[495][Function] = 95;
   _jumpMap[495][InsertValueList] = 648;
   _jumpMap[495][CasePrepare] = 94;
   _jumpMap[495][CaseClause] = 93;
   _jumpMap[495][Factor] = 92;
   _jumpMap[495][Term] = 91;
   _jumpMap[495][Expr] = 647;
   _actionMap[496][RB] = ActionEntry(SHIFT, 650);
   _actionMap[496][KSEP] = ActionEntry(SHIFT, 649);
   _actionMap[497][KSEP] = ActionEntry(REDUCE, 199);
   _actionMap[497][RB] = ActionEntry(REDUCE, 199);
   _actionMap[498][SEMICOLON] = ActionEntry(REDUCE, 49);
   _actionMap[499][END_TOKEN] = ActionEntry(SHIFT, 651);
   _actionMap[499][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[499][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[499][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[500][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[500][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[500][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[500][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[500][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[500][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[500][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[500][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[500][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[500][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[500][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[500][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[500][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[500][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[500][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[500][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[500][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[500][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[500][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[500][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[500][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[500][STR2DATE] = ActionEntry(SHIFT, 139);
}
void Cego::loadParser72()
{
   _actionMap[500][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[500][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[500][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[500][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[500][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[500][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[500][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[500][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[500][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[500][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[500][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[500][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[500][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[500][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[500][LB] = ActionEntry(SHIFT, 144);
   _actionMap[500][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[500][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[500][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[500][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[500][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[500][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[500][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[500][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[500][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[500][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[500][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[500][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[500][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[500][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[500][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[500][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[500][ObjSpec] = 100;
   _jumpMap[500][Constant] = 99;
   _jumpMap[500][SignedFloat] = 98;
   _jumpMap[500][SignedInt] = 97;
   _jumpMap[500][Attribute] = 96;
   _jumpMap[500][Function] = 95;
   _jumpMap[500][CasePrepare] = 94;
   _jumpMap[500][CaseClause] = 93;
   _jumpMap[500][Factor] = 92;
   _jumpMap[500][Term] = 91;
   _jumpMap[500][Expr] = 652;
   _actionMap[501][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[501][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[501][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[501][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[501][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[501][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[501][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[501][DATE2STR] = ActionEntry(SHIFT, 110);
}
void Cego::loadParser73()
{
   _actionMap[501][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[501][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[501][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[501][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[501][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[501][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[501][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[501][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[501][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[501][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[501][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[501][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[501][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[501][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[501][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[501][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[501][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[501][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[501][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[501][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[501][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[501][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[501][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[501][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[501][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[501][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[501][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[501][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[501][LB] = ActionEntry(SHIFT, 144);
   _actionMap[501][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[501][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[501][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[501][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[501][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[501][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[501][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[501][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[501][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[501][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[501][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[501][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[501][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[501][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[501][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[501][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[501][ObjSpec] = 100;
   _jumpMap[501][Constant] = 99;
   _jumpMap[501][SignedFloat] = 98;
   _jumpMap[501][SignedInt] = 97;
   _jumpMap[501][Attribute] = 96;
}
void Cego::loadParser74()
{
   _jumpMap[501][Function] = 95;
   _jumpMap[501][CasePrepare] = 94;
   _jumpMap[501][CaseClause] = 93;
   _jumpMap[501][Factor] = 92;
   _jumpMap[501][Term] = 91;
   _jumpMap[501][Expr] = 653;
   _actionMap[502][LB] = ActionEntry(SHIFT, 654);
   _actionMap[503][NOT] = ActionEntry(SHIFT, 655);
   _actionMap[503][NULLTOKEN] = ActionEntry(SHIFT, 656);
   _actionMap[504][STRINGVAL] = ActionEntry(SHIFT, 657);
   _actionMap[505][LIKE] = ActionEntry(SHIFT, 659);
   _actionMap[505][INTOK] = ActionEntry(SHIFT, 658);
   _actionMap[506][VARREF] = ActionEntry(REDUCE, 336);
   _actionMap[506][FETCH] = ActionEntry(REDUCE, 336);
   _actionMap[506][LB] = ActionEntry(REDUCE, 336);
   _actionMap[506][COUNT] = ActionEntry(REDUCE, 336);
   _actionMap[506][SUM] = ActionEntry(REDUCE, 336);
   _actionMap[506][AVG] = ActionEntry(REDUCE, 336);
   _actionMap[506][MIN] = ActionEntry(REDUCE, 336);
   _actionMap[506][MAX] = ActionEntry(REDUCE, 336);
   _actionMap[506][CASE] = ActionEntry(REDUCE, 336);
   _actionMap[506][TRIM] = ActionEntry(REDUCE, 336);
   _actionMap[506][RTRIM] = ActionEntry(REDUCE, 336);
   _actionMap[506][LTRIM] = ActionEntry(REDUCE, 336);
   _actionMap[506][ROUND] = ActionEntry(REDUCE, 336);
   _actionMap[506][DATE2STR] = ActionEntry(REDUCE, 336);
   _actionMap[506][DATE2INT] = ActionEntry(REDUCE, 336);
   _actionMap[506][INT2DATE] = ActionEntry(REDUCE, 336);
   _actionMap[506][LOWER] = ActionEntry(REDUCE, 336);
   _actionMap[506][UPPER] = ActionEntry(REDUCE, 336);
   _actionMap[506][LEFT] = ActionEntry(REDUCE, 336);
   _actionMap[506][RIGHT] = ActionEntry(REDUCE, 336);
   _actionMap[506][GETPOS] = ActionEntry(REDUCE, 336);
   _actionMap[506][SUBSTR] = ActionEntry(REDUCE, 336);
   _actionMap[506][REPLACE] = ActionEntry(REDUCE, 336);
   _actionMap[506][LENGTH] = ActionEntry(REDUCE, 336);
   _actionMap[506][TRUNC] = ActionEntry(REDUCE, 336);
   _actionMap[506][STR2INT] = ActionEntry(REDUCE, 336);
   _actionMap[506][STR2LONG] = ActionEntry(REDUCE, 336);
   _actionMap[506][STR2DATE] = ActionEntry(REDUCE, 336);
   _actionMap[506][RANDSTR] = ActionEntry(REDUCE, 336);
   _actionMap[506][RANDINT] = ActionEntry(REDUCE, 336);
   _actionMap[506][MOD] = ActionEntry(REDUCE, 336);
   _actionMap[506][DIV] = ActionEntry(REDUCE, 336);
   _actionMap[506][POWER] = ActionEntry(REDUCE, 336);
   _actionMap[506][BITAND] = ActionEntry(REDUCE, 336);
   _actionMap[506][BITOR] = ActionEntry(REDUCE, 336);
   _actionMap[506][BITXOR] = ActionEntry(REDUCE, 336);
   _actionMap[506][BLOBSIZE] = ActionEntry(REDUCE, 336);
   _actionMap[506][NEXTCOUNT] = ActionEntry(REDUCE, 336);
}
void Cego::loadParser75()
{
   _actionMap[506][SETCOUNT] = ActionEntry(REDUCE, 336);
   _actionMap[506][IDENTIFIER] = ActionEntry(REDUCE, 336);
   _actionMap[506][QUALIFIEDOBJ] = ActionEntry(REDUCE, 336);
   _actionMap[506][QUALIFIEDTS] = ActionEntry(REDUCE, 336);
   _actionMap[506][QUALIFIEDPRE] = ActionEntry(REDUCE, 336);
   _actionMap[506][STRINGVAL] = ActionEntry(REDUCE, 336);
   _actionMap[506][DATE] = ActionEntry(REDUCE, 336);
   _actionMap[506][SYSDATE] = ActionEntry(REDUCE, 336);
   _actionMap[506][NULLTOKEN] = ActionEntry(REDUCE, 336);
   _actionMap[506][TRUEVAL] = ActionEntry(REDUCE, 336);
   _actionMap[506][FALSEVAL] = ActionEntry(REDUCE, 336);
   _actionMap[506][LAB] = ActionEntry(REDUCE, 336);
   _actionMap[506][FLOATVAL] = ActionEntry(REDUCE, 336);
   _actionMap[506][MINUS] = ActionEntry(REDUCE, 336);
   _actionMap[506][INTVAL] = ActionEntry(REDUCE, 336);
   _actionMap[507][VARREF] = ActionEntry(REDUCE, 338);
   _actionMap[507][FETCH] = ActionEntry(REDUCE, 338);
   _actionMap[507][LB] = ActionEntry(REDUCE, 338);
   _actionMap[507][COUNT] = ActionEntry(REDUCE, 338);
   _actionMap[507][SUM] = ActionEntry(REDUCE, 338);
   _actionMap[507][AVG] = ActionEntry(REDUCE, 338);
   _actionMap[507][MIN] = ActionEntry(REDUCE, 338);
   _actionMap[507][MAX] = ActionEntry(REDUCE, 338);
   _actionMap[507][CASE] = ActionEntry(REDUCE, 338);
   _actionMap[507][TRIM] = ActionEntry(REDUCE, 338);
   _actionMap[507][RTRIM] = ActionEntry(REDUCE, 338);
   _actionMap[507][LTRIM] = ActionEntry(REDUCE, 338);
   _actionMap[507][ROUND] = ActionEntry(REDUCE, 338);
   _actionMap[507][DATE2STR] = ActionEntry(REDUCE, 338);
   _actionMap[507][DATE2INT] = ActionEntry(REDUCE, 338);
   _actionMap[507][INT2DATE] = ActionEntry(REDUCE, 338);
   _actionMap[507][LOWER] = ActionEntry(REDUCE, 338);
   _actionMap[507][UPPER] = ActionEntry(REDUCE, 338);
   _actionMap[507][LEFT] = ActionEntry(REDUCE, 338);
   _actionMap[507][RIGHT] = ActionEntry(REDUCE, 338);
   _actionMap[507][GETPOS] = ActionEntry(REDUCE, 338);
   _actionMap[507][SUBSTR] = ActionEntry(REDUCE, 338);
   _actionMap[507][REPLACE] = ActionEntry(REDUCE, 338);
   _actionMap[507][LENGTH] = ActionEntry(REDUCE, 338);
   _actionMap[507][TRUNC] = ActionEntry(REDUCE, 338);
   _actionMap[507][STR2INT] = ActionEntry(REDUCE, 338);
   _actionMap[507][STR2LONG] = ActionEntry(REDUCE, 338);
   _actionMap[507][STR2DATE] = ActionEntry(REDUCE, 338);
   _actionMap[507][RANDSTR] = ActionEntry(REDUCE, 338);
   _actionMap[507][RANDINT] = ActionEntry(REDUCE, 338);
   _actionMap[507][MOD] = ActionEntry(REDUCE, 338);
   _actionMap[507][DIV] = ActionEntry(REDUCE, 338);
   _actionMap[507][POWER] = ActionEntry(REDUCE, 338);
   _actionMap[507][BITAND] = ActionEntry(REDUCE, 338);
   _actionMap[507][BITOR] = ActionEntry(REDUCE, 338);
}
void Cego::loadParser76()
{
   _actionMap[507][BITXOR] = ActionEntry(REDUCE, 338);
   _actionMap[507][BLOBSIZE] = ActionEntry(REDUCE, 338);
   _actionMap[507][NEXTCOUNT] = ActionEntry(REDUCE, 338);
   _actionMap[507][SETCOUNT] = ActionEntry(REDUCE, 338);
   _actionMap[507][IDENTIFIER] = ActionEntry(REDUCE, 338);
   _actionMap[507][QUALIFIEDOBJ] = ActionEntry(REDUCE, 338);
   _actionMap[507][QUALIFIEDTS] = ActionEntry(REDUCE, 338);
   _actionMap[507][QUALIFIEDPRE] = ActionEntry(REDUCE, 338);
   _actionMap[507][STRINGVAL] = ActionEntry(REDUCE, 338);
   _actionMap[507][DATE] = ActionEntry(REDUCE, 338);
   _actionMap[507][SYSDATE] = ActionEntry(REDUCE, 338);
   _actionMap[507][NULLTOKEN] = ActionEntry(REDUCE, 338);
   _actionMap[507][TRUEVAL] = ActionEntry(REDUCE, 338);
   _actionMap[507][FALSEVAL] = ActionEntry(REDUCE, 338);
   _actionMap[507][LAB] = ActionEntry(REDUCE, 338);
   _actionMap[507][FLOATVAL] = ActionEntry(REDUCE, 338);
   _actionMap[507][MINUS] = ActionEntry(REDUCE, 338);
   _actionMap[507][INTVAL] = ActionEntry(REDUCE, 338);
   _actionMap[507][EQU] = ActionEntry(SHIFT, 660);
   _actionMap[508][VARREF] = ActionEntry(REDUCE, 339);
   _actionMap[508][FETCH] = ActionEntry(REDUCE, 339);
   _actionMap[508][LB] = ActionEntry(REDUCE, 339);
   _actionMap[508][COUNT] = ActionEntry(REDUCE, 339);
   _actionMap[508][SUM] = ActionEntry(REDUCE, 339);
   _actionMap[508][AVG] = ActionEntry(REDUCE, 339);
   _actionMap[508][MIN] = ActionEntry(REDUCE, 339);
   _actionMap[508][MAX] = ActionEntry(REDUCE, 339);
   _actionMap[508][CASE] = ActionEntry(REDUCE, 339);
   _actionMap[508][TRIM] = ActionEntry(REDUCE, 339);
   _actionMap[508][RTRIM] = ActionEntry(REDUCE, 339);
   _actionMap[508][LTRIM] = ActionEntry(REDUCE, 339);
   _actionMap[508][ROUND] = ActionEntry(REDUCE, 339);
   _actionMap[508][DATE2STR] = ActionEntry(REDUCE, 339);
   _actionMap[508][DATE2INT] = ActionEntry(REDUCE, 339);
   _actionMap[508][INT2DATE] = ActionEntry(REDUCE, 339);
   _actionMap[508][LOWER] = ActionEntry(REDUCE, 339);
   _actionMap[508][UPPER] = ActionEntry(REDUCE, 339);
   _actionMap[508][LEFT] = ActionEntry(REDUCE, 339);
   _actionMap[508][RIGHT] = ActionEntry(REDUCE, 339);
   _actionMap[508][GETPOS] = ActionEntry(REDUCE, 339);
   _actionMap[508][SUBSTR] = ActionEntry(REDUCE, 339);
   _actionMap[508][REPLACE] = ActionEntry(REDUCE, 339);
   _actionMap[508][LENGTH] = ActionEntry(REDUCE, 339);
   _actionMap[508][TRUNC] = ActionEntry(REDUCE, 339);
   _actionMap[508][STR2INT] = ActionEntry(REDUCE, 339);
   _actionMap[508][STR2LONG] = ActionEntry(REDUCE, 339);
   _actionMap[508][STR2DATE] = ActionEntry(REDUCE, 339);
   _actionMap[508][RANDSTR] = ActionEntry(REDUCE, 339);
   _actionMap[508][RANDINT] = ActionEntry(REDUCE, 339);
   _actionMap[508][MOD] = ActionEntry(REDUCE, 339);
}
void Cego::loadParser77()
{
   _actionMap[508][DIV] = ActionEntry(REDUCE, 339);
   _actionMap[508][POWER] = ActionEntry(REDUCE, 339);
   _actionMap[508][BITAND] = ActionEntry(REDUCE, 339);
   _actionMap[508][BITOR] = ActionEntry(REDUCE, 339);
   _actionMap[508][BITXOR] = ActionEntry(REDUCE, 339);
   _actionMap[508][BLOBSIZE] = ActionEntry(REDUCE, 339);
   _actionMap[508][NEXTCOUNT] = ActionEntry(REDUCE, 339);
   _actionMap[508][SETCOUNT] = ActionEntry(REDUCE, 339);
   _actionMap[508][IDENTIFIER] = ActionEntry(REDUCE, 339);
   _actionMap[508][QUALIFIEDOBJ] = ActionEntry(REDUCE, 339);
   _actionMap[508][QUALIFIEDTS] = ActionEntry(REDUCE, 339);
   _actionMap[508][QUALIFIEDPRE] = ActionEntry(REDUCE, 339);
   _actionMap[508][STRINGVAL] = ActionEntry(REDUCE, 339);
   _actionMap[508][DATE] = ActionEntry(REDUCE, 339);
   _actionMap[508][SYSDATE] = ActionEntry(REDUCE, 339);
   _actionMap[508][NULLTOKEN] = ActionEntry(REDUCE, 339);
   _actionMap[508][TRUEVAL] = ActionEntry(REDUCE, 339);
   _actionMap[508][FALSEVAL] = ActionEntry(REDUCE, 339);
   _actionMap[508][LAB] = ActionEntry(REDUCE, 339);
   _actionMap[508][FLOATVAL] = ActionEntry(REDUCE, 339);
   _actionMap[508][MINUS] = ActionEntry(REDUCE, 339);
   _actionMap[508][INTVAL] = ActionEntry(REDUCE, 339);
   _actionMap[508][EQU] = ActionEntry(SHIFT, 661);
   _actionMap[509][EQU] = ActionEntry(SHIFT, 662);
   _actionMap[510][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[510][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[510][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[510][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[510][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[510][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[510][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[510][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[510][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[510][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[510][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[510][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[510][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[510][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[510][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[510][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[510][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[510][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[510][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[510][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[510][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[510][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[510][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[510][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[510][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[510][DIV] = ActionEntry(SHIFT, 112);
}
void Cego::loadParser78()
{
   _actionMap[510][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[510][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[510][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[510][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[510][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[510][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[510][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[510][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[510][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[510][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[510][LB] = ActionEntry(SHIFT, 374);
   _actionMap[510][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[510][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[510][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[510][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[510][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[510][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[510][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[510][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[510][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[510][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[510][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[510][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[510][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[510][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[510][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[510][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[510][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[510][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[510][ObjSpec] = 100;
   _jumpMap[510][Constant] = 99;
   _jumpMap[510][SignedFloat] = 98;
   _jumpMap[510][SignedInt] = 97;
   _jumpMap[510][Attribute] = 96;
   _jumpMap[510][QueryPredicate] = 663;
   _jumpMap[510][Function] = 95;
   _jumpMap[510][CasePrepare] = 94;
   _jumpMap[510][CaseClause] = 93;
   _jumpMap[510][Factor] = 92;
   _jumpMap[510][Term] = 91;
   _jumpMap[510][Expr] = 369;
   _actionMap[511][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[511][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[511][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[511][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[511][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[511][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[511][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[511][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[511][DATE2INT] = ActionEntry(SHIFT, 111);
}
void Cego::loadParser79()
{
   _actionMap[511][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[511][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[511][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[511][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[511][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[511][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[511][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[511][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[511][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[511][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[511][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[511][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[511][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[511][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[511][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[511][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[511][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[511][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[511][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[511][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[511][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[511][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[511][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[511][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[511][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[511][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[511][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[511][LB] = ActionEntry(SHIFT, 374);
   _actionMap[511][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[511][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[511][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[511][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[511][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[511][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[511][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[511][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[511][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[511][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[511][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[511][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[511][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[511][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[511][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[511][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[511][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[511][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[511][ObjSpec] = 100;
   _jumpMap[511][Constant] = 99;
   _jumpMap[511][SignedFloat] = 98;
   _jumpMap[511][SignedInt] = 97;
}
void Cego::loadParser80()
{
   _jumpMap[511][Attribute] = 96;
   _jumpMap[511][QueryPredicate] = 664;
   _jumpMap[511][Function] = 95;
   _jumpMap[511][CasePrepare] = 94;
   _jumpMap[511][CaseClause] = 93;
   _jumpMap[511][Factor] = 92;
   _jumpMap[511][Term] = 91;
   _jumpMap[511][Expr] = 369;
   _actionMap[512][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[512][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[512][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[512][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[512][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[512][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[512][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[512][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[512][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[512][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[512][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[512][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[512][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[512][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[512][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[512][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[512][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[512][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[512][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[512][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[512][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[512][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[512][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[512][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[512][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[512][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[512][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[512][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[512][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[512][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[512][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[512][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[512][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[512][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[512][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[512][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[512][LB] = ActionEntry(SHIFT, 144);
   _actionMap[512][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[512][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[512][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[512][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[512][TRUEVAL] = ActionEntry(SHIFT, 141);
}
void Cego::loadParser81()
{
   _actionMap[512][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[512][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[512][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[512][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[512][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[512][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[512][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[512][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[512][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[512][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[512][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[512][ObjSpec] = 100;
   _jumpMap[512][Constant] = 99;
   _jumpMap[512][SignedFloat] = 98;
   _jumpMap[512][SignedInt] = 97;
   _jumpMap[512][Attribute] = 96;
   _jumpMap[512][Function] = 95;
   _jumpMap[512][CasePrepare] = 94;
   _jumpMap[512][CaseClause] = 93;
   _jumpMap[512][Factor] = 92;
   _jumpMap[512][Term] = 91;
   _jumpMap[512][Expr] = 665;
   _actionMap[513][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[513][SelectStatement] = 666;
   _actionMap[514][THEN] = ActionEntry(REDUCE, 322);
   _actionMap[514][LEFT] = ActionEntry(REDUCE, 322);
   _actionMap[514][RIGHT] = ActionEntry(REDUCE, 322);
   _actionMap[514][INNER] = ActionEntry(REDUCE, 322);
   _actionMap[514][JOIN] = ActionEntry(REDUCE, 322);
   _actionMap[514][RETURNTOKEN] = ActionEntry(REDUCE, 322);
   _actionMap[514][SEMICOLON] = ActionEntry(REDUCE, 322);
   _actionMap[514][RB] = ActionEntry(REDUCE, 322);
   _actionMap[514][ENDTOKEN] = ActionEntry(REDUCE, 322);
   _actionMap[514][UNION] = ActionEntry(REDUCE, 322);
   _actionMap[514][ROWLIMIT] = ActionEntry(REDUCE, 322);
   _actionMap[514][ORDER] = ActionEntry(REDUCE, 322);
   _actionMap[514][GROUP] = ActionEntry(REDUCE, 322);
   _actionMap[514][WHERE] = ActionEntry(REDUCE, 322);
   _actionMap[514][AND] = ActionEntry(REDUCE, 322);
   _actionMap[514][OR] = ActionEntry(REDUCE, 322);
   _actionMap[515][RB] = ActionEntry(SHIFT, 418);
   _actionMap[515][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[515][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[515][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[515][INTOK] = ActionEntry(SHIFT, 502);
   _actionMap[515][NOT] = ActionEntry(SHIFT, 505);
   _actionMap[515][BETWEEN] = ActionEntry(SHIFT, 501);
   _actionMap[515][IS] = ActionEntry(SHIFT, 503);
   _actionMap[515][LIKE] = ActionEntry(SHIFT, 504);
   _actionMap[515][EQU] = ActionEntry(SHIFT, 506);
}
void Cego::loadParser82()
{
   _actionMap[515][NEGATION] = ActionEntry(SHIFT, 509);
   _actionMap[515][LT] = ActionEntry(SHIFT, 507);
   _actionMap[515][MT] = ActionEntry(SHIFT, 508);
   _jumpMap[515][Comparison] = 500;
   _actionMap[516][RB] = ActionEntry(SHIFT, 667);
   _actionMap[516][AND] = ActionEntry(SHIFT, 510);
   _actionMap[516][OR] = ActionEntry(SHIFT, 511);
   _actionMap[517][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[517][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[517][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[517][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[517][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[517][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[517][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[517][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[517][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[517][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[517][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[517][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[517][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[517][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[517][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[517][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[517][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[517][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[517][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[517][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[517][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[517][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[517][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[517][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[517][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[517][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[517][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[517][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[517][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[517][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[517][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[517][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[517][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[517][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[517][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[517][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[517][LB] = ActionEntry(SHIFT, 144);
   _actionMap[517][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[517][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[517][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[517][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[517][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[517][FALSEVAL] = ActionEntry(SHIFT, 113);
}
void Cego::loadParser83()
{
   _actionMap[517][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[517][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[517][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[517][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[517][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[517][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[517][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[517][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[517][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[517][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[517][ObjSpec] = 100;
   _jumpMap[517][Constant] = 99;
   _jumpMap[517][SignedFloat] = 98;
   _jumpMap[517][SignedInt] = 97;
   _jumpMap[517][Attribute] = 96;
   _jumpMap[517][Function] = 95;
   _jumpMap[517][CasePrepare] = 94;
   _jumpMap[517][CaseClause] = 93;
   _jumpMap[517][Factor] = 92;
   _jumpMap[517][Term] = 91;
   _jumpMap[517][Expr] = 668;
   _actionMap[518][WHEN] = ActionEntry(REDUCE, 302);
   _actionMap[518][ELSE] = ActionEntry(REDUCE, 302);
   _actionMap[518][LEFT] = ActionEntry(REDUCE, 302);
   _actionMap[518][RIGHT] = ActionEntry(REDUCE, 302);
   _actionMap[518][INNER] = ActionEntry(REDUCE, 302);
   _actionMap[518][JOIN] = ActionEntry(REDUCE, 302);
   _actionMap[518][RETURNTOKEN] = ActionEntry(REDUCE, 302);
   _actionMap[518][ORDER] = ActionEntry(REDUCE, 302);
   _actionMap[518][GROUP] = ActionEntry(REDUCE, 302);
   _actionMap[518][WHERE] = ActionEntry(REDUCE, 302);
   _actionMap[518][FROM] = ActionEntry(REDUCE, 302);
   _actionMap[518][AS] = ActionEntry(REDUCE, 302);
   _actionMap[518][END_TOKEN] = ActionEntry(REDUCE, 302);
   _actionMap[518][BEGIN] = ActionEntry(REDUCE, 302);
   _actionMap[518][THEN] = ActionEntry(REDUCE, 302);
   _actionMap[518][OR] = ActionEntry(REDUCE, 302);
   _actionMap[518][AND] = ActionEntry(REDUCE, 302);
   _actionMap[518][INTOK] = ActionEntry(REDUCE, 302);
   _actionMap[518][NOT] = ActionEntry(REDUCE, 302);
   _actionMap[518][BETWEEN] = ActionEntry(REDUCE, 302);
   _actionMap[518][IS] = ActionEntry(REDUCE, 302);
   _actionMap[518][LIKE] = ActionEntry(REDUCE, 302);
   _actionMap[518][MT] = ActionEntry(REDUCE, 302);
   _actionMap[518][LT] = ActionEntry(REDUCE, 302);
   _actionMap[518][NEGATION] = ActionEntry(REDUCE, 302);
   _actionMap[518][EQU] = ActionEntry(REDUCE, 302);
   _actionMap[518][RB] = ActionEntry(REDUCE, 302);
   _actionMap[518][ENDTOKEN] = ActionEntry(REDUCE, 302);
   _actionMap[518][UNION] = ActionEntry(REDUCE, 302);
}
void Cego::loadParser84()
{
   _actionMap[518][ROWLIMIT] = ActionEntry(REDUCE, 302);
   _actionMap[518][KSEP] = ActionEntry(REDUCE, 302);
   _actionMap[518][ASC] = ActionEntry(REDUCE, 302);
   _actionMap[518][DESC] = ActionEntry(REDUCE, 302);
   _actionMap[518][SEMICOLON] = ActionEntry(REDUCE, 302);
   _actionMap[518][PLUS] = ActionEntry(REDUCE, 302);
   _actionMap[518][MINUS] = ActionEntry(REDUCE, 302);
   _actionMap[518][DIVISION] = ActionEntry(REDUCE, 302);
   _actionMap[518][STAR] = ActionEntry(REDUCE, 302);
   _actionMap[518][CONCAT] = ActionEntry(REDUCE, 302);
   _actionMap[519][WHEN] = ActionEntry(REDUCE, 157);
   _actionMap[519][ELSE] = ActionEntry(REDUCE, 157);
   _actionMap[519][LEFT] = ActionEntry(REDUCE, 157);
   _actionMap[519][RIGHT] = ActionEntry(REDUCE, 157);
   _actionMap[519][INNER] = ActionEntry(REDUCE, 157);
   _actionMap[519][JOIN] = ActionEntry(REDUCE, 157);
   _actionMap[519][RETURNTOKEN] = ActionEntry(REDUCE, 157);
   _actionMap[519][ORDER] = ActionEntry(REDUCE, 157);
   _actionMap[519][GROUP] = ActionEntry(REDUCE, 157);
   _actionMap[519][WHERE] = ActionEntry(REDUCE, 157);
   _actionMap[519][AS] = ActionEntry(REDUCE, 157);
   _actionMap[519][FROM] = ActionEntry(REDUCE, 157);
   _actionMap[519][END_TOKEN] = ActionEntry(REDUCE, 157);
   _actionMap[519][BEGIN] = ActionEntry(REDUCE, 157);
   _actionMap[519][THEN] = ActionEntry(REDUCE, 157);
   _actionMap[519][OR] = ActionEntry(REDUCE, 157);
   _actionMap[519][AND] = ActionEntry(REDUCE, 157);
   _actionMap[519][LIKE] = ActionEntry(REDUCE, 157);
   _actionMap[519][IS] = ActionEntry(REDUCE, 157);
   _actionMap[519][BETWEEN] = ActionEntry(REDUCE, 157);
   _actionMap[519][NOT] = ActionEntry(REDUCE, 157);
   _actionMap[519][INTOK] = ActionEntry(REDUCE, 157);
   _actionMap[519][EQU] = ActionEntry(REDUCE, 157);
   _actionMap[519][NEGATION] = ActionEntry(REDUCE, 157);
   _actionMap[519][LT] = ActionEntry(REDUCE, 157);
   _actionMap[519][MT] = ActionEntry(REDUCE, 157);
   _actionMap[519][DESC] = ActionEntry(REDUCE, 157);
   _actionMap[519][ASC] = ActionEntry(REDUCE, 157);
   _actionMap[519][KSEP] = ActionEntry(REDUCE, 157);
   _actionMap[519][ROWLIMIT] = ActionEntry(REDUCE, 157);
   _actionMap[519][UNION] = ActionEntry(REDUCE, 157);
   _actionMap[519][ENDTOKEN] = ActionEntry(REDUCE, 157);
   _actionMap[519][RB] = ActionEntry(REDUCE, 157);
   _actionMap[519][SEMICOLON] = ActionEntry(REDUCE, 157);
   _actionMap[519][CONCAT] = ActionEntry(REDUCE, 157);
   _actionMap[519][STAR] = ActionEntry(REDUCE, 157);
   _actionMap[519][DIVISION] = ActionEntry(REDUCE, 157);
   _actionMap[519][MINUS] = ActionEntry(REDUCE, 157);
   _actionMap[519][PLUS] = ActionEntry(REDUCE, 157);
   _actionMap[520][WHEN] = ActionEntry(REDUCE, 296);
}
void Cego::loadParser85()
{
   _actionMap[520][ELSE] = ActionEntry(REDUCE, 296);
   _actionMap[520][LEFT] = ActionEntry(REDUCE, 296);
   _actionMap[520][RIGHT] = ActionEntry(REDUCE, 296);
   _actionMap[520][INNER] = ActionEntry(REDUCE, 296);
   _actionMap[520][JOIN] = ActionEntry(REDUCE, 296);
   _actionMap[520][RETURNTOKEN] = ActionEntry(REDUCE, 296);
   _actionMap[520][ORDER] = ActionEntry(REDUCE, 296);
   _actionMap[520][GROUP] = ActionEntry(REDUCE, 296);
   _actionMap[520][WHERE] = ActionEntry(REDUCE, 296);
   _actionMap[520][FROM] = ActionEntry(REDUCE, 296);
   _actionMap[520][AS] = ActionEntry(REDUCE, 296);
   _actionMap[520][END_TOKEN] = ActionEntry(REDUCE, 296);
   _actionMap[520][BEGIN] = ActionEntry(REDUCE, 296);
   _actionMap[520][THEN] = ActionEntry(REDUCE, 296);
   _actionMap[520][OR] = ActionEntry(REDUCE, 296);
   _actionMap[520][AND] = ActionEntry(REDUCE, 296);
   _actionMap[520][INTOK] = ActionEntry(REDUCE, 296);
   _actionMap[520][NOT] = ActionEntry(REDUCE, 296);
   _actionMap[520][BETWEEN] = ActionEntry(REDUCE, 296);
   _actionMap[520][IS] = ActionEntry(REDUCE, 296);
   _actionMap[520][LIKE] = ActionEntry(REDUCE, 296);
   _actionMap[520][MT] = ActionEntry(REDUCE, 296);
   _actionMap[520][LT] = ActionEntry(REDUCE, 296);
   _actionMap[520][NEGATION] = ActionEntry(REDUCE, 296);
   _actionMap[520][EQU] = ActionEntry(REDUCE, 296);
   _actionMap[520][RB] = ActionEntry(REDUCE, 296);
   _actionMap[520][ENDTOKEN] = ActionEntry(REDUCE, 296);
   _actionMap[520][UNION] = ActionEntry(REDUCE, 296);
   _actionMap[520][ROWLIMIT] = ActionEntry(REDUCE, 296);
   _actionMap[520][KSEP] = ActionEntry(REDUCE, 296);
   _actionMap[520][ASC] = ActionEntry(REDUCE, 296);
   _actionMap[520][DESC] = ActionEntry(REDUCE, 296);
   _actionMap[520][SEMICOLON] = ActionEntry(REDUCE, 296);
   _actionMap[520][PLUS] = ActionEntry(REDUCE, 296);
   _actionMap[520][MINUS] = ActionEntry(REDUCE, 296);
   _actionMap[520][DIVISION] = ActionEntry(REDUCE, 296);
   _actionMap[520][STAR] = ActionEntry(REDUCE, 296);
   _actionMap[520][CONCAT] = ActionEntry(REDUCE, 296);
   _actionMap[521][WHEN] = ActionEntry(REDUCE, 297);
   _actionMap[521][ELSE] = ActionEntry(REDUCE, 297);
   _actionMap[521][LEFT] = ActionEntry(REDUCE, 297);
   _actionMap[521][RIGHT] = ActionEntry(REDUCE, 297);
   _actionMap[521][INNER] = ActionEntry(REDUCE, 297);
   _actionMap[521][JOIN] = ActionEntry(REDUCE, 297);
   _actionMap[521][RETURNTOKEN] = ActionEntry(REDUCE, 297);
   _actionMap[521][ORDER] = ActionEntry(REDUCE, 297);
   _actionMap[521][GROUP] = ActionEntry(REDUCE, 297);
   _actionMap[521][WHERE] = ActionEntry(REDUCE, 297);
   _actionMap[521][FROM] = ActionEntry(REDUCE, 297);
   _actionMap[521][AS] = ActionEntry(REDUCE, 297);
}
void Cego::loadParser86()
{
   _actionMap[521][END_TOKEN] = ActionEntry(REDUCE, 297);
   _actionMap[521][BEGIN] = ActionEntry(REDUCE, 297);
   _actionMap[521][THEN] = ActionEntry(REDUCE, 297);
   _actionMap[521][OR] = ActionEntry(REDUCE, 297);
   _actionMap[521][AND] = ActionEntry(REDUCE, 297);
   _actionMap[521][INTOK] = ActionEntry(REDUCE, 297);
   _actionMap[521][NOT] = ActionEntry(REDUCE, 297);
   _actionMap[521][BETWEEN] = ActionEntry(REDUCE, 297);
   _actionMap[521][IS] = ActionEntry(REDUCE, 297);
   _actionMap[521][LIKE] = ActionEntry(REDUCE, 297);
   _actionMap[521][MT] = ActionEntry(REDUCE, 297);
   _actionMap[521][LT] = ActionEntry(REDUCE, 297);
   _actionMap[521][NEGATION] = ActionEntry(REDUCE, 297);
   _actionMap[521][EQU] = ActionEntry(REDUCE, 297);
   _actionMap[521][RB] = ActionEntry(REDUCE, 297);
   _actionMap[521][ENDTOKEN] = ActionEntry(REDUCE, 297);
   _actionMap[521][UNION] = ActionEntry(REDUCE, 297);
   _actionMap[521][ROWLIMIT] = ActionEntry(REDUCE, 297);
   _actionMap[521][KSEP] = ActionEntry(REDUCE, 297);
   _actionMap[521][ASC] = ActionEntry(REDUCE, 297);
   _actionMap[521][DESC] = ActionEntry(REDUCE, 297);
   _actionMap[521][SEMICOLON] = ActionEntry(REDUCE, 297);
   _actionMap[521][PLUS] = ActionEntry(REDUCE, 297);
   _actionMap[521][MINUS] = ActionEntry(REDUCE, 297);
   _actionMap[521][DIVISION] = ActionEntry(REDUCE, 297);
   _actionMap[521][STAR] = ActionEntry(REDUCE, 297);
   _actionMap[521][CONCAT] = ActionEntry(REDUCE, 297);
   _actionMap[522][WHEN] = ActionEntry(REDUCE, 298);
   _actionMap[522][ELSE] = ActionEntry(REDUCE, 298);
   _actionMap[522][LEFT] = ActionEntry(REDUCE, 298);
   _actionMap[522][RIGHT] = ActionEntry(REDUCE, 298);
   _actionMap[522][INNER] = ActionEntry(REDUCE, 298);
   _actionMap[522][JOIN] = ActionEntry(REDUCE, 298);
   _actionMap[522][RETURNTOKEN] = ActionEntry(REDUCE, 298);
   _actionMap[522][ORDER] = ActionEntry(REDUCE, 298);
   _actionMap[522][GROUP] = ActionEntry(REDUCE, 298);
   _actionMap[522][WHERE] = ActionEntry(REDUCE, 298);
   _actionMap[522][FROM] = ActionEntry(REDUCE, 298);
   _actionMap[522][AS] = ActionEntry(REDUCE, 298);
   _actionMap[522][END_TOKEN] = ActionEntry(REDUCE, 298);
   _actionMap[522][BEGIN] = ActionEntry(REDUCE, 298);
   _actionMap[522][THEN] = ActionEntry(REDUCE, 298);
   _actionMap[522][OR] = ActionEntry(REDUCE, 298);
   _actionMap[522][AND] = ActionEntry(REDUCE, 298);
   _actionMap[522][INTOK] = ActionEntry(REDUCE, 298);
   _actionMap[522][NOT] = ActionEntry(REDUCE, 298);
   _actionMap[522][BETWEEN] = ActionEntry(REDUCE, 298);
   _actionMap[522][IS] = ActionEntry(REDUCE, 298);
   _actionMap[522][LIKE] = ActionEntry(REDUCE, 298);
   _actionMap[522][MT] = ActionEntry(REDUCE, 298);
}
void Cego::loadParser87()
{
   _actionMap[522][LT] = ActionEntry(REDUCE, 298);
   _actionMap[522][NEGATION] = ActionEntry(REDUCE, 298);
   _actionMap[522][EQU] = ActionEntry(REDUCE, 298);
   _actionMap[522][RB] = ActionEntry(REDUCE, 298);
   _actionMap[522][ENDTOKEN] = ActionEntry(REDUCE, 298);
   _actionMap[522][UNION] = ActionEntry(REDUCE, 298);
   _actionMap[522][ROWLIMIT] = ActionEntry(REDUCE, 298);
   _actionMap[522][KSEP] = ActionEntry(REDUCE, 298);
   _actionMap[522][ASC] = ActionEntry(REDUCE, 298);
   _actionMap[522][DESC] = ActionEntry(REDUCE, 298);
   _actionMap[522][SEMICOLON] = ActionEntry(REDUCE, 298);
   _actionMap[522][PLUS] = ActionEntry(REDUCE, 298);
   _actionMap[522][MINUS] = ActionEntry(REDUCE, 298);
   _actionMap[522][DIVISION] = ActionEntry(REDUCE, 298);
   _actionMap[522][STAR] = ActionEntry(REDUCE, 298);
   _actionMap[522][CONCAT] = ActionEntry(REDUCE, 298);
   _actionMap[523][WHEN] = ActionEntry(REDUCE, 299);
   _actionMap[523][ELSE] = ActionEntry(REDUCE, 299);
   _actionMap[523][LEFT] = ActionEntry(REDUCE, 299);
   _actionMap[523][RIGHT] = ActionEntry(REDUCE, 299);
   _actionMap[523][INNER] = ActionEntry(REDUCE, 299);
   _actionMap[523][JOIN] = ActionEntry(REDUCE, 299);
   _actionMap[523][RETURNTOKEN] = ActionEntry(REDUCE, 299);
   _actionMap[523][ORDER] = ActionEntry(REDUCE, 299);
   _actionMap[523][GROUP] = ActionEntry(REDUCE, 299);
   _actionMap[523][WHERE] = ActionEntry(REDUCE, 299);
   _actionMap[523][FROM] = ActionEntry(REDUCE, 299);
   _actionMap[523][AS] = ActionEntry(REDUCE, 299);
   _actionMap[523][END_TOKEN] = ActionEntry(REDUCE, 299);
   _actionMap[523][BEGIN] = ActionEntry(REDUCE, 299);
   _actionMap[523][THEN] = ActionEntry(REDUCE, 299);
   _actionMap[523][OR] = ActionEntry(REDUCE, 299);
   _actionMap[523][AND] = ActionEntry(REDUCE, 299);
   _actionMap[523][INTOK] = ActionEntry(REDUCE, 299);
   _actionMap[523][NOT] = ActionEntry(REDUCE, 299);
   _actionMap[523][BETWEEN] = ActionEntry(REDUCE, 299);
   _actionMap[523][IS] = ActionEntry(REDUCE, 299);
   _actionMap[523][LIKE] = ActionEntry(REDUCE, 299);
   _actionMap[523][MT] = ActionEntry(REDUCE, 299);
   _actionMap[523][LT] = ActionEntry(REDUCE, 299);
   _actionMap[523][NEGATION] = ActionEntry(REDUCE, 299);
   _actionMap[523][EQU] = ActionEntry(REDUCE, 299);
   _actionMap[523][RB] = ActionEntry(REDUCE, 299);
   _actionMap[523][ENDTOKEN] = ActionEntry(REDUCE, 299);
   _actionMap[523][UNION] = ActionEntry(REDUCE, 299);
   _actionMap[523][ROWLIMIT] = ActionEntry(REDUCE, 299);
   _actionMap[523][KSEP] = ActionEntry(REDUCE, 299);
   _actionMap[523][ASC] = ActionEntry(REDUCE, 299);
   _actionMap[523][DESC] = ActionEntry(REDUCE, 299);
   _actionMap[523][SEMICOLON] = ActionEntry(REDUCE, 299);
}
void Cego::loadParser88()
{
   _actionMap[523][PLUS] = ActionEntry(REDUCE, 299);
   _actionMap[523][MINUS] = ActionEntry(REDUCE, 299);
   _actionMap[523][DIVISION] = ActionEntry(REDUCE, 299);
   _actionMap[523][STAR] = ActionEntry(REDUCE, 299);
   _actionMap[523][CONCAT] = ActionEntry(REDUCE, 299);
   _actionMap[524][WHEN] = ActionEntry(REDUCE, 158);
   _actionMap[524][ELSE] = ActionEntry(REDUCE, 158);
   _actionMap[524][LEFT] = ActionEntry(REDUCE, 158);
   _actionMap[524][RIGHT] = ActionEntry(REDUCE, 158);
   _actionMap[524][INNER] = ActionEntry(REDUCE, 158);
   _actionMap[524][JOIN] = ActionEntry(REDUCE, 158);
   _actionMap[524][RETURNTOKEN] = ActionEntry(REDUCE, 158);
   _actionMap[524][ORDER] = ActionEntry(REDUCE, 158);
   _actionMap[524][GROUP] = ActionEntry(REDUCE, 158);
   _actionMap[524][WHERE] = ActionEntry(REDUCE, 158);
   _actionMap[524][AS] = ActionEntry(REDUCE, 158);
   _actionMap[524][FROM] = ActionEntry(REDUCE, 158);
   _actionMap[524][END_TOKEN] = ActionEntry(REDUCE, 158);
   _actionMap[524][BEGIN] = ActionEntry(REDUCE, 158);
   _actionMap[524][THEN] = ActionEntry(REDUCE, 158);
   _actionMap[524][OR] = ActionEntry(REDUCE, 158);
   _actionMap[524][AND] = ActionEntry(REDUCE, 158);
   _actionMap[524][LIKE] = ActionEntry(REDUCE, 158);
   _actionMap[524][IS] = ActionEntry(REDUCE, 158);
   _actionMap[524][BETWEEN] = ActionEntry(REDUCE, 158);
   _actionMap[524][NOT] = ActionEntry(REDUCE, 158);
   _actionMap[524][INTOK] = ActionEntry(REDUCE, 158);
   _actionMap[524][EQU] = ActionEntry(REDUCE, 158);
   _actionMap[524][NEGATION] = ActionEntry(REDUCE, 158);
   _actionMap[524][LT] = ActionEntry(REDUCE, 158);
   _actionMap[524][MT] = ActionEntry(REDUCE, 158);
   _actionMap[524][DESC] = ActionEntry(REDUCE, 158);
   _actionMap[524][ASC] = ActionEntry(REDUCE, 158);
   _actionMap[524][KSEP] = ActionEntry(REDUCE, 158);
   _actionMap[524][ROWLIMIT] = ActionEntry(REDUCE, 158);
   _actionMap[524][UNION] = ActionEntry(REDUCE, 158);
   _actionMap[524][ENDTOKEN] = ActionEntry(REDUCE, 158);
   _actionMap[524][RB] = ActionEntry(REDUCE, 158);
   _actionMap[524][SEMICOLON] = ActionEntry(REDUCE, 158);
   _actionMap[524][CONCAT] = ActionEntry(REDUCE, 158);
   _actionMap[524][STAR] = ActionEntry(REDUCE, 158);
   _actionMap[524][DIVISION] = ActionEntry(REDUCE, 158);
   _actionMap[524][MINUS] = ActionEntry(REDUCE, 158);
   _actionMap[524][PLUS] = ActionEntry(REDUCE, 158);
   _actionMap[525][WHEN] = ActionEntry(REDUCE, 155);
   _actionMap[525][ELSE] = ActionEntry(REDUCE, 155);
   _actionMap[525][LEFT] = ActionEntry(REDUCE, 155);
   _actionMap[525][RIGHT] = ActionEntry(REDUCE, 155);
   _actionMap[525][INNER] = ActionEntry(REDUCE, 155);
   _actionMap[525][JOIN] = ActionEntry(REDUCE, 155);
}
void Cego::loadParser89()
{
   _actionMap[525][RETURNTOKEN] = ActionEntry(REDUCE, 155);
   _actionMap[525][ORDER] = ActionEntry(REDUCE, 155);
   _actionMap[525][GROUP] = ActionEntry(REDUCE, 155);
   _actionMap[525][WHERE] = ActionEntry(REDUCE, 155);
   _actionMap[525][AS] = ActionEntry(REDUCE, 155);
   _actionMap[525][FROM] = ActionEntry(REDUCE, 155);
   _actionMap[525][END_TOKEN] = ActionEntry(REDUCE, 155);
   _actionMap[525][BEGIN] = ActionEntry(REDUCE, 155);
   _actionMap[525][THEN] = ActionEntry(REDUCE, 155);
   _actionMap[525][OR] = ActionEntry(REDUCE, 155);
   _actionMap[525][AND] = ActionEntry(REDUCE, 155);
   _actionMap[525][LIKE] = ActionEntry(REDUCE, 155);
   _actionMap[525][IS] = ActionEntry(REDUCE, 155);
   _actionMap[525][BETWEEN] = ActionEntry(REDUCE, 155);
   _actionMap[525][NOT] = ActionEntry(REDUCE, 155);
   _actionMap[525][INTOK] = ActionEntry(REDUCE, 155);
   _actionMap[525][EQU] = ActionEntry(REDUCE, 155);
   _actionMap[525][NEGATION] = ActionEntry(REDUCE, 155);
   _actionMap[525][LT] = ActionEntry(REDUCE, 155);
   _actionMap[525][MT] = ActionEntry(REDUCE, 155);
   _actionMap[525][DESC] = ActionEntry(REDUCE, 155);
   _actionMap[525][ASC] = ActionEntry(REDUCE, 155);
   _actionMap[525][KSEP] = ActionEntry(REDUCE, 155);
   _actionMap[525][ROWLIMIT] = ActionEntry(REDUCE, 155);
   _actionMap[525][UNION] = ActionEntry(REDUCE, 155);
   _actionMap[525][ENDTOKEN] = ActionEntry(REDUCE, 155);
   _actionMap[525][RB] = ActionEntry(REDUCE, 155);
   _actionMap[525][SEMICOLON] = ActionEntry(REDUCE, 155);
   _actionMap[525][CONCAT] = ActionEntry(REDUCE, 155);
   _actionMap[525][STAR] = ActionEntry(REDUCE, 155);
   _actionMap[525][DIVISION] = ActionEntry(REDUCE, 155);
   _actionMap[525][MINUS] = ActionEntry(REDUCE, 155);
   _actionMap[525][PLUS] = ActionEntry(REDUCE, 155);
   _actionMap[526][STRINGVAL] = ActionEntry(SHIFT, 670);
   _jumpMap[526][DateValue] = 669;
   _actionMap[527][WHEN] = ActionEntry(REDUCE, 276);
   _actionMap[527][ELSE] = ActionEntry(REDUCE, 276);
   _actionMap[527][LEFT] = ActionEntry(REDUCE, 276);
   _actionMap[527][RIGHT] = ActionEntry(REDUCE, 276);
   _actionMap[527][INNER] = ActionEntry(REDUCE, 276);
   _actionMap[527][JOIN] = ActionEntry(REDUCE, 276);
   _actionMap[527][RETURNTOKEN] = ActionEntry(REDUCE, 276);
   _actionMap[527][ORDER] = ActionEntry(REDUCE, 276);
   _actionMap[527][GROUP] = ActionEntry(REDUCE, 276);
   _actionMap[527][WHERE] = ActionEntry(REDUCE, 276);
   _actionMap[527][FROM] = ActionEntry(REDUCE, 276);
   _actionMap[527][AS] = ActionEntry(REDUCE, 276);
   _actionMap[527][END_TOKEN] = ActionEntry(REDUCE, 276);
   _actionMap[527][BEGIN] = ActionEntry(REDUCE, 276);
   _actionMap[527][THEN] = ActionEntry(REDUCE, 276);
}
void Cego::loadParser90()
{
   _actionMap[527][OR] = ActionEntry(REDUCE, 276);
   _actionMap[527][AND] = ActionEntry(REDUCE, 276);
   _actionMap[527][INTOK] = ActionEntry(REDUCE, 276);
   _actionMap[527][NOT] = ActionEntry(REDUCE, 276);
   _actionMap[527][BETWEEN] = ActionEntry(REDUCE, 276);
   _actionMap[527][IS] = ActionEntry(REDUCE, 276);
   _actionMap[527][LIKE] = ActionEntry(REDUCE, 276);
   _actionMap[527][MT] = ActionEntry(REDUCE, 276);
   _actionMap[527][LT] = ActionEntry(REDUCE, 276);
   _actionMap[527][NEGATION] = ActionEntry(REDUCE, 276);
   _actionMap[527][EQU] = ActionEntry(REDUCE, 276);
   _actionMap[527][RB] = ActionEntry(REDUCE, 276);
   _actionMap[527][ENDTOKEN] = ActionEntry(REDUCE, 276);
   _actionMap[527][UNION] = ActionEntry(REDUCE, 276);
   _actionMap[527][ROWLIMIT] = ActionEntry(REDUCE, 276);
   _actionMap[527][KSEP] = ActionEntry(REDUCE, 276);
   _actionMap[527][ASC] = ActionEntry(REDUCE, 276);
   _actionMap[527][DESC] = ActionEntry(REDUCE, 276);
   _actionMap[527][SEMICOLON] = ActionEntry(REDUCE, 276);
   _actionMap[527][PLUS] = ActionEntry(REDUCE, 276);
   _actionMap[527][MINUS] = ActionEntry(REDUCE, 276);
   _actionMap[527][DIVISION] = ActionEntry(REDUCE, 276);
   _actionMap[527][STAR] = ActionEntry(REDUCE, 276);
   _actionMap[527][CONCAT] = ActionEntry(REDUCE, 276);
   _actionMap[528][WHEN] = ActionEntry(REDUCE, 277);
   _actionMap[528][ELSE] = ActionEntry(REDUCE, 277);
   _actionMap[528][LEFT] = ActionEntry(REDUCE, 277);
   _actionMap[528][RIGHT] = ActionEntry(REDUCE, 277);
   _actionMap[528][INNER] = ActionEntry(REDUCE, 277);
   _actionMap[528][JOIN] = ActionEntry(REDUCE, 277);
   _actionMap[528][RETURNTOKEN] = ActionEntry(REDUCE, 277);
   _actionMap[528][ORDER] = ActionEntry(REDUCE, 277);
   _actionMap[528][GROUP] = ActionEntry(REDUCE, 277);
   _actionMap[528][WHERE] = ActionEntry(REDUCE, 277);
   _actionMap[528][FROM] = ActionEntry(REDUCE, 277);
   _actionMap[528][AS] = ActionEntry(REDUCE, 277);
   _actionMap[528][END_TOKEN] = ActionEntry(REDUCE, 277);
   _actionMap[528][BEGIN] = ActionEntry(REDUCE, 277);
   _actionMap[528][THEN] = ActionEntry(REDUCE, 277);
   _actionMap[528][OR] = ActionEntry(REDUCE, 277);
   _actionMap[528][AND] = ActionEntry(REDUCE, 277);
   _actionMap[528][INTOK] = ActionEntry(REDUCE, 277);
   _actionMap[528][NOT] = ActionEntry(REDUCE, 277);
   _actionMap[528][BETWEEN] = ActionEntry(REDUCE, 277);
   _actionMap[528][IS] = ActionEntry(REDUCE, 277);
   _actionMap[528][LIKE] = ActionEntry(REDUCE, 277);
   _actionMap[528][MT] = ActionEntry(REDUCE, 277);
   _actionMap[528][LT] = ActionEntry(REDUCE, 277);
   _actionMap[528][NEGATION] = ActionEntry(REDUCE, 277);
   _actionMap[528][EQU] = ActionEntry(REDUCE, 277);
}
void Cego::loadParser91()
{
   _actionMap[528][RB] = ActionEntry(REDUCE, 277);
   _actionMap[528][ENDTOKEN] = ActionEntry(REDUCE, 277);
   _actionMap[528][UNION] = ActionEntry(REDUCE, 277);
   _actionMap[528][ROWLIMIT] = ActionEntry(REDUCE, 277);
   _actionMap[528][KSEP] = ActionEntry(REDUCE, 277);
   _actionMap[528][ASC] = ActionEntry(REDUCE, 277);
   _actionMap[528][DESC] = ActionEntry(REDUCE, 277);
   _actionMap[528][SEMICOLON] = ActionEntry(REDUCE, 277);
   _actionMap[528][PLUS] = ActionEntry(REDUCE, 277);
   _actionMap[528][MINUS] = ActionEntry(REDUCE, 277);
   _actionMap[528][DIVISION] = ActionEntry(REDUCE, 277);
   _actionMap[528][STAR] = ActionEntry(REDUCE, 277);
   _actionMap[528][CONCAT] = ActionEntry(REDUCE, 277);
   _actionMap[529][WHEN] = ActionEntry(REDUCE, 294);
   _actionMap[529][ELSE] = ActionEntry(REDUCE, 294);
   _actionMap[529][LEFT] = ActionEntry(REDUCE, 294);
   _actionMap[529][RIGHT] = ActionEntry(REDUCE, 294);
   _actionMap[529][INNER] = ActionEntry(REDUCE, 294);
   _actionMap[529][JOIN] = ActionEntry(REDUCE, 294);
   _actionMap[529][RETURNTOKEN] = ActionEntry(REDUCE, 294);
   _actionMap[529][ORDER] = ActionEntry(REDUCE, 294);
   _actionMap[529][GROUP] = ActionEntry(REDUCE, 294);
   _actionMap[529][WHERE] = ActionEntry(REDUCE, 294);
   _actionMap[529][FROM] = ActionEntry(REDUCE, 294);
   _actionMap[529][AS] = ActionEntry(REDUCE, 294);
   _actionMap[529][END_TOKEN] = ActionEntry(REDUCE, 294);
   _actionMap[529][BEGIN] = ActionEntry(REDUCE, 294);
   _actionMap[529][THEN] = ActionEntry(REDUCE, 294);
   _actionMap[529][OR] = ActionEntry(REDUCE, 294);
   _actionMap[529][AND] = ActionEntry(REDUCE, 294);
   _actionMap[529][INTOK] = ActionEntry(REDUCE, 294);
   _actionMap[529][NOT] = ActionEntry(REDUCE, 294);
   _actionMap[529][BETWEEN] = ActionEntry(REDUCE, 294);
   _actionMap[529][IS] = ActionEntry(REDUCE, 294);
   _actionMap[529][LIKE] = ActionEntry(REDUCE, 294);
   _actionMap[529][MT] = ActionEntry(REDUCE, 294);
   _actionMap[529][LT] = ActionEntry(REDUCE, 294);
   _actionMap[529][NEGATION] = ActionEntry(REDUCE, 294);
   _actionMap[529][EQU] = ActionEntry(REDUCE, 294);
   _actionMap[529][RB] = ActionEntry(REDUCE, 294);
   _actionMap[529][ENDTOKEN] = ActionEntry(REDUCE, 294);
   _actionMap[529][UNION] = ActionEntry(REDUCE, 294);
   _actionMap[529][ROWLIMIT] = ActionEntry(REDUCE, 294);
   _actionMap[529][KSEP] = ActionEntry(REDUCE, 294);
   _actionMap[529][ASC] = ActionEntry(REDUCE, 294);
   _actionMap[529][DESC] = ActionEntry(REDUCE, 294);
   _actionMap[529][SEMICOLON] = ActionEntry(REDUCE, 294);
   _actionMap[529][PLUS] = ActionEntry(REDUCE, 294);
   _actionMap[529][MINUS] = ActionEntry(REDUCE, 294);
   _actionMap[529][DIVISION] = ActionEntry(REDUCE, 294);
}
void Cego::loadParser92()
{
   _actionMap[529][STAR] = ActionEntry(REDUCE, 294);
   _actionMap[529][CONCAT] = ActionEntry(REDUCE, 294);
   _actionMap[530][VARREF] = ActionEntry(SHIFT, 672);
   _jumpMap[530][FetchArgList] = 671;
   _actionMap[531][WHEN] = ActionEntry(REDUCE, 283);
   _actionMap[531][ELSE] = ActionEntry(REDUCE, 283);
   _actionMap[531][LEFT] = ActionEntry(REDUCE, 283);
   _actionMap[531][RIGHT] = ActionEntry(REDUCE, 283);
   _actionMap[531][INNER] = ActionEntry(REDUCE, 283);
   _actionMap[531][JOIN] = ActionEntry(REDUCE, 283);
   _actionMap[531][RETURNTOKEN] = ActionEntry(REDUCE, 283);
   _actionMap[531][ORDER] = ActionEntry(REDUCE, 283);
   _actionMap[531][GROUP] = ActionEntry(REDUCE, 283);
   _actionMap[531][WHERE] = ActionEntry(REDUCE, 283);
   _actionMap[531][FROM] = ActionEntry(REDUCE, 283);
   _actionMap[531][AS] = ActionEntry(REDUCE, 283);
   _actionMap[531][END_TOKEN] = ActionEntry(REDUCE, 283);
   _actionMap[531][BEGIN] = ActionEntry(REDUCE, 283);
   _actionMap[531][THEN] = ActionEntry(REDUCE, 283);
   _actionMap[531][OR] = ActionEntry(REDUCE, 283);
   _actionMap[531][AND] = ActionEntry(REDUCE, 283);
   _actionMap[531][INTOK] = ActionEntry(REDUCE, 283);
   _actionMap[531][NOT] = ActionEntry(REDUCE, 283);
   _actionMap[531][BETWEEN] = ActionEntry(REDUCE, 283);
   _actionMap[531][IS] = ActionEntry(REDUCE, 283);
   _actionMap[531][LIKE] = ActionEntry(REDUCE, 283);
   _actionMap[531][MT] = ActionEntry(REDUCE, 283);
   _actionMap[531][LT] = ActionEntry(REDUCE, 283);
   _actionMap[531][NEGATION] = ActionEntry(REDUCE, 283);
   _actionMap[531][EQU] = ActionEntry(REDUCE, 283);
   _actionMap[531][RB] = ActionEntry(REDUCE, 283);
   _actionMap[531][ENDTOKEN] = ActionEntry(REDUCE, 283);
   _actionMap[531][UNION] = ActionEntry(REDUCE, 283);
   _actionMap[531][ROWLIMIT] = ActionEntry(REDUCE, 283);
   _actionMap[531][KSEP] = ActionEntry(REDUCE, 283);
   _actionMap[531][ASC] = ActionEntry(REDUCE, 283);
   _actionMap[531][DESC] = ActionEntry(REDUCE, 283);
   _actionMap[531][SEMICOLON] = ActionEntry(REDUCE, 283);
   _actionMap[531][PLUS] = ActionEntry(REDUCE, 283);
   _actionMap[531][MINUS] = ActionEntry(REDUCE, 283);
   _actionMap[531][DIVISION] = ActionEntry(REDUCE, 283);
   _actionMap[531][STAR] = ActionEntry(REDUCE, 283);
   _actionMap[531][CONCAT] = ActionEntry(REDUCE, 283);
   _actionMap[532][WHEN] = ActionEntry(REDUCE, 278);
   _actionMap[532][ELSE] = ActionEntry(REDUCE, 278);
   _actionMap[532][LEFT] = ActionEntry(REDUCE, 278);
   _actionMap[532][RIGHT] = ActionEntry(REDUCE, 278);
   _actionMap[532][INNER] = ActionEntry(REDUCE, 278);
   _actionMap[532][JOIN] = ActionEntry(REDUCE, 278);
   _actionMap[532][RETURNTOKEN] = ActionEntry(REDUCE, 278);
}
void Cego::loadParser93()
{
   _actionMap[532][ORDER] = ActionEntry(REDUCE, 278);
   _actionMap[532][GROUP] = ActionEntry(REDUCE, 278);
   _actionMap[532][WHERE] = ActionEntry(REDUCE, 278);
   _actionMap[532][FROM] = ActionEntry(REDUCE, 278);
   _actionMap[532][AS] = ActionEntry(REDUCE, 278);
   _actionMap[532][END_TOKEN] = ActionEntry(REDUCE, 278);
   _actionMap[532][BEGIN] = ActionEntry(REDUCE, 278);
   _actionMap[532][THEN] = ActionEntry(REDUCE, 278);
   _actionMap[532][OR] = ActionEntry(REDUCE, 278);
   _actionMap[532][AND] = ActionEntry(REDUCE, 278);
   _actionMap[532][INTOK] = ActionEntry(REDUCE, 278);
   _actionMap[532][NOT] = ActionEntry(REDUCE, 278);
   _actionMap[532][BETWEEN] = ActionEntry(REDUCE, 278);
   _actionMap[532][IS] = ActionEntry(REDUCE, 278);
   _actionMap[532][LIKE] = ActionEntry(REDUCE, 278);
   _actionMap[532][MT] = ActionEntry(REDUCE, 278);
   _actionMap[532][LT] = ActionEntry(REDUCE, 278);
   _actionMap[532][NEGATION] = ActionEntry(REDUCE, 278);
   _actionMap[532][EQU] = ActionEntry(REDUCE, 278);
   _actionMap[532][RB] = ActionEntry(REDUCE, 278);
   _actionMap[532][ENDTOKEN] = ActionEntry(REDUCE, 278);
   _actionMap[532][UNION] = ActionEntry(REDUCE, 278);
   _actionMap[532][ROWLIMIT] = ActionEntry(REDUCE, 278);
   _actionMap[532][KSEP] = ActionEntry(REDUCE, 278);
   _actionMap[532][ASC] = ActionEntry(REDUCE, 278);
   _actionMap[532][DESC] = ActionEntry(REDUCE, 278);
   _actionMap[532][SEMICOLON] = ActionEntry(REDUCE, 278);
   _actionMap[532][PLUS] = ActionEntry(REDUCE, 278);
   _actionMap[532][MINUS] = ActionEntry(REDUCE, 278);
   _actionMap[532][DIVISION] = ActionEntry(REDUCE, 278);
   _actionMap[532][STAR] = ActionEntry(REDUCE, 278);
   _actionMap[532][CONCAT] = ActionEntry(REDUCE, 278);
   _actionMap[533][WHEN] = ActionEntry(REDUCE, 281);
   _actionMap[533][ELSE] = ActionEntry(REDUCE, 281);
   _actionMap[533][LEFT] = ActionEntry(REDUCE, 281);
   _actionMap[533][RIGHT] = ActionEntry(REDUCE, 281);
   _actionMap[533][INNER] = ActionEntry(REDUCE, 281);
   _actionMap[533][JOIN] = ActionEntry(REDUCE, 281);
   _actionMap[533][RETURNTOKEN] = ActionEntry(REDUCE, 281);
   _actionMap[533][ORDER] = ActionEntry(REDUCE, 281);
   _actionMap[533][GROUP] = ActionEntry(REDUCE, 281);
   _actionMap[533][WHERE] = ActionEntry(REDUCE, 281);
   _actionMap[533][FROM] = ActionEntry(REDUCE, 281);
   _actionMap[533][AS] = ActionEntry(REDUCE, 281);
   _actionMap[533][END_TOKEN] = ActionEntry(REDUCE, 281);
   _actionMap[533][BEGIN] = ActionEntry(REDUCE, 281);
   _actionMap[533][THEN] = ActionEntry(REDUCE, 281);
   _actionMap[533][OR] = ActionEntry(REDUCE, 281);
   _actionMap[533][AND] = ActionEntry(REDUCE, 281);
   _actionMap[533][INTOK] = ActionEntry(REDUCE, 281);
}
void Cego::loadParser94()
{
   _actionMap[533][NOT] = ActionEntry(REDUCE, 281);
   _actionMap[533][BETWEEN] = ActionEntry(REDUCE, 281);
   _actionMap[533][IS] = ActionEntry(REDUCE, 281);
   _actionMap[533][LIKE] = ActionEntry(REDUCE, 281);
   _actionMap[533][MT] = ActionEntry(REDUCE, 281);
   _actionMap[533][LT] = ActionEntry(REDUCE, 281);
   _actionMap[533][NEGATION] = ActionEntry(REDUCE, 281);
   _actionMap[533][EQU] = ActionEntry(REDUCE, 281);
   _actionMap[533][RB] = ActionEntry(REDUCE, 281);
   _actionMap[533][ENDTOKEN] = ActionEntry(REDUCE, 281);
   _actionMap[533][UNION] = ActionEntry(REDUCE, 281);
   _actionMap[533][ROWLIMIT] = ActionEntry(REDUCE, 281);
   _actionMap[533][KSEP] = ActionEntry(REDUCE, 281);
   _actionMap[533][ASC] = ActionEntry(REDUCE, 281);
   _actionMap[533][DESC] = ActionEntry(REDUCE, 281);
   _actionMap[533][SEMICOLON] = ActionEntry(REDUCE, 281);
   _actionMap[533][PLUS] = ActionEntry(REDUCE, 281);
   _actionMap[533][MINUS] = ActionEntry(REDUCE, 281);
   _actionMap[533][DIVISION] = ActionEntry(REDUCE, 281);
   _actionMap[533][STAR] = ActionEntry(REDUCE, 281);
   _actionMap[533][CONCAT] = ActionEntry(REDUCE, 281);
   _actionMap[534][WHEN] = ActionEntry(REDUCE, 286);
   _actionMap[534][ELSE] = ActionEntry(REDUCE, 286);
   _actionMap[534][LEFT] = ActionEntry(REDUCE, 286);
   _actionMap[534][RIGHT] = ActionEntry(REDUCE, 286);
   _actionMap[534][INNER] = ActionEntry(REDUCE, 286);
   _actionMap[534][JOIN] = ActionEntry(REDUCE, 286);
   _actionMap[534][RETURNTOKEN] = ActionEntry(REDUCE, 286);
   _actionMap[534][ORDER] = ActionEntry(REDUCE, 286);
   _actionMap[534][GROUP] = ActionEntry(REDUCE, 286);
   _actionMap[534][WHERE] = ActionEntry(REDUCE, 286);
   _actionMap[534][FROM] = ActionEntry(REDUCE, 286);
   _actionMap[534][AS] = ActionEntry(REDUCE, 286);
   _actionMap[534][END_TOKEN] = ActionEntry(REDUCE, 286);
   _actionMap[534][BEGIN] = ActionEntry(REDUCE, 286);
   _actionMap[534][THEN] = ActionEntry(REDUCE, 286);
   _actionMap[534][OR] = ActionEntry(REDUCE, 286);
   _actionMap[534][AND] = ActionEntry(REDUCE, 286);
   _actionMap[534][INTOK] = ActionEntry(REDUCE, 286);
   _actionMap[534][NOT] = ActionEntry(REDUCE, 286);
   _actionMap[534][BETWEEN] = ActionEntry(REDUCE, 286);
   _actionMap[534][IS] = ActionEntry(REDUCE, 286);
   _actionMap[534][LIKE] = ActionEntry(REDUCE, 286);
   _actionMap[534][MT] = ActionEntry(REDUCE, 286);
   _actionMap[534][LT] = ActionEntry(REDUCE, 286);
   _actionMap[534][NEGATION] = ActionEntry(REDUCE, 286);
   _actionMap[534][EQU] = ActionEntry(REDUCE, 286);
   _actionMap[534][RB] = ActionEntry(REDUCE, 286);
   _actionMap[534][ENDTOKEN] = ActionEntry(REDUCE, 286);
   _actionMap[534][UNION] = ActionEntry(REDUCE, 286);
}
void Cego::loadParser95()
{
   _actionMap[534][ROWLIMIT] = ActionEntry(REDUCE, 286);
   _actionMap[534][KSEP] = ActionEntry(REDUCE, 286);
   _actionMap[534][ASC] = ActionEntry(REDUCE, 286);
   _actionMap[534][DESC] = ActionEntry(REDUCE, 286);
   _actionMap[534][SEMICOLON] = ActionEntry(REDUCE, 286);
   _actionMap[534][PLUS] = ActionEntry(REDUCE, 286);
   _actionMap[534][MINUS] = ActionEntry(REDUCE, 286);
   _actionMap[534][DIVISION] = ActionEntry(REDUCE, 286);
   _actionMap[534][STAR] = ActionEntry(REDUCE, 286);
   _actionMap[534][CONCAT] = ActionEntry(REDUCE, 286);
   _actionMap[535][WHEN] = ActionEntry(REDUCE, 279);
   _actionMap[535][ELSE] = ActionEntry(REDUCE, 279);
   _actionMap[535][LEFT] = ActionEntry(REDUCE, 279);
   _actionMap[535][RIGHT] = ActionEntry(REDUCE, 279);
   _actionMap[535][INNER] = ActionEntry(REDUCE, 279);
   _actionMap[535][JOIN] = ActionEntry(REDUCE, 279);
   _actionMap[535][RETURNTOKEN] = ActionEntry(REDUCE, 279);
   _actionMap[535][ORDER] = ActionEntry(REDUCE, 279);
   _actionMap[535][GROUP] = ActionEntry(REDUCE, 279);
   _actionMap[535][WHERE] = ActionEntry(REDUCE, 279);
   _actionMap[535][FROM] = ActionEntry(REDUCE, 279);
   _actionMap[535][AS] = ActionEntry(REDUCE, 279);
   _actionMap[535][END_TOKEN] = ActionEntry(REDUCE, 279);
   _actionMap[535][BEGIN] = ActionEntry(REDUCE, 279);
   _actionMap[535][THEN] = ActionEntry(REDUCE, 279);
   _actionMap[535][OR] = ActionEntry(REDUCE, 279);
   _actionMap[535][AND] = ActionEntry(REDUCE, 279);
   _actionMap[535][INTOK] = ActionEntry(REDUCE, 279);
   _actionMap[535][NOT] = ActionEntry(REDUCE, 279);
   _actionMap[535][BETWEEN] = ActionEntry(REDUCE, 279);
   _actionMap[535][IS] = ActionEntry(REDUCE, 279);
   _actionMap[535][LIKE] = ActionEntry(REDUCE, 279);
   _actionMap[535][MT] = ActionEntry(REDUCE, 279);
   _actionMap[535][LT] = ActionEntry(REDUCE, 279);
   _actionMap[535][NEGATION] = ActionEntry(REDUCE, 279);
   _actionMap[535][EQU] = ActionEntry(REDUCE, 279);
   _actionMap[535][RB] = ActionEntry(REDUCE, 279);
   _actionMap[535][ENDTOKEN] = ActionEntry(REDUCE, 279);
   _actionMap[535][UNION] = ActionEntry(REDUCE, 279);
   _actionMap[535][ROWLIMIT] = ActionEntry(REDUCE, 279);
   _actionMap[535][KSEP] = ActionEntry(REDUCE, 279);
   _actionMap[535][ASC] = ActionEntry(REDUCE, 279);
   _actionMap[535][DESC] = ActionEntry(REDUCE, 279);
   _actionMap[535][SEMICOLON] = ActionEntry(REDUCE, 279);
   _actionMap[535][PLUS] = ActionEntry(REDUCE, 279);
   _actionMap[535][MINUS] = ActionEntry(REDUCE, 279);
   _actionMap[535][DIVISION] = ActionEntry(REDUCE, 279);
   _actionMap[535][STAR] = ActionEntry(REDUCE, 279);
   _actionMap[535][CONCAT] = ActionEntry(REDUCE, 279);
   _actionMap[536][WHEN] = ActionEntry(REDUCE, 274);
}
void Cego::loadParser96()
{
   _actionMap[536][ELSE] = ActionEntry(REDUCE, 274);
   _actionMap[536][LEFT] = ActionEntry(REDUCE, 274);
   _actionMap[536][RIGHT] = ActionEntry(REDUCE, 274);
   _actionMap[536][INNER] = ActionEntry(REDUCE, 274);
   _actionMap[536][JOIN] = ActionEntry(REDUCE, 274);
   _actionMap[536][RETURNTOKEN] = ActionEntry(REDUCE, 274);
   _actionMap[536][ORDER] = ActionEntry(REDUCE, 274);
   _actionMap[536][GROUP] = ActionEntry(REDUCE, 274);
   _actionMap[536][WHERE] = ActionEntry(REDUCE, 274);
   _actionMap[536][FROM] = ActionEntry(REDUCE, 274);
   _actionMap[536][AS] = ActionEntry(REDUCE, 274);
   _actionMap[536][END_TOKEN] = ActionEntry(REDUCE, 274);
   _actionMap[536][BEGIN] = ActionEntry(REDUCE, 274);
   _actionMap[536][THEN] = ActionEntry(REDUCE, 274);
   _actionMap[536][OR] = ActionEntry(REDUCE, 274);
   _actionMap[536][AND] = ActionEntry(REDUCE, 274);
   _actionMap[536][INTOK] = ActionEntry(REDUCE, 274);
   _actionMap[536][NOT] = ActionEntry(REDUCE, 274);
   _actionMap[536][BETWEEN] = ActionEntry(REDUCE, 274);
   _actionMap[536][IS] = ActionEntry(REDUCE, 274);
   _actionMap[536][LIKE] = ActionEntry(REDUCE, 274);
   _actionMap[536][MT] = ActionEntry(REDUCE, 274);
   _actionMap[536][LT] = ActionEntry(REDUCE, 274);
   _actionMap[536][NEGATION] = ActionEntry(REDUCE, 274);
   _actionMap[536][EQU] = ActionEntry(REDUCE, 274);
   _actionMap[536][RB] = ActionEntry(REDUCE, 274);
   _actionMap[536][ENDTOKEN] = ActionEntry(REDUCE, 274);
   _actionMap[536][UNION] = ActionEntry(REDUCE, 274);
   _actionMap[536][ROWLIMIT] = ActionEntry(REDUCE, 274);
   _actionMap[536][KSEP] = ActionEntry(REDUCE, 274);
   _actionMap[536][ASC] = ActionEntry(REDUCE, 274);
   _actionMap[536][DESC] = ActionEntry(REDUCE, 274);
   _actionMap[536][SEMICOLON] = ActionEntry(REDUCE, 274);
   _actionMap[536][PLUS] = ActionEntry(REDUCE, 274);
   _actionMap[536][MINUS] = ActionEntry(REDUCE, 274);
   _actionMap[536][DIVISION] = ActionEntry(REDUCE, 274);
   _actionMap[536][STAR] = ActionEntry(REDUCE, 274);
   _actionMap[536][CONCAT] = ActionEntry(REDUCE, 274);
   _actionMap[537][WHEN] = ActionEntry(REDUCE, 159);
   _actionMap[537][ELSE] = ActionEntry(REDUCE, 159);
   _actionMap[537][LEFT] = ActionEntry(REDUCE, 159);
   _actionMap[537][RIGHT] = ActionEntry(REDUCE, 159);
   _actionMap[537][INNER] = ActionEntry(REDUCE, 159);
   _actionMap[537][JOIN] = ActionEntry(REDUCE, 159);
   _actionMap[537][RETURNTOKEN] = ActionEntry(REDUCE, 159);
   _actionMap[537][ORDER] = ActionEntry(REDUCE, 159);
   _actionMap[537][GROUP] = ActionEntry(REDUCE, 159);
   _actionMap[537][WHERE] = ActionEntry(REDUCE, 159);
   _actionMap[537][AS] = ActionEntry(REDUCE, 159);
   _actionMap[537][FROM] = ActionEntry(REDUCE, 159);
}
void Cego::loadParser97()
{
   _actionMap[537][END_TOKEN] = ActionEntry(REDUCE, 159);
   _actionMap[537][BEGIN] = ActionEntry(REDUCE, 159);
   _actionMap[537][THEN] = ActionEntry(REDUCE, 159);
   _actionMap[537][OR] = ActionEntry(REDUCE, 159);
   _actionMap[537][AND] = ActionEntry(REDUCE, 159);
   _actionMap[537][LIKE] = ActionEntry(REDUCE, 159);
   _actionMap[537][IS] = ActionEntry(REDUCE, 159);
   _actionMap[537][BETWEEN] = ActionEntry(REDUCE, 159);
   _actionMap[537][NOT] = ActionEntry(REDUCE, 159);
   _actionMap[537][INTOK] = ActionEntry(REDUCE, 159);
   _actionMap[537][EQU] = ActionEntry(REDUCE, 159);
   _actionMap[537][NEGATION] = ActionEntry(REDUCE, 159);
   _actionMap[537][LT] = ActionEntry(REDUCE, 159);
   _actionMap[537][MT] = ActionEntry(REDUCE, 159);
   _actionMap[537][DESC] = ActionEntry(REDUCE, 159);
   _actionMap[537][ASC] = ActionEntry(REDUCE, 159);
   _actionMap[537][KSEP] = ActionEntry(REDUCE, 159);
   _actionMap[537][ROWLIMIT] = ActionEntry(REDUCE, 159);
   _actionMap[537][UNION] = ActionEntry(REDUCE, 159);
   _actionMap[537][ENDTOKEN] = ActionEntry(REDUCE, 159);
   _actionMap[537][RB] = ActionEntry(REDUCE, 159);
   _actionMap[537][SEMICOLON] = ActionEntry(REDUCE, 159);
   _actionMap[537][CONCAT] = ActionEntry(REDUCE, 159);
   _actionMap[537][STAR] = ActionEntry(REDUCE, 159);
   _actionMap[537][DIVISION] = ActionEntry(REDUCE, 159);
   _actionMap[537][MINUS] = ActionEntry(REDUCE, 159);
   _actionMap[537][PLUS] = ActionEntry(REDUCE, 159);
   _actionMap[538][WHEN] = ActionEntry(REDUCE, 160);
   _actionMap[538][ELSE] = ActionEntry(REDUCE, 160);
   _actionMap[538][LEFT] = ActionEntry(REDUCE, 160);
   _actionMap[538][RIGHT] = ActionEntry(REDUCE, 160);
   _actionMap[538][INNER] = ActionEntry(REDUCE, 160);
   _actionMap[538][JOIN] = ActionEntry(REDUCE, 160);
   _actionMap[538][RETURNTOKEN] = ActionEntry(REDUCE, 160);
   _actionMap[538][ORDER] = ActionEntry(REDUCE, 160);
   _actionMap[538][GROUP] = ActionEntry(REDUCE, 160);
   _actionMap[538][WHERE] = ActionEntry(REDUCE, 160);
   _actionMap[538][AS] = ActionEntry(REDUCE, 160);
   _actionMap[538][FROM] = ActionEntry(REDUCE, 160);
   _actionMap[538][END_TOKEN] = ActionEntry(REDUCE, 160);
   _actionMap[538][BEGIN] = ActionEntry(REDUCE, 160);
   _actionMap[538][THEN] = ActionEntry(REDUCE, 160);
   _actionMap[538][OR] = ActionEntry(REDUCE, 160);
   _actionMap[538][AND] = ActionEntry(REDUCE, 160);
   _actionMap[538][LIKE] = ActionEntry(REDUCE, 160);
   _actionMap[538][IS] = ActionEntry(REDUCE, 160);
   _actionMap[538][BETWEEN] = ActionEntry(REDUCE, 160);
   _actionMap[538][NOT] = ActionEntry(REDUCE, 160);
   _actionMap[538][INTOK] = ActionEntry(REDUCE, 160);
   _actionMap[538][EQU] = ActionEntry(REDUCE, 160);
}
void Cego::loadParser98()
{
   _actionMap[538][NEGATION] = ActionEntry(REDUCE, 160);
   _actionMap[538][LT] = ActionEntry(REDUCE, 160);
   _actionMap[538][MT] = ActionEntry(REDUCE, 160);
   _actionMap[538][DESC] = ActionEntry(REDUCE, 160);
   _actionMap[538][ASC] = ActionEntry(REDUCE, 160);
   _actionMap[538][KSEP] = ActionEntry(REDUCE, 160);
   _actionMap[538][ROWLIMIT] = ActionEntry(REDUCE, 160);
   _actionMap[538][UNION] = ActionEntry(REDUCE, 160);
   _actionMap[538][ENDTOKEN] = ActionEntry(REDUCE, 160);
   _actionMap[538][RB] = ActionEntry(REDUCE, 160);
   _actionMap[538][SEMICOLON] = ActionEntry(REDUCE, 160);
   _actionMap[538][CONCAT] = ActionEntry(REDUCE, 160);
   _actionMap[538][STAR] = ActionEntry(REDUCE, 160);
   _actionMap[538][DIVISION] = ActionEntry(REDUCE, 160);
   _actionMap[538][MINUS] = ActionEntry(REDUCE, 160);
   _actionMap[538][PLUS] = ActionEntry(REDUCE, 160);
   _actionMap[539][WHEN] = ActionEntry(REDUCE, 293);
   _actionMap[539][ELSE] = ActionEntry(REDUCE, 293);
   _actionMap[539][LEFT] = ActionEntry(REDUCE, 293);
   _actionMap[539][RIGHT] = ActionEntry(REDUCE, 293);
   _actionMap[539][INNER] = ActionEntry(REDUCE, 293);
   _actionMap[539][JOIN] = ActionEntry(REDUCE, 293);
   _actionMap[539][RETURNTOKEN] = ActionEntry(REDUCE, 293);
   _actionMap[539][ORDER] = ActionEntry(REDUCE, 293);
   _actionMap[539][GROUP] = ActionEntry(REDUCE, 293);
   _actionMap[539][WHERE] = ActionEntry(REDUCE, 293);
   _actionMap[539][FROM] = ActionEntry(REDUCE, 293);
   _actionMap[539][AS] = ActionEntry(REDUCE, 293);
   _actionMap[539][END_TOKEN] = ActionEntry(REDUCE, 293);
   _actionMap[539][BEGIN] = ActionEntry(REDUCE, 293);
   _actionMap[539][THEN] = ActionEntry(REDUCE, 293);
   _actionMap[539][OR] = ActionEntry(REDUCE, 293);
   _actionMap[539][AND] = ActionEntry(REDUCE, 293);
   _actionMap[539][INTOK] = ActionEntry(REDUCE, 293);
   _actionMap[539][NOT] = ActionEntry(REDUCE, 293);
   _actionMap[539][BETWEEN] = ActionEntry(REDUCE, 293);
   _actionMap[539][IS] = ActionEntry(REDUCE, 293);
   _actionMap[539][LIKE] = ActionEntry(REDUCE, 293);
   _actionMap[539][MT] = ActionEntry(REDUCE, 293);
   _actionMap[539][LT] = ActionEntry(REDUCE, 293);
   _actionMap[539][NEGATION] = ActionEntry(REDUCE, 293);
   _actionMap[539][EQU] = ActionEntry(REDUCE, 293);
   _actionMap[539][RB] = ActionEntry(REDUCE, 293);
   _actionMap[539][ENDTOKEN] = ActionEntry(REDUCE, 293);
   _actionMap[539][UNION] = ActionEntry(REDUCE, 293);
   _actionMap[539][ROWLIMIT] = ActionEntry(REDUCE, 293);
   _actionMap[539][KSEP] = ActionEntry(REDUCE, 293);
   _actionMap[539][ASC] = ActionEntry(REDUCE, 293);
   _actionMap[539][DESC] = ActionEntry(REDUCE, 293);
   _actionMap[539][SEMICOLON] = ActionEntry(REDUCE, 293);
}
void Cego::loadParser99()
{
   _actionMap[539][PLUS] = ActionEntry(REDUCE, 293);
   _actionMap[539][MINUS] = ActionEntry(REDUCE, 293);
   _actionMap[539][DIVISION] = ActionEntry(REDUCE, 293);
   _actionMap[539][STAR] = ActionEntry(REDUCE, 293);
   _actionMap[539][CONCAT] = ActionEntry(REDUCE, 293);
   _actionMap[540][WHEN] = ActionEntry(REDUCE, 300);
   _actionMap[540][ELSE] = ActionEntry(REDUCE, 300);
   _actionMap[540][LEFT] = ActionEntry(REDUCE, 300);
   _actionMap[540][RIGHT] = ActionEntry(REDUCE, 300);
   _actionMap[540][INNER] = ActionEntry(REDUCE, 300);
   _actionMap[540][JOIN] = ActionEntry(REDUCE, 300);
   _actionMap[540][RETURNTOKEN] = ActionEntry(REDUCE, 300);
   _actionMap[540][ORDER] = ActionEntry(REDUCE, 300);
   _actionMap[540][GROUP] = ActionEntry(REDUCE, 300);
   _actionMap[540][WHERE] = ActionEntry(REDUCE, 300);
   _actionMap[540][FROM] = ActionEntry(REDUCE, 300);
   _actionMap[540][AS] = ActionEntry(REDUCE, 300);
   _actionMap[540][END_TOKEN] = ActionEntry(REDUCE, 300);
   _actionMap[540][BEGIN] = ActionEntry(REDUCE, 300);
   _actionMap[540][THEN] = ActionEntry(REDUCE, 300);
   _actionMap[540][OR] = ActionEntry(REDUCE, 300);
   _actionMap[540][AND] = ActionEntry(REDUCE, 300);
   _actionMap[540][INTOK] = ActionEntry(REDUCE, 300);
   _actionMap[540][NOT] = ActionEntry(REDUCE, 300);
   _actionMap[540][BETWEEN] = ActionEntry(REDUCE, 300);
   _actionMap[540][IS] = ActionEntry(REDUCE, 300);
   _actionMap[540][LIKE] = ActionEntry(REDUCE, 300);
   _actionMap[540][MT] = ActionEntry(REDUCE, 300);
   _actionMap[540][LT] = ActionEntry(REDUCE, 300);
   _actionMap[540][NEGATION] = ActionEntry(REDUCE, 300);
   _actionMap[540][EQU] = ActionEntry(REDUCE, 300);
   _actionMap[540][RB] = ActionEntry(REDUCE, 300);
   _actionMap[540][ENDTOKEN] = ActionEntry(REDUCE, 300);
   _actionMap[540][UNION] = ActionEntry(REDUCE, 300);
   _actionMap[540][ROWLIMIT] = ActionEntry(REDUCE, 300);
   _actionMap[540][KSEP] = ActionEntry(REDUCE, 300);
   _actionMap[540][ASC] = ActionEntry(REDUCE, 300);
   _actionMap[540][DESC] = ActionEntry(REDUCE, 300);
   _actionMap[540][SEMICOLON] = ActionEntry(REDUCE, 300);
   _actionMap[540][PLUS] = ActionEntry(REDUCE, 300);
   _actionMap[540][MINUS] = ActionEntry(REDUCE, 300);
   _actionMap[540][DIVISION] = ActionEntry(REDUCE, 300);
   _actionMap[540][STAR] = ActionEntry(REDUCE, 300);
   _actionMap[540][CONCAT] = ActionEntry(REDUCE, 300);
   _actionMap[541][WHEN] = ActionEntry(REDUCE, 295);
   _actionMap[541][ELSE] = ActionEntry(REDUCE, 295);
   _actionMap[541][LEFT] = ActionEntry(REDUCE, 295);
   _actionMap[541][RIGHT] = ActionEntry(REDUCE, 295);
   _actionMap[541][INNER] = ActionEntry(REDUCE, 295);
   _actionMap[541][JOIN] = ActionEntry(REDUCE, 295);
}
void Cego::loadParser100()
{
   _actionMap[541][RETURNTOKEN] = ActionEntry(REDUCE, 295);
   _actionMap[541][ORDER] = ActionEntry(REDUCE, 295);
   _actionMap[541][GROUP] = ActionEntry(REDUCE, 295);
   _actionMap[541][WHERE] = ActionEntry(REDUCE, 295);
   _actionMap[541][FROM] = ActionEntry(REDUCE, 295);
   _actionMap[541][AS] = ActionEntry(REDUCE, 295);
   _actionMap[541][END_TOKEN] = ActionEntry(REDUCE, 295);
   _actionMap[541][BEGIN] = ActionEntry(REDUCE, 295);
   _actionMap[541][THEN] = ActionEntry(REDUCE, 295);
   _actionMap[541][OR] = ActionEntry(REDUCE, 295);
   _actionMap[541][AND] = ActionEntry(REDUCE, 295);
   _actionMap[541][INTOK] = ActionEntry(REDUCE, 295);
   _actionMap[541][NOT] = ActionEntry(REDUCE, 295);
   _actionMap[541][BETWEEN] = ActionEntry(REDUCE, 295);
   _actionMap[541][IS] = ActionEntry(REDUCE, 295);
   _actionMap[541][LIKE] = ActionEntry(REDUCE, 295);
   _actionMap[541][MT] = ActionEntry(REDUCE, 295);
   _actionMap[541][LT] = ActionEntry(REDUCE, 295);
   _actionMap[541][NEGATION] = ActionEntry(REDUCE, 295);
   _actionMap[541][EQU] = ActionEntry(REDUCE, 295);
   _actionMap[541][RB] = ActionEntry(REDUCE, 295);
   _actionMap[541][ENDTOKEN] = ActionEntry(REDUCE, 295);
   _actionMap[541][UNION] = ActionEntry(REDUCE, 295);
   _actionMap[541][ROWLIMIT] = ActionEntry(REDUCE, 295);
   _actionMap[541][KSEP] = ActionEntry(REDUCE, 295);
   _actionMap[541][ASC] = ActionEntry(REDUCE, 295);
   _actionMap[541][DESC] = ActionEntry(REDUCE, 295);
   _actionMap[541][SEMICOLON] = ActionEntry(REDUCE, 295);
   _actionMap[541][PLUS] = ActionEntry(REDUCE, 295);
   _actionMap[541][MINUS] = ActionEntry(REDUCE, 295);
   _actionMap[541][DIVISION] = ActionEntry(REDUCE, 295);
   _actionMap[541][STAR] = ActionEntry(REDUCE, 295);
   _actionMap[541][CONCAT] = ActionEntry(REDUCE, 295);
   _actionMap[542][WHEN] = ActionEntry(REDUCE, 291);
   _actionMap[542][ELSE] = ActionEntry(REDUCE, 291);
   _actionMap[542][LEFT] = ActionEntry(REDUCE, 291);
   _actionMap[542][RIGHT] = ActionEntry(REDUCE, 291);
   _actionMap[542][INNER] = ActionEntry(REDUCE, 291);
   _actionMap[542][JOIN] = ActionEntry(REDUCE, 291);
   _actionMap[542][RETURNTOKEN] = ActionEntry(REDUCE, 291);
   _actionMap[542][ORDER] = ActionEntry(REDUCE, 291);
   _actionMap[542][GROUP] = ActionEntry(REDUCE, 291);
   _actionMap[542][WHERE] = ActionEntry(REDUCE, 291);
   _actionMap[542][FROM] = ActionEntry(REDUCE, 291);
   _actionMap[542][AS] = ActionEntry(REDUCE, 291);
   _actionMap[542][END_TOKEN] = ActionEntry(REDUCE, 291);
   _actionMap[542][BEGIN] = ActionEntry(REDUCE, 291);
   _actionMap[542][THEN] = ActionEntry(REDUCE, 291);
   _actionMap[542][OR] = ActionEntry(REDUCE, 291);
   _actionMap[542][AND] = ActionEntry(REDUCE, 291);
}
void Cego::loadParser101()
{
   _actionMap[542][INTOK] = ActionEntry(REDUCE, 291);
   _actionMap[542][NOT] = ActionEntry(REDUCE, 291);
   _actionMap[542][BETWEEN] = ActionEntry(REDUCE, 291);
   _actionMap[542][IS] = ActionEntry(REDUCE, 291);
   _actionMap[542][LIKE] = ActionEntry(REDUCE, 291);
   _actionMap[542][MT] = ActionEntry(REDUCE, 291);
   _actionMap[542][LT] = ActionEntry(REDUCE, 291);
   _actionMap[542][NEGATION] = ActionEntry(REDUCE, 291);
   _actionMap[542][EQU] = ActionEntry(REDUCE, 291);
   _actionMap[542][RB] = ActionEntry(REDUCE, 291);
   _actionMap[542][ENDTOKEN] = ActionEntry(REDUCE, 291);
   _actionMap[542][UNION] = ActionEntry(REDUCE, 291);
   _actionMap[542][ROWLIMIT] = ActionEntry(REDUCE, 291);
   _actionMap[542][KSEP] = ActionEntry(REDUCE, 291);
   _actionMap[542][ASC] = ActionEntry(REDUCE, 291);
   _actionMap[542][DESC] = ActionEntry(REDUCE, 291);
   _actionMap[542][SEMICOLON] = ActionEntry(REDUCE, 291);
   _actionMap[542][PLUS] = ActionEntry(REDUCE, 291);
   _actionMap[542][MINUS] = ActionEntry(REDUCE, 291);
   _actionMap[542][DIVISION] = ActionEntry(REDUCE, 291);
   _actionMap[542][STAR] = ActionEntry(REDUCE, 291);
   _actionMap[542][CONCAT] = ActionEntry(REDUCE, 291);
   _actionMap[543][WHEN] = ActionEntry(REDUCE, 292);
   _actionMap[543][ELSE] = ActionEntry(REDUCE, 292);
   _actionMap[543][LEFT] = ActionEntry(REDUCE, 292);
   _actionMap[543][RIGHT] = ActionEntry(REDUCE, 292);
   _actionMap[543][INNER] = ActionEntry(REDUCE, 292);
   _actionMap[543][JOIN] = ActionEntry(REDUCE, 292);
   _actionMap[543][RETURNTOKEN] = ActionEntry(REDUCE, 292);
   _actionMap[543][ORDER] = ActionEntry(REDUCE, 292);
   _actionMap[543][GROUP] = ActionEntry(REDUCE, 292);
   _actionMap[543][WHERE] = ActionEntry(REDUCE, 292);
   _actionMap[543][FROM] = ActionEntry(REDUCE, 292);
   _actionMap[543][AS] = ActionEntry(REDUCE, 292);
   _actionMap[543][END_TOKEN] = ActionEntry(REDUCE, 292);
   _actionMap[543][BEGIN] = ActionEntry(REDUCE, 292);
   _actionMap[543][THEN] = ActionEntry(REDUCE, 292);
   _actionMap[543][OR] = ActionEntry(REDUCE, 292);
   _actionMap[543][AND] = ActionEntry(REDUCE, 292);
   _actionMap[543][INTOK] = ActionEntry(REDUCE, 292);
   _actionMap[543][NOT] = ActionEntry(REDUCE, 292);
   _actionMap[543][BETWEEN] = ActionEntry(REDUCE, 292);
   _actionMap[543][IS] = ActionEntry(REDUCE, 292);
   _actionMap[543][LIKE] = ActionEntry(REDUCE, 292);
   _actionMap[543][MT] = ActionEntry(REDUCE, 292);
   _actionMap[543][LT] = ActionEntry(REDUCE, 292);
   _actionMap[543][NEGATION] = ActionEntry(REDUCE, 292);
   _actionMap[543][EQU] = ActionEntry(REDUCE, 292);
   _actionMap[543][RB] = ActionEntry(REDUCE, 292);
   _actionMap[543][ENDTOKEN] = ActionEntry(REDUCE, 292);
}
void Cego::loadParser102()
{
   _actionMap[543][UNION] = ActionEntry(REDUCE, 292);
   _actionMap[543][ROWLIMIT] = ActionEntry(REDUCE, 292);
   _actionMap[543][KSEP] = ActionEntry(REDUCE, 292);
   _actionMap[543][ASC] = ActionEntry(REDUCE, 292);
   _actionMap[543][DESC] = ActionEntry(REDUCE, 292);
   _actionMap[543][SEMICOLON] = ActionEntry(REDUCE, 292);
   _actionMap[543][PLUS] = ActionEntry(REDUCE, 292);
   _actionMap[543][MINUS] = ActionEntry(REDUCE, 292);
   _actionMap[543][DIVISION] = ActionEntry(REDUCE, 292);
   _actionMap[543][STAR] = ActionEntry(REDUCE, 292);
   _actionMap[543][CONCAT] = ActionEntry(REDUCE, 292);
   _actionMap[544][WHEN] = ActionEntry(REDUCE, 285);
   _actionMap[544][ELSE] = ActionEntry(REDUCE, 285);
   _actionMap[544][LEFT] = ActionEntry(REDUCE, 285);
   _actionMap[544][RIGHT] = ActionEntry(REDUCE, 285);
   _actionMap[544][INNER] = ActionEntry(REDUCE, 285);
   _actionMap[544][JOIN] = ActionEntry(REDUCE, 285);
   _actionMap[544][RETURNTOKEN] = ActionEntry(REDUCE, 285);
   _actionMap[544][ORDER] = ActionEntry(REDUCE, 285);
   _actionMap[544][GROUP] = ActionEntry(REDUCE, 285);
   _actionMap[544][WHERE] = ActionEntry(REDUCE, 285);
   _actionMap[544][FROM] = ActionEntry(REDUCE, 285);
   _actionMap[544][AS] = ActionEntry(REDUCE, 285);
   _actionMap[544][END_TOKEN] = ActionEntry(REDUCE, 285);
   _actionMap[544][BEGIN] = ActionEntry(REDUCE, 285);
   _actionMap[544][THEN] = ActionEntry(REDUCE, 285);
   _actionMap[544][OR] = ActionEntry(REDUCE, 285);
   _actionMap[544][AND] = ActionEntry(REDUCE, 285);
   _actionMap[544][INTOK] = ActionEntry(REDUCE, 285);
   _actionMap[544][NOT] = ActionEntry(REDUCE, 285);
   _actionMap[544][BETWEEN] = ActionEntry(REDUCE, 285);
   _actionMap[544][IS] = ActionEntry(REDUCE, 285);
   _actionMap[544][LIKE] = ActionEntry(REDUCE, 285);
   _actionMap[544][MT] = ActionEntry(REDUCE, 285);
   _actionMap[544][LT] = ActionEntry(REDUCE, 285);
   _actionMap[544][NEGATION] = ActionEntry(REDUCE, 285);
   _actionMap[544][EQU] = ActionEntry(REDUCE, 285);
   _actionMap[544][RB] = ActionEntry(REDUCE, 285);
   _actionMap[544][ENDTOKEN] = ActionEntry(REDUCE, 285);
   _actionMap[544][UNION] = ActionEntry(REDUCE, 285);
   _actionMap[544][ROWLIMIT] = ActionEntry(REDUCE, 285);
   _actionMap[544][KSEP] = ActionEntry(REDUCE, 285);
   _actionMap[544][ASC] = ActionEntry(REDUCE, 285);
   _actionMap[544][DESC] = ActionEntry(REDUCE, 285);
   _actionMap[544][SEMICOLON] = ActionEntry(REDUCE, 285);
   _actionMap[544][PLUS] = ActionEntry(REDUCE, 285);
   _actionMap[544][MINUS] = ActionEntry(REDUCE, 285);
   _actionMap[544][DIVISION] = ActionEntry(REDUCE, 285);
   _actionMap[544][STAR] = ActionEntry(REDUCE, 285);
   _actionMap[544][CONCAT] = ActionEntry(REDUCE, 285);
}
void Cego::loadParser103()
{
   _actionMap[545][WHEN] = ActionEntry(REDUCE, 282);
   _actionMap[545][ELSE] = ActionEntry(REDUCE, 282);
   _actionMap[545][LEFT] = ActionEntry(REDUCE, 282);
   _actionMap[545][RIGHT] = ActionEntry(REDUCE, 282);
   _actionMap[545][INNER] = ActionEntry(REDUCE, 282);
   _actionMap[545][JOIN] = ActionEntry(REDUCE, 282);
   _actionMap[545][RETURNTOKEN] = ActionEntry(REDUCE, 282);
   _actionMap[545][ORDER] = ActionEntry(REDUCE, 282);
   _actionMap[545][GROUP] = ActionEntry(REDUCE, 282);
   _actionMap[545][WHERE] = ActionEntry(REDUCE, 282);
   _actionMap[545][FROM] = ActionEntry(REDUCE, 282);
   _actionMap[545][AS] = ActionEntry(REDUCE, 282);
   _actionMap[545][END_TOKEN] = ActionEntry(REDUCE, 282);
   _actionMap[545][BEGIN] = ActionEntry(REDUCE, 282);
   _actionMap[545][THEN] = ActionEntry(REDUCE, 282);
   _actionMap[545][OR] = ActionEntry(REDUCE, 282);
   _actionMap[545][AND] = ActionEntry(REDUCE, 282);
   _actionMap[545][INTOK] = ActionEntry(REDUCE, 282);
   _actionMap[545][NOT] = ActionEntry(REDUCE, 282);
   _actionMap[545][BETWEEN] = ActionEntry(REDUCE, 282);
   _actionMap[545][IS] = ActionEntry(REDUCE, 282);
   _actionMap[545][LIKE] = ActionEntry(REDUCE, 282);
   _actionMap[545][MT] = ActionEntry(REDUCE, 282);
   _actionMap[545][LT] = ActionEntry(REDUCE, 282);
   _actionMap[545][NEGATION] = ActionEntry(REDUCE, 282);
   _actionMap[545][EQU] = ActionEntry(REDUCE, 282);
   _actionMap[545][RB] = ActionEntry(REDUCE, 282);
   _actionMap[545][ENDTOKEN] = ActionEntry(REDUCE, 282);
   _actionMap[545][UNION] = ActionEntry(REDUCE, 282);
   _actionMap[545][ROWLIMIT] = ActionEntry(REDUCE, 282);
   _actionMap[545][KSEP] = ActionEntry(REDUCE, 282);
   _actionMap[545][ASC] = ActionEntry(REDUCE, 282);
   _actionMap[545][DESC] = ActionEntry(REDUCE, 282);
   _actionMap[545][SEMICOLON] = ActionEntry(REDUCE, 282);
   _actionMap[545][PLUS] = ActionEntry(REDUCE, 282);
   _actionMap[545][MINUS] = ActionEntry(REDUCE, 282);
   _actionMap[545][DIVISION] = ActionEntry(REDUCE, 282);
   _actionMap[545][STAR] = ActionEntry(REDUCE, 282);
   _actionMap[545][CONCAT] = ActionEntry(REDUCE, 282);
   _actionMap[546][WHEN] = ActionEntry(REDUCE, 275);
   _actionMap[546][ELSE] = ActionEntry(REDUCE, 275);
   _actionMap[546][LEFT] = ActionEntry(REDUCE, 275);
   _actionMap[546][RIGHT] = ActionEntry(REDUCE, 275);
   _actionMap[546][INNER] = ActionEntry(REDUCE, 275);
   _actionMap[546][JOIN] = ActionEntry(REDUCE, 275);
   _actionMap[546][RETURNTOKEN] = ActionEntry(REDUCE, 275);
   _actionMap[546][ORDER] = ActionEntry(REDUCE, 275);
   _actionMap[546][GROUP] = ActionEntry(REDUCE, 275);
   _actionMap[546][WHERE] = ActionEntry(REDUCE, 275);
   _actionMap[546][FROM] = ActionEntry(REDUCE, 275);
}
void Cego::loadParser104()
{
   _actionMap[546][AS] = ActionEntry(REDUCE, 275);
   _actionMap[546][END_TOKEN] = ActionEntry(REDUCE, 275);
   _actionMap[546][BEGIN] = ActionEntry(REDUCE, 275);
   _actionMap[546][THEN] = ActionEntry(REDUCE, 275);
   _actionMap[546][OR] = ActionEntry(REDUCE, 275);
   _actionMap[546][AND] = ActionEntry(REDUCE, 275);
   _actionMap[546][INTOK] = ActionEntry(REDUCE, 275);
   _actionMap[546][NOT] = ActionEntry(REDUCE, 275);
   _actionMap[546][BETWEEN] = ActionEntry(REDUCE, 275);
   _actionMap[546][IS] = ActionEntry(REDUCE, 275);
   _actionMap[546][LIKE] = ActionEntry(REDUCE, 275);
   _actionMap[546][MT] = ActionEntry(REDUCE, 275);
   _actionMap[546][LT] = ActionEntry(REDUCE, 275);
   _actionMap[546][NEGATION] = ActionEntry(REDUCE, 275);
   _actionMap[546][EQU] = ActionEntry(REDUCE, 275);
   _actionMap[546][RB] = ActionEntry(REDUCE, 275);
   _actionMap[546][ENDTOKEN] = ActionEntry(REDUCE, 275);
   _actionMap[546][UNION] = ActionEntry(REDUCE, 275);
   _actionMap[546][ROWLIMIT] = ActionEntry(REDUCE, 275);
   _actionMap[546][KSEP] = ActionEntry(REDUCE, 275);
   _actionMap[546][ASC] = ActionEntry(REDUCE, 275);
   _actionMap[546][DESC] = ActionEntry(REDUCE, 275);
   _actionMap[546][SEMICOLON] = ActionEntry(REDUCE, 275);
   _actionMap[546][PLUS] = ActionEntry(REDUCE, 275);
   _actionMap[546][MINUS] = ActionEntry(REDUCE, 275);
   _actionMap[546][DIVISION] = ActionEntry(REDUCE, 275);
   _actionMap[546][STAR] = ActionEntry(REDUCE, 275);
   _actionMap[546][CONCAT] = ActionEntry(REDUCE, 275);
   _actionMap[547][WHEN] = ActionEntry(REDUCE, 273);
   _actionMap[547][ELSE] = ActionEntry(REDUCE, 273);
   _actionMap[547][LEFT] = ActionEntry(REDUCE, 273);
   _actionMap[547][RIGHT] = ActionEntry(REDUCE, 273);
   _actionMap[547][INNER] = ActionEntry(REDUCE, 273);
   _actionMap[547][JOIN] = ActionEntry(REDUCE, 273);
   _actionMap[547][RETURNTOKEN] = ActionEntry(REDUCE, 273);
   _actionMap[547][ORDER] = ActionEntry(REDUCE, 273);
   _actionMap[547][GROUP] = ActionEntry(REDUCE, 273);
   _actionMap[547][WHERE] = ActionEntry(REDUCE, 273);
   _actionMap[547][FROM] = ActionEntry(REDUCE, 273);
   _actionMap[547][AS] = ActionEntry(REDUCE, 273);
   _actionMap[547][END_TOKEN] = ActionEntry(REDUCE, 273);
   _actionMap[547][BEGIN] = ActionEntry(REDUCE, 273);
   _actionMap[547][THEN] = ActionEntry(REDUCE, 273);
   _actionMap[547][OR] = ActionEntry(REDUCE, 273);
   _actionMap[547][AND] = ActionEntry(REDUCE, 273);
   _actionMap[547][INTOK] = ActionEntry(REDUCE, 273);
   _actionMap[547][NOT] = ActionEntry(REDUCE, 273);
   _actionMap[547][BETWEEN] = ActionEntry(REDUCE, 273);
   _actionMap[547][IS] = ActionEntry(REDUCE, 273);
   _actionMap[547][LIKE] = ActionEntry(REDUCE, 273);
}
void Cego::loadParser105()
{
   _actionMap[547][MT] = ActionEntry(REDUCE, 273);
   _actionMap[547][LT] = ActionEntry(REDUCE, 273);
   _actionMap[547][NEGATION] = ActionEntry(REDUCE, 273);
   _actionMap[547][EQU] = ActionEntry(REDUCE, 273);
   _actionMap[547][RB] = ActionEntry(REDUCE, 273);
   _actionMap[547][ENDTOKEN] = ActionEntry(REDUCE, 273);
   _actionMap[547][UNION] = ActionEntry(REDUCE, 273);
   _actionMap[547][ROWLIMIT] = ActionEntry(REDUCE, 273);
   _actionMap[547][KSEP] = ActionEntry(REDUCE, 273);
   _actionMap[547][ASC] = ActionEntry(REDUCE, 273);
   _actionMap[547][DESC] = ActionEntry(REDUCE, 273);
   _actionMap[547][SEMICOLON] = ActionEntry(REDUCE, 273);
   _actionMap[547][PLUS] = ActionEntry(REDUCE, 273);
   _actionMap[547][MINUS] = ActionEntry(REDUCE, 273);
   _actionMap[547][DIVISION] = ActionEntry(REDUCE, 273);
   _actionMap[547][STAR] = ActionEntry(REDUCE, 273);
   _actionMap[547][CONCAT] = ActionEntry(REDUCE, 273);
   _actionMap[548][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[548][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[548][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[548][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[548][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[548][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[548][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[548][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[548][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[548][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[548][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[548][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[548][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[548][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[548][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[548][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[548][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[548][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[548][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[548][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[548][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[548][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[548][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[548][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[548][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[548][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[548][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[548][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[548][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[548][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[548][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[548][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[548][SETCOUNT] = ActionEntry(SHIFT, 133);
}
void Cego::loadParser106()
{
   _actionMap[548][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[548][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[548][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[548][LB] = ActionEntry(SHIFT, 144);
   _actionMap[548][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[548][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[548][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[548][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[548][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[548][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[548][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[548][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[548][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[548][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[548][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[548][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[548][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[548][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[548][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[548][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[548][ObjSpec] = 100;
   _jumpMap[548][Constant] = 99;
   _jumpMap[548][SignedFloat] = 98;
   _jumpMap[548][SignedInt] = 97;
   _jumpMap[548][Attribute] = 96;
   _jumpMap[548][Function] = 95;
   _jumpMap[548][CasePrepare] = 94;
   _jumpMap[548][CaseClause] = 93;
   _jumpMap[548][Factor] = 92;
   _jumpMap[548][Term] = 91;
   _jumpMap[548][Expr] = 673;
   _actionMap[549][WHEN] = ActionEntry(REDUCE, 284);
   _actionMap[549][ELSE] = ActionEntry(REDUCE, 284);
   _actionMap[549][LEFT] = ActionEntry(REDUCE, 284);
   _actionMap[549][RIGHT] = ActionEntry(REDUCE, 284);
   _actionMap[549][INNER] = ActionEntry(REDUCE, 284);
   _actionMap[549][JOIN] = ActionEntry(REDUCE, 284);
   _actionMap[549][RETURNTOKEN] = ActionEntry(REDUCE, 284);
   _actionMap[549][ORDER] = ActionEntry(REDUCE, 284);
   _actionMap[549][GROUP] = ActionEntry(REDUCE, 284);
   _actionMap[549][WHERE] = ActionEntry(REDUCE, 284);
   _actionMap[549][FROM] = ActionEntry(REDUCE, 284);
   _actionMap[549][AS] = ActionEntry(REDUCE, 284);
   _actionMap[549][END_TOKEN] = ActionEntry(REDUCE, 284);
   _actionMap[549][BEGIN] = ActionEntry(REDUCE, 284);
   _actionMap[549][THEN] = ActionEntry(REDUCE, 284);
   _actionMap[549][OR] = ActionEntry(REDUCE, 284);
   _actionMap[549][AND] = ActionEntry(REDUCE, 284);
   _actionMap[549][INTOK] = ActionEntry(REDUCE, 284);
   _actionMap[549][NOT] = ActionEntry(REDUCE, 284);
}
void Cego::loadParser107()
{
   _actionMap[549][BETWEEN] = ActionEntry(REDUCE, 284);
   _actionMap[549][IS] = ActionEntry(REDUCE, 284);
   _actionMap[549][LIKE] = ActionEntry(REDUCE, 284);
   _actionMap[549][MT] = ActionEntry(REDUCE, 284);
   _actionMap[549][LT] = ActionEntry(REDUCE, 284);
   _actionMap[549][NEGATION] = ActionEntry(REDUCE, 284);
   _actionMap[549][EQU] = ActionEntry(REDUCE, 284);
   _actionMap[549][RB] = ActionEntry(REDUCE, 284);
   _actionMap[549][ENDTOKEN] = ActionEntry(REDUCE, 284);
   _actionMap[549][UNION] = ActionEntry(REDUCE, 284);
   _actionMap[549][ROWLIMIT] = ActionEntry(REDUCE, 284);
   _actionMap[549][KSEP] = ActionEntry(REDUCE, 284);
   _actionMap[549][ASC] = ActionEntry(REDUCE, 284);
   _actionMap[549][DESC] = ActionEntry(REDUCE, 284);
   _actionMap[549][SEMICOLON] = ActionEntry(REDUCE, 284);
   _actionMap[549][PLUS] = ActionEntry(REDUCE, 284);
   _actionMap[549][MINUS] = ActionEntry(REDUCE, 284);
   _actionMap[549][DIVISION] = ActionEntry(REDUCE, 284);
   _actionMap[549][STAR] = ActionEntry(REDUCE, 284);
   _actionMap[549][CONCAT] = ActionEntry(REDUCE, 284);
   _actionMap[550][WHEN] = ActionEntry(REDUCE, 156);
   _actionMap[550][ELSE] = ActionEntry(REDUCE, 156);
   _actionMap[550][LEFT] = ActionEntry(REDUCE, 156);
   _actionMap[550][RIGHT] = ActionEntry(REDUCE, 156);
   _actionMap[550][INNER] = ActionEntry(REDUCE, 156);
   _actionMap[550][JOIN] = ActionEntry(REDUCE, 156);
   _actionMap[550][RETURNTOKEN] = ActionEntry(REDUCE, 156);
   _actionMap[550][ORDER] = ActionEntry(REDUCE, 156);
   _actionMap[550][GROUP] = ActionEntry(REDUCE, 156);
   _actionMap[550][WHERE] = ActionEntry(REDUCE, 156);
   _actionMap[550][AS] = ActionEntry(REDUCE, 156);
   _actionMap[550][FROM] = ActionEntry(REDUCE, 156);
   _actionMap[550][END_TOKEN] = ActionEntry(REDUCE, 156);
   _actionMap[550][BEGIN] = ActionEntry(REDUCE, 156);
   _actionMap[550][THEN] = ActionEntry(REDUCE, 156);
   _actionMap[550][OR] = ActionEntry(REDUCE, 156);
   _actionMap[550][AND] = ActionEntry(REDUCE, 156);
   _actionMap[550][LIKE] = ActionEntry(REDUCE, 156);
   _actionMap[550][IS] = ActionEntry(REDUCE, 156);
   _actionMap[550][BETWEEN] = ActionEntry(REDUCE, 156);
   _actionMap[550][NOT] = ActionEntry(REDUCE, 156);
   _actionMap[550][INTOK] = ActionEntry(REDUCE, 156);
   _actionMap[550][EQU] = ActionEntry(REDUCE, 156);
   _actionMap[550][NEGATION] = ActionEntry(REDUCE, 156);
   _actionMap[550][LT] = ActionEntry(REDUCE, 156);
   _actionMap[550][MT] = ActionEntry(REDUCE, 156);
   _actionMap[550][DESC] = ActionEntry(REDUCE, 156);
   _actionMap[550][ASC] = ActionEntry(REDUCE, 156);
   _actionMap[550][KSEP] = ActionEntry(REDUCE, 156);
   _actionMap[550][ROWLIMIT] = ActionEntry(REDUCE, 156);
}
void Cego::loadParser108()
{
   _actionMap[550][UNION] = ActionEntry(REDUCE, 156);
   _actionMap[550][ENDTOKEN] = ActionEntry(REDUCE, 156);
   _actionMap[550][RB] = ActionEntry(REDUCE, 156);
   _actionMap[550][SEMICOLON] = ActionEntry(REDUCE, 156);
   _actionMap[550][CONCAT] = ActionEntry(REDUCE, 156);
   _actionMap[550][STAR] = ActionEntry(REDUCE, 156);
   _actionMap[550][DIVISION] = ActionEntry(REDUCE, 156);
   _actionMap[550][MINUS] = ActionEntry(REDUCE, 156);
   _actionMap[550][PLUS] = ActionEntry(REDUCE, 156);
   _actionMap[551][WHEN] = ActionEntry(REDUCE, 288);
   _actionMap[551][ELSE] = ActionEntry(REDUCE, 288);
   _actionMap[551][LEFT] = ActionEntry(REDUCE, 288);
   _actionMap[551][RIGHT] = ActionEntry(REDUCE, 288);
   _actionMap[551][INNER] = ActionEntry(REDUCE, 288);
   _actionMap[551][JOIN] = ActionEntry(REDUCE, 288);
   _actionMap[551][RETURNTOKEN] = ActionEntry(REDUCE, 288);
   _actionMap[551][ORDER] = ActionEntry(REDUCE, 288);
   _actionMap[551][GROUP] = ActionEntry(REDUCE, 288);
   _actionMap[551][WHERE] = ActionEntry(REDUCE, 288);
   _actionMap[551][FROM] = ActionEntry(REDUCE, 288);
   _actionMap[551][AS] = ActionEntry(REDUCE, 288);
   _actionMap[551][END_TOKEN] = ActionEntry(REDUCE, 288);
   _actionMap[551][BEGIN] = ActionEntry(REDUCE, 288);
   _actionMap[551][THEN] = ActionEntry(REDUCE, 288);
   _actionMap[551][OR] = ActionEntry(REDUCE, 288);
   _actionMap[551][AND] = ActionEntry(REDUCE, 288);
   _actionMap[551][INTOK] = ActionEntry(REDUCE, 288);
   _actionMap[551][NOT] = ActionEntry(REDUCE, 288);
   _actionMap[551][BETWEEN] = ActionEntry(REDUCE, 288);
   _actionMap[551][IS] = ActionEntry(REDUCE, 288);
   _actionMap[551][LIKE] = ActionEntry(REDUCE, 288);
   _actionMap[551][MT] = ActionEntry(REDUCE, 288);
   _actionMap[551][LT] = ActionEntry(REDUCE, 288);
   _actionMap[551][NEGATION] = ActionEntry(REDUCE, 288);
   _actionMap[551][EQU] = ActionEntry(REDUCE, 288);
   _actionMap[551][RB] = ActionEntry(REDUCE, 288);
   _actionMap[551][ENDTOKEN] = ActionEntry(REDUCE, 288);
   _actionMap[551][UNION] = ActionEntry(REDUCE, 288);
   _actionMap[551][ROWLIMIT] = ActionEntry(REDUCE, 288);
   _actionMap[551][KSEP] = ActionEntry(REDUCE, 288);
   _actionMap[551][ASC] = ActionEntry(REDUCE, 288);
   _actionMap[551][DESC] = ActionEntry(REDUCE, 288);
   _actionMap[551][SEMICOLON] = ActionEntry(REDUCE, 288);
   _actionMap[551][PLUS] = ActionEntry(REDUCE, 288);
   _actionMap[551][MINUS] = ActionEntry(REDUCE, 288);
   _actionMap[551][DIVISION] = ActionEntry(REDUCE, 288);
   _actionMap[551][STAR] = ActionEntry(REDUCE, 288);
   _actionMap[551][CONCAT] = ActionEntry(REDUCE, 288);
   _actionMap[552][WHEN] = ActionEntry(REDUCE, 289);
   _actionMap[552][ELSE] = ActionEntry(REDUCE, 289);
}
void Cego::loadParser109()
{
   _actionMap[552][LEFT] = ActionEntry(REDUCE, 289);
   _actionMap[552][RIGHT] = ActionEntry(REDUCE, 289);
   _actionMap[552][INNER] = ActionEntry(REDUCE, 289);
   _actionMap[552][JOIN] = ActionEntry(REDUCE, 289);
   _actionMap[552][RETURNTOKEN] = ActionEntry(REDUCE, 289);
   _actionMap[552][ORDER] = ActionEntry(REDUCE, 289);
   _actionMap[552][GROUP] = ActionEntry(REDUCE, 289);
   _actionMap[552][WHERE] = ActionEntry(REDUCE, 289);
   _actionMap[552][FROM] = ActionEntry(REDUCE, 289);
   _actionMap[552][AS] = ActionEntry(REDUCE, 289);
   _actionMap[552][END_TOKEN] = ActionEntry(REDUCE, 289);
   _actionMap[552][BEGIN] = ActionEntry(REDUCE, 289);
   _actionMap[552][THEN] = ActionEntry(REDUCE, 289);
   _actionMap[552][OR] = ActionEntry(REDUCE, 289);
   _actionMap[552][AND] = ActionEntry(REDUCE, 289);
   _actionMap[552][INTOK] = ActionEntry(REDUCE, 289);
   _actionMap[552][NOT] = ActionEntry(REDUCE, 289);
   _actionMap[552][BETWEEN] = ActionEntry(REDUCE, 289);
   _actionMap[552][IS] = ActionEntry(REDUCE, 289);
   _actionMap[552][LIKE] = ActionEntry(REDUCE, 289);
   _actionMap[552][MT] = ActionEntry(REDUCE, 289);
   _actionMap[552][LT] = ActionEntry(REDUCE, 289);
   _actionMap[552][NEGATION] = ActionEntry(REDUCE, 289);
   _actionMap[552][EQU] = ActionEntry(REDUCE, 289);
   _actionMap[552][RB] = ActionEntry(REDUCE, 289);
   _actionMap[552][ENDTOKEN] = ActionEntry(REDUCE, 289);
   _actionMap[552][UNION] = ActionEntry(REDUCE, 289);
   _actionMap[552][ROWLIMIT] = ActionEntry(REDUCE, 289);
   _actionMap[552][KSEP] = ActionEntry(REDUCE, 289);
   _actionMap[552][ASC] = ActionEntry(REDUCE, 289);
   _actionMap[552][DESC] = ActionEntry(REDUCE, 289);
   _actionMap[552][SEMICOLON] = ActionEntry(REDUCE, 289);
   _actionMap[552][PLUS] = ActionEntry(REDUCE, 289);
   _actionMap[552][MINUS] = ActionEntry(REDUCE, 289);
   _actionMap[552][DIVISION] = ActionEntry(REDUCE, 289);
   _actionMap[552][STAR] = ActionEntry(REDUCE, 289);
   _actionMap[552][CONCAT] = ActionEntry(REDUCE, 289);
   _actionMap[553][WHEN] = ActionEntry(REDUCE, 290);
   _actionMap[553][ELSE] = ActionEntry(REDUCE, 290);
   _actionMap[553][LEFT] = ActionEntry(REDUCE, 290);
   _actionMap[553][RIGHT] = ActionEntry(REDUCE, 290);
   _actionMap[553][INNER] = ActionEntry(REDUCE, 290);
   _actionMap[553][JOIN] = ActionEntry(REDUCE, 290);
   _actionMap[553][RETURNTOKEN] = ActionEntry(REDUCE, 290);
   _actionMap[553][ORDER] = ActionEntry(REDUCE, 290);
   _actionMap[553][GROUP] = ActionEntry(REDUCE, 290);
   _actionMap[553][WHERE] = ActionEntry(REDUCE, 290);
   _actionMap[553][FROM] = ActionEntry(REDUCE, 290);
   _actionMap[553][AS] = ActionEntry(REDUCE, 290);
   _actionMap[553][END_TOKEN] = ActionEntry(REDUCE, 290);
}
void Cego::loadParser110()
{
   _actionMap[553][BEGIN] = ActionEntry(REDUCE, 290);
   _actionMap[553][THEN] = ActionEntry(REDUCE, 290);
   _actionMap[553][OR] = ActionEntry(REDUCE, 290);
   _actionMap[553][AND] = ActionEntry(REDUCE, 290);
   _actionMap[553][INTOK] = ActionEntry(REDUCE, 290);
   _actionMap[553][NOT] = ActionEntry(REDUCE, 290);
   _actionMap[553][BETWEEN] = ActionEntry(REDUCE, 290);
   _actionMap[553][IS] = ActionEntry(REDUCE, 290);
   _actionMap[553][LIKE] = ActionEntry(REDUCE, 290);
   _actionMap[553][MT] = ActionEntry(REDUCE, 290);
   _actionMap[553][LT] = ActionEntry(REDUCE, 290);
   _actionMap[553][NEGATION] = ActionEntry(REDUCE, 290);
   _actionMap[553][EQU] = ActionEntry(REDUCE, 290);
   _actionMap[553][RB] = ActionEntry(REDUCE, 290);
   _actionMap[553][ENDTOKEN] = ActionEntry(REDUCE, 290);
   _actionMap[553][UNION] = ActionEntry(REDUCE, 290);
   _actionMap[553][ROWLIMIT] = ActionEntry(REDUCE, 290);
   _actionMap[553][KSEP] = ActionEntry(REDUCE, 290);
   _actionMap[553][ASC] = ActionEntry(REDUCE, 290);
   _actionMap[553][DESC] = ActionEntry(REDUCE, 290);
   _actionMap[553][SEMICOLON] = ActionEntry(REDUCE, 290);
   _actionMap[553][PLUS] = ActionEntry(REDUCE, 290);
   _actionMap[553][MINUS] = ActionEntry(REDUCE, 290);
   _actionMap[553][DIVISION] = ActionEntry(REDUCE, 290);
   _actionMap[553][STAR] = ActionEntry(REDUCE, 290);
   _actionMap[553][CONCAT] = ActionEntry(REDUCE, 290);
   _actionMap[554][WHEN] = ActionEntry(REDUCE, 272);
   _actionMap[554][ELSE] = ActionEntry(REDUCE, 272);
   _actionMap[554][LEFT] = ActionEntry(REDUCE, 272);
   _actionMap[554][RIGHT] = ActionEntry(REDUCE, 272);
   _actionMap[554][INNER] = ActionEntry(REDUCE, 272);
   _actionMap[554][JOIN] = ActionEntry(REDUCE, 272);
   _actionMap[554][RETURNTOKEN] = ActionEntry(REDUCE, 272);
   _actionMap[554][ORDER] = ActionEntry(REDUCE, 272);
   _actionMap[554][GROUP] = ActionEntry(REDUCE, 272);
   _actionMap[554][WHERE] = ActionEntry(REDUCE, 272);
   _actionMap[554][FROM] = ActionEntry(REDUCE, 272);
   _actionMap[554][AS] = ActionEntry(REDUCE, 272);
   _actionMap[554][END_TOKEN] = ActionEntry(REDUCE, 272);
   _actionMap[554][BEGIN] = ActionEntry(REDUCE, 272);
   _actionMap[554][THEN] = ActionEntry(REDUCE, 272);
   _actionMap[554][OR] = ActionEntry(REDUCE, 272);
   _actionMap[554][AND] = ActionEntry(REDUCE, 272);
   _actionMap[554][INTOK] = ActionEntry(REDUCE, 272);
   _actionMap[554][NOT] = ActionEntry(REDUCE, 272);
   _actionMap[554][BETWEEN] = ActionEntry(REDUCE, 272);
   _actionMap[554][IS] = ActionEntry(REDUCE, 272);
   _actionMap[554][LIKE] = ActionEntry(REDUCE, 272);
   _actionMap[554][MT] = ActionEntry(REDUCE, 272);
   _actionMap[554][LT] = ActionEntry(REDUCE, 272);
}
void Cego::loadParser111()
{
   _actionMap[554][NEGATION] = ActionEntry(REDUCE, 272);
   _actionMap[554][EQU] = ActionEntry(REDUCE, 272);
   _actionMap[554][RB] = ActionEntry(REDUCE, 272);
   _actionMap[554][ENDTOKEN] = ActionEntry(REDUCE, 272);
   _actionMap[554][UNION] = ActionEntry(REDUCE, 272);
   _actionMap[554][ROWLIMIT] = ActionEntry(REDUCE, 272);
   _actionMap[554][KSEP] = ActionEntry(REDUCE, 272);
   _actionMap[554][ASC] = ActionEntry(REDUCE, 272);
   _actionMap[554][DESC] = ActionEntry(REDUCE, 272);
   _actionMap[554][SEMICOLON] = ActionEntry(REDUCE, 272);
   _actionMap[554][PLUS] = ActionEntry(REDUCE, 272);
   _actionMap[554][MINUS] = ActionEntry(REDUCE, 272);
   _actionMap[554][DIVISION] = ActionEntry(REDUCE, 272);
   _actionMap[554][STAR] = ActionEntry(REDUCE, 272);
   _actionMap[554][CONCAT] = ActionEntry(REDUCE, 272);
   _actionMap[555][WHEN] = ActionEntry(REDUCE, 287);
   _actionMap[555][ELSE] = ActionEntry(REDUCE, 287);
   _actionMap[555][LEFT] = ActionEntry(REDUCE, 287);
   _actionMap[555][RIGHT] = ActionEntry(REDUCE, 287);
   _actionMap[555][INNER] = ActionEntry(REDUCE, 287);
   _actionMap[555][JOIN] = ActionEntry(REDUCE, 287);
   _actionMap[555][RETURNTOKEN] = ActionEntry(REDUCE, 287);
   _actionMap[555][ORDER] = ActionEntry(REDUCE, 287);
   _actionMap[555][GROUP] = ActionEntry(REDUCE, 287);
   _actionMap[555][WHERE] = ActionEntry(REDUCE, 287);
   _actionMap[555][FROM] = ActionEntry(REDUCE, 287);
   _actionMap[555][AS] = ActionEntry(REDUCE, 287);
   _actionMap[555][END_TOKEN] = ActionEntry(REDUCE, 287);
   _actionMap[555][BEGIN] = ActionEntry(REDUCE, 287);
   _actionMap[555][THEN] = ActionEntry(REDUCE, 287);
   _actionMap[555][OR] = ActionEntry(REDUCE, 287);
   _actionMap[555][AND] = ActionEntry(REDUCE, 287);
   _actionMap[555][INTOK] = ActionEntry(REDUCE, 287);
   _actionMap[555][NOT] = ActionEntry(REDUCE, 287);
   _actionMap[555][BETWEEN] = ActionEntry(REDUCE, 287);
   _actionMap[555][IS] = ActionEntry(REDUCE, 287);
   _actionMap[555][LIKE] = ActionEntry(REDUCE, 287);
   _actionMap[555][MT] = ActionEntry(REDUCE, 287);
   _actionMap[555][LT] = ActionEntry(REDUCE, 287);
   _actionMap[555][NEGATION] = ActionEntry(REDUCE, 287);
   _actionMap[555][EQU] = ActionEntry(REDUCE, 287);
   _actionMap[555][RB] = ActionEntry(REDUCE, 287);
   _actionMap[555][ENDTOKEN] = ActionEntry(REDUCE, 287);
   _actionMap[555][UNION] = ActionEntry(REDUCE, 287);
   _actionMap[555][ROWLIMIT] = ActionEntry(REDUCE, 287);
   _actionMap[555][KSEP] = ActionEntry(REDUCE, 287);
   _actionMap[555][ASC] = ActionEntry(REDUCE, 287);
   _actionMap[555][DESC] = ActionEntry(REDUCE, 287);
   _actionMap[555][SEMICOLON] = ActionEntry(REDUCE, 287);
   _actionMap[555][PLUS] = ActionEntry(REDUCE, 287);
}
void Cego::loadParser112()
{
   _actionMap[555][MINUS] = ActionEntry(REDUCE, 287);
   _actionMap[555][DIVISION] = ActionEntry(REDUCE, 287);
   _actionMap[555][STAR] = ActionEntry(REDUCE, 287);
   _actionMap[555][CONCAT] = ActionEntry(REDUCE, 287);
   _actionMap[556][WHEN] = ActionEntry(REDUCE, 280);
   _actionMap[556][ELSE] = ActionEntry(REDUCE, 280);
   _actionMap[556][LEFT] = ActionEntry(REDUCE, 280);
   _actionMap[556][RIGHT] = ActionEntry(REDUCE, 280);
   _actionMap[556][INNER] = ActionEntry(REDUCE, 280);
   _actionMap[556][JOIN] = ActionEntry(REDUCE, 280);
   _actionMap[556][RETURNTOKEN] = ActionEntry(REDUCE, 280);
   _actionMap[556][ORDER] = ActionEntry(REDUCE, 280);
   _actionMap[556][GROUP] = ActionEntry(REDUCE, 280);
   _actionMap[556][WHERE] = ActionEntry(REDUCE, 280);
   _actionMap[556][FROM] = ActionEntry(REDUCE, 280);
   _actionMap[556][AS] = ActionEntry(REDUCE, 280);
   _actionMap[556][END_TOKEN] = ActionEntry(REDUCE, 280);
   _actionMap[556][BEGIN] = ActionEntry(REDUCE, 280);
   _actionMap[556][THEN] = ActionEntry(REDUCE, 280);
   _actionMap[556][OR] = ActionEntry(REDUCE, 280);
   _actionMap[556][AND] = ActionEntry(REDUCE, 280);
   _actionMap[556][INTOK] = ActionEntry(REDUCE, 280);
   _actionMap[556][NOT] = ActionEntry(REDUCE, 280);
   _actionMap[556][BETWEEN] = ActionEntry(REDUCE, 280);
   _actionMap[556][IS] = ActionEntry(REDUCE, 280);
   _actionMap[556][LIKE] = ActionEntry(REDUCE, 280);
   _actionMap[556][MT] = ActionEntry(REDUCE, 280);
   _actionMap[556][LT] = ActionEntry(REDUCE, 280);
   _actionMap[556][NEGATION] = ActionEntry(REDUCE, 280);
   _actionMap[556][EQU] = ActionEntry(REDUCE, 280);
   _actionMap[556][RB] = ActionEntry(REDUCE, 280);
   _actionMap[556][ENDTOKEN] = ActionEntry(REDUCE, 280);
   _actionMap[556][UNION] = ActionEntry(REDUCE, 280);
   _actionMap[556][ROWLIMIT] = ActionEntry(REDUCE, 280);
   _actionMap[556][KSEP] = ActionEntry(REDUCE, 280);
   _actionMap[556][ASC] = ActionEntry(REDUCE, 280);
   _actionMap[556][DESC] = ActionEntry(REDUCE, 280);
   _actionMap[556][SEMICOLON] = ActionEntry(REDUCE, 280);
   _actionMap[556][PLUS] = ActionEntry(REDUCE, 280);
   _actionMap[556][MINUS] = ActionEntry(REDUCE, 280);
   _actionMap[556][DIVISION] = ActionEntry(REDUCE, 280);
   _actionMap[556][STAR] = ActionEntry(REDUCE, 280);
   _actionMap[556][CONCAT] = ActionEntry(REDUCE, 280);
   _actionMap[557][WHEN] = ActionEntry(REDUCE, 351);
   _actionMap[557][ELSE] = ActionEntry(REDUCE, 351);
   _actionMap[557][LEFT] = ActionEntry(REDUCE, 351);
   _actionMap[557][RIGHT] = ActionEntry(REDUCE, 351);
   _actionMap[557][INNER] = ActionEntry(REDUCE, 351);
   _actionMap[557][JOIN] = ActionEntry(REDUCE, 351);
   _actionMap[557][RETURNTOKEN] = ActionEntry(REDUCE, 351);
}
void Cego::loadParser113()
{
   _actionMap[557][ORDER] = ActionEntry(REDUCE, 351);
   _actionMap[557][GROUP] = ActionEntry(REDUCE, 351);
   _actionMap[557][WHERE] = ActionEntry(REDUCE, 351);
   _actionMap[557][FROM] = ActionEntry(REDUCE, 351);
   _actionMap[557][AS] = ActionEntry(REDUCE, 351);
   _actionMap[557][END_TOKEN] = ActionEntry(REDUCE, 351);
   _actionMap[557][BEGIN] = ActionEntry(REDUCE, 351);
   _actionMap[557][THEN] = ActionEntry(REDUCE, 351);
   _actionMap[557][OR] = ActionEntry(REDUCE, 351);
   _actionMap[557][AND] = ActionEntry(REDUCE, 351);
   _actionMap[557][ENDTOKEN] = ActionEntry(REDUCE, 351);
   _actionMap[557][UNION] = ActionEntry(REDUCE, 351);
   _actionMap[557][ROWLIMIT] = ActionEntry(REDUCE, 351);
   _actionMap[557][ASC] = ActionEntry(REDUCE, 351);
   _actionMap[557][DESC] = ActionEntry(REDUCE, 351);
   _actionMap[557][INTOK] = ActionEntry(REDUCE, 351);
   _actionMap[557][BETWEEN] = ActionEntry(REDUCE, 351);
   _actionMap[557][LIKE] = ActionEntry(REDUCE, 351);
   _actionMap[557][PLUS] = ActionEntry(REDUCE, 351);
   _actionMap[557][MINUS] = ActionEntry(REDUCE, 351);
   _actionMap[557][CONCAT] = ActionEntry(REDUCE, 351);
   _actionMap[557][DIVISION] = ActionEntry(REDUCE, 351);
   _actionMap[557][STAR] = ActionEntry(REDUCE, 351);
   _actionMap[557][MT] = ActionEntry(REDUCE, 351);
   _actionMap[557][LT] = ActionEntry(REDUCE, 351);
   _actionMap[557][NEGATION] = ActionEntry(REDUCE, 351);
   _actionMap[557][EQU] = ActionEntry(REDUCE, 351);
   _actionMap[557][IS] = ActionEntry(REDUCE, 351);
   _actionMap[557][NULLTOKEN] = ActionEntry(REDUCE, 351);
   _actionMap[557][NOT] = ActionEntry(REDUCE, 351);
   _actionMap[557][KSEP] = ActionEntry(REDUCE, 351);
   _actionMap[557][SEMICOLON] = ActionEntry(REDUCE, 351);
   _actionMap[557][RB] = ActionEntry(REDUCE, 351);
   _actionMap[558][INTVAL] = ActionEntry(SHIFT, 281);
   _actionMap[559][WHEN] = ActionEntry(REDUCE, 357);
   _actionMap[559][ELSE] = ActionEntry(REDUCE, 357);
   _actionMap[559][LEFT] = ActionEntry(REDUCE, 357);
   _actionMap[559][RIGHT] = ActionEntry(REDUCE, 357);
   _actionMap[559][INNER] = ActionEntry(REDUCE, 357);
   _actionMap[559][JOIN] = ActionEntry(REDUCE, 357);
   _actionMap[559][RETURNTOKEN] = ActionEntry(REDUCE, 357);
   _actionMap[559][ORDER] = ActionEntry(REDUCE, 357);
   _actionMap[559][GROUP] = ActionEntry(REDUCE, 357);
   _actionMap[559][WHERE] = ActionEntry(REDUCE, 357);
   _actionMap[559][FROM] = ActionEntry(REDUCE, 357);
   _actionMap[559][AS] = ActionEntry(REDUCE, 357);
   _actionMap[559][END_TOKEN] = ActionEntry(REDUCE, 357);
   _actionMap[559][BEGIN] = ActionEntry(REDUCE, 357);
   _actionMap[559][THEN] = ActionEntry(REDUCE, 357);
   _actionMap[559][OR] = ActionEntry(REDUCE, 357);
}
void Cego::loadParser114()
{
   _actionMap[559][AND] = ActionEntry(REDUCE, 357);
   _actionMap[559][ENDTOKEN] = ActionEntry(REDUCE, 357);
   _actionMap[559][UNION] = ActionEntry(REDUCE, 357);
   _actionMap[559][ROWLIMIT] = ActionEntry(REDUCE, 357);
   _actionMap[559][ASC] = ActionEntry(REDUCE, 357);
   _actionMap[559][DESC] = ActionEntry(REDUCE, 357);
   _actionMap[559][INTOK] = ActionEntry(REDUCE, 357);
   _actionMap[559][BETWEEN] = ActionEntry(REDUCE, 357);
   _actionMap[559][LIKE] = ActionEntry(REDUCE, 357);
   _actionMap[559][PLUS] = ActionEntry(REDUCE, 357);
   _actionMap[559][MINUS] = ActionEntry(REDUCE, 357);
   _actionMap[559][CONCAT] = ActionEntry(REDUCE, 357);
   _actionMap[559][DIVISION] = ActionEntry(REDUCE, 357);
   _actionMap[559][STAR] = ActionEntry(REDUCE, 357);
   _actionMap[559][MT] = ActionEntry(REDUCE, 357);
   _actionMap[559][LT] = ActionEntry(REDUCE, 357);
   _actionMap[559][NEGATION] = ActionEntry(REDUCE, 357);
   _actionMap[559][EQU] = ActionEntry(REDUCE, 357);
   _actionMap[559][IS] = ActionEntry(REDUCE, 357);
   _actionMap[559][NULLTOKEN] = ActionEntry(REDUCE, 357);
   _actionMap[559][NOT] = ActionEntry(REDUCE, 357);
   _actionMap[559][KSEP] = ActionEntry(REDUCE, 357);
   _actionMap[559][SEMICOLON] = ActionEntry(REDUCE, 357);
   _actionMap[559][RB] = ActionEntry(REDUCE, 357);
   _actionMap[560][FLOATVAL] = ActionEntry(SHIFT, 282);
   _actionMap[561][WHEN] = ActionEntry(REDUCE, 356);
   _actionMap[561][ELSE] = ActionEntry(REDUCE, 356);
   _actionMap[561][LEFT] = ActionEntry(REDUCE, 356);
   _actionMap[561][RIGHT] = ActionEntry(REDUCE, 356);
   _actionMap[561][INNER] = ActionEntry(REDUCE, 356);
   _actionMap[561][JOIN] = ActionEntry(REDUCE, 356);
   _actionMap[561][RETURNTOKEN] = ActionEntry(REDUCE, 356);
   _actionMap[561][ORDER] = ActionEntry(REDUCE, 356);
   _actionMap[561][GROUP] = ActionEntry(REDUCE, 356);
   _actionMap[561][WHERE] = ActionEntry(REDUCE, 356);
   _actionMap[561][FROM] = ActionEntry(REDUCE, 356);
   _actionMap[561][AS] = ActionEntry(REDUCE, 356);
   _actionMap[561][END_TOKEN] = ActionEntry(REDUCE, 356);
   _actionMap[561][BEGIN] = ActionEntry(REDUCE, 356);
   _actionMap[561][THEN] = ActionEntry(REDUCE, 356);
   _actionMap[561][OR] = ActionEntry(REDUCE, 356);
   _actionMap[561][AND] = ActionEntry(REDUCE, 356);
   _actionMap[561][ENDTOKEN] = ActionEntry(REDUCE, 356);
   _actionMap[561][UNION] = ActionEntry(REDUCE, 356);
   _actionMap[561][ROWLIMIT] = ActionEntry(REDUCE, 356);
   _actionMap[561][ASC] = ActionEntry(REDUCE, 356);
   _actionMap[561][DESC] = ActionEntry(REDUCE, 356);
   _actionMap[561][INTOK] = ActionEntry(REDUCE, 356);
   _actionMap[561][BETWEEN] = ActionEntry(REDUCE, 356);
   _actionMap[561][LIKE] = ActionEntry(REDUCE, 356);
}
void Cego::loadParser115()
{
   _actionMap[561][PLUS] = ActionEntry(REDUCE, 356);
   _actionMap[561][MINUS] = ActionEntry(REDUCE, 356);
   _actionMap[561][CONCAT] = ActionEntry(REDUCE, 356);
   _actionMap[561][DIVISION] = ActionEntry(REDUCE, 356);
   _actionMap[561][STAR] = ActionEntry(REDUCE, 356);
   _actionMap[561][MT] = ActionEntry(REDUCE, 356);
   _actionMap[561][LT] = ActionEntry(REDUCE, 356);
   _actionMap[561][NEGATION] = ActionEntry(REDUCE, 356);
   _actionMap[561][EQU] = ActionEntry(REDUCE, 356);
   _actionMap[561][IS] = ActionEntry(REDUCE, 356);
   _actionMap[561][NULLTOKEN] = ActionEntry(REDUCE, 356);
   _actionMap[561][NOT] = ActionEntry(REDUCE, 356);
   _actionMap[561][KSEP] = ActionEntry(REDUCE, 356);
   _actionMap[561][SEMICOLON] = ActionEntry(REDUCE, 356);
   _actionMap[561][RB] = ActionEntry(REDUCE, 356);
   _actionMap[562][WHEN] = ActionEntry(REDUCE, 358);
   _actionMap[562][ELSE] = ActionEntry(REDUCE, 358);
   _actionMap[562][LEFT] = ActionEntry(REDUCE, 358);
   _actionMap[562][RIGHT] = ActionEntry(REDUCE, 358);
   _actionMap[562][INNER] = ActionEntry(REDUCE, 358);
   _actionMap[562][JOIN] = ActionEntry(REDUCE, 358);
   _actionMap[562][RETURNTOKEN] = ActionEntry(REDUCE, 358);
   _actionMap[562][ORDER] = ActionEntry(REDUCE, 358);
   _actionMap[562][GROUP] = ActionEntry(REDUCE, 358);
   _actionMap[562][WHERE] = ActionEntry(REDUCE, 358);
   _actionMap[562][FROM] = ActionEntry(REDUCE, 358);
   _actionMap[562][AS] = ActionEntry(REDUCE, 358);
   _actionMap[562][END_TOKEN] = ActionEntry(REDUCE, 358);
   _actionMap[562][BEGIN] = ActionEntry(REDUCE, 358);
   _actionMap[562][THEN] = ActionEntry(REDUCE, 358);
   _actionMap[562][OR] = ActionEntry(REDUCE, 358);
   _actionMap[562][AND] = ActionEntry(REDUCE, 358);
   _actionMap[562][ENDTOKEN] = ActionEntry(REDUCE, 358);
   _actionMap[562][UNION] = ActionEntry(REDUCE, 358);
   _actionMap[562][ROWLIMIT] = ActionEntry(REDUCE, 358);
   _actionMap[562][ASC] = ActionEntry(REDUCE, 358);
   _actionMap[562][DESC] = ActionEntry(REDUCE, 358);
   _actionMap[562][INTOK] = ActionEntry(REDUCE, 358);
   _actionMap[562][BETWEEN] = ActionEntry(REDUCE, 358);
   _actionMap[562][LIKE] = ActionEntry(REDUCE, 358);
   _actionMap[562][PLUS] = ActionEntry(REDUCE, 358);
   _actionMap[562][MINUS] = ActionEntry(REDUCE, 358);
   _actionMap[562][CONCAT] = ActionEntry(REDUCE, 358);
   _actionMap[562][DIVISION] = ActionEntry(REDUCE, 358);
   _actionMap[562][STAR] = ActionEntry(REDUCE, 358);
   _actionMap[562][MT] = ActionEntry(REDUCE, 358);
   _actionMap[562][LT] = ActionEntry(REDUCE, 358);
   _actionMap[562][NEGATION] = ActionEntry(REDUCE, 358);
   _actionMap[562][EQU] = ActionEntry(REDUCE, 358);
   _actionMap[562][IS] = ActionEntry(REDUCE, 358);
}
void Cego::loadParser116()
{
   _actionMap[562][NULLTOKEN] = ActionEntry(REDUCE, 358);
   _actionMap[562][NOT] = ActionEntry(REDUCE, 358);
   _actionMap[562][KSEP] = ActionEntry(REDUCE, 358);
   _actionMap[562][SEMICOLON] = ActionEntry(REDUCE, 358);
   _actionMap[562][RB] = ActionEntry(REDUCE, 358);
   _actionMap[563][WHEN] = ActionEntry(REDUCE, 350);
   _actionMap[563][ELSE] = ActionEntry(REDUCE, 350);
   _actionMap[563][LEFT] = ActionEntry(REDUCE, 350);
   _actionMap[563][RIGHT] = ActionEntry(REDUCE, 350);
   _actionMap[563][INNER] = ActionEntry(REDUCE, 350);
   _actionMap[563][JOIN] = ActionEntry(REDUCE, 350);
   _actionMap[563][RETURNTOKEN] = ActionEntry(REDUCE, 350);
   _actionMap[563][ORDER] = ActionEntry(REDUCE, 350);
   _actionMap[563][GROUP] = ActionEntry(REDUCE, 350);
   _actionMap[563][WHERE] = ActionEntry(REDUCE, 350);
   _actionMap[563][FROM] = ActionEntry(REDUCE, 350);
   _actionMap[563][AS] = ActionEntry(REDUCE, 350);
   _actionMap[563][END_TOKEN] = ActionEntry(REDUCE, 350);
   _actionMap[563][BEGIN] = ActionEntry(REDUCE, 350);
   _actionMap[563][THEN] = ActionEntry(REDUCE, 350);
   _actionMap[563][OR] = ActionEntry(REDUCE, 350);
   _actionMap[563][AND] = ActionEntry(REDUCE, 350);
   _actionMap[563][ENDTOKEN] = ActionEntry(REDUCE, 350);
   _actionMap[563][UNION] = ActionEntry(REDUCE, 350);
   _actionMap[563][ROWLIMIT] = ActionEntry(REDUCE, 350);
   _actionMap[563][ASC] = ActionEntry(REDUCE, 350);
   _actionMap[563][DESC] = ActionEntry(REDUCE, 350);
   _actionMap[563][INTOK] = ActionEntry(REDUCE, 350);
   _actionMap[563][BETWEEN] = ActionEntry(REDUCE, 350);
   _actionMap[563][LIKE] = ActionEntry(REDUCE, 350);
   _actionMap[563][PLUS] = ActionEntry(REDUCE, 350);
   _actionMap[563][MINUS] = ActionEntry(REDUCE, 350);
   _actionMap[563][CONCAT] = ActionEntry(REDUCE, 350);
   _actionMap[563][DIVISION] = ActionEntry(REDUCE, 350);
   _actionMap[563][STAR] = ActionEntry(REDUCE, 350);
   _actionMap[563][MT] = ActionEntry(REDUCE, 350);
   _actionMap[563][LT] = ActionEntry(REDUCE, 350);
   _actionMap[563][NEGATION] = ActionEntry(REDUCE, 350);
   _actionMap[563][EQU] = ActionEntry(REDUCE, 350);
   _actionMap[563][IS] = ActionEntry(REDUCE, 350);
   _actionMap[563][NULLTOKEN] = ActionEntry(REDUCE, 350);
   _actionMap[563][NOT] = ActionEntry(REDUCE, 350);
   _actionMap[563][KSEP] = ActionEntry(REDUCE, 350);
   _actionMap[563][SEMICOLON] = ActionEntry(REDUCE, 350);
   _actionMap[563][RB] = ActionEntry(REDUCE, 350);
   _actionMap[564][WHEN] = ActionEntry(REDUCE, 352);
   _actionMap[564][ELSE] = ActionEntry(REDUCE, 352);
   _actionMap[564][LEFT] = ActionEntry(REDUCE, 352);
   _actionMap[564][RIGHT] = ActionEntry(REDUCE, 352);
   _actionMap[564][INNER] = ActionEntry(REDUCE, 352);
}
void Cego::loadParser117()
{
   _actionMap[564][JOIN] = ActionEntry(REDUCE, 352);
   _actionMap[564][RETURNTOKEN] = ActionEntry(REDUCE, 352);
   _actionMap[564][ORDER] = ActionEntry(REDUCE, 352);
   _actionMap[564][GROUP] = ActionEntry(REDUCE, 352);
   _actionMap[564][WHERE] = ActionEntry(REDUCE, 352);
   _actionMap[564][FROM] = ActionEntry(REDUCE, 352);
   _actionMap[564][AS] = ActionEntry(REDUCE, 352);
   _actionMap[564][END_TOKEN] = ActionEntry(REDUCE, 352);
   _actionMap[564][BEGIN] = ActionEntry(REDUCE, 352);
   _actionMap[564][THEN] = ActionEntry(REDUCE, 352);
   _actionMap[564][OR] = ActionEntry(REDUCE, 352);
   _actionMap[564][AND] = ActionEntry(REDUCE, 352);
   _actionMap[564][ENDTOKEN] = ActionEntry(REDUCE, 352);
   _actionMap[564][UNION] = ActionEntry(REDUCE, 352);
   _actionMap[564][ROWLIMIT] = ActionEntry(REDUCE, 352);
   _actionMap[564][ASC] = ActionEntry(REDUCE, 352);
   _actionMap[564][DESC] = ActionEntry(REDUCE, 352);
   _actionMap[564][INTOK] = ActionEntry(REDUCE, 352);
   _actionMap[564][BETWEEN] = ActionEntry(REDUCE, 352);
   _actionMap[564][LIKE] = ActionEntry(REDUCE, 352);
   _actionMap[564][PLUS] = ActionEntry(REDUCE, 352);
   _actionMap[564][MINUS] = ActionEntry(REDUCE, 352);
   _actionMap[564][CONCAT] = ActionEntry(REDUCE, 352);
   _actionMap[564][DIVISION] = ActionEntry(REDUCE, 352);
   _actionMap[564][STAR] = ActionEntry(REDUCE, 352);
   _actionMap[564][MT] = ActionEntry(REDUCE, 352);
   _actionMap[564][LT] = ActionEntry(REDUCE, 352);
   _actionMap[564][NEGATION] = ActionEntry(REDUCE, 352);
   _actionMap[564][EQU] = ActionEntry(REDUCE, 352);
   _actionMap[564][IS] = ActionEntry(REDUCE, 352);
   _actionMap[564][NULLTOKEN] = ActionEntry(REDUCE, 352);
   _actionMap[564][NOT] = ActionEntry(REDUCE, 352);
   _actionMap[564][KSEP] = ActionEntry(REDUCE, 352);
   _actionMap[564][SEMICOLON] = ActionEntry(REDUCE, 352);
   _actionMap[564][RB] = ActionEntry(REDUCE, 352);
   _actionMap[565][WHEN] = ActionEntry(REDUCE, 353);
   _actionMap[565][ELSE] = ActionEntry(REDUCE, 353);
   _actionMap[565][LEFT] = ActionEntry(REDUCE, 353);
   _actionMap[565][RIGHT] = ActionEntry(REDUCE, 353);
   _actionMap[565][INNER] = ActionEntry(REDUCE, 353);
   _actionMap[565][JOIN] = ActionEntry(REDUCE, 353);
   _actionMap[565][RETURNTOKEN] = ActionEntry(REDUCE, 353);
   _actionMap[565][ORDER] = ActionEntry(REDUCE, 353);
   _actionMap[565][GROUP] = ActionEntry(REDUCE, 353);
   _actionMap[565][WHERE] = ActionEntry(REDUCE, 353);
   _actionMap[565][FROM] = ActionEntry(REDUCE, 353);
   _actionMap[565][AS] = ActionEntry(REDUCE, 353);
   _actionMap[565][END_TOKEN] = ActionEntry(REDUCE, 353);
   _actionMap[565][BEGIN] = ActionEntry(REDUCE, 353);
   _actionMap[565][THEN] = ActionEntry(REDUCE, 353);
}
void Cego::loadParser118()
{
   _actionMap[565][OR] = ActionEntry(REDUCE, 353);
   _actionMap[565][AND] = ActionEntry(REDUCE, 353);
   _actionMap[565][ENDTOKEN] = ActionEntry(REDUCE, 353);
   _actionMap[565][UNION] = ActionEntry(REDUCE, 353);
   _actionMap[565][ROWLIMIT] = ActionEntry(REDUCE, 353);
   _actionMap[565][ASC] = ActionEntry(REDUCE, 353);
   _actionMap[565][DESC] = ActionEntry(REDUCE, 353);
   _actionMap[565][INTOK] = ActionEntry(REDUCE, 353);
   _actionMap[565][BETWEEN] = ActionEntry(REDUCE, 353);
   _actionMap[565][LIKE] = ActionEntry(REDUCE, 353);
   _actionMap[565][PLUS] = ActionEntry(REDUCE, 353);
   _actionMap[565][MINUS] = ActionEntry(REDUCE, 353);
   _actionMap[565][CONCAT] = ActionEntry(REDUCE, 353);
   _actionMap[565][DIVISION] = ActionEntry(REDUCE, 353);
   _actionMap[565][STAR] = ActionEntry(REDUCE, 353);
   _actionMap[565][MT] = ActionEntry(REDUCE, 353);
   _actionMap[565][LT] = ActionEntry(REDUCE, 353);
   _actionMap[565][NEGATION] = ActionEntry(REDUCE, 353);
   _actionMap[565][EQU] = ActionEntry(REDUCE, 353);
   _actionMap[565][IS] = ActionEntry(REDUCE, 353);
   _actionMap[565][NULLTOKEN] = ActionEntry(REDUCE, 353);
   _actionMap[565][NOT] = ActionEntry(REDUCE, 353);
   _actionMap[565][KSEP] = ActionEntry(REDUCE, 353);
   _actionMap[565][SEMICOLON] = ActionEntry(REDUCE, 353);
   _actionMap[565][RB] = ActionEntry(REDUCE, 353);
   _actionMap[566][RAB] = ActionEntry(SHIFT, 674);
   _actionMap[567][SEMICOLON] = ActionEntry(REDUCE, 271);
   _actionMap[568][SEMICOLON] = ActionEntry(REDUCE, 267);
   _actionMap[569][SEMICOLON] = ActionEntry(REDUCE, 268);
   _actionMap[570][SEMICOLON] = ActionEntry(REDUCE, 269);
   _actionMap[571][SEMICOLON] = ActionEntry(REDUCE, 266);
   _actionMap[572][SEMICOLON] = ActionEntry(REDUCE, 270);
   _actionMap[573][SEMICOLON] = ActionEntry(REDUCE, 227);
   _actionMap[573][RB] = ActionEntry(REDUCE, 227);
   _actionMap[573][ENDTOKEN] = ActionEntry(REDUCE, 227);
   _actionMap[573][UNION] = ActionEntry(REDUCE, 227);
   _actionMap[573][ROWLIMIT] = ActionEntry(REDUCE, 227);
   _actionMap[573][ORDER] = ActionEntry(REDUCE, 227);
   _actionMap[573][GROUP] = ActionEntry(SHIFT, 677);
   _jumpMap[573][NoGroup] = 676;
   _jumpMap[573][GroupClause] = 675;
   _actionMap[574][LEFT] = ActionEntry(REDUCE, 210);
   _actionMap[574][RIGHT] = ActionEntry(REDUCE, 210);
   _actionMap[574][INNER] = ActionEntry(REDUCE, 210);
   _actionMap[574][JOIN] = ActionEntry(REDUCE, 210);
   _actionMap[574][RETURNTOKEN] = ActionEntry(REDUCE, 210);
   _actionMap[574][SEMICOLON] = ActionEntry(REDUCE, 210);
   _actionMap[574][RB] = ActionEntry(REDUCE, 210);
   _actionMap[574][ENDTOKEN] = ActionEntry(REDUCE, 210);
   _actionMap[574][UNION] = ActionEntry(REDUCE, 210);
}
void Cego::loadParser119()
{
   _actionMap[574][ROWLIMIT] = ActionEntry(REDUCE, 210);
   _actionMap[574][ORDER] = ActionEntry(REDUCE, 210);
   _actionMap[574][GROUP] = ActionEntry(REDUCE, 210);
   _actionMap[574][WHERE] = ActionEntry(REDUCE, 210);
   _actionMap[575][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[575][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[575][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[575][ObjSpec] = 438;
   _jumpMap[575][Table] = 678;
   _actionMap[576][JOIN] = ActionEntry(SHIFT, 679);
   _actionMap[577][IDENTIFIER] = ActionEntry(REDUCE, 216);
   _actionMap[577][QUALIFIEDOBJ] = ActionEntry(REDUCE, 216);
   _actionMap[577][QUALIFIEDTS] = ActionEntry(REDUCE, 216);
   _actionMap[578][OUTER] = ActionEntry(SHIFT, 680);
   _actionMap[579][OUTER] = ActionEntry(SHIFT, 681);
   _actionMap[580][LEFT] = ActionEntry(REDUCE, 211);
   _actionMap[580][RIGHT] = ActionEntry(REDUCE, 211);
   _actionMap[580][INNER] = ActionEntry(REDUCE, 211);
   _actionMap[580][JOIN] = ActionEntry(REDUCE, 211);
   _actionMap[580][RETURNTOKEN] = ActionEntry(REDUCE, 211);
   _actionMap[580][SEMICOLON] = ActionEntry(REDUCE, 211);
   _actionMap[580][RB] = ActionEntry(REDUCE, 211);
   _actionMap[580][ENDTOKEN] = ActionEntry(REDUCE, 211);
   _actionMap[580][UNION] = ActionEntry(REDUCE, 211);
   _actionMap[580][ROWLIMIT] = ActionEntry(REDUCE, 211);
   _actionMap[580][ORDER] = ActionEntry(REDUCE, 211);
   _actionMap[580][GROUP] = ActionEntry(REDUCE, 211);
   _actionMap[580][WHERE] = ActionEntry(REDUCE, 211);
   _actionMap[581][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[581][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[581][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[581][ObjSpec] = 438;
   _jumpMap[581][Table] = 683;
   _jumpMap[581][TableList] = 682;
   _actionMap[582][WHERE] = ActionEntry(REDUCE, 220);
   _actionMap[582][GROUP] = ActionEntry(REDUCE, 220);
   _actionMap[582][ORDER] = ActionEntry(REDUCE, 220);
   _actionMap[582][ROWLIMIT] = ActionEntry(REDUCE, 220);
   _actionMap[582][UNION] = ActionEntry(REDUCE, 220);
   _actionMap[582][ENDTOKEN] = ActionEntry(REDUCE, 220);
   _actionMap[582][RB] = ActionEntry(REDUCE, 220);
   _actionMap[582][SEMICOLON] = ActionEntry(REDUCE, 220);
   _actionMap[582][RETURNTOKEN] = ActionEntry(REDUCE, 220);
   _actionMap[582][LEFT] = ActionEntry(REDUCE, 220);
   _actionMap[582][RIGHT] = ActionEntry(REDUCE, 220);
   _actionMap[582][INNER] = ActionEntry(REDUCE, 220);
   _actionMap[582][JOIN] = ActionEntry(REDUCE, 220);
   _actionMap[582][KSEP] = ActionEntry(REDUCE, 220);
   _actionMap[582][ON] = ActionEntry(REDUCE, 220);
   _actionMap[583][FROM] = ActionEntry(REDUCE, 222);
}
void Cego::loadParser120()
{
   _actionMap[583][KSEP] = ActionEntry(REDUCE, 222);
   _actionMap[584][FROM] = ActionEntry(REDUCE, 205);
   _actionMap[584][KSEP] = ActionEntry(REDUCE, 205);
   _actionMap[585][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[585][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[585][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[585][SEMICOLON] = ActionEntry(REDUCE, 73);
   _actionMap[586][RETURNTOKEN] = ActionEntry(SHIFT, 685);
   _actionMap[586][SEMICOLON] = ActionEntry(REDUCE, 252);
   _jumpMap[586][UpdReturnOpt] = 684;
   _actionMap[587][IDENTIFIER] = ActionEntry(SHIFT, 447);
   _jumpMap[587][Assignment] = 686;
   _actionMap[588][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[588][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[588][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[588][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[588][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[588][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[588][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[588][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[588][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[588][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[588][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[588][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[588][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[588][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[588][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[588][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[588][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[588][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[588][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[588][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[588][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[588][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[588][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[588][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[588][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[588][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[588][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[588][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[588][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[588][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[588][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[588][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[588][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[588][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[588][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[588][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[588][LB] = ActionEntry(SHIFT, 144);
   _actionMap[588][STRINGVAL] = ActionEntry(SHIFT, 101);
}
void Cego::loadParser121()
{
   _actionMap[588][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[588][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[588][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[588][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[588][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[588][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[588][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[588][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[588][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[588][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[588][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[588][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[588][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[588][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[588][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[588][ObjSpec] = 100;
   _jumpMap[588][Constant] = 99;
   _jumpMap[588][SignedFloat] = 98;
   _jumpMap[588][SignedInt] = 97;
   _jumpMap[588][Attribute] = 96;
   _jumpMap[588][Function] = 95;
   _jumpMap[588][CasePrepare] = 94;
   _jumpMap[588][CaseClause] = 93;
   _jumpMap[588][Factor] = 92;
   _jumpMap[588][Term] = 91;
   _jumpMap[588][Expr] = 687;
   _actionMap[589][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[589][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[589][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[589][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[589][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[589][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[589][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[589][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[589][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[589][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[589][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[589][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[589][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[589][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[589][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[589][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[589][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[589][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[589][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[589][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[589][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[589][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[589][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[589][RANDINT] = ActionEntry(SHIFT, 128);
}
void Cego::loadParser122()
{
   _actionMap[589][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[589][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[589][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[589][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[589][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[589][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[589][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[589][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[589][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[589][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[589][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[589][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[589][LB] = ActionEntry(SHIFT, 144);
   _actionMap[589][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[589][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[589][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[589][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[589][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[589][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[589][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[589][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[589][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[589][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[589][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[589][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[589][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[589][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[589][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[589][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[589][RB] = ActionEntry(REDUCE, 117);
   _jumpMap[589][ObjSpec] = 100;
   _jumpMap[589][Constant] = 99;
   _jumpMap[589][SignedFloat] = 98;
   _jumpMap[589][SignedInt] = 97;
   _jumpMap[589][Attribute] = 96;
   _jumpMap[589][Function] = 95;
   _jumpMap[589][CasePrepare] = 94;
   _jumpMap[589][CaseClause] = 93;
   _jumpMap[589][Factor] = 92;
   _jumpMap[589][Term] = 91;
   _jumpMap[589][Expr] = 321;
   _jumpMap[589][ProcValueList] = 320;
   _jumpMap[589][ProcValueListOpt] = 688;
   _actionMap[311][SEMICOLON] = ActionEntry(REDUCE, 61);
   _actionMap[312][SEMICOLON] = ActionEntry(REDUCE, 259);
   _actionMap[313][KSEP] = ActionEntry(SHIFT, 449);
   _actionMap[313][SEMICOLON] = ActionEntry(REDUCE, 261);
   _actionMap[314][CHECK] = ActionEntry(SHIFT, 450);
   _actionMap[314][FOREIGN] = ActionEntry(SHIFT, 452);
   _actionMap[314][COLUMN] = ActionEntry(SHIFT, 451);
}
void Cego::loadParser123()
{
   _actionMap[315][COLUMN] = ActionEntry(SHIFT, 453);
   _actionMap[316][COLUMN] = ActionEntry(SHIFT, 454);
   _actionMap[317][COLUMN] = ActionEntry(SHIFT, 455);
   _actionMap[318][STRINGVAL] = ActionEntry(SHIFT, 456);
   _actionMap[319][RB] = ActionEntry(SHIFT, 322);
   _actionMap[320][KSEP] = ActionEntry(SHIFT, 457);
   _actionMap[320][RB] = ActionEntry(REDUCE, 116);
   _actionMap[321][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[321][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[321][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[321][KSEP] = ActionEntry(REDUCE, 119);
   _actionMap[321][RB] = ActionEntry(REDUCE, 119);
   _actionMap[322][SEMICOLON] = ActionEntry(REDUCE, 52);
   _actionMap[323][END_TOKEN] = ActionEntry(SHIFT, 458);
   _actionMap[324][EXCEPTION] = ActionEntry(REDUCE, 114);
   _actionMap[324][ELSE] = ActionEntry(REDUCE, 114);
   _actionMap[324][ELSIF] = ActionEntry(REDUCE, 114);
   _actionMap[324][END_TOKEN] = ActionEntry(REDUCE, 114);
   _actionMap[324][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[324][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[324][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[324][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[324][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[324][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[324][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[324][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[324][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[324][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[324][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[324][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[324][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[324][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[324][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[324][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[324][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[324][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[324][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[324][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[324][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[324][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[324][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[324][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[324][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[324][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[324][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[324][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[324][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[324][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[324][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[324][NEXTCOUNT] = ActionEntry(SHIFT, 124);
}
void Cego::loadParser124()
{
   _actionMap[324][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[324][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[324][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[324][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[324][LB] = ActionEntry(SHIFT, 144);
   _actionMap[324][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[324][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[324][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[324][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[324][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[324][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[324][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[324][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[324][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[324][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[324][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[324][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[324][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[324][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[324][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[324][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[324][IF] = ActionEntry(SHIFT, 338);
   _actionMap[324][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[324][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[324][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[324][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[324][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[324][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[324][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[324][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[324][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[324][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[324][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[324][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[324][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[324][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[324][ObjSpec] = 100;
   _jumpMap[324][Constant] = 99;
   _jumpMap[324][SignedFloat] = 98;
   _jumpMap[324][SignedInt] = 97;
   _jumpMap[324][Attribute] = 96;
   _jumpMap[324][Function] = 95;
   _jumpMap[324][DeleteStatement] = 334;
   _jumpMap[324][UpdateStatement] = 333;
   _jumpMap[324][InsertStatement] = 332;
   _jumpMap[324][RollbackStatement] = 331;
   _jumpMap[324][CommitStatement] = 330;
   _jumpMap[324][StartStatement] = 329;
   _jumpMap[324][CasePrepare] = 94;
   _jumpMap[324][CaseClause] = 93;
}
void Cego::loadParser125()
{
   _jumpMap[324][Factor] = 92;
   _jumpMap[324][Term] = 91;
   _jumpMap[324][Expr] = 328;
   _jumpMap[324][ProcStatement] = 460;
   _jumpMap[324][ProcIfPart] = 326;
   _jumpMap[324][ProcExceptionList] = 459;
   _jumpMap[324][ProcBlockStart] = 325;
   _actionMap[325][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[325][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[325][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[325][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[325][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[325][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[325][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[325][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[325][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[325][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[325][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[325][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[325][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[325][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[325][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[325][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[325][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[325][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[325][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[325][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[325][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[325][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[325][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[325][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[325][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[325][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[325][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[325][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[325][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[325][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[325][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[325][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[325][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[325][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[325][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[325][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[325][LB] = ActionEntry(SHIFT, 144);
   _actionMap[325][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[325][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[325][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[325][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[325][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[325][FALSEVAL] = ActionEntry(SHIFT, 113);
}
void Cego::loadParser126()
{
   _actionMap[325][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[325][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[325][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[325][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[325][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[325][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[325][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[325][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[325][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[325][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[325][IF] = ActionEntry(SHIFT, 338);
   _actionMap[325][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[325][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[325][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[325][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[325][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[325][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[325][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[325][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[325][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[325][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[325][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[325][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[325][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[325][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[325][ObjSpec] = 100;
   _jumpMap[325][Constant] = 99;
   _jumpMap[325][SignedFloat] = 98;
   _jumpMap[325][SignedInt] = 97;
   _jumpMap[325][Attribute] = 96;
   _jumpMap[325][Function] = 95;
   _jumpMap[325][DeleteStatement] = 334;
   _jumpMap[325][UpdateStatement] = 333;
   _jumpMap[325][InsertStatement] = 332;
   _jumpMap[325][RollbackStatement] = 331;
   _jumpMap[325][CommitStatement] = 330;
   _jumpMap[325][StartStatement] = 329;
   _jumpMap[325][CasePrepare] = 94;
   _jumpMap[325][CaseClause] = 93;
   _jumpMap[325][Factor] = 92;
   _jumpMap[325][Term] = 91;
   _jumpMap[325][Expr] = 328;
   _jumpMap[325][ProcStatement] = 327;
   _jumpMap[325][ProcIfPart] = 326;
   _jumpMap[325][ProcBlockStart] = 325;
   _jumpMap[325][ProcStatementList] = 324;
   _jumpMap[325][ProcStmtBlock] = 461;
   _actionMap[326][ELSIF] = ActionEntry(SHIFT, 464);
   _actionMap[326][END_TOKEN] = ActionEntry(REDUCE, 124);
   _actionMap[326][ELSE] = ActionEntry(REDUCE, 124);
}
void Cego::loadParser127()
{
   _jumpMap[326][ProcElsIfOpt] = 463;
   _jumpMap[326][ProcElsIfList] = 462;
   _actionMap[327][SEMICOLON] = ActionEntry(SHIFT, 465);
   _actionMap[328][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[328][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[328][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[328][SEMICOLON] = ActionEntry(REDUCE, 97);
   _actionMap[329][SEMICOLON] = ActionEntry(REDUCE, 106);
   _actionMap[330][SEMICOLON] = ActionEntry(REDUCE, 107);
   _actionMap[331][SEMICOLON] = ActionEntry(REDUCE, 108);
   _actionMap[332][SEMICOLON] = ActionEntry(REDUCE, 103);
   _actionMap[333][SEMICOLON] = ActionEntry(REDUCE, 105);
   _actionMap[334][SEMICOLON] = ActionEntry(REDUCE, 104);
   _actionMap[335][VAR] = ActionEntry(REDUCE, 112);
   _actionMap[335][CURSOR] = ActionEntry(REDUCE, 112);
   _actionMap[335][CLOSE] = ActionEntry(REDUCE, 112);
   _actionMap[335][VARREF] = ActionEntry(REDUCE, 112);
   _actionMap[335][NOOP] = ActionEntry(REDUCE, 112);
   _actionMap[335][THROW] = ActionEntry(REDUCE, 112);
   _actionMap[335][RETURNTOKEN] = ActionEntry(REDUCE, 112);
   _actionMap[335][WHILE] = ActionEntry(REDUCE, 112);
   _actionMap[335][IF] = ActionEntry(REDUCE, 112);
   _actionMap[335][BEGIN] = ActionEntry(REDUCE, 112);
   _actionMap[335][ROLLBACK] = ActionEntry(REDUCE, 112);
   _actionMap[335][COMMIT] = ActionEntry(REDUCE, 112);
   _actionMap[335][START_TOKEN] = ActionEntry(REDUCE, 112);
   _actionMap[335][UPDATE] = ActionEntry(REDUCE, 112);
   _actionMap[335][DELETETOK] = ActionEntry(REDUCE, 112);
   _actionMap[335][INSERT] = ActionEntry(REDUCE, 112);
   _actionMap[335][FETCH] = ActionEntry(REDUCE, 112);
   _actionMap[335][LB] = ActionEntry(REDUCE, 112);
   _actionMap[335][COUNT] = ActionEntry(REDUCE, 112);
   _actionMap[335][SUM] = ActionEntry(REDUCE, 112);
   _actionMap[335][AVG] = ActionEntry(REDUCE, 112);
   _actionMap[335][MIN] = ActionEntry(REDUCE, 112);
   _actionMap[335][MAX] = ActionEntry(REDUCE, 112);
   _actionMap[335][CASE] = ActionEntry(REDUCE, 112);
   _actionMap[335][TRIM] = ActionEntry(REDUCE, 112);
   _actionMap[335][RTRIM] = ActionEntry(REDUCE, 112);
   _actionMap[335][LTRIM] = ActionEntry(REDUCE, 112);
   _actionMap[335][ROUND] = ActionEntry(REDUCE, 112);
   _actionMap[335][DATE2STR] = ActionEntry(REDUCE, 112);
   _actionMap[335][DATE2INT] = ActionEntry(REDUCE, 112);
   _actionMap[335][INT2DATE] = ActionEntry(REDUCE, 112);
   _actionMap[335][LOWER] = ActionEntry(REDUCE, 112);
   _actionMap[335][UPPER] = ActionEntry(REDUCE, 112);
   _actionMap[335][LEFT] = ActionEntry(REDUCE, 112);
   _actionMap[335][RIGHT] = ActionEntry(REDUCE, 112);
   _actionMap[335][GETPOS] = ActionEntry(REDUCE, 112);
   _actionMap[335][SUBSTR] = ActionEntry(REDUCE, 112);
}
void Cego::loadParser128()
{
   _actionMap[335][REPLACE] = ActionEntry(REDUCE, 112);
   _actionMap[335][LENGTH] = ActionEntry(REDUCE, 112);
   _actionMap[335][TRUNC] = ActionEntry(REDUCE, 112);
   _actionMap[335][STR2INT] = ActionEntry(REDUCE, 112);
   _actionMap[335][STR2LONG] = ActionEntry(REDUCE, 112);
   _actionMap[335][STR2DATE] = ActionEntry(REDUCE, 112);
   _actionMap[335][RANDSTR] = ActionEntry(REDUCE, 112);
   _actionMap[335][RANDINT] = ActionEntry(REDUCE, 112);
   _actionMap[335][MOD] = ActionEntry(REDUCE, 112);
   _actionMap[335][DIV] = ActionEntry(REDUCE, 112);
   _actionMap[335][POWER] = ActionEntry(REDUCE, 112);
   _actionMap[335][BITAND] = ActionEntry(REDUCE, 112);
   _actionMap[335][BITOR] = ActionEntry(REDUCE, 112);
   _actionMap[335][BITXOR] = ActionEntry(REDUCE, 112);
   _actionMap[335][BLOBSIZE] = ActionEntry(REDUCE, 112);
   _actionMap[335][NEXTCOUNT] = ActionEntry(REDUCE, 112);
   _actionMap[335][SETCOUNT] = ActionEntry(REDUCE, 112);
   _actionMap[335][IDENTIFIER] = ActionEntry(REDUCE, 112);
   _actionMap[335][QUALIFIEDOBJ] = ActionEntry(REDUCE, 112);
   _actionMap[335][QUALIFIEDTS] = ActionEntry(REDUCE, 112);
   _actionMap[335][QUALIFIEDPRE] = ActionEntry(REDUCE, 112);
   _actionMap[335][STRINGVAL] = ActionEntry(REDUCE, 112);
   _actionMap[335][DATE] = ActionEntry(REDUCE, 112);
   _actionMap[335][SYSDATE] = ActionEntry(REDUCE, 112);
   _actionMap[335][NULLTOKEN] = ActionEntry(REDUCE, 112);
   _actionMap[335][TRUEVAL] = ActionEntry(REDUCE, 112);
   _actionMap[335][FALSEVAL] = ActionEntry(REDUCE, 112);
   _actionMap[335][LAB] = ActionEntry(REDUCE, 112);
   _actionMap[335][FLOATVAL] = ActionEntry(REDUCE, 112);
   _actionMap[335][MINUS] = ActionEntry(REDUCE, 112);
   _actionMap[335][INTVAL] = ActionEntry(REDUCE, 112);
   _actionMap[336][IDENTIFIER] = ActionEntry(SHIFT, 466);
   _actionMap[337][IDENTIFIER] = ActionEntry(SHIFT, 467);
   _actionMap[338][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[338][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[338][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[338][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[338][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[338][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[338][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[338][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[338][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[338][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[338][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[338][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[338][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[338][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[338][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[338][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[338][REPLACE] = ActionEntry(SHIFT, 129);
}
void Cego::loadParser129()
{
   _actionMap[338][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[338][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[338][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[338][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[338][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[338][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[338][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[338][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[338][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[338][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[338][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[338][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[338][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[338][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[338][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[338][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[338][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[338][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[338][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[338][LB] = ActionEntry(SHIFT, 472);
   _actionMap[338][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[338][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[338][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[338][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[338][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[338][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[338][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[338][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[338][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[338][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[338][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[338][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[338][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[338][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[338][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[338][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[338][ObjSpec] = 100;
   _jumpMap[338][Constant] = 99;
   _jumpMap[338][SignedFloat] = 98;
   _jumpMap[338][SignedInt] = 97;
   _jumpMap[338][Attribute] = 96;
   _jumpMap[338][Function] = 95;
   _jumpMap[338][CasePrepare] = 94;
   _jumpMap[338][CaseClause] = 93;
   _jumpMap[338][Factor] = 92;
   _jumpMap[338][Term] = 91;
   _jumpMap[338][Expr] = 471;
   _jumpMap[338][ProcPredicate] = 470;
   _jumpMap[338][ProcCondition] = 469;
   _jumpMap[338][ProcIfCondition] = 468;
}
void Cego::loadParser130()
{
   _actionMap[339][SEMICOLON] = ActionEntry(REDUCE, 98);
   _actionMap[340][SEMICOLON] = ActionEntry(REDUCE, 109);
   _actionMap[340][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[340][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[340][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[340][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[340][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[340][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[340][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[340][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[340][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[340][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[340][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[340][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[340][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[340][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[340][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[340][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[340][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[340][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[340][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[340][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[340][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[340][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[340][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[340][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[340][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[340][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[340][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[340][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[340][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[340][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[340][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[340][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[340][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[340][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[340][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[340][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[340][LB] = ActionEntry(SHIFT, 144);
   _actionMap[340][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[340][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[340][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[340][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[340][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[340][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[340][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[340][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[340][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[340][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[340][FETCH] = ActionEntry(SHIFT, 114);
}
void Cego::loadParser131()
{
   _actionMap[340][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[340][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[340][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[340][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[340][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[340][ObjSpec] = 100;
   _jumpMap[340][Constant] = 99;
   _jumpMap[340][SignedFloat] = 98;
   _jumpMap[340][SignedInt] = 97;
   _jumpMap[340][Attribute] = 96;
   _jumpMap[340][Function] = 95;
   _jumpMap[340][CasePrepare] = 94;
   _jumpMap[340][CaseClause] = 93;
   _jumpMap[340][Factor] = 92;
   _jumpMap[340][Term] = 91;
   _jumpMap[340][Expr] = 473;
   _actionMap[341][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[341][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[341][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[341][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[341][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[341][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[341][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[341][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[341][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[341][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[341][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[341][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[341][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[341][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[341][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[341][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[341][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[341][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[341][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[341][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[341][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[341][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[341][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[341][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[341][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[341][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[341][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[341][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[341][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[341][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[341][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[341][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[341][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[341][IDENTIFIER] = ActionEntry(SHIFT, 149);
}
void Cego::loadParser132()
{
   _actionMap[341][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[341][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[341][LB] = ActionEntry(SHIFT, 144);
   _actionMap[341][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[341][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[341][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[341][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[341][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[341][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[341][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[341][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[341][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[341][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[341][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[341][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[341][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[341][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[341][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[341][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[341][ObjSpec] = 100;
   _jumpMap[341][Constant] = 99;
   _jumpMap[341][SignedFloat] = 98;
   _jumpMap[341][SignedInt] = 97;
   _jumpMap[341][Attribute] = 96;
   _jumpMap[341][Function] = 95;
   _jumpMap[341][CasePrepare] = 94;
   _jumpMap[341][CaseClause] = 93;
   _jumpMap[341][Factor] = 92;
   _jumpMap[341][Term] = 91;
   _jumpMap[341][Expr] = 474;
   _actionMap[342][IDENTIFIER] = ActionEntry(SHIFT, 475);
   _actionMap[343][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[343][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[343][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[343][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[343][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[343][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[343][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[343][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[343][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[343][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[343][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[343][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[343][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[343][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[343][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[343][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[343][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[343][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[343][TRUNC] = ActionEntry(SHIFT, 142);
}
void Cego::loadParser133()
{
   _actionMap[343][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[343][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[343][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[343][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[343][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[343][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[343][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[343][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[343][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[343][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[343][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[343][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[343][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[343][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[343][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[343][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[343][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[343][LB] = ActionEntry(SHIFT, 472);
   _actionMap[343][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[343][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[343][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[343][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[343][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[343][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[343][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[343][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[343][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[343][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[343][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[343][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[343][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[343][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[343][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[343][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[343][ObjSpec] = 100;
   _jumpMap[343][Constant] = 99;
   _jumpMap[343][SignedFloat] = 98;
   _jumpMap[343][SignedInt] = 97;
   _jumpMap[343][Attribute] = 96;
   _jumpMap[343][Function] = 95;
   _jumpMap[343][CasePrepare] = 94;
   _jumpMap[343][CaseClause] = 93;
   _jumpMap[343][Factor] = 92;
   _jumpMap[343][Term] = 91;
   _jumpMap[343][Expr] = 471;
   _jumpMap[343][ProcPredicate] = 470;
   _jumpMap[343][ProcCondition] = 477;
   _jumpMap[343][ProcWhileCondition] = 476;
   _actionMap[344][CONCAT] = ActionEntry(REDUCE, 147);
   _actionMap[344][STAR] = ActionEntry(REDUCE, 147);
}
void Cego::loadParser134()
{
   _actionMap[344][DIVISION] = ActionEntry(REDUCE, 147);
   _actionMap[344][MINUS] = ActionEntry(REDUCE, 147);
   _actionMap[344][PLUS] = ActionEntry(REDUCE, 147);
   _actionMap[344][SEMICOLON] = ActionEntry(REDUCE, 147);
   _actionMap[344][EQU] = ActionEntry(SHIFT, 478);
   _actionMap[345][ON] = ActionEntry(SHIFT, 479);
   _actionMap[346][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[346][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[346][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[346][ObjSpec] = 480;
   _actionMap[347][IDENTIFIER] = ActionEntry(SHIFT, 485);
   _actionMap[347][RB] = ActionEntry(REDUCE, 85);
   _jumpMap[347][ProcArg] = 483;
   _jumpMap[347][ProcArgList] = 482;
   _jumpMap[347][ProcArgOpt] = 481;
   _actionMap[348][IDENTIFIER] = ActionEntry(SHIFT, 490);
   _actionMap[348][PRIMARY] = ActionEntry(SHIFT, 489);
   _jumpMap[348][ColumnDesc] = 488;
   _jumpMap[348][KeyColumn] = 487;
   _jumpMap[348][ColumnList] = 486;
   _actionMap[349][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[349][SelectStatement] = 491;
   _actionMap[350][SEMICOLON] = ActionEntry(REDUCE, 308);
   _actionMap[350][WHERE] = ActionEntry(SHIFT, 353);
   _jumpMap[350][NoWhere] = 352;
   _jumpMap[350][WhereClause] = 351;
   _actionMap[351][SEMICOLON] = ActionEntry(REDUCE, 256);
   _actionMap[352][RETURNTOKEN] = ActionEntry(REDUCE, 307);
   _actionMap[352][GROUP] = ActionEntry(REDUCE, 307);
   _actionMap[352][ORDER] = ActionEntry(REDUCE, 307);
   _actionMap[352][ROWLIMIT] = ActionEntry(REDUCE, 307);
   _actionMap[352][UNION] = ActionEntry(REDUCE, 307);
   _actionMap[352][ENDTOKEN] = ActionEntry(REDUCE, 307);
   _actionMap[352][RB] = ActionEntry(REDUCE, 307);
   _actionMap[352][SEMICOLON] = ActionEntry(REDUCE, 307);
   _actionMap[353][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[353][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[353][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[353][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[353][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[353][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[353][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[353][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[353][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[353][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[353][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[353][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[353][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[353][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[353][GETPOS] = ActionEntry(SHIFT, 115);
}
void Cego::loadParser135()
{
   _actionMap[353][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[353][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[353][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[353][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[353][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[353][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[353][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[353][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[353][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[353][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[353][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[353][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[353][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[353][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[353][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[353][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[353][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[353][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[353][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[353][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[353][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[353][LB] = ActionEntry(SHIFT, 374);
   _actionMap[353][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[353][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[353][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[353][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[353][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[353][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[353][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[353][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[353][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[353][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[353][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[353][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[353][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[353][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[353][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[353][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[353][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[353][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[353][ObjSpec] = 100;
   _jumpMap[353][Constant] = 99;
   _jumpMap[353][SignedFloat] = 98;
   _jumpMap[353][SignedInt] = 97;
   _jumpMap[353][Attribute] = 96;
   _jumpMap[353][QueryPredicate] = 371;
   _jumpMap[353][QueryCondition] = 492;
   _jumpMap[353][Function] = 95;
   _jumpMap[353][CasePrepare] = 94;
   _jumpMap[353][CaseClause] = 93;
}
void Cego::loadParser136()
{
   _jumpMap[353][Factor] = 92;
   _jumpMap[353][Term] = 91;
   _jumpMap[353][Expr] = 369;
   _actionMap[354][SEMICOLON] = ActionEntry(REDUCE, 23);
   _actionMap[355][SELECT] = ActionEntry(SHIFT, 30);
   _actionMap[355][VALUES] = ActionEntry(SHIFT, 358);
   _jumpMap[355][SelectStatement] = 357;
   _jumpMap[355][InsertPrepare] = 356;
   _actionMap[356][LB] = ActionEntry(SHIFT, 495);
   _jumpMap[356][InsertValueSpec] = 494;
   _jumpMap[356][InsertValueSpecList] = 493;
   _actionMap[357][SEMICOLON] = ActionEntry(REDUCE, 191);
   _actionMap[358][LB] = ActionEntry(REDUCE, 194);
   _actionMap[359][IDENTIFIER] = ActionEntry(SHIFT, 497);
   _jumpMap[359][InsertArgList] = 496;
   _actionMap[360][SEMICOLON] = ActionEntry(REDUCE, 13);
   _actionMap[361][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[361][SelectStatement] = 498;
   _actionMap[362][STAR] = ActionEntry(SHIFT, 228);
   _actionMap[362][DIVISION] = ActionEntry(SHIFT, 229);
   _actionMap[362][WHEN] = ActionEntry(REDUCE, 143);
   _actionMap[362][ELSE] = ActionEntry(REDUCE, 143);
   _actionMap[362][LEFT] = ActionEntry(REDUCE, 143);
   _actionMap[362][RIGHT] = ActionEntry(REDUCE, 143);
   _actionMap[362][INNER] = ActionEntry(REDUCE, 143);
   _actionMap[362][JOIN] = ActionEntry(REDUCE, 143);
   _actionMap[362][RETURNTOKEN] = ActionEntry(REDUCE, 143);
   _actionMap[362][ORDER] = ActionEntry(REDUCE, 143);
   _actionMap[362][GROUP] = ActionEntry(REDUCE, 143);
   _actionMap[362][WHERE] = ActionEntry(REDUCE, 143);
   _actionMap[362][BEGIN] = ActionEntry(REDUCE, 143);
   _actionMap[362][THEN] = ActionEntry(REDUCE, 143);
   _actionMap[362][OR] = ActionEntry(REDUCE, 143);
   _actionMap[362][AS] = ActionEntry(REDUCE, 143);
   _actionMap[362][FROM] = ActionEntry(REDUCE, 143);
   _actionMap[362][LIKE] = ActionEntry(REDUCE, 143);
   _actionMap[362][BETWEEN] = ActionEntry(REDUCE, 143);
   _actionMap[362][NOT] = ActionEntry(REDUCE, 143);
   _actionMap[362][INTOK] = ActionEntry(REDUCE, 143);
   _actionMap[362][END_TOKEN] = ActionEntry(REDUCE, 143);
   _actionMap[362][AND] = ActionEntry(REDUCE, 143);
   _actionMap[362][IS] = ActionEntry(REDUCE, 143);
   _actionMap[362][EQU] = ActionEntry(REDUCE, 143);
   _actionMap[362][NEGATION] = ActionEntry(REDUCE, 143);
   _actionMap[362][LT] = ActionEntry(REDUCE, 143);
   _actionMap[362][MT] = ActionEntry(REDUCE, 143);
   _actionMap[362][DESC] = ActionEntry(REDUCE, 143);
   _actionMap[362][ASC] = ActionEntry(REDUCE, 143);
   _actionMap[362][KSEP] = ActionEntry(REDUCE, 143);
   _actionMap[362][ROWLIMIT] = ActionEntry(REDUCE, 143);
}
void Cego::loadParser137()
{
   _actionMap[362][UNION] = ActionEntry(REDUCE, 143);
   _actionMap[362][ENDTOKEN] = ActionEntry(REDUCE, 143);
   _actionMap[362][RB] = ActionEntry(REDUCE, 143);
   _actionMap[362][SEMICOLON] = ActionEntry(REDUCE, 143);
   _actionMap[362][CONCAT] = ActionEntry(REDUCE, 143);
   _actionMap[362][MINUS] = ActionEntry(REDUCE, 143);
   _actionMap[362][PLUS] = ActionEntry(REDUCE, 143);
   _actionMap[363][STAR] = ActionEntry(SHIFT, 228);
   _actionMap[363][DIVISION] = ActionEntry(SHIFT, 229);
   _actionMap[363][WHEN] = ActionEntry(REDUCE, 141);
   _actionMap[363][ELSE] = ActionEntry(REDUCE, 141);
   _actionMap[363][LEFT] = ActionEntry(REDUCE, 141);
   _actionMap[363][RIGHT] = ActionEntry(REDUCE, 141);
   _actionMap[363][INNER] = ActionEntry(REDUCE, 141);
   _actionMap[363][JOIN] = ActionEntry(REDUCE, 141);
   _actionMap[363][RETURNTOKEN] = ActionEntry(REDUCE, 141);
   _actionMap[363][ORDER] = ActionEntry(REDUCE, 141);
   _actionMap[363][GROUP] = ActionEntry(REDUCE, 141);
   _actionMap[363][WHERE] = ActionEntry(REDUCE, 141);
   _actionMap[363][BEGIN] = ActionEntry(REDUCE, 141);
   _actionMap[363][THEN] = ActionEntry(REDUCE, 141);
   _actionMap[363][OR] = ActionEntry(REDUCE, 141);
   _actionMap[363][AS] = ActionEntry(REDUCE, 141);
   _actionMap[363][FROM] = ActionEntry(REDUCE, 141);
   _actionMap[363][LIKE] = ActionEntry(REDUCE, 141);
   _actionMap[363][BETWEEN] = ActionEntry(REDUCE, 141);
   _actionMap[363][NOT] = ActionEntry(REDUCE, 141);
   _actionMap[363][INTOK] = ActionEntry(REDUCE, 141);
   _actionMap[363][END_TOKEN] = ActionEntry(REDUCE, 141);
   _actionMap[363][AND] = ActionEntry(REDUCE, 141);
   _actionMap[363][IS] = ActionEntry(REDUCE, 141);
   _actionMap[363][EQU] = ActionEntry(REDUCE, 141);
   _actionMap[363][NEGATION] = ActionEntry(REDUCE, 141);
   _actionMap[363][LT] = ActionEntry(REDUCE, 141);
   _actionMap[363][MT] = ActionEntry(REDUCE, 141);
   _actionMap[363][DESC] = ActionEntry(REDUCE, 141);
   _actionMap[363][ASC] = ActionEntry(REDUCE, 141);
   _actionMap[363][KSEP] = ActionEntry(REDUCE, 141);
   _actionMap[363][ROWLIMIT] = ActionEntry(REDUCE, 141);
   _actionMap[363][UNION] = ActionEntry(REDUCE, 141);
   _actionMap[363][ENDTOKEN] = ActionEntry(REDUCE, 141);
   _actionMap[363][RB] = ActionEntry(REDUCE, 141);
   _actionMap[363][SEMICOLON] = ActionEntry(REDUCE, 141);
   _actionMap[363][CONCAT] = ActionEntry(REDUCE, 141);
   _actionMap[363][MINUS] = ActionEntry(REDUCE, 141);
   _actionMap[363][PLUS] = ActionEntry(REDUCE, 141);
   _actionMap[364][STAR] = ActionEntry(SHIFT, 228);
   _actionMap[364][DIVISION] = ActionEntry(SHIFT, 229);
   _actionMap[364][WHEN] = ActionEntry(REDUCE, 140);
   _actionMap[364][ELSE] = ActionEntry(REDUCE, 140);
}
void Cego::loadParser138()
{
   _actionMap[364][LEFT] = ActionEntry(REDUCE, 140);
   _actionMap[364][RIGHT] = ActionEntry(REDUCE, 140);
   _actionMap[364][INNER] = ActionEntry(REDUCE, 140);
   _actionMap[364][JOIN] = ActionEntry(REDUCE, 140);
   _actionMap[364][RETURNTOKEN] = ActionEntry(REDUCE, 140);
   _actionMap[364][ORDER] = ActionEntry(REDUCE, 140);
   _actionMap[364][GROUP] = ActionEntry(REDUCE, 140);
   _actionMap[364][WHERE] = ActionEntry(REDUCE, 140);
   _actionMap[364][BEGIN] = ActionEntry(REDUCE, 140);
   _actionMap[364][THEN] = ActionEntry(REDUCE, 140);
   _actionMap[364][OR] = ActionEntry(REDUCE, 140);
   _actionMap[364][AS] = ActionEntry(REDUCE, 140);
   _actionMap[364][FROM] = ActionEntry(REDUCE, 140);
   _actionMap[364][LIKE] = ActionEntry(REDUCE, 140);
   _actionMap[364][BETWEEN] = ActionEntry(REDUCE, 140);
   _actionMap[364][NOT] = ActionEntry(REDUCE, 140);
   _actionMap[364][INTOK] = ActionEntry(REDUCE, 140);
   _actionMap[364][END_TOKEN] = ActionEntry(REDUCE, 140);
   _actionMap[364][AND] = ActionEntry(REDUCE, 140);
   _actionMap[364][IS] = ActionEntry(REDUCE, 140);
   _actionMap[364][EQU] = ActionEntry(REDUCE, 140);
   _actionMap[364][NEGATION] = ActionEntry(REDUCE, 140);
   _actionMap[364][LT] = ActionEntry(REDUCE, 140);
   _actionMap[364][MT] = ActionEntry(REDUCE, 140);
   _actionMap[364][DESC] = ActionEntry(REDUCE, 140);
   _actionMap[364][ASC] = ActionEntry(REDUCE, 140);
   _actionMap[364][KSEP] = ActionEntry(REDUCE, 140);
   _actionMap[364][ROWLIMIT] = ActionEntry(REDUCE, 140);
   _actionMap[364][UNION] = ActionEntry(REDUCE, 140);
   _actionMap[364][ENDTOKEN] = ActionEntry(REDUCE, 140);
   _actionMap[364][RB] = ActionEntry(REDUCE, 140);
   _actionMap[364][SEMICOLON] = ActionEntry(REDUCE, 140);
   _actionMap[364][CONCAT] = ActionEntry(REDUCE, 140);
   _actionMap[364][MINUS] = ActionEntry(REDUCE, 140);
   _actionMap[364][PLUS] = ActionEntry(REDUCE, 140);
   _actionMap[365][WHEN] = ActionEntry(REDUCE, 144);
   _actionMap[365][ELSE] = ActionEntry(REDUCE, 144);
   _actionMap[365][LEFT] = ActionEntry(REDUCE, 144);
   _actionMap[365][RIGHT] = ActionEntry(REDUCE, 144);
   _actionMap[365][INNER] = ActionEntry(REDUCE, 144);
   _actionMap[365][JOIN] = ActionEntry(REDUCE, 144);
   _actionMap[365][RETURNTOKEN] = ActionEntry(REDUCE, 144);
   _actionMap[365][ORDER] = ActionEntry(REDUCE, 144);
   _actionMap[365][GROUP] = ActionEntry(REDUCE, 144);
   _actionMap[365][WHERE] = ActionEntry(REDUCE, 144);
   _actionMap[365][BEGIN] = ActionEntry(REDUCE, 144);
   _actionMap[365][THEN] = ActionEntry(REDUCE, 144);
   _actionMap[365][OR] = ActionEntry(REDUCE, 144);
   _actionMap[365][FROM] = ActionEntry(REDUCE, 144);
   _actionMap[365][AS] = ActionEntry(REDUCE, 144);
}
void Cego::loadParser139()
{
   _actionMap[365][END_TOKEN] = ActionEntry(REDUCE, 144);
   _actionMap[365][AND] = ActionEntry(REDUCE, 144);
   _actionMap[365][INTOK] = ActionEntry(REDUCE, 144);
   _actionMap[365][NOT] = ActionEntry(REDUCE, 144);
   _actionMap[365][BETWEEN] = ActionEntry(REDUCE, 144);
   _actionMap[365][IS] = ActionEntry(REDUCE, 144);
   _actionMap[365][LIKE] = ActionEntry(REDUCE, 144);
   _actionMap[365][MT] = ActionEntry(REDUCE, 144);
   _actionMap[365][LT] = ActionEntry(REDUCE, 144);
   _actionMap[365][NEGATION] = ActionEntry(REDUCE, 144);
   _actionMap[365][EQU] = ActionEntry(REDUCE, 144);
   _actionMap[365][RB] = ActionEntry(REDUCE, 144);
   _actionMap[365][ENDTOKEN] = ActionEntry(REDUCE, 144);
   _actionMap[365][UNION] = ActionEntry(REDUCE, 144);
   _actionMap[365][ROWLIMIT] = ActionEntry(REDUCE, 144);
   _actionMap[365][KSEP] = ActionEntry(REDUCE, 144);
   _actionMap[365][ASC] = ActionEntry(REDUCE, 144);
   _actionMap[365][DESC] = ActionEntry(REDUCE, 144);
   _actionMap[365][SEMICOLON] = ActionEntry(REDUCE, 144);
   _actionMap[365][PLUS] = ActionEntry(REDUCE, 144);
   _actionMap[365][MINUS] = ActionEntry(REDUCE, 144);
   _actionMap[365][CONCAT] = ActionEntry(REDUCE, 144);
   _actionMap[365][DIVISION] = ActionEntry(REDUCE, 144);
   _actionMap[365][STAR] = ActionEntry(REDUCE, 144);
   _actionMap[366][WHEN] = ActionEntry(REDUCE, 145);
   _actionMap[366][ELSE] = ActionEntry(REDUCE, 145);
   _actionMap[366][LEFT] = ActionEntry(REDUCE, 145);
   _actionMap[366][RIGHT] = ActionEntry(REDUCE, 145);
   _actionMap[366][INNER] = ActionEntry(REDUCE, 145);
   _actionMap[366][JOIN] = ActionEntry(REDUCE, 145);
   _actionMap[366][RETURNTOKEN] = ActionEntry(REDUCE, 145);
   _actionMap[366][ORDER] = ActionEntry(REDUCE, 145);
   _actionMap[366][GROUP] = ActionEntry(REDUCE, 145);
   _actionMap[366][WHERE] = ActionEntry(REDUCE, 145);
   _actionMap[366][BEGIN] = ActionEntry(REDUCE, 145);
   _actionMap[366][THEN] = ActionEntry(REDUCE, 145);
   _actionMap[366][OR] = ActionEntry(REDUCE, 145);
   _actionMap[366][FROM] = ActionEntry(REDUCE, 145);
   _actionMap[366][AS] = ActionEntry(REDUCE, 145);
   _actionMap[366][END_TOKEN] = ActionEntry(REDUCE, 145);
   _actionMap[366][AND] = ActionEntry(REDUCE, 145);
   _actionMap[366][INTOK] = ActionEntry(REDUCE, 145);
   _actionMap[366][NOT] = ActionEntry(REDUCE, 145);
   _actionMap[366][BETWEEN] = ActionEntry(REDUCE, 145);
   _actionMap[366][IS] = ActionEntry(REDUCE, 145);
   _actionMap[366][LIKE] = ActionEntry(REDUCE, 145);
   _actionMap[366][MT] = ActionEntry(REDUCE, 145);
   _actionMap[366][LT] = ActionEntry(REDUCE, 145);
   _actionMap[366][NEGATION] = ActionEntry(REDUCE, 145);
   _actionMap[366][EQU] = ActionEntry(REDUCE, 145);
}
void Cego::loadParser140()
{
   _actionMap[366][RB] = ActionEntry(REDUCE, 145);
   _actionMap[366][ENDTOKEN] = ActionEntry(REDUCE, 145);
   _actionMap[366][UNION] = ActionEntry(REDUCE, 145);
   _actionMap[366][ROWLIMIT] = ActionEntry(REDUCE, 145);
   _actionMap[366][KSEP] = ActionEntry(REDUCE, 145);
   _actionMap[366][ASC] = ActionEntry(REDUCE, 145);
   _actionMap[366][DESC] = ActionEntry(REDUCE, 145);
   _actionMap[366][SEMICOLON] = ActionEntry(REDUCE, 145);
   _actionMap[366][PLUS] = ActionEntry(REDUCE, 145);
   _actionMap[366][MINUS] = ActionEntry(REDUCE, 145);
   _actionMap[366][CONCAT] = ActionEntry(REDUCE, 145);
   _actionMap[366][DIVISION] = ActionEntry(REDUCE, 145);
   _actionMap[366][STAR] = ActionEntry(REDUCE, 145);
   _actionMap[367][WHEN] = ActionEntry(REDUCE, 162);
   _actionMap[367][ELSE] = ActionEntry(REDUCE, 162);
   _actionMap[368][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[368][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[368][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[368][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[368][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[368][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[368][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[368][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[368][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[368][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[368][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[368][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[368][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[368][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[368][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[368][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[368][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[368][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[368][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[368][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[368][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[368][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[368][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[368][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[368][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[368][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[368][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[368][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[368][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[368][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[368][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[368][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[368][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[368][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[368][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
}
void Cego::loadParser141()
{
   _actionMap[368][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[368][LB] = ActionEntry(SHIFT, 144);
   _actionMap[368][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[368][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[368][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[368][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[368][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[368][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[368][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[368][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[368][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[368][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[368][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[368][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[368][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[368][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[368][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[368][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[368][ObjSpec] = 100;
   _jumpMap[368][Constant] = 99;
   _jumpMap[368][SignedFloat] = 98;
   _jumpMap[368][SignedInt] = 97;
   _jumpMap[368][Attribute] = 96;
   _jumpMap[368][Function] = 95;
   _jumpMap[368][CasePrepare] = 94;
   _jumpMap[368][CaseClause] = 93;
   _jumpMap[368][Factor] = 92;
   _jumpMap[368][Term] = 91;
   _jumpMap[368][Expr] = 499;
   _actionMap[369][INTOK] = ActionEntry(SHIFT, 502);
   _actionMap[369][NOT] = ActionEntry(SHIFT, 505);
   _actionMap[369][BETWEEN] = ActionEntry(SHIFT, 501);
   _actionMap[369][IS] = ActionEntry(SHIFT, 503);
   _actionMap[369][LIKE] = ActionEntry(SHIFT, 504);
   _actionMap[369][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[369][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[369][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[369][EQU] = ActionEntry(SHIFT, 506);
   _actionMap[369][NEGATION] = ActionEntry(SHIFT, 509);
   _actionMap[369][LT] = ActionEntry(SHIFT, 507);
   _actionMap[369][MT] = ActionEntry(SHIFT, 508);
   _jumpMap[369][Comparison] = 500;
   _actionMap[370][THEN] = ActionEntry(SHIFT, 512);
   _actionMap[370][AND] = ActionEntry(SHIFT, 510);
   _actionMap[370][OR] = ActionEntry(SHIFT, 511);
   _actionMap[371][THEN] = ActionEntry(REDUCE, 311);
   _actionMap[371][LEFT] = ActionEntry(REDUCE, 311);
   _actionMap[371][RIGHT] = ActionEntry(REDUCE, 311);
   _actionMap[371][INNER] = ActionEntry(REDUCE, 311);
   _actionMap[371][JOIN] = ActionEntry(REDUCE, 311);
}
void Cego::loadParser142()
{
   _actionMap[371][RETURNTOKEN] = ActionEntry(REDUCE, 311);
   _actionMap[371][SEMICOLON] = ActionEntry(REDUCE, 311);
   _actionMap[371][RB] = ActionEntry(REDUCE, 311);
   _actionMap[371][ENDTOKEN] = ActionEntry(REDUCE, 311);
   _actionMap[371][UNION] = ActionEntry(REDUCE, 311);
   _actionMap[371][ROWLIMIT] = ActionEntry(REDUCE, 311);
   _actionMap[371][ORDER] = ActionEntry(REDUCE, 311);
   _actionMap[371][GROUP] = ActionEntry(REDUCE, 311);
   _actionMap[371][WHERE] = ActionEntry(REDUCE, 311);
   _actionMap[371][OR] = ActionEntry(REDUCE, 311);
   _actionMap[371][AND] = ActionEntry(REDUCE, 311);
   _actionMap[372][LB] = ActionEntry(SHIFT, 513);
   _actionMap[373][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[373][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[373][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[373][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[373][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[373][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[373][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[373][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[373][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[373][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[373][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[373][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[373][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[373][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[373][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[373][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[373][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[373][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[373][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[373][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[373][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[373][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[373][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[373][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[373][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[373][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[373][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[373][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[373][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[373][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[373][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[373][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[373][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[373][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[373][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[373][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[373][LB] = ActionEntry(SHIFT, 374);
   _actionMap[373][STRINGVAL] = ActionEntry(SHIFT, 101);
}
void Cego::loadParser143()
{
   _actionMap[373][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[373][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[373][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[373][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[373][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[373][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[373][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[373][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[373][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[373][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[373][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[373][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[373][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[373][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[373][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[373][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[373][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[373][ObjSpec] = 100;
   _jumpMap[373][Constant] = 99;
   _jumpMap[373][SignedFloat] = 98;
   _jumpMap[373][SignedInt] = 97;
   _jumpMap[373][Attribute] = 96;
   _jumpMap[373][QueryPredicate] = 514;
   _jumpMap[373][Function] = 95;
   _jumpMap[373][CasePrepare] = 94;
   _jumpMap[373][CaseClause] = 93;
   _jumpMap[373][Factor] = 92;
   _jumpMap[373][Term] = 91;
   _jumpMap[373][Expr] = 369;
   _actionMap[374][LONG] = ActionEntry(SHIFT, 277);
   _actionMap[374][BIGINT] = ActionEntry(SHIFT, 273);
   _actionMap[374][SMALLINT] = ActionEntry(SHIFT, 278);
   _actionMap[374][TINYINT] = ActionEntry(SHIFT, 279);
   _actionMap[374][DOUBLE] = ActionEntry(SHIFT, 275);
   _actionMap[374][DECIMAL] = ActionEntry(SHIFT, 274);
   _actionMap[374][FIXED] = ActionEntry(SHIFT, 276);
   _actionMap[374][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[374][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[374][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[374][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[374][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[374][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[374][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[374][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[374][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[374][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[374][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[374][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[374][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[374][RIGHT] = ActionEntry(SHIFT, 130);
}
void Cego::loadParser144()
{
   _actionMap[374][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[374][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[374][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[374][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[374][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[374][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[374][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[374][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[374][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[374][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[374][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[374][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[374][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[374][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[374][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[374][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[374][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[374][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[374][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[374][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[374][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[374][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[374][LB] = ActionEntry(SHIFT, 374);
   _actionMap[374][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[374][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[374][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[374][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[374][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[374][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[374][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[374][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[374][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[374][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[374][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[374][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[374][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[374][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[374][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[374][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[374][SELECT] = ActionEntry(SHIFT, 30);
   _actionMap[374][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[374][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[374][ObjSpec] = 100;
   _jumpMap[374][Constant] = 99;
   _jumpMap[374][SignedFloat] = 98;
   _jumpMap[374][SignedInt] = 97;
   _jumpMap[374][Attribute] = 96;
   _jumpMap[374][QueryPredicate] = 371;
   _jumpMap[374][QueryCondition] = 516;
   _jumpMap[374][Function] = 95;
}
void Cego::loadParser145()
{
   _jumpMap[374][SelectStatement] = 272;
   _jumpMap[374][CasePrepare] = 94;
   _jumpMap[374][CaseClause] = 93;
   _jumpMap[374][Factor] = 92;
   _jumpMap[374][Term] = 91;
   _jumpMap[374][Expr] = 515;
   _actionMap[375][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[375][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[375][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[375][KSEP] = ActionEntry(REDUCE, 305);
   _actionMap[375][RB] = ActionEntry(REDUCE, 305);
   _actionMap[376][RB] = ActionEntry(SHIFT, 518);
   _actionMap[376][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[377][WHEN] = ActionEntry(REDUCE, 303);
   _actionMap[377][ELSE] = ActionEntry(REDUCE, 303);
   _actionMap[377][LEFT] = ActionEntry(REDUCE, 303);
   _actionMap[377][RIGHT] = ActionEntry(REDUCE, 303);
   _actionMap[377][INNER] = ActionEntry(REDUCE, 303);
   _actionMap[377][JOIN] = ActionEntry(REDUCE, 303);
   _actionMap[377][RETURNTOKEN] = ActionEntry(REDUCE, 303);
   _actionMap[377][ORDER] = ActionEntry(REDUCE, 303);
   _actionMap[377][GROUP] = ActionEntry(REDUCE, 303);
   _actionMap[377][WHERE] = ActionEntry(REDUCE, 303);
   _actionMap[377][FROM] = ActionEntry(REDUCE, 303);
   _actionMap[377][AS] = ActionEntry(REDUCE, 303);
   _actionMap[377][END_TOKEN] = ActionEntry(REDUCE, 303);
   _actionMap[377][BEGIN] = ActionEntry(REDUCE, 303);
   _actionMap[377][THEN] = ActionEntry(REDUCE, 303);
   _actionMap[377][OR] = ActionEntry(REDUCE, 303);
   _actionMap[377][AND] = ActionEntry(REDUCE, 303);
   _actionMap[377][INTOK] = ActionEntry(REDUCE, 303);
   _actionMap[377][NOT] = ActionEntry(REDUCE, 303);
   _actionMap[377][BETWEEN] = ActionEntry(REDUCE, 303);
   _actionMap[377][IS] = ActionEntry(REDUCE, 303);
   _actionMap[377][LIKE] = ActionEntry(REDUCE, 303);
   _actionMap[377][MT] = ActionEntry(REDUCE, 303);
   _actionMap[377][LT] = ActionEntry(REDUCE, 303);
   _actionMap[377][NEGATION] = ActionEntry(REDUCE, 303);
   _actionMap[377][EQU] = ActionEntry(REDUCE, 303);
   _actionMap[377][RB] = ActionEntry(REDUCE, 303);
   _actionMap[377][ENDTOKEN] = ActionEntry(REDUCE, 303);
   _actionMap[377][UNION] = ActionEntry(REDUCE, 303);
   _actionMap[377][ROWLIMIT] = ActionEntry(REDUCE, 303);
   _actionMap[377][KSEP] = ActionEntry(REDUCE, 303);
   _actionMap[377][ASC] = ActionEntry(REDUCE, 303);
   _actionMap[377][DESC] = ActionEntry(REDUCE, 303);
   _actionMap[377][SEMICOLON] = ActionEntry(REDUCE, 303);
   _actionMap[377][PLUS] = ActionEntry(REDUCE, 303);
   _actionMap[377][MINUS] = ActionEntry(REDUCE, 303);
   _actionMap[377][DIVISION] = ActionEntry(REDUCE, 303);
}
void Cego::loadParser146()
{
   _actionMap[377][STAR] = ActionEntry(REDUCE, 303);
   _actionMap[377][CONCAT] = ActionEntry(REDUCE, 303);
   _actionMap[378][RB] = ActionEntry(SHIFT, 519);
   _actionMap[378][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[378][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[378][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[379][RB] = ActionEntry(SHIFT, 520);
   _actionMap[379][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[380][RB] = ActionEntry(SHIFT, 521);
   _actionMap[380][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[381][RB] = ActionEntry(SHIFT, 522);
   _actionMap[381][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[382][RB] = ActionEntry(SHIFT, 523);
   _actionMap[382][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[383][RB] = ActionEntry(SHIFT, 524);
   _actionMap[383][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[383][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[383][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[384][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[384][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[384][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[384][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[384][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[384][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[384][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[384][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[384][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[384][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[384][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[384][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[384][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[384][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[384][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[384][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[384][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[384][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[384][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[384][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[384][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[384][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[384][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[384][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[384][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[384][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[384][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[384][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[384][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[384][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[384][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[384][NEXTCOUNT] = ActionEntry(SHIFT, 124);
}
void Cego::loadParser147()
{
   _actionMap[384][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[384][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[384][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[384][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[384][LB] = ActionEntry(SHIFT, 144);
   _actionMap[384][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[384][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[384][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[384][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[384][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[384][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[384][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[384][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[384][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[384][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[384][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[384][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[384][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[384][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[384][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[384][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[384][ObjSpec] = 100;
   _jumpMap[384][Constant] = 99;
   _jumpMap[384][SignedFloat] = 98;
   _jumpMap[384][SignedInt] = 97;
   _jumpMap[384][Attribute] = 96;
   _jumpMap[384][Function] = 95;
   _jumpMap[384][CasePrepare] = 94;
   _jumpMap[384][CaseClause] = 93;
   _jumpMap[384][Factor] = 92;
   _jumpMap[384][Term] = 91;
   _jumpMap[384][Expr] = 383;
   _actionMap[385][RB] = ActionEntry(SHIFT, 525);
   _actionMap[386][KSEP] = ActionEntry(SHIFT, 526);
   _actionMap[387][KSEP] = ActionEntry(REDUCE, 365);
   _actionMap[388][RB] = ActionEntry(SHIFT, 527);
   _actionMap[388][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[389][RB] = ActionEntry(SHIFT, 528);
   _actionMap[389][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[390][RB] = ActionEntry(SHIFT, 529);
   _actionMap[390][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[391][LB] = ActionEntry(SHIFT, 530);
   _actionMap[392][RB] = ActionEntry(SHIFT, 531);
   _actionMap[392][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[393][RB] = ActionEntry(SHIFT, 532);
   _actionMap[393][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[394][RB] = ActionEntry(SHIFT, 533);
   _actionMap[394][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[395][RB] = ActionEntry(SHIFT, 534);
   _actionMap[395][KSEP] = ActionEntry(SHIFT, 517);
}
void Cego::loadParser148()
{
   _actionMap[396][RB] = ActionEntry(SHIFT, 535);
   _actionMap[396][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[397][RB] = ActionEntry(SHIFT, 536);
   _actionMap[397][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[398][RB] = ActionEntry(SHIFT, 537);
   _actionMap[398][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[398][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[398][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[399][RB] = ActionEntry(SHIFT, 538);
   _actionMap[399][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[399][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[399][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[400][RB] = ActionEntry(SHIFT, 539);
   _actionMap[400][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[401][RB] = ActionEntry(SHIFT, 540);
   _actionMap[402][RB] = ActionEntry(SHIFT, 541);
   _actionMap[402][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[403][RB] = ActionEntry(SHIFT, 542);
   _actionMap[403][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[404][RB] = ActionEntry(SHIFT, 543);
   _actionMap[404][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[405][RB] = ActionEntry(SHIFT, 544);
   _actionMap[405][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[406][RB] = ActionEntry(SHIFT, 545);
   _actionMap[406][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[407][RB] = ActionEntry(SHIFT, 546);
   _actionMap[407][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[408][RB] = ActionEntry(SHIFT, 547);
   _actionMap[408][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[409][KSEP] = ActionEntry(SHIFT, 548);
   _actionMap[410][RB] = ActionEntry(SHIFT, 549);
   _actionMap[410][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[411][RB] = ActionEntry(SHIFT, 550);
   _actionMap[411][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[411][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[411][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[412][RB] = ActionEntry(SHIFT, 551);
   _actionMap[412][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[413][RB] = ActionEntry(SHIFT, 552);
   _actionMap[413][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[414][RB] = ActionEntry(SHIFT, 553);
   _actionMap[414][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[415][RB] = ActionEntry(SHIFT, 554);
   _actionMap[415][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[416][RB] = ActionEntry(SHIFT, 555);
   _actionMap[416][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[417][RB] = ActionEntry(SHIFT, 556);
   _actionMap[417][KSEP] = ActionEntry(SHIFT, 517);
   _actionMap[418][WHEN] = ActionEntry(REDUCE, 152);
   _actionMap[418][ELSE] = ActionEntry(REDUCE, 152);
}
void Cego::loadParser149()
{
   _actionMap[418][LEFT] = ActionEntry(REDUCE, 152);
   _actionMap[418][RIGHT] = ActionEntry(REDUCE, 152);
   _actionMap[418][INNER] = ActionEntry(REDUCE, 152);
   _actionMap[418][JOIN] = ActionEntry(REDUCE, 152);
   _actionMap[418][RETURNTOKEN] = ActionEntry(REDUCE, 152);
   _actionMap[418][ORDER] = ActionEntry(REDUCE, 152);
   _actionMap[418][GROUP] = ActionEntry(REDUCE, 152);
   _actionMap[418][WHERE] = ActionEntry(REDUCE, 152);
   _actionMap[418][AS] = ActionEntry(REDUCE, 152);
   _actionMap[418][FROM] = ActionEntry(REDUCE, 152);
   _actionMap[418][END_TOKEN] = ActionEntry(REDUCE, 152);
   _actionMap[418][BEGIN] = ActionEntry(REDUCE, 152);
   _actionMap[418][THEN] = ActionEntry(REDUCE, 152);
   _actionMap[418][OR] = ActionEntry(REDUCE, 152);
   _actionMap[418][AND] = ActionEntry(REDUCE, 152);
   _actionMap[418][DESC] = ActionEntry(REDUCE, 152);
   _actionMap[418][ASC] = ActionEntry(REDUCE, 152);
   _actionMap[418][KSEP] = ActionEntry(REDUCE, 152);
   _actionMap[418][ROWLIMIT] = ActionEntry(REDUCE, 152);
   _actionMap[418][UNION] = ActionEntry(REDUCE, 152);
   _actionMap[418][ENDTOKEN] = ActionEntry(REDUCE, 152);
   _actionMap[418][SEMICOLON] = ActionEntry(REDUCE, 152);
   _actionMap[418][LIKE] = ActionEntry(REDUCE, 152);
   _actionMap[418][BETWEEN] = ActionEntry(REDUCE, 152);
   _actionMap[418][NOT] = ActionEntry(REDUCE, 152);
   _actionMap[418][INTOK] = ActionEntry(REDUCE, 152);
   _actionMap[418][RB] = ActionEntry(REDUCE, 152);
   _actionMap[418][STAR] = ActionEntry(REDUCE, 152);
   _actionMap[418][DIVISION] = ActionEntry(REDUCE, 152);
   _actionMap[418][CONCAT] = ActionEntry(REDUCE, 152);
   _actionMap[418][MINUS] = ActionEntry(REDUCE, 152);
   _actionMap[418][PLUS] = ActionEntry(REDUCE, 152);
   _actionMap[418][IS] = ActionEntry(REDUCE, 152);
   _actionMap[418][EQU] = ActionEntry(REDUCE, 152);
   _actionMap[418][NEGATION] = ActionEntry(REDUCE, 152);
   _actionMap[418][LT] = ActionEntry(REDUCE, 152);
   _actionMap[418][MT] = ActionEntry(REDUCE, 152);
   _actionMap[419][WHEN] = ActionEntry(REDUCE, 153);
   _actionMap[419][ELSE] = ActionEntry(REDUCE, 153);
   _actionMap[419][LEFT] = ActionEntry(REDUCE, 153);
   _actionMap[419][RIGHT] = ActionEntry(REDUCE, 153);
   _actionMap[419][INNER] = ActionEntry(REDUCE, 153);
   _actionMap[419][JOIN] = ActionEntry(REDUCE, 153);
   _actionMap[419][RETURNTOKEN] = ActionEntry(REDUCE, 153);
   _actionMap[419][ORDER] = ActionEntry(REDUCE, 153);
   _actionMap[419][GROUP] = ActionEntry(REDUCE, 153);
   _actionMap[419][WHERE] = ActionEntry(REDUCE, 153);
   _actionMap[419][AS] = ActionEntry(REDUCE, 153);
   _actionMap[419][FROM] = ActionEntry(REDUCE, 153);
   _actionMap[419][END_TOKEN] = ActionEntry(REDUCE, 153);
}
void Cego::loadParser150()
{
   _actionMap[419][BEGIN] = ActionEntry(REDUCE, 153);
   _actionMap[419][THEN] = ActionEntry(REDUCE, 153);
   _actionMap[419][OR] = ActionEntry(REDUCE, 153);
   _actionMap[419][AND] = ActionEntry(REDUCE, 153);
   _actionMap[419][DESC] = ActionEntry(REDUCE, 153);
   _actionMap[419][ASC] = ActionEntry(REDUCE, 153);
   _actionMap[419][KSEP] = ActionEntry(REDUCE, 153);
   _actionMap[419][ROWLIMIT] = ActionEntry(REDUCE, 153);
   _actionMap[419][UNION] = ActionEntry(REDUCE, 153);
   _actionMap[419][ENDTOKEN] = ActionEntry(REDUCE, 153);
   _actionMap[419][SEMICOLON] = ActionEntry(REDUCE, 153);
   _actionMap[419][LIKE] = ActionEntry(REDUCE, 153);
   _actionMap[419][BETWEEN] = ActionEntry(REDUCE, 153);
   _actionMap[419][NOT] = ActionEntry(REDUCE, 153);
   _actionMap[419][INTOK] = ActionEntry(REDUCE, 153);
   _actionMap[419][RB] = ActionEntry(REDUCE, 153);
   _actionMap[419][STAR] = ActionEntry(REDUCE, 153);
   _actionMap[419][DIVISION] = ActionEntry(REDUCE, 153);
   _actionMap[419][CONCAT] = ActionEntry(REDUCE, 153);
   _actionMap[419][MINUS] = ActionEntry(REDUCE, 153);
   _actionMap[419][PLUS] = ActionEntry(REDUCE, 153);
   _actionMap[419][IS] = ActionEntry(REDUCE, 153);
   _actionMap[419][EQU] = ActionEntry(REDUCE, 153);
   _actionMap[419][NEGATION] = ActionEntry(REDUCE, 153);
   _actionMap[419][LT] = ActionEntry(REDUCE, 153);
   _actionMap[419][MT] = ActionEntry(REDUCE, 153);
   _actionMap[420][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[420][MINUS] = ActionEntry(SHIFT, 558);
   _jumpMap[420][SignedInt] = 557;
   _actionMap[421][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[421][MINUS] = ActionEntry(SHIFT, 560);
   _jumpMap[421][SignedFloat] = 559;
   _actionMap[422][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[422][MINUS] = ActionEntry(SHIFT, 560);
   _jumpMap[422][SignedFloat] = 561;
   _actionMap[423][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[423][MINUS] = ActionEntry(SHIFT, 560);
   _jumpMap[423][SignedFloat] = 562;
   _actionMap[424][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[424][MINUS] = ActionEntry(SHIFT, 558);
   _jumpMap[424][SignedInt] = 563;
   _actionMap[425][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[425][MINUS] = ActionEntry(SHIFT, 558);
   _jumpMap[425][SignedInt] = 564;
   _actionMap[426][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[426][MINUS] = ActionEntry(SHIFT, 558);
   _jumpMap[426][SignedInt] = 565;
   _actionMap[427][INTVAL] = ActionEntry(SHIFT, 566);
   _actionMap[428][IDENTIFIER] = ActionEntry(SHIFT, 567);
   _actionMap[429][IDENTIFIER] = ActionEntry(SHIFT, 568);
}
void Cego::loadParser151()
{
   _actionMap[430][IDENTIFIER] = ActionEntry(SHIFT, 569);
   _actionMap[431][IDENTIFIER] = ActionEntry(SHIFT, 570);
   _actionMap[432][IDENTIFIER] = ActionEntry(SHIFT, 571);
   _actionMap[433][IDENTIFIER] = ActionEntry(SHIFT, 572);
   _actionMap[434][SEMICOLON] = ActionEntry(REDUCE, 308);
   _actionMap[434][RB] = ActionEntry(REDUCE, 308);
   _actionMap[434][ENDTOKEN] = ActionEntry(REDUCE, 308);
   _actionMap[434][UNION] = ActionEntry(REDUCE, 308);
   _actionMap[434][ROWLIMIT] = ActionEntry(REDUCE, 308);
   _actionMap[434][ORDER] = ActionEntry(REDUCE, 308);
   _actionMap[434][GROUP] = ActionEntry(REDUCE, 308);
   _actionMap[434][WHERE] = ActionEntry(SHIFT, 353);
   _jumpMap[434][NoWhere] = 352;
   _jumpMap[434][WhereClause] = 573;
   _actionMap[435][WHERE] = ActionEntry(REDUCE, 209);
   _actionMap[435][GROUP] = ActionEntry(REDUCE, 209);
   _actionMap[435][ORDER] = ActionEntry(REDUCE, 209);
   _actionMap[435][ROWLIMIT] = ActionEntry(REDUCE, 209);
   _actionMap[435][UNION] = ActionEntry(REDUCE, 209);
   _actionMap[435][ENDTOKEN] = ActionEntry(REDUCE, 209);
   _actionMap[435][RB] = ActionEntry(REDUCE, 209);
   _actionMap[435][SEMICOLON] = ActionEntry(REDUCE, 209);
   _actionMap[435][RETURNTOKEN] = ActionEntry(REDUCE, 209);
   _actionMap[435][INNER] = ActionEntry(SHIFT, 576);
   _actionMap[435][JOIN] = ActionEntry(SHIFT, 577);
   _actionMap[435][LEFT] = ActionEntry(SHIFT, 578);
   _actionMap[435][RIGHT] = ActionEntry(SHIFT, 579);
   _jumpMap[435][InnerJoin] = 575;
   _jumpMap[435][JoinSpec] = 574;
   _actionMap[436][WHERE] = ActionEntry(REDUCE, 208);
   _actionMap[436][GROUP] = ActionEntry(REDUCE, 208);
   _actionMap[436][ORDER] = ActionEntry(REDUCE, 208);
   _actionMap[436][ROWLIMIT] = ActionEntry(REDUCE, 208);
   _actionMap[436][UNION] = ActionEntry(REDUCE, 208);
   _actionMap[436][ENDTOKEN] = ActionEntry(REDUCE, 208);
   _actionMap[436][RB] = ActionEntry(REDUCE, 208);
   _actionMap[436][SEMICOLON] = ActionEntry(REDUCE, 208);
   _actionMap[436][RETURNTOKEN] = ActionEntry(REDUCE, 208);
   _actionMap[437][KSEP] = ActionEntry(SHIFT, 581);
   _actionMap[437][RETURNTOKEN] = ActionEntry(REDUCE, 218);
   _actionMap[437][SEMICOLON] = ActionEntry(REDUCE, 218);
   _actionMap[437][RB] = ActionEntry(REDUCE, 218);
   _actionMap[437][ENDTOKEN] = ActionEntry(REDUCE, 218);
   _actionMap[437][UNION] = ActionEntry(REDUCE, 218);
   _actionMap[437][ROWLIMIT] = ActionEntry(REDUCE, 218);
   _actionMap[437][ORDER] = ActionEntry(REDUCE, 218);
   _actionMap[437][GROUP] = ActionEntry(REDUCE, 218);
   _actionMap[437][WHERE] = ActionEntry(REDUCE, 218);
   _actionMap[437][INNER] = ActionEntry(SHIFT, 576);
   _actionMap[437][JOIN] = ActionEntry(SHIFT, 577);
}
void Cego::loadParser152()
{
   _actionMap[437][LEFT] = ActionEntry(SHIFT, 578);
   _actionMap[437][RIGHT] = ActionEntry(SHIFT, 579);
   _jumpMap[437][InnerJoin] = 575;
   _jumpMap[437][JoinSpec] = 580;
   _actionMap[438][WHERE] = ActionEntry(REDUCE, 219);
   _actionMap[438][IDENTIFIER] = ActionEntry(SHIFT, 582);
   _actionMap[438][GROUP] = ActionEntry(REDUCE, 219);
   _actionMap[438][ORDER] = ActionEntry(REDUCE, 219);
   _actionMap[438][ROWLIMIT] = ActionEntry(REDUCE, 219);
   _actionMap[438][UNION] = ActionEntry(REDUCE, 219);
   _actionMap[438][ENDTOKEN] = ActionEntry(REDUCE, 219);
   _actionMap[438][RB] = ActionEntry(REDUCE, 219);
   _actionMap[438][SEMICOLON] = ActionEntry(REDUCE, 219);
   _actionMap[438][RETURNTOKEN] = ActionEntry(REDUCE, 219);
   _actionMap[438][LEFT] = ActionEntry(REDUCE, 219);
   _actionMap[438][RIGHT] = ActionEntry(REDUCE, 219);
   _actionMap[438][INNER] = ActionEntry(REDUCE, 219);
   _actionMap[438][JOIN] = ActionEntry(REDUCE, 219);
   _actionMap[438][KSEP] = ActionEntry(REDUCE, 219);
   _actionMap[438][ON] = ActionEntry(REDUCE, 219);
   _actionMap[439][FROM] = ActionEntry(REDUCE, 207);
   _actionMap[439][KSEP] = ActionEntry(REDUCE, 207);
   _actionMap[440][FROM] = ActionEntry(REDUCE, 223);
   _actionMap[440][KSEP] = ActionEntry(REDUCE, 223);
   _actionMap[441][IDENTIFIER] = ActionEntry(SHIFT, 583);
   _actionMap[442][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[442][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[442][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[442][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[442][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[442][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[442][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[442][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[442][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[442][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[442][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[442][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[442][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[442][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[442][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[442][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[442][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[442][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[442][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[442][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[442][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[442][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[442][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[442][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[442][MOD] = ActionEntry(SHIFT, 123);
}
void Cego::loadParser153()
{
   _actionMap[442][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[442][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[442][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[442][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[442][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[442][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[442][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[442][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[442][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[442][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[442][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[442][LB] = ActionEntry(SHIFT, 144);
   _actionMap[442][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[442][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[442][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[442][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[442][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[442][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[442][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[442][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[442][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[442][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[442][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[442][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[442][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[442][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[442][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[442][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[442][ObjSpec] = 100;
   _jumpMap[442][Constant] = 99;
   _jumpMap[442][SignedFloat] = 98;
   _jumpMap[442][SignedInt] = 97;
   _jumpMap[442][Attribute] = 96;
   _jumpMap[442][Function] = 95;
   _jumpMap[442][SelectItem] = 584;
   _jumpMap[442][CasePrepare] = 94;
   _jumpMap[442][CaseClause] = 93;
   _jumpMap[442][Factor] = 92;
   _jumpMap[442][Term] = 91;
   _jumpMap[442][Expr] = 293;
   _actionMap[443][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[443][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[443][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[443][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[443][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[443][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[443][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[443][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[443][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[443][INT2DATE] = ActionEntry(SHIFT, 116);
}
void Cego::loadParser154()
{
   _actionMap[443][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[443][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[443][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[443][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[443][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[443][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[443][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[443][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[443][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[443][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[443][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[443][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[443][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[443][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[443][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[443][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[443][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[443][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[443][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[443][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[443][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[443][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[443][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[443][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[443][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[443][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[443][LB] = ActionEntry(SHIFT, 144);
   _actionMap[443][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[443][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[443][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[443][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[443][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[443][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[443][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[443][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[443][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[443][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[443][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[443][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[443][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[443][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[443][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[443][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[443][ObjSpec] = 100;
   _jumpMap[443][Constant] = 99;
   _jumpMap[443][SignedFloat] = 98;
   _jumpMap[443][SignedInt] = 97;
   _jumpMap[443][Attribute] = 96;
   _jumpMap[443][Function] = 95;
   _jumpMap[443][CasePrepare] = 94;
}
void Cego::loadParser155()
{
   _jumpMap[443][CaseClause] = 93;
   _jumpMap[443][Factor] = 92;
   _jumpMap[443][Term] = 91;
   _jumpMap[443][Expr] = 585;
   _actionMap[444][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[444][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[444][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[444][SEMICOLON] = ActionEntry(REDUCE, 68);
   _actionMap[445][KSEP] = ActionEntry(SHIFT, 587);
   _actionMap[445][SEMICOLON] = ActionEntry(REDUCE, 308);
   _actionMap[445][RETURNTOKEN] = ActionEntry(REDUCE, 308);
   _actionMap[445][WHERE] = ActionEntry(SHIFT, 353);
   _jumpMap[445][NoWhere] = 352;
   _jumpMap[445][WhereClause] = 586;
   _actionMap[446][KSEP] = ActionEntry(REDUCE, 249);
   _actionMap[446][WHERE] = ActionEntry(REDUCE, 249);
   _actionMap[446][GROUP] = ActionEntry(REDUCE, 249);
   _actionMap[446][ORDER] = ActionEntry(REDUCE, 249);
   _actionMap[446][ROWLIMIT] = ActionEntry(REDUCE, 249);
   _actionMap[446][UNION] = ActionEntry(REDUCE, 249);
   _actionMap[446][ENDTOKEN] = ActionEntry(REDUCE, 249);
   _actionMap[446][RB] = ActionEntry(REDUCE, 249);
   _actionMap[446][SEMICOLON] = ActionEntry(REDUCE, 249);
   _actionMap[446][RETURNTOKEN] = ActionEntry(REDUCE, 249);
   _actionMap[447][EQU] = ActionEntry(SHIFT, 588);
   _actionMap[448][LB] = ActionEntry(SHIFT, 589);
   _actionMap[180][SEMICOLON] = ActionEntry(REDUCE, 63);
   _actionMap[181][SEMICOLON] = ActionEntry(REDUCE, 62);
   _actionMap[182][SEMICOLON] = ActionEntry(REDUCE, 72);
   _actionMap[183][TO] = ActionEntry(REDUCE, 74);
   _actionMap[183][SEMICOLON] = ActionEntry(REDUCE, 74);
   _actionMap[184][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[184][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[184][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[184][ObjSpec] = 311;
   _actionMap[185][SEMICOLON] = ActionEntry(REDUCE, 58);
   _actionMap[186][SEMICOLON] = ActionEntry(REDUCE, 60);
   _actionMap[187][SEMICOLON] = ActionEntry(REDUCE, 57);
   _actionMap[188][SEMICOLON] = ActionEntry(REDUCE, 59);
   _actionMap[189][ADD] = ActionEntry(SHIFT, 314);
   _actionMap[189][DROP] = ActionEntry(SHIFT, 315);
   _actionMap[189][MODIFY] = ActionEntry(SHIFT, 316);
   _actionMap[189][RENAME] = ActionEntry(SHIFT, 317);
   _jumpMap[189][AlterOption] = 313;
   _jumpMap[189][AlterList] = 312;
   _actionMap[190][BY] = ActionEntry(SHIFT, 318);
   _actionMap[191][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[191][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[191][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[191][TRIM] = ActionEntry(SHIFT, 140);
}
void Cego::loadParser156()
{
   _actionMap[191][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[191][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[191][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[191][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[191][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[191][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[191][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[191][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[191][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[191][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[191][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[191][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[191][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[191][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[191][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[191][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[191][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[191][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[191][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[191][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[191][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[191][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[191][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[191][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[191][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[191][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[191][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[191][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[191][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[191][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[191][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[191][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[191][LB] = ActionEntry(SHIFT, 144);
   _actionMap[191][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[191][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[191][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[191][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[191][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[191][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[191][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[191][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[191][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[191][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[191][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[191][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[191][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[191][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[191][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[191][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[191][RB] = ActionEntry(REDUCE, 117);
}
void Cego::loadParser157()
{
   _jumpMap[191][ObjSpec] = 100;
   _jumpMap[191][Constant] = 99;
   _jumpMap[191][SignedFloat] = 98;
   _jumpMap[191][SignedInt] = 97;
   _jumpMap[191][Attribute] = 96;
   _jumpMap[191][Function] = 95;
   _jumpMap[191][CasePrepare] = 94;
   _jumpMap[191][CaseClause] = 93;
   _jumpMap[191][Factor] = 92;
   _jumpMap[191][Term] = 91;
   _jumpMap[191][Expr] = 321;
   _jumpMap[191][ProcValueList] = 320;
   _jumpMap[191][ProcValueListOpt] = 319;
   _actionMap[192][SEMICOLON] = ActionEntry(REDUCE, 70);
   _actionMap[193][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[193][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[193][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[193][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[193][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[193][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[193][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[193][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[193][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[193][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[193][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[193][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[193][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[193][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[193][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[193][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[193][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[193][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[193][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[193][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[193][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[193][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[193][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[193][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[193][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[193][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[193][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[193][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[193][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[193][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[193][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[193][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[193][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[193][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[193][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[193][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
}
void Cego::loadParser158()
{
   _actionMap[193][LB] = ActionEntry(SHIFT, 144);
   _actionMap[193][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[193][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[193][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[193][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[193][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[193][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[193][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[193][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[193][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[193][VARREF] = ActionEntry(SHIFT, 344);
   _actionMap[193][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[193][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[193][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[193][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[193][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[193][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[193][IF] = ActionEntry(SHIFT, 338);
   _actionMap[193][BEGIN] = ActionEntry(SHIFT, 335);
   _actionMap[193][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[193][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[193][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[193][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[193][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[193][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[193][VAR] = ActionEntry(SHIFT, 342);
   _actionMap[193][CURSOR] = ActionEntry(SHIFT, 337);
   _actionMap[193][CLOSE] = ActionEntry(SHIFT, 336);
   _actionMap[193][NOOP] = ActionEntry(SHIFT, 339);
   _actionMap[193][THROW] = ActionEntry(SHIFT, 341);
   _actionMap[193][RETURNTOKEN] = ActionEntry(SHIFT, 340);
   _actionMap[193][WHILE] = ActionEntry(SHIFT, 343);
   _jumpMap[193][ObjSpec] = 100;
   _jumpMap[193][Constant] = 99;
   _jumpMap[193][SignedFloat] = 98;
   _jumpMap[193][SignedInt] = 97;
   _jumpMap[193][Attribute] = 96;
   _jumpMap[193][Function] = 95;
   _jumpMap[193][DeleteStatement] = 334;
   _jumpMap[193][UpdateStatement] = 333;
   _jumpMap[193][InsertStatement] = 332;
   _jumpMap[193][RollbackStatement] = 331;
   _jumpMap[193][CommitStatement] = 330;
   _jumpMap[193][StartStatement] = 329;
   _jumpMap[193][CasePrepare] = 94;
   _jumpMap[193][CaseClause] = 93;
   _jumpMap[193][Factor] = 92;
   _jumpMap[193][Term] = 91;
   _jumpMap[193][Expr] = 328;
   _jumpMap[193][ProcStatement] = 327;
}
void Cego::loadParser159()
{
   _jumpMap[193][ProcIfPart] = 326;
   _jumpMap[193][ProcBlockStart] = 325;
   _jumpMap[193][ProcStatementList] = 324;
   _jumpMap[193][ProcStmtBlock] = 323;
   _actionMap[194][IDENTIFIER] = ActionEntry(SHIFT, 345);
   _actionMap[195][ON] = ActionEntry(REDUCE, 186);
   _actionMap[195][IDENTIFIER] = ActionEntry(REDUCE, 186);
   _actionMap[196][ON] = ActionEntry(REDUCE, 185);
   _actionMap[196][IDENTIFIER] = ActionEntry(REDUCE, 185);
   _actionMap[197][SEMICOLON] = ActionEntry(REDUCE, 71);
   _actionMap[198][ON] = ActionEntry(SHIFT, 346);
   _actionMap[199][LB] = ActionEntry(SHIFT, 347);
   _actionMap[200][LB] = ActionEntry(SHIFT, 348);
   _actionMap[201][AS] = ActionEntry(SHIFT, 349);
   _actionMap[202][IDENTIFIER] = ActionEntry(SHIFT, 309);
   _actionMap[202][WHERE] = ActionEntry(REDUCE, 258);
   _actionMap[202][GROUP] = ActionEntry(REDUCE, 258);
   _actionMap[202][ORDER] = ActionEntry(REDUCE, 258);
   _actionMap[202][ROWLIMIT] = ActionEntry(REDUCE, 258);
   _actionMap[202][UNION] = ActionEntry(REDUCE, 258);
   _actionMap[202][ENDTOKEN] = ActionEntry(REDUCE, 258);
   _actionMap[202][RB] = ActionEntry(REDUCE, 258);
   _actionMap[202][SEMICOLON] = ActionEntry(REDUCE, 258);
   _actionMap[202][RETURNTOKEN] = ActionEntry(REDUCE, 258);
   _jumpMap[202][NoWhere] = 352;
   _jumpMap[202][WhereClause] = 351;
   _jumpMap[202][UpdDelAlias] = 350;
   _actionMap[203][SEMICOLON] = ActionEntry(REDUCE, 21);
   _actionMap[204][SEMICOLON] = ActionEntry(REDUCE, 24);
   _actionMap[205][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[205][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[205][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[205][ObjSpec] = 354;
   _actionMap[206][SEMICOLON] = ActionEntry(REDUCE, 20);
   _actionMap[207][SEMICOLON] = ActionEntry(REDUCE, 25);
   _actionMap[208][SEMICOLON] = ActionEntry(REDUCE, 19);
   _actionMap[209][SEMICOLON] = ActionEntry(REDUCE, 22);
   _actionMap[210][COUNTER] = ActionEntry(REDUCE, 65);
   _actionMap[210][BTREE] = ActionEntry(REDUCE, 65);
   _actionMap[210][CHECK] = ActionEntry(REDUCE, 65);
   _actionMap[210][FOREIGN] = ActionEntry(REDUCE, 65);
   _actionMap[210][PROCEDURE] = ActionEntry(REDUCE, 65);
   _actionMap[210][VIEW] = ActionEntry(REDUCE, 65);
   _actionMap[210][INDEX] = ActionEntry(REDUCE, 65);
   _actionMap[210][TABLE] = ActionEntry(REDUCE, 65);
   _actionMap[211][LB] = ActionEntry(SHIFT, 359);
   _actionMap[211][VALUES] = ActionEntry(REDUCE, 193);
   _actionMap[211][SELECT] = ActionEntry(REDUCE, 193);
   _jumpMap[211][SelectStatement] = 357;
   _jumpMap[211][InsertPrepare] = 356;
}
void Cego::loadParser160()
{
   _jumpMap[211][InsertArgSpec] = 355;
   _actionMap[212][SEMICOLON] = ActionEntry(REDUCE, 76);
   _actionMap[212][IDENTIFIER] = ActionEntry(REDUCE, 76);
   _actionMap[213][SEMICOLON] = ActionEntry(REDUCE, 7);
   _actionMap[214][IDENTIFIER] = ActionEntry(SHIFT, 360);
   _actionMap[215][SEMICOLON] = ActionEntry(REDUCE, 12);
   _actionMap[216][SEMICOLON] = ActionEntry(REDUCE, 9);
   _actionMap[217][SEMICOLON] = ActionEntry(REDUCE, 6);
   _actionMap[218][SEMICOLON] = ActionEntry(REDUCE, 8);
   _actionMap[219][SEMICOLON] = ActionEntry(REDUCE, 4);
   _actionMap[220][SEMICOLON] = ActionEntry(REDUCE, 10);
   _actionMap[221][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[222][SEMICOLON] = ActionEntry(REDUCE, 11);
   _actionMap[223][SEMICOLON] = ActionEntry(REDUCE, 5);
   _actionMap[224][AS] = ActionEntry(SHIFT, 361);
   _actionMap[225][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[225][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[225][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[225][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[225][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[225][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[225][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[225][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[225][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[225][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[225][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[225][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[225][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[225][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[225][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[225][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[225][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[225][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[225][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[225][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[225][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[225][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[225][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[225][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[225][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[225][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[225][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[225][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[225][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[225][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[225][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[225][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[225][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[225][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[225][BLOBSIZE] = ActionEntry(SHIFT, 106);
}
void Cego::loadParser161()
{
   _actionMap[225][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[225][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[225][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[225][LB] = ActionEntry(SHIFT, 144);
   _actionMap[225][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[225][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[225][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[225][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[225][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[225][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[225][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[225][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[225][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[225][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[225][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[225][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[225][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[225][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[225][ObjSpec] = 100;
   _jumpMap[225][Constant] = 99;
   _jumpMap[225][SignedFloat] = 98;
   _jumpMap[225][SignedInt] = 97;
   _jumpMap[225][Attribute] = 96;
   _jumpMap[225][Function] = 95;
   _jumpMap[225][CasePrepare] = 94;
   _jumpMap[225][CaseClause] = 93;
   _jumpMap[225][Factor] = 92;
   _jumpMap[225][Term] = 362;
   _actionMap[226][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[226][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[226][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[226][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[226][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[226][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[226][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[226][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[226][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[226][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[226][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[226][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[226][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[226][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[226][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[226][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[226][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[226][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[226][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[226][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[226][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[226][LENGTH] = ActionEntry(SHIFT, 118);
}
void Cego::loadParser162()
{
   _actionMap[226][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[226][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[226][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[226][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[226][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[226][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[226][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[226][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[226][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[226][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[226][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[226][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[226][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[226][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[226][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[226][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[226][LB] = ActionEntry(SHIFT, 144);
   _actionMap[226][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[226][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[226][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[226][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[226][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[226][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[226][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[226][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[226][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[226][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[226][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[226][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[226][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[226][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[226][ObjSpec] = 100;
   _jumpMap[226][Constant] = 99;
   _jumpMap[226][SignedFloat] = 98;
   _jumpMap[226][SignedInt] = 97;
   _jumpMap[226][Attribute] = 96;
   _jumpMap[226][Function] = 95;
   _jumpMap[226][CasePrepare] = 94;
   _jumpMap[226][CaseClause] = 93;
   _jumpMap[226][Factor] = 92;
   _jumpMap[226][Term] = 363;
   _actionMap[227][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[227][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[227][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[227][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[227][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[227][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[227][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[227][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[227][RTRIM] = ActionEntry(SHIFT, 132);
}
void Cego::loadParser163()
{
   _actionMap[227][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[227][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[227][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[227][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[227][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[227][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[227][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[227][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[227][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[227][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[227][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[227][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[227][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[227][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[227][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[227][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[227][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[227][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[227][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[227][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[227][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[227][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[227][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[227][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[227][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[227][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[227][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[227][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[227][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[227][LB] = ActionEntry(SHIFT, 144);
   _actionMap[227][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[227][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[227][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[227][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[227][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[227][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[227][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[227][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[227][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[227][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[227][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[227][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[227][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[227][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[227][ObjSpec] = 100;
   _jumpMap[227][Constant] = 99;
   _jumpMap[227][SignedFloat] = 98;
   _jumpMap[227][SignedInt] = 97;
   _jumpMap[227][Attribute] = 96;
   _jumpMap[227][Function] = 95;
}
void Cego::loadParser164()
{
   _jumpMap[227][CasePrepare] = 94;
   _jumpMap[227][CaseClause] = 93;
   _jumpMap[227][Factor] = 92;
   _jumpMap[227][Term] = 364;
   _actionMap[228][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[228][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[228][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[228][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[228][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[228][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[228][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[228][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[228][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[228][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[228][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[228][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[228][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[228][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[228][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[228][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[228][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[228][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[228][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[228][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[228][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[228][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[228][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[228][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[228][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[228][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[228][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[228][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[228][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[228][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[228][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[228][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[228][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[228][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[228][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[228][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[228][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[228][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[228][LB] = ActionEntry(SHIFT, 144);
   _actionMap[228][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[228][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[228][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[228][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[228][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[228][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[228][LAB] = ActionEntry(SHIFT, 145);
}
void Cego::loadParser165()
{
   _actionMap[228][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[228][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[228][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[228][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[228][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[228][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[228][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[228][ObjSpec] = 100;
   _jumpMap[228][Constant] = 99;
   _jumpMap[228][SignedFloat] = 98;
   _jumpMap[228][SignedInt] = 97;
   _jumpMap[228][Attribute] = 96;
   _jumpMap[228][Function] = 95;
   _jumpMap[228][CasePrepare] = 94;
   _jumpMap[228][CaseClause] = 93;
   _jumpMap[228][Factor] = 365;
   _actionMap[229][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[229][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[229][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[229][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[229][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[229][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[229][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[229][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[229][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[229][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[229][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[229][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[229][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[229][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[229][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[229][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[229][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[229][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[229][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[229][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[229][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[229][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[229][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[229][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[229][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[229][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[229][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[229][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[229][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[229][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[229][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[229][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[229][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[229][BITXOR] = ActionEntry(SHIFT, 105);
}
void Cego::loadParser166()
{
   _actionMap[229][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[229][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[229][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[229][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[229][LB] = ActionEntry(SHIFT, 144);
   _actionMap[229][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[229][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[229][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[229][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[229][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[229][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[229][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[229][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[229][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[229][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[229][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[229][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[229][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[229][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[229][ObjSpec] = 100;
   _jumpMap[229][Constant] = 99;
   _jumpMap[229][SignedFloat] = 98;
   _jumpMap[229][SignedInt] = 97;
   _jumpMap[229][Attribute] = 96;
   _jumpMap[229][Function] = 95;
   _jumpMap[229][CasePrepare] = 94;
   _jumpMap[229][CaseClause] = 93;
   _jumpMap[229][Factor] = 366;
   _actionMap[230][ELSE] = ActionEntry(SHIFT, 368);
   _actionMap[230][WHEN] = ActionEntry(SHIFT, 232);
   _jumpMap[230][CaseCondition] = 367;
   _actionMap[231][WHEN] = ActionEntry(REDUCE, 163);
   _actionMap[231][ELSE] = ActionEntry(REDUCE, 163);
   _actionMap[232][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[232][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[232][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[232][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[232][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[232][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[232][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[232][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[232][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[232][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[232][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[232][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[232][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[232][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[232][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[232][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[232][REPLACE] = ActionEntry(SHIFT, 129);
}
void Cego::loadParser167()
{
   _actionMap[232][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[232][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[232][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[232][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[232][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[232][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[232][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[232][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[232][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[232][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[232][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[232][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[232][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[232][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[232][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[232][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[232][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[232][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[232][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[232][LB] = ActionEntry(SHIFT, 374);
   _actionMap[232][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[232][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[232][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[232][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[232][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[232][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[232][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[232][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[232][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[232][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[232][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[232][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[232][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[232][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[232][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[232][MAX] = ActionEntry(SHIFT, 122);
   _actionMap[232][EXISTS] = ActionEntry(SHIFT, 372);
   _actionMap[232][NOT] = ActionEntry(SHIFT, 373);
   _jumpMap[232][ObjSpec] = 100;
   _jumpMap[232][Constant] = 99;
   _jumpMap[232][SignedFloat] = 98;
   _jumpMap[232][SignedInt] = 97;
   _jumpMap[232][Attribute] = 96;
   _jumpMap[232][QueryPredicate] = 371;
   _jumpMap[232][QueryCondition] = 370;
   _jumpMap[232][Function] = 95;
   _jumpMap[232][CasePrepare] = 94;
   _jumpMap[232][CaseClause] = 93;
   _jumpMap[232][Factor] = 92;
   _jumpMap[232][Term] = 91;
}
void Cego::loadParser168()
{
   _jumpMap[232][Expr] = 369;
   _actionMap[233][RB] = ActionEntry(SHIFT, 377);
   _actionMap[233][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[233][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[233][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[233][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[233][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[233][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[233][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[233][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[233][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[233][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[233][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[233][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[233][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[233][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[233][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[233][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[233][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[233][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[233][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[233][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[233][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[233][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[233][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[233][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[233][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[233][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[233][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[233][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[233][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[233][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[233][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[233][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[233][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[233][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[233][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[233][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[233][LB] = ActionEntry(SHIFT, 144);
   _actionMap[233][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[233][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[233][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[233][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[233][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[233][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[233][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[233][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[233][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[233][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[233][FETCH] = ActionEntry(SHIFT, 114);
}
void Cego::loadParser169()
{
   _actionMap[233][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[233][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[233][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[233][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[233][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[233][ObjSpec] = 100;
   _jumpMap[233][Constant] = 99;
   _jumpMap[233][SignedFloat] = 98;
   _jumpMap[233][SignedInt] = 97;
   _jumpMap[233][Attribute] = 96;
   _jumpMap[233][ExpressionList] = 376;
   _jumpMap[233][Function] = 95;
   _jumpMap[233][CasePrepare] = 94;
   _jumpMap[233][CaseClause] = 93;
   _jumpMap[233][Factor] = 92;
   _jumpMap[233][Term] = 91;
   _jumpMap[233][Expr] = 375;
   _actionMap[234][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[234][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[234][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[234][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[234][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[234][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[234][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[234][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[234][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[234][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[234][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[234][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[234][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[234][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[234][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[234][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[234][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[234][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[234][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[234][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[234][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[234][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[234][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[234][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[234][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[234][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[234][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[234][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[234][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[234][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[234][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[234][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[234][SETCOUNT] = ActionEntry(SHIFT, 133);
}
void Cego::loadParser170()
{
   _actionMap[234][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[234][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[234][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[234][LB] = ActionEntry(SHIFT, 144);
   _actionMap[234][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[234][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[234][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[234][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[234][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[234][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[234][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[234][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[234][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[234][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[234][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[234][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[234][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[234][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[234][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[234][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[234][ObjSpec] = 100;
   _jumpMap[234][Constant] = 99;
   _jumpMap[234][SignedFloat] = 98;
   _jumpMap[234][SignedInt] = 97;
   _jumpMap[234][Attribute] = 96;
   _jumpMap[234][Function] = 95;
   _jumpMap[234][CasePrepare] = 94;
   _jumpMap[234][CaseClause] = 93;
   _jumpMap[234][Factor] = 92;
   _jumpMap[234][Term] = 91;
   _jumpMap[234][Expr] = 378;
   _actionMap[235][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[235][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[235][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[235][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[235][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[235][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[235][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[235][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[235][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[235][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[235][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[235][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[235][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[235][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[235][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[235][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[235][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[235][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[235][TRUNC] = ActionEntry(SHIFT, 142);
}
void Cego::loadParser171()
{
   _actionMap[235][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[235][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[235][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[235][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[235][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[235][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[235][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[235][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[235][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[235][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[235][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[235][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[235][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[235][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[235][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[235][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[235][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[235][LB] = ActionEntry(SHIFT, 144);
   _actionMap[235][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[235][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[235][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[235][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[235][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[235][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[235][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[235][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[235][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[235][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[235][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[235][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[235][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[235][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[235][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[235][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[235][ObjSpec] = 100;
   _jumpMap[235][Constant] = 99;
   _jumpMap[235][SignedFloat] = 98;
   _jumpMap[235][SignedInt] = 97;
   _jumpMap[235][Attribute] = 96;
   _jumpMap[235][ExpressionList] = 379;
   _jumpMap[235][Function] = 95;
   _jumpMap[235][CasePrepare] = 94;
   _jumpMap[235][CaseClause] = 93;
   _jumpMap[235][Factor] = 92;
   _jumpMap[235][Term] = 91;
   _jumpMap[235][Expr] = 375;
   _actionMap[236][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[236][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[236][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[236][TRIM] = ActionEntry(SHIFT, 140);
}
void Cego::loadParser172()
{
   _actionMap[236][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[236][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[236][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[236][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[236][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[236][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[236][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[236][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[236][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[236][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[236][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[236][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[236][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[236][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[236][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[236][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[236][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[236][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[236][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[236][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[236][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[236][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[236][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[236][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[236][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[236][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[236][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[236][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[236][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[236][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[236][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[236][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[236][LB] = ActionEntry(SHIFT, 144);
   _actionMap[236][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[236][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[236][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[236][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[236][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[236][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[236][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[236][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[236][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[236][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[236][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[236][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[236][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[236][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[236][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[236][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[236][ObjSpec] = 100;
}
void Cego::loadParser173()
{
   _jumpMap[236][Constant] = 99;
   _jumpMap[236][SignedFloat] = 98;
   _jumpMap[236][SignedInt] = 97;
   _jumpMap[236][Attribute] = 96;
   _jumpMap[236][ExpressionList] = 380;
   _jumpMap[236][Function] = 95;
   _jumpMap[236][CasePrepare] = 94;
   _jumpMap[236][CaseClause] = 93;
   _jumpMap[236][Factor] = 92;
   _jumpMap[236][Term] = 91;
   _jumpMap[236][Expr] = 375;
   _actionMap[237][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[237][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[237][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[237][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[237][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[237][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[237][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[237][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[237][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[237][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[237][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[237][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[237][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[237][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[237][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[237][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[237][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[237][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[237][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[237][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[237][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[237][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[237][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[237][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[237][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[237][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[237][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[237][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[237][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[237][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[237][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[237][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[237][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[237][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[237][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[237][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[237][LB] = ActionEntry(SHIFT, 144);
   _actionMap[237][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[237][DATE] = ActionEntry(SHIFT, 109);
}
void Cego::loadParser174()
{
   _actionMap[237][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[237][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[237][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[237][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[237][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[237][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[237][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[237][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[237][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[237][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[237][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[237][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[237][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[237][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[237][ObjSpec] = 100;
   _jumpMap[237][Constant] = 99;
   _jumpMap[237][SignedFloat] = 98;
   _jumpMap[237][SignedInt] = 97;
   _jumpMap[237][Attribute] = 96;
   _jumpMap[237][ExpressionList] = 381;
   _jumpMap[237][Function] = 95;
   _jumpMap[237][CasePrepare] = 94;
   _jumpMap[237][CaseClause] = 93;
   _jumpMap[237][Factor] = 92;
   _jumpMap[237][Term] = 91;
   _jumpMap[237][Expr] = 375;
   _actionMap[238][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[238][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[238][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[238][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[238][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[238][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[238][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[238][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[238][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[238][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[238][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[238][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[238][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[238][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[238][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[238][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[238][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[238][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[238][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[238][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[238][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[238][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[238][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[238][RANDINT] = ActionEntry(SHIFT, 128);
}
void Cego::loadParser175()
{
   _actionMap[238][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[238][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[238][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[238][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[238][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[238][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[238][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[238][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[238][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[238][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[238][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[238][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[238][LB] = ActionEntry(SHIFT, 144);
   _actionMap[238][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[238][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[238][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[238][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[238][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[238][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[238][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[238][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[238][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[238][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[238][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[238][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[238][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[238][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[238][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[238][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[238][ObjSpec] = 100;
   _jumpMap[238][Constant] = 99;
   _jumpMap[238][SignedFloat] = 98;
   _jumpMap[238][SignedInt] = 97;
   _jumpMap[238][Attribute] = 96;
   _jumpMap[238][ExpressionList] = 382;
   _jumpMap[238][Function] = 95;
   _jumpMap[238][CasePrepare] = 94;
   _jumpMap[238][CaseClause] = 93;
   _jumpMap[238][Factor] = 92;
   _jumpMap[238][Term] = 91;
   _jumpMap[238][Expr] = 375;
   _actionMap[239][STAR] = ActionEntry(SHIFT, 385);
   _actionMap[239][DISTINCT] = ActionEntry(SHIFT, 163);
   _actionMap[239][VARREF] = ActionEntry(REDUCE, 243);
   _actionMap[239][FETCH] = ActionEntry(REDUCE, 243);
   _actionMap[239][LB] = ActionEntry(REDUCE, 243);
   _actionMap[239][COUNT] = ActionEntry(REDUCE, 243);
   _actionMap[239][SUM] = ActionEntry(REDUCE, 243);
   _actionMap[239][AVG] = ActionEntry(REDUCE, 243);
   _actionMap[239][MIN] = ActionEntry(REDUCE, 243);
}
void Cego::loadParser176()
{
   _actionMap[239][MAX] = ActionEntry(REDUCE, 243);
   _actionMap[239][CASE] = ActionEntry(REDUCE, 243);
   _actionMap[239][TRIM] = ActionEntry(REDUCE, 243);
   _actionMap[239][RTRIM] = ActionEntry(REDUCE, 243);
   _actionMap[239][LTRIM] = ActionEntry(REDUCE, 243);
   _actionMap[239][ROUND] = ActionEntry(REDUCE, 243);
   _actionMap[239][DATE2STR] = ActionEntry(REDUCE, 243);
   _actionMap[239][DATE2INT] = ActionEntry(REDUCE, 243);
   _actionMap[239][INT2DATE] = ActionEntry(REDUCE, 243);
   _actionMap[239][LOWER] = ActionEntry(REDUCE, 243);
   _actionMap[239][UPPER] = ActionEntry(REDUCE, 243);
   _actionMap[239][LEFT] = ActionEntry(REDUCE, 243);
   _actionMap[239][RIGHT] = ActionEntry(REDUCE, 243);
   _actionMap[239][GETPOS] = ActionEntry(REDUCE, 243);
   _actionMap[239][SUBSTR] = ActionEntry(REDUCE, 243);
   _actionMap[239][REPLACE] = ActionEntry(REDUCE, 243);
   _actionMap[239][LENGTH] = ActionEntry(REDUCE, 243);
   _actionMap[239][TRUNC] = ActionEntry(REDUCE, 243);
   _actionMap[239][STR2INT] = ActionEntry(REDUCE, 243);
   _actionMap[239][STR2LONG] = ActionEntry(REDUCE, 243);
   _actionMap[239][STR2DATE] = ActionEntry(REDUCE, 243);
   _actionMap[239][RANDSTR] = ActionEntry(REDUCE, 243);
   _actionMap[239][RANDINT] = ActionEntry(REDUCE, 243);
   _actionMap[239][MOD] = ActionEntry(REDUCE, 243);
   _actionMap[239][DIV] = ActionEntry(REDUCE, 243);
   _actionMap[239][POWER] = ActionEntry(REDUCE, 243);
   _actionMap[239][BITAND] = ActionEntry(REDUCE, 243);
   _actionMap[239][BITOR] = ActionEntry(REDUCE, 243);
   _actionMap[239][BITXOR] = ActionEntry(REDUCE, 243);
   _actionMap[239][BLOBSIZE] = ActionEntry(REDUCE, 243);
   _actionMap[239][NEXTCOUNT] = ActionEntry(REDUCE, 243);
   _actionMap[239][SETCOUNT] = ActionEntry(REDUCE, 243);
   _actionMap[239][IDENTIFIER] = ActionEntry(REDUCE, 243);
   _actionMap[239][QUALIFIEDOBJ] = ActionEntry(REDUCE, 243);
   _actionMap[239][QUALIFIEDTS] = ActionEntry(REDUCE, 243);
   _actionMap[239][QUALIFIEDPRE] = ActionEntry(REDUCE, 243);
   _actionMap[239][STRINGVAL] = ActionEntry(REDUCE, 243);
   _actionMap[239][DATE] = ActionEntry(REDUCE, 243);
   _actionMap[239][SYSDATE] = ActionEntry(REDUCE, 243);
   _actionMap[239][NULLTOKEN] = ActionEntry(REDUCE, 243);
   _actionMap[239][TRUEVAL] = ActionEntry(REDUCE, 243);
   _actionMap[239][FALSEVAL] = ActionEntry(REDUCE, 243);
   _actionMap[239][LAB] = ActionEntry(REDUCE, 243);
   _actionMap[239][FLOATVAL] = ActionEntry(REDUCE, 243);
   _actionMap[239][MINUS] = ActionEntry(REDUCE, 243);
   _actionMap[239][INTVAL] = ActionEntry(REDUCE, 243);
   _jumpMap[239][ObjSpec] = 100;
   _jumpMap[239][Constant] = 99;
   _jumpMap[239][SignedFloat] = 98;
   _jumpMap[239][SignedInt] = 97;
}
void Cego::loadParser177()
{
   _jumpMap[239][Attribute] = 96;
   _jumpMap[239][Function] = 95;
   _jumpMap[239][DistinctOpt] = 384;
   _jumpMap[239][CasePrepare] = 94;
   _jumpMap[239][CaseClause] = 93;
   _jumpMap[239][Factor] = 92;
   _jumpMap[239][Term] = 91;
   _jumpMap[239][Expr] = 383;
   _actionMap[240][STRINGVAL] = ActionEntry(SHIFT, 387);
   _jumpMap[240][DateFormat] = 386;
   _actionMap[241][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[241][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[241][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[241][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[241][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[241][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[241][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[241][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[241][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[241][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[241][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[241][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[241][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[241][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[241][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[241][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[241][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[241][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[241][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[241][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[241][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[241][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[241][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[241][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[241][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[241][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[241][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[241][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[241][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[241][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[241][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[241][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[241][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[241][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[241][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[241][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[241][LB] = ActionEntry(SHIFT, 144);
   _actionMap[241][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[241][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[241][SYSDATE] = ActionEntry(SHIFT, 136);
}
void Cego::loadParser178()
{
   _actionMap[241][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[241][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[241][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[241][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[241][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[241][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[241][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[241][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[241][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[241][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[241][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[241][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[241][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[241][ObjSpec] = 100;
   _jumpMap[241][Constant] = 99;
   _jumpMap[241][SignedFloat] = 98;
   _jumpMap[241][SignedInt] = 97;
   _jumpMap[241][Attribute] = 96;
   _jumpMap[241][ExpressionList] = 388;
   _jumpMap[241][Function] = 95;
   _jumpMap[241][CasePrepare] = 94;
   _jumpMap[241][CaseClause] = 93;
   _jumpMap[241][Factor] = 92;
   _jumpMap[241][Term] = 91;
   _jumpMap[241][Expr] = 375;
   _actionMap[242][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[242][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[242][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[242][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[242][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[242][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[242][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[242][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[242][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[242][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[242][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[242][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[242][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[242][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[242][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[242][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[242][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[242][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[242][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[242][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[242][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[242][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[242][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[242][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[242][MOD] = ActionEntry(SHIFT, 123);
}
void Cego::loadParser179()
{
   _actionMap[242][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[242][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[242][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[242][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[242][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[242][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[242][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[242][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[242][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[242][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[242][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[242][LB] = ActionEntry(SHIFT, 144);
   _actionMap[242][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[242][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[242][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[242][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[242][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[242][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[242][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[242][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[242][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[242][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[242][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[242][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[242][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[242][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[242][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[242][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[242][ObjSpec] = 100;
   _jumpMap[242][Constant] = 99;
   _jumpMap[242][SignedFloat] = 98;
   _jumpMap[242][SignedInt] = 97;
   _jumpMap[242][Attribute] = 96;
   _jumpMap[242][ExpressionList] = 389;
   _jumpMap[242][Function] = 95;
   _jumpMap[242][CasePrepare] = 94;
   _jumpMap[242][CaseClause] = 93;
   _jumpMap[242][Factor] = 92;
   _jumpMap[242][Term] = 91;
   _jumpMap[242][Expr] = 375;
   _actionMap[243][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[243][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[243][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[243][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[243][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[243][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[243][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[243][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[243][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[243][INT2DATE] = ActionEntry(SHIFT, 116);
}
void Cego::loadParser180()
{
   _actionMap[243][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[243][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[243][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[243][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[243][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[243][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[243][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[243][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[243][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[243][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[243][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[243][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[243][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[243][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[243][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[243][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[243][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[243][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[243][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[243][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[243][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[243][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[243][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[243][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[243][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[243][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[243][LB] = ActionEntry(SHIFT, 144);
   _actionMap[243][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[243][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[243][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[243][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[243][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[243][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[243][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[243][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[243][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[243][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[243][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[243][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[243][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[243][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[243][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[243][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[243][ObjSpec] = 100;
   _jumpMap[243][Constant] = 99;
   _jumpMap[243][SignedFloat] = 98;
   _jumpMap[243][SignedInt] = 97;
   _jumpMap[243][Attribute] = 96;
   _jumpMap[243][ExpressionList] = 390;
   _jumpMap[243][Function] = 95;
}
void Cego::loadParser181()
{
   _jumpMap[243][CasePrepare] = 94;
   _jumpMap[243][CaseClause] = 93;
   _jumpMap[243][Factor] = 92;
   _jumpMap[243][Term] = 91;
   _jumpMap[243][Expr] = 375;
   _actionMap[244][INTO] = ActionEntry(SHIFT, 391);
   _actionMap[245][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[245][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[245][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[245][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[245][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[245][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[245][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[245][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[245][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[245][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[245][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[245][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[245][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[245][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[245][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[245][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[245][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[245][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[245][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[245][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[245][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[245][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[245][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[245][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[245][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[245][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[245][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[245][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[245][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[245][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[245][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[245][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[245][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[245][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[245][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[245][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[245][LB] = ActionEntry(SHIFT, 144);
   _actionMap[245][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[245][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[245][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[245][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[245][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[245][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[245][LAB] = ActionEntry(SHIFT, 145);
}
void Cego::loadParser182()
{
   _actionMap[245][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[245][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[245][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[245][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[245][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[245][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[245][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[245][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[245][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[245][ObjSpec] = 100;
   _jumpMap[245][Constant] = 99;
   _jumpMap[245][SignedFloat] = 98;
   _jumpMap[245][SignedInt] = 97;
   _jumpMap[245][Attribute] = 96;
   _jumpMap[245][ExpressionList] = 392;
   _jumpMap[245][Function] = 95;
   _jumpMap[245][CasePrepare] = 94;
   _jumpMap[245][CaseClause] = 93;
   _jumpMap[245][Factor] = 92;
   _jumpMap[245][Term] = 91;
   _jumpMap[245][Expr] = 375;
   _actionMap[246][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[246][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[246][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[246][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[246][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[246][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[246][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[246][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[246][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[246][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[246][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[246][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[246][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[246][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[246][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[246][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[246][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[246][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[246][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[246][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[246][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[246][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[246][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[246][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[246][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[246][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[246][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[246][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[246][BITOR] = ActionEntry(SHIFT, 104);
}
void Cego::loadParser183()
{
   _actionMap[246][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[246][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[246][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[246][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[246][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[246][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[246][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[246][LB] = ActionEntry(SHIFT, 144);
   _actionMap[246][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[246][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[246][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[246][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[246][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[246][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[246][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[246][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[246][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[246][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[246][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[246][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[246][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[246][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[246][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[246][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[246][ObjSpec] = 100;
   _jumpMap[246][Constant] = 99;
   _jumpMap[246][SignedFloat] = 98;
   _jumpMap[246][SignedInt] = 97;
   _jumpMap[246][Attribute] = 96;
   _jumpMap[246][ExpressionList] = 393;
   _jumpMap[246][Function] = 95;
   _jumpMap[246][CasePrepare] = 94;
   _jumpMap[246][CaseClause] = 93;
   _jumpMap[246][Factor] = 92;
   _jumpMap[246][Term] = 91;
   _jumpMap[246][Expr] = 375;
   _actionMap[247][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[247][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[247][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[247][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[247][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[247][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[247][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[247][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[247][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[247][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[247][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[247][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[247][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[247][RIGHT] = ActionEntry(SHIFT, 130);
}
void Cego::loadParser184()
{
   _actionMap[247][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[247][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[247][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[247][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[247][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[247][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[247][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[247][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[247][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[247][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[247][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[247][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[247][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[247][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[247][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[247][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[247][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[247][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[247][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[247][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[247][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[247][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[247][LB] = ActionEntry(SHIFT, 144);
   _actionMap[247][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[247][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[247][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[247][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[247][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[247][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[247][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[247][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[247][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[247][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[247][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[247][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[247][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[247][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[247][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[247][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[247][ObjSpec] = 100;
   _jumpMap[247][Constant] = 99;
   _jumpMap[247][SignedFloat] = 98;
   _jumpMap[247][SignedInt] = 97;
   _jumpMap[247][Attribute] = 96;
   _jumpMap[247][ExpressionList] = 394;
   _jumpMap[247][Function] = 95;
   _jumpMap[247][CasePrepare] = 94;
   _jumpMap[247][CaseClause] = 93;
   _jumpMap[247][Factor] = 92;
   _jumpMap[247][Term] = 91;
}
void Cego::loadParser185()
{
   _jumpMap[247][Expr] = 375;
   _actionMap[248][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[248][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[248][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[248][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[248][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[248][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[248][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[248][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[248][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[248][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[248][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[248][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[248][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[248][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[248][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[248][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[248][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[248][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[248][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[248][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[248][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[248][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[248][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[248][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[248][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[248][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[248][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[248][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[248][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[248][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[248][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[248][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[248][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[248][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[248][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[248][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[248][LB] = ActionEntry(SHIFT, 144);
   _actionMap[248][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[248][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[248][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[248][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[248][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[248][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[248][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[248][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[248][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[248][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[248][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[248][COUNT] = ActionEntry(SHIFT, 108);
}
void Cego::loadParser186()
{
   _actionMap[248][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[248][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[248][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[248][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[248][ObjSpec] = 100;
   _jumpMap[248][Constant] = 99;
   _jumpMap[248][SignedFloat] = 98;
   _jumpMap[248][SignedInt] = 97;
   _jumpMap[248][Attribute] = 96;
   _jumpMap[248][ExpressionList] = 395;
   _jumpMap[248][Function] = 95;
   _jumpMap[248][CasePrepare] = 94;
   _jumpMap[248][CaseClause] = 93;
   _jumpMap[248][Factor] = 92;
   _jumpMap[248][Term] = 91;
   _jumpMap[248][Expr] = 375;
   _actionMap[249][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[249][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[249][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[249][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[249][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[249][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[249][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[249][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[249][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[249][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[249][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[249][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[249][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[249][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[249][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[249][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[249][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[249][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[249][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[249][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[249][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[249][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[249][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[249][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[249][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[249][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[249][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[249][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[249][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[249][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[249][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[249][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[249][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[249][IDENTIFIER] = ActionEntry(SHIFT, 149);
}
void Cego::loadParser187()
{
   _actionMap[249][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[249][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[249][LB] = ActionEntry(SHIFT, 144);
   _actionMap[249][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[249][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[249][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[249][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[249][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[249][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[249][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[249][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[249][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[249][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[249][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[249][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[249][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[249][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[249][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[249][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[249][ObjSpec] = 100;
   _jumpMap[249][Constant] = 99;
   _jumpMap[249][SignedFloat] = 98;
   _jumpMap[249][SignedInt] = 97;
   _jumpMap[249][Attribute] = 96;
   _jumpMap[249][ExpressionList] = 396;
   _jumpMap[249][Function] = 95;
   _jumpMap[249][CasePrepare] = 94;
   _jumpMap[249][CaseClause] = 93;
   _jumpMap[249][Factor] = 92;
   _jumpMap[249][Term] = 91;
   _jumpMap[249][Expr] = 375;
   _actionMap[250][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[250][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[250][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[250][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[250][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[250][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[250][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[250][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[250][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[250][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[250][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[250][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[250][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[250][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[250][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[250][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[250][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[250][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[250][TRUNC] = ActionEntry(SHIFT, 142);
}
void Cego::loadParser188()
{
   _actionMap[250][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[250][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[250][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[250][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[250][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[250][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[250][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[250][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[250][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[250][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[250][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[250][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[250][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[250][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[250][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[250][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[250][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[250][LB] = ActionEntry(SHIFT, 144);
   _actionMap[250][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[250][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[250][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[250][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[250][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[250][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[250][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[250][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[250][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[250][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[250][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[250][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[250][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[250][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[250][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[250][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[250][ObjSpec] = 100;
   _jumpMap[250][Constant] = 99;
   _jumpMap[250][SignedFloat] = 98;
   _jumpMap[250][SignedInt] = 97;
   _jumpMap[250][Attribute] = 96;
   _jumpMap[250][ExpressionList] = 397;
   _jumpMap[250][Function] = 95;
   _jumpMap[250][CasePrepare] = 94;
   _jumpMap[250][CaseClause] = 93;
   _jumpMap[250][Factor] = 92;
   _jumpMap[250][Term] = 91;
   _jumpMap[250][Expr] = 375;
   _actionMap[251][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[251][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[251][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[251][TRIM] = ActionEntry(SHIFT, 140);
}
void Cego::loadParser189()
{
   _actionMap[251][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[251][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[251][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[251][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[251][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[251][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[251][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[251][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[251][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[251][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[251][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[251][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[251][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[251][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[251][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[251][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[251][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[251][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[251][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[251][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[251][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[251][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[251][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[251][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[251][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[251][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[251][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[251][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[251][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[251][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[251][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[251][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[251][LB] = ActionEntry(SHIFT, 144);
   _actionMap[251][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[251][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[251][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[251][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[251][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[251][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[251][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[251][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[251][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[251][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[251][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[251][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[251][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[251][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[251][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[251][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[251][ObjSpec] = 100;
}
void Cego::loadParser190()
{
   _jumpMap[251][Constant] = 99;
   _jumpMap[251][SignedFloat] = 98;
   _jumpMap[251][SignedInt] = 97;
   _jumpMap[251][Attribute] = 96;
   _jumpMap[251][Function] = 95;
   _jumpMap[251][CasePrepare] = 94;
   _jumpMap[251][CaseClause] = 93;
   _jumpMap[251][Factor] = 92;
   _jumpMap[251][Term] = 91;
   _jumpMap[251][Expr] = 398;
   _actionMap[252][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[252][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[252][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[252][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[252][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[252][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[252][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[252][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[252][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[252][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[252][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[252][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[252][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[252][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[252][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[252][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[252][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[252][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[252][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[252][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[252][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[252][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[252][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[252][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[252][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[252][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[252][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[252][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[252][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[252][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[252][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[252][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[252][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[252][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[252][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[252][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[252][LB] = ActionEntry(SHIFT, 144);
   _actionMap[252][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[252][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[252][SYSDATE] = ActionEntry(SHIFT, 136);
}
void Cego::loadParser191()
{
   _actionMap[252][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[252][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[252][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[252][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[252][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[252][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[252][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[252][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[252][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[252][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[252][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[252][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[252][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[252][ObjSpec] = 100;
   _jumpMap[252][Constant] = 99;
   _jumpMap[252][SignedFloat] = 98;
   _jumpMap[252][SignedInt] = 97;
   _jumpMap[252][Attribute] = 96;
   _jumpMap[252][Function] = 95;
   _jumpMap[252][CasePrepare] = 94;
   _jumpMap[252][CaseClause] = 93;
   _jumpMap[252][Factor] = 92;
   _jumpMap[252][Term] = 91;
   _jumpMap[252][Expr] = 399;
   _actionMap[253][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[253][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[253][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[253][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[253][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[253][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[253][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[253][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[253][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[253][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[253][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[253][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[253][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[253][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[253][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[253][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[253][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[253][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[253][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[253][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[253][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[253][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[253][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[253][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[253][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[253][DIV] = ActionEntry(SHIFT, 112);
}
void Cego::loadParser192()
{
   _actionMap[253][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[253][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[253][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[253][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[253][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[253][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[253][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[253][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[253][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[253][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[253][LB] = ActionEntry(SHIFT, 144);
   _actionMap[253][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[253][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[253][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[253][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[253][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[253][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[253][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[253][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[253][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[253][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[253][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[253][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[253][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[253][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[253][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[253][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[253][ObjSpec] = 100;
   _jumpMap[253][Constant] = 99;
   _jumpMap[253][SignedFloat] = 98;
   _jumpMap[253][SignedInt] = 97;
   _jumpMap[253][Attribute] = 96;
   _jumpMap[253][ExpressionList] = 400;
   _jumpMap[253][Function] = 95;
   _jumpMap[253][CasePrepare] = 94;
   _jumpMap[253][CaseClause] = 93;
   _jumpMap[253][Factor] = 92;
   _jumpMap[253][Term] = 91;
   _jumpMap[253][Expr] = 375;
   _actionMap[254][IDENTIFIER] = ActionEntry(SHIFT, 401);
   _actionMap[255][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[255][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[255][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[255][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[255][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[255][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[255][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[255][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[255][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[255][INT2DATE] = ActionEntry(SHIFT, 116);
}
void Cego::loadParser193()
{
   _actionMap[255][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[255][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[255][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[255][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[255][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[255][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[255][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[255][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[255][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[255][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[255][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[255][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[255][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[255][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[255][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[255][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[255][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[255][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[255][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[255][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[255][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[255][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[255][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[255][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[255][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[255][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[255][LB] = ActionEntry(SHIFT, 144);
   _actionMap[255][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[255][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[255][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[255][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[255][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[255][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[255][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[255][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[255][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[255][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[255][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[255][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[255][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[255][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[255][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[255][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[255][ObjSpec] = 100;
   _jumpMap[255][Constant] = 99;
   _jumpMap[255][SignedFloat] = 98;
   _jumpMap[255][SignedInt] = 97;
   _jumpMap[255][Attribute] = 96;
   _jumpMap[255][ExpressionList] = 402;
   _jumpMap[255][Function] = 95;
}
void Cego::loadParser194()
{
   _jumpMap[255][CasePrepare] = 94;
   _jumpMap[255][CaseClause] = 93;
   _jumpMap[255][Factor] = 92;
   _jumpMap[255][Term] = 91;
   _jumpMap[255][Expr] = 375;
   _actionMap[256][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[256][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[256][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[256][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[256][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[256][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[256][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[256][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[256][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[256][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[256][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[256][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[256][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[256][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[256][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[256][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[256][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[256][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[256][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[256][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[256][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[256][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[256][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[256][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[256][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[256][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[256][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[256][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[256][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[256][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[256][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[256][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[256][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[256][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[256][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[256][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[256][LB] = ActionEntry(SHIFT, 144);
   _actionMap[256][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[256][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[256][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[256][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[256][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[256][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[256][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[256][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
}
void Cego::loadParser195()
{
   _actionMap[256][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[256][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[256][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[256][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[256][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[256][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[256][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[256][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[256][ObjSpec] = 100;
   _jumpMap[256][Constant] = 99;
   _jumpMap[256][SignedFloat] = 98;
   _jumpMap[256][SignedInt] = 97;
   _jumpMap[256][Attribute] = 96;
   _jumpMap[256][ExpressionList] = 403;
   _jumpMap[256][Function] = 95;
   _jumpMap[256][CasePrepare] = 94;
   _jumpMap[256][CaseClause] = 93;
   _jumpMap[256][Factor] = 92;
   _jumpMap[256][Term] = 91;
   _jumpMap[256][Expr] = 375;
   _actionMap[257][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[257][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[257][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[257][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[257][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[257][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[257][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[257][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[257][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[257][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[257][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[257][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[257][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[257][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[257][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[257][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[257][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[257][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[257][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[257][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[257][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[257][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[257][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[257][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[257][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[257][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[257][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[257][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[257][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[257][BITXOR] = ActionEntry(SHIFT, 105);
}
void Cego::loadParser196()
{
   _actionMap[257][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[257][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[257][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[257][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[257][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[257][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[257][LB] = ActionEntry(SHIFT, 144);
   _actionMap[257][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[257][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[257][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[257][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[257][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[257][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[257][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[257][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[257][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[257][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[257][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[257][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[257][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[257][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[257][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[257][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[257][ObjSpec] = 100;
   _jumpMap[257][Constant] = 99;
   _jumpMap[257][SignedFloat] = 98;
   _jumpMap[257][SignedInt] = 97;
   _jumpMap[257][Attribute] = 96;
   _jumpMap[257][ExpressionList] = 404;
   _jumpMap[257][Function] = 95;
   _jumpMap[257][CasePrepare] = 94;
   _jumpMap[257][CaseClause] = 93;
   _jumpMap[257][Factor] = 92;
   _jumpMap[257][Term] = 91;
   _jumpMap[257][Expr] = 375;
   _actionMap[258][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[258][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[258][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[258][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[258][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[258][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[258][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[258][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[258][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[258][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[258][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[258][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[258][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[258][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[258][GETPOS] = ActionEntry(SHIFT, 115);
}
void Cego::loadParser197()
{
   _actionMap[258][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[258][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[258][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[258][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[258][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[258][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[258][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[258][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[258][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[258][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[258][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[258][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[258][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[258][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[258][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[258][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[258][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[258][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[258][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[258][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[258][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[258][LB] = ActionEntry(SHIFT, 144);
   _actionMap[258][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[258][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[258][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[258][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[258][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[258][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[258][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[258][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[258][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[258][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[258][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[258][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[258][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[258][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[258][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[258][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[258][ObjSpec] = 100;
   _jumpMap[258][Constant] = 99;
   _jumpMap[258][SignedFloat] = 98;
   _jumpMap[258][SignedInt] = 97;
   _jumpMap[258][Attribute] = 96;
   _jumpMap[258][ExpressionList] = 405;
   _jumpMap[258][Function] = 95;
   _jumpMap[258][CasePrepare] = 94;
   _jumpMap[258][CaseClause] = 93;
   _jumpMap[258][Factor] = 92;
   _jumpMap[258][Term] = 91;
   _jumpMap[258][Expr] = 375;
}
void Cego::loadParser198()
{
   _actionMap[259][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[259][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[259][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[259][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[259][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[259][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[259][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[259][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[259][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[259][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[259][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[259][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[259][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[259][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[259][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[259][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[259][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[259][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[259][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[259][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[259][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[259][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[259][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[259][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[259][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[259][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[259][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[259][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[259][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[259][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[259][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[259][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[259][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[259][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[259][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[259][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[259][LB] = ActionEntry(SHIFT, 144);
   _actionMap[259][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[259][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[259][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[259][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[259][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[259][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[259][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[259][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[259][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[259][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[259][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[259][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[259][SUM] = ActionEntry(SHIFT, 135);
}
void Cego::loadParser199()
{
   _actionMap[259][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[259][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[259][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[259][ObjSpec] = 100;
   _jumpMap[259][Constant] = 99;
   _jumpMap[259][SignedFloat] = 98;
   _jumpMap[259][SignedInt] = 97;
   _jumpMap[259][Attribute] = 96;
   _jumpMap[259][ExpressionList] = 406;
   _jumpMap[259][Function] = 95;
   _jumpMap[259][CasePrepare] = 94;
   _jumpMap[259][CaseClause] = 93;
   _jumpMap[259][Factor] = 92;
   _jumpMap[259][Term] = 91;
   _jumpMap[259][Expr] = 375;
   _actionMap[260][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[260][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[260][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[260][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[260][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[260][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[260][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[260][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[260][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[260][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[260][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[260][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[260][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[260][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[260][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[260][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[260][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[260][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[260][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[260][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[260][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[260][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[260][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[260][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[260][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[260][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[260][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[260][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[260][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[260][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[260][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[260][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[260][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[260][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[260][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
}
void Cego::loadParser200()
{
   _actionMap[260][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[260][LB] = ActionEntry(SHIFT, 144);
   _actionMap[260][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[260][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[260][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[260][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[260][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[260][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[260][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[260][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[260][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[260][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[260][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[260][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[260][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[260][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[260][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[260][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[260][ObjSpec] = 100;
   _jumpMap[260][Constant] = 99;
   _jumpMap[260][SignedFloat] = 98;
   _jumpMap[260][SignedInt] = 97;
   _jumpMap[260][Attribute] = 96;
   _jumpMap[260][ExpressionList] = 407;
   _jumpMap[260][Function] = 95;
   _jumpMap[260][CasePrepare] = 94;
   _jumpMap[260][CaseClause] = 93;
   _jumpMap[260][Factor] = 92;
   _jumpMap[260][Term] = 91;
   _jumpMap[260][Expr] = 375;
   _actionMap[261][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[261][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[261][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[261][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[261][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[261][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[261][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[261][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[261][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[261][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[261][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[261][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[261][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[261][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[261][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[261][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[261][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[261][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[261][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[261][STR2INT] = ActionEntry(SHIFT, 137);
}
void Cego::loadParser201()
{
   _actionMap[261][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[261][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[261][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[261][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[261][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[261][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[261][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[261][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[261][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[261][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[261][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[261][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[261][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[261][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[261][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[261][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[261][LB] = ActionEntry(SHIFT, 144);
   _actionMap[261][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[261][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[261][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[261][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[261][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[261][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[261][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[261][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[261][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[261][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[261][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[261][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[261][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[261][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[261][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[261][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[261][ObjSpec] = 100;
   _jumpMap[261][Constant] = 99;
   _jumpMap[261][SignedFloat] = 98;
   _jumpMap[261][SignedInt] = 97;
   _jumpMap[261][Attribute] = 96;
   _jumpMap[261][ExpressionList] = 408;
   _jumpMap[261][Function] = 95;
   _jumpMap[261][CasePrepare] = 94;
   _jumpMap[261][CaseClause] = 93;
   _jumpMap[261][Factor] = 92;
   _jumpMap[261][Term] = 91;
   _jumpMap[261][Expr] = 375;
   _actionMap[262][IDENTIFIER] = ActionEntry(SHIFT, 409);
   _actionMap[263][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[263][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[263][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[263][TRIM] = ActionEntry(SHIFT, 140);
}
void Cego::loadParser202()
{
   _actionMap[263][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[263][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[263][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[263][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[263][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[263][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[263][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[263][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[263][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[263][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[263][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[263][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[263][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[263][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[263][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[263][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[263][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[263][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[263][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[263][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[263][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[263][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[263][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[263][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[263][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[263][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[263][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[263][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[263][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[263][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[263][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[263][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[263][LB] = ActionEntry(SHIFT, 144);
   _actionMap[263][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[263][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[263][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[263][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[263][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[263][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[263][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[263][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[263][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[263][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[263][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[263][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[263][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[263][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[263][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[263][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[263][ObjSpec] = 100;
}
void Cego::loadParser203()
{
   _jumpMap[263][Constant] = 99;
   _jumpMap[263][SignedFloat] = 98;
   _jumpMap[263][SignedInt] = 97;
   _jumpMap[263][Attribute] = 96;
   _jumpMap[263][ExpressionList] = 410;
   _jumpMap[263][Function] = 95;
   _jumpMap[263][CasePrepare] = 94;
   _jumpMap[263][CaseClause] = 93;
   _jumpMap[263][Factor] = 92;
   _jumpMap[263][Term] = 91;
   _jumpMap[263][Expr] = 375;
   _actionMap[264][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[264][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[264][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[264][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[264][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[264][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[264][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[264][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[264][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[264][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[264][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[264][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[264][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[264][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[264][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[264][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[264][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[264][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[264][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[264][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[264][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[264][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[264][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[264][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[264][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[264][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[264][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[264][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[264][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[264][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[264][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[264][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[264][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[264][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[264][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[264][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[264][LB] = ActionEntry(SHIFT, 144);
   _actionMap[264][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[264][DATE] = ActionEntry(SHIFT, 109);
}
void Cego::loadParser204()
{
   _actionMap[264][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[264][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[264][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[264][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[264][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[264][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[264][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[264][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[264][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[264][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[264][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[264][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[264][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[264][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[264][ObjSpec] = 100;
   _jumpMap[264][Constant] = 99;
   _jumpMap[264][SignedFloat] = 98;
   _jumpMap[264][SignedInt] = 97;
   _jumpMap[264][Attribute] = 96;
   _jumpMap[264][Function] = 95;
   _jumpMap[264][CasePrepare] = 94;
   _jumpMap[264][CaseClause] = 93;
   _jumpMap[264][Factor] = 92;
   _jumpMap[264][Term] = 91;
   _jumpMap[264][Expr] = 411;
   _actionMap[265][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[265][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[265][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[265][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[265][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[265][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[265][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[265][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[265][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[265][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[265][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[265][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[265][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[265][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[265][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[265][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[265][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[265][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[265][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[265][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[265][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[265][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[265][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[265][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[265][MOD] = ActionEntry(SHIFT, 123);
}
void Cego::loadParser205()
{
   _actionMap[265][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[265][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[265][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[265][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[265][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[265][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[265][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[265][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[265][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[265][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[265][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[265][LB] = ActionEntry(SHIFT, 144);
   _actionMap[265][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[265][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[265][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[265][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[265][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[265][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[265][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[265][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[265][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[265][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[265][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[265][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[265][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[265][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[265][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[265][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[265][ObjSpec] = 100;
   _jumpMap[265][Constant] = 99;
   _jumpMap[265][SignedFloat] = 98;
   _jumpMap[265][SignedInt] = 97;
   _jumpMap[265][Attribute] = 96;
   _jumpMap[265][ExpressionList] = 412;
   _jumpMap[265][Function] = 95;
   _jumpMap[265][CasePrepare] = 94;
   _jumpMap[265][CaseClause] = 93;
   _jumpMap[265][Factor] = 92;
   _jumpMap[265][Term] = 91;
   _jumpMap[265][Expr] = 375;
   _actionMap[266][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[266][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[266][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[266][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[266][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[266][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[266][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[266][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[266][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[266][INT2DATE] = ActionEntry(SHIFT, 116);
}
void Cego::loadParser206()
{
   _actionMap[266][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[266][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[266][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[266][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[266][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[266][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[266][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[266][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[266][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[266][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[266][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[266][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[266][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[266][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[266][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[266][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[266][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[266][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[266][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[266][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[266][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[266][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[266][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[266][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[266][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[266][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[266][LB] = ActionEntry(SHIFT, 144);
   _actionMap[266][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[266][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[266][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[266][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[266][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[266][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[266][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[266][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[266][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[266][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[266][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[266][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[266][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[266][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[266][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[266][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[266][ObjSpec] = 100;
   _jumpMap[266][Constant] = 99;
   _jumpMap[266][SignedFloat] = 98;
   _jumpMap[266][SignedInt] = 97;
   _jumpMap[266][Attribute] = 96;
   _jumpMap[266][ExpressionList] = 413;
   _jumpMap[266][Function] = 95;
}
void Cego::loadParser207()
{
   _jumpMap[266][CasePrepare] = 94;
   _jumpMap[266][CaseClause] = 93;
   _jumpMap[266][Factor] = 92;
   _jumpMap[266][Term] = 91;
   _jumpMap[266][Expr] = 375;
   _actionMap[267][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[267][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[267][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[267][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[267][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[267][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[267][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[267][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[267][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[267][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[267][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[267][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[267][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[267][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[267][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[267][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[267][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[267][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[267][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[267][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[267][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[267][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[267][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[267][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[267][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[267][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[267][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[267][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[267][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[267][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[267][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[267][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[267][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[267][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[267][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[267][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[267][LB] = ActionEntry(SHIFT, 144);
   _actionMap[267][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[267][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[267][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[267][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[267][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[267][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[267][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[267][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
}
void Cego::loadParser208()
{
   _actionMap[267][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[267][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[267][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[267][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[267][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[267][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[267][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[267][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[267][ObjSpec] = 100;
   _jumpMap[267][Constant] = 99;
   _jumpMap[267][SignedFloat] = 98;
   _jumpMap[267][SignedInt] = 97;
   _jumpMap[267][Attribute] = 96;
   _jumpMap[267][ExpressionList] = 414;
   _jumpMap[267][Function] = 95;
   _jumpMap[267][CasePrepare] = 94;
   _jumpMap[267][CaseClause] = 93;
   _jumpMap[267][Factor] = 92;
   _jumpMap[267][Term] = 91;
   _jumpMap[267][Expr] = 375;
   _actionMap[268][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[268][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[268][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[268][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[268][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[268][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[268][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[268][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[268][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[268][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[268][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[268][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[268][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[268][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[268][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[268][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[268][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[268][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[268][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[268][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[268][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[268][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[268][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[268][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[268][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[268][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[268][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[268][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[268][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[268][BITXOR] = ActionEntry(SHIFT, 105);
}
void Cego::loadParser209()
{
   _actionMap[268][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[268][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[268][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[268][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[268][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[268][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[268][LB] = ActionEntry(SHIFT, 144);
   _actionMap[268][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[268][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[268][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[268][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[268][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[268][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[268][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[268][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[268][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[268][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[268][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[268][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[268][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[268][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[268][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[268][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[268][ObjSpec] = 100;
   _jumpMap[268][Constant] = 99;
   _jumpMap[268][SignedFloat] = 98;
   _jumpMap[268][SignedInt] = 97;
   _jumpMap[268][Attribute] = 96;
   _jumpMap[268][ExpressionList] = 415;
   _jumpMap[268][Function] = 95;
   _jumpMap[268][CasePrepare] = 94;
   _jumpMap[268][CaseClause] = 93;
   _jumpMap[268][Factor] = 92;
   _jumpMap[268][Term] = 91;
   _jumpMap[268][Expr] = 375;
   _actionMap[269][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[269][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[269][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[269][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[269][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[269][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[269][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[269][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[269][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[269][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[269][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[269][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[269][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[269][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[269][GETPOS] = ActionEntry(SHIFT, 115);
}
void Cego::loadParser210()
{
   _actionMap[269][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[269][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[269][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[269][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[269][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[269][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[269][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[269][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[269][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[269][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[269][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[269][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[269][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[269][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[269][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[269][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[269][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[269][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[269][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[269][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[269][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[269][LB] = ActionEntry(SHIFT, 144);
   _actionMap[269][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[269][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[269][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[269][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[269][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[269][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[269][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[269][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[269][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[269][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[269][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[269][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[269][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[269][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[269][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[269][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[269][ObjSpec] = 100;
   _jumpMap[269][Constant] = 99;
   _jumpMap[269][SignedFloat] = 98;
   _jumpMap[269][SignedInt] = 97;
   _jumpMap[269][Attribute] = 96;
   _jumpMap[269][ExpressionList] = 416;
   _jumpMap[269][Function] = 95;
   _jumpMap[269][CasePrepare] = 94;
   _jumpMap[269][CaseClause] = 93;
   _jumpMap[269][Factor] = 92;
   _jumpMap[269][Term] = 91;
   _jumpMap[269][Expr] = 375;
}
void Cego::loadParser211()
{
   _actionMap[270][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[270][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[270][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[270][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[270][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[270][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[270][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[270][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[270][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[270][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[270][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[270][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[270][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[270][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[270][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[270][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[270][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[270][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[270][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[270][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[270][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[270][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[270][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[270][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[270][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[270][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[270][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[270][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[270][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[270][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[270][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[270][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[270][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[270][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[270][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[270][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[270][LB] = ActionEntry(SHIFT, 144);
   _actionMap[270][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[270][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[270][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[270][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[270][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[270][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[270][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[270][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[270][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[270][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[270][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[270][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[270][SUM] = ActionEntry(SHIFT, 135);
}
void Cego::loadParser212()
{
   _actionMap[270][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[270][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[270][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[270][ObjSpec] = 100;
   _jumpMap[270][Constant] = 99;
   _jumpMap[270][SignedFloat] = 98;
   _jumpMap[270][SignedInt] = 97;
   _jumpMap[270][Attribute] = 96;
   _jumpMap[270][ExpressionList] = 417;
   _jumpMap[270][Function] = 95;
   _jumpMap[270][CasePrepare] = 94;
   _jumpMap[270][CaseClause] = 93;
   _jumpMap[270][Factor] = 92;
   _jumpMap[270][Term] = 91;
   _jumpMap[270][Expr] = 375;
   _actionMap[271][RB] = ActionEntry(SHIFT, 418);
   _actionMap[271][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[271][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[271][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[272][RB] = ActionEntry(SHIFT, 419);
   _actionMap[273][RB] = ActionEntry(SHIFT, 420);
   _actionMap[274][RB] = ActionEntry(SHIFT, 421);
   _actionMap[275][RB] = ActionEntry(SHIFT, 422);
   _actionMap[276][RB] = ActionEntry(SHIFT, 423);
   _actionMap[277][RB] = ActionEntry(SHIFT, 424);
   _actionMap[278][RB] = ActionEntry(SHIFT, 425);
   _actionMap[279][RB] = ActionEntry(SHIFT, 426);
   _actionMap[280][KSEP] = ActionEntry(SHIFT, 427);
   _actionMap[281][WHEN] = ActionEntry(REDUCE, 346);
   _actionMap[281][ELSE] = ActionEntry(REDUCE, 346);
   _actionMap[281][LEFT] = ActionEntry(REDUCE, 346);
   _actionMap[281][RIGHT] = ActionEntry(REDUCE, 346);
   _actionMap[281][INNER] = ActionEntry(REDUCE, 346);
   _actionMap[281][JOIN] = ActionEntry(REDUCE, 346);
   _actionMap[281][RETURNTOKEN] = ActionEntry(REDUCE, 346);
   _actionMap[281][ORDER] = ActionEntry(REDUCE, 346);
   _actionMap[281][GROUP] = ActionEntry(REDUCE, 346);
   _actionMap[281][WHERE] = ActionEntry(REDUCE, 346);
   _actionMap[281][AS] = ActionEntry(REDUCE, 346);
   _actionMap[281][FROM] = ActionEntry(REDUCE, 346);
   _actionMap[281][END_TOKEN] = ActionEntry(REDUCE, 346);
   _actionMap[281][BEGIN] = ActionEntry(REDUCE, 346);
   _actionMap[281][THEN] = ActionEntry(REDUCE, 346);
   _actionMap[281][OR] = ActionEntry(REDUCE, 346);
   _actionMap[281][AND] = ActionEntry(REDUCE, 346);
   _actionMap[281][NULLTOKEN] = ActionEntry(REDUCE, 346);
   _actionMap[281][LIKE] = ActionEntry(REDUCE, 346);
   _actionMap[281][IS] = ActionEntry(REDUCE, 346);
   _actionMap[281][BETWEEN] = ActionEntry(REDUCE, 346);
   _actionMap[281][NOT] = ActionEntry(REDUCE, 346);
}
void Cego::loadParser213()
{
   _actionMap[281][INTOK] = ActionEntry(REDUCE, 346);
   _actionMap[281][EQU] = ActionEntry(REDUCE, 346);
   _actionMap[281][NEGATION] = ActionEntry(REDUCE, 346);
   _actionMap[281][LT] = ActionEntry(REDUCE, 346);
   _actionMap[281][MT] = ActionEntry(REDUCE, 346);
   _actionMap[281][DESC] = ActionEntry(REDUCE, 346);
   _actionMap[281][ASC] = ActionEntry(REDUCE, 346);
   _actionMap[281][KSEP] = ActionEntry(REDUCE, 346);
   _actionMap[281][ROWLIMIT] = ActionEntry(REDUCE, 346);
   _actionMap[281][UNION] = ActionEntry(REDUCE, 346);
   _actionMap[281][ENDTOKEN] = ActionEntry(REDUCE, 346);
   _actionMap[281][RB] = ActionEntry(REDUCE, 346);
   _actionMap[281][SEMICOLON] = ActionEntry(REDUCE, 346);
   _actionMap[281][CONCAT] = ActionEntry(REDUCE, 346);
   _actionMap[281][STAR] = ActionEntry(REDUCE, 346);
   _actionMap[281][DIVISION] = ActionEntry(REDUCE, 346);
   _actionMap[281][MINUS] = ActionEntry(REDUCE, 346);
   _actionMap[281][PLUS] = ActionEntry(REDUCE, 346);
   _actionMap[282][WHEN] = ActionEntry(REDUCE, 348);
   _actionMap[282][ELSE] = ActionEntry(REDUCE, 348);
   _actionMap[282][LEFT] = ActionEntry(REDUCE, 348);
   _actionMap[282][RIGHT] = ActionEntry(REDUCE, 348);
   _actionMap[282][INNER] = ActionEntry(REDUCE, 348);
   _actionMap[282][JOIN] = ActionEntry(REDUCE, 348);
   _actionMap[282][RETURNTOKEN] = ActionEntry(REDUCE, 348);
   _actionMap[282][ORDER] = ActionEntry(REDUCE, 348);
   _actionMap[282][GROUP] = ActionEntry(REDUCE, 348);
   _actionMap[282][WHERE] = ActionEntry(REDUCE, 348);
   _actionMap[282][AS] = ActionEntry(REDUCE, 348);
   _actionMap[282][FROM] = ActionEntry(REDUCE, 348);
   _actionMap[282][END_TOKEN] = ActionEntry(REDUCE, 348);
   _actionMap[282][BEGIN] = ActionEntry(REDUCE, 348);
   _actionMap[282][THEN] = ActionEntry(REDUCE, 348);
   _actionMap[282][OR] = ActionEntry(REDUCE, 348);
   _actionMap[282][AND] = ActionEntry(REDUCE, 348);
   _actionMap[282][NULLTOKEN] = ActionEntry(REDUCE, 348);
   _actionMap[282][LIKE] = ActionEntry(REDUCE, 348);
   _actionMap[282][IS] = ActionEntry(REDUCE, 348);
   _actionMap[282][BETWEEN] = ActionEntry(REDUCE, 348);
   _actionMap[282][NOT] = ActionEntry(REDUCE, 348);
   _actionMap[282][INTOK] = ActionEntry(REDUCE, 348);
   _actionMap[282][EQU] = ActionEntry(REDUCE, 348);
   _actionMap[282][NEGATION] = ActionEntry(REDUCE, 348);
   _actionMap[282][LT] = ActionEntry(REDUCE, 348);
   _actionMap[282][MT] = ActionEntry(REDUCE, 348);
   _actionMap[282][DESC] = ActionEntry(REDUCE, 348);
   _actionMap[282][ASC] = ActionEntry(REDUCE, 348);
   _actionMap[282][KSEP] = ActionEntry(REDUCE, 348);
   _actionMap[282][ROWLIMIT] = ActionEntry(REDUCE, 348);
   _actionMap[282][UNION] = ActionEntry(REDUCE, 348);
}
void Cego::loadParser214()
{
   _actionMap[282][ENDTOKEN] = ActionEntry(REDUCE, 348);
   _actionMap[282][RB] = ActionEntry(REDUCE, 348);
   _actionMap[282][SEMICOLON] = ActionEntry(REDUCE, 348);
   _actionMap[282][CONCAT] = ActionEntry(REDUCE, 348);
   _actionMap[282][STAR] = ActionEntry(REDUCE, 348);
   _actionMap[282][DIVISION] = ActionEntry(REDUCE, 348);
   _actionMap[282][MINUS] = ActionEntry(REDUCE, 348);
   _actionMap[282][PLUS] = ActionEntry(REDUCE, 348);
   _actionMap[283][WHEN] = ActionEntry(REDUCE, 344);
   _actionMap[283][ELSE] = ActionEntry(REDUCE, 344);
   _actionMap[283][LEFT] = ActionEntry(REDUCE, 344);
   _actionMap[283][RIGHT] = ActionEntry(REDUCE, 344);
   _actionMap[283][INNER] = ActionEntry(REDUCE, 344);
   _actionMap[283][JOIN] = ActionEntry(REDUCE, 344);
   _actionMap[283][RETURNTOKEN] = ActionEntry(REDUCE, 344);
   _actionMap[283][GROUP] = ActionEntry(REDUCE, 344);
   _actionMap[283][WHERE] = ActionEntry(REDUCE, 344);
   _actionMap[283][FROM] = ActionEntry(REDUCE, 344);
   _actionMap[283][AS] = ActionEntry(REDUCE, 344);
   _actionMap[283][END_TOKEN] = ActionEntry(REDUCE, 344);
   _actionMap[283][BEGIN] = ActionEntry(REDUCE, 344);
   _actionMap[283][THEN] = ActionEntry(REDUCE, 344);
   _actionMap[283][OR] = ActionEntry(REDUCE, 344);
   _actionMap[283][AND] = ActionEntry(REDUCE, 344);
   _actionMap[283][INTOK] = ActionEntry(REDUCE, 344);
   _actionMap[283][NOT] = ActionEntry(REDUCE, 344);
   _actionMap[283][BETWEEN] = ActionEntry(REDUCE, 344);
   _actionMap[283][IS] = ActionEntry(REDUCE, 344);
   _actionMap[283][LIKE] = ActionEntry(REDUCE, 344);
   _actionMap[283][HAVING] = ActionEntry(REDUCE, 344);
   _actionMap[283][ORDER] = ActionEntry(REDUCE, 344);
   _actionMap[283][MT] = ActionEntry(REDUCE, 344);
   _actionMap[283][LT] = ActionEntry(REDUCE, 344);
   _actionMap[283][NEGATION] = ActionEntry(REDUCE, 344);
   _actionMap[283][EQU] = ActionEntry(REDUCE, 344);
   _actionMap[283][RB] = ActionEntry(REDUCE, 344);
   _actionMap[283][ENDTOKEN] = ActionEntry(REDUCE, 344);
   _actionMap[283][UNION] = ActionEntry(REDUCE, 344);
   _actionMap[283][ROWLIMIT] = ActionEntry(REDUCE, 344);
   _actionMap[283][KSEP] = ActionEntry(REDUCE, 344);
   _actionMap[283][ASC] = ActionEntry(REDUCE, 344);
   _actionMap[283][DESC] = ActionEntry(REDUCE, 344);
   _actionMap[283][SEMICOLON] = ActionEntry(REDUCE, 344);
   _actionMap[283][PLUS] = ActionEntry(REDUCE, 344);
   _actionMap[283][MINUS] = ActionEntry(REDUCE, 344);
   _actionMap[283][DIVISION] = ActionEntry(REDUCE, 344);
   _actionMap[283][STAR] = ActionEntry(REDUCE, 344);
   _actionMap[283][CONCAT] = ActionEntry(REDUCE, 344);
   _actionMap[284][TO] = ActionEntry(SHIFT, 428);
   _actionMap[285][TO] = ActionEntry(SHIFT, 429);
}
void Cego::loadParser215()
{
   _actionMap[286][TO] = ActionEntry(SHIFT, 430);
   _actionMap[287][TO] = ActionEntry(SHIFT, 431);
   _actionMap[288][TO] = ActionEntry(SHIFT, 432);
   _actionMap[289][TO] = ActionEntry(SHIFT, 433);
   _actionMap[290][SEMICOLON] = ActionEntry(REDUCE, 40);
   _actionMap[291][SEMICOLON] = ActionEntry(REDUCE, 39);
   _actionMap[292][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[292][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[292][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[292][ObjSpec] = 438;
   _jumpMap[292][Table] = 437;
   _jumpMap[292][TableList] = 436;
   _jumpMap[292][JoinSpecList] = 435;
   _jumpMap[292][TableSource] = 434;
   _actionMap[293][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[293][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[293][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[293][FROM] = ActionEntry(REDUCE, 224);
   _actionMap[293][AS] = ActionEntry(SHIFT, 441);
   _actionMap[293][KSEP] = ActionEntry(REDUCE, 224);
   _jumpMap[293][NoAliasOpt] = 440;
   _jumpMap[293][AliasOpt] = 439;
   _actionMap[294][KSEP] = ActionEntry(SHIFT, 442);
   _actionMap[294][FROM] = ActionEntry(REDUCE, 203);
   _actionMap[295][FROM] = ActionEntry(REDUCE, 206);
   _actionMap[295][KSEP] = ActionEntry(REDUCE, 206);
   _actionMap[296][SEMICOLON] = ActionEntry(REDUCE, 35);
   _actionMap[297][SEMICOLON] = ActionEntry(REDUCE, 34);
   _actionMap[298][SEMICOLON] = ActionEntry(REDUCE, 37);
   _actionMap[299][SEMICOLON] = ActionEntry(REDUCE, 36);
   _actionMap[300][TO] = ActionEntry(SHIFT, 443);
   _actionMap[301][SEMICOLON] = ActionEntry(REDUCE, 38);
   _actionMap[302][SEMICOLON] = ActionEntry(REDUCE, 29);
   _actionMap[303][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[303][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[303][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[303][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[303][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[303][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[303][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[303][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[303][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[303][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[303][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[303][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[303][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[303][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[303][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[303][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[303][REPLACE] = ActionEntry(SHIFT, 129);
}
void Cego::loadParser216()
{
   _actionMap[303][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[303][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[303][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[303][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[303][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[303][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[303][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[303][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[303][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[303][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[303][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[303][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[303][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[303][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[303][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[303][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[303][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[303][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[303][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[303][LB] = ActionEntry(SHIFT, 144);
   _actionMap[303][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[303][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[303][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[303][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[303][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[303][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[303][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[303][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[303][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[303][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[303][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[303][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[303][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[303][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[303][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[303][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[303][ObjSpec] = 100;
   _jumpMap[303][Constant] = 99;
   _jumpMap[303][SignedFloat] = 98;
   _jumpMap[303][SignedInt] = 97;
   _jumpMap[303][Attribute] = 96;
   _jumpMap[303][Function] = 95;
   _jumpMap[303][CasePrepare] = 94;
   _jumpMap[303][CaseClause] = 93;
   _jumpMap[303][Factor] = 92;
   _jumpMap[303][Term] = 91;
   _jumpMap[303][Expr] = 444;
   _actionMap[304][SEMICOLON] = ActionEntry(REDUCE, 28);
   _actionMap[305][SEMICOLON] = ActionEntry(REDUCE, 26);
   _actionMap[306][SEMICOLON] = ActionEntry(REDUCE, 27);
}
void Cego::loadParser217()
{
   _actionMap[307][SET] = ActionEntry(SHIFT, 308);
   _actionMap[308][IDENTIFIER] = ActionEntry(SHIFT, 447);
   _jumpMap[308][Assignment] = 446;
   _jumpMap[308][UpdateList] = 445;
   _actionMap[309][SET] = ActionEntry(REDUCE, 257);
   _actionMap[309][WHERE] = ActionEntry(REDUCE, 257);
   _actionMap[309][GROUP] = ActionEntry(REDUCE, 257);
   _actionMap[309][ORDER] = ActionEntry(REDUCE, 257);
   _actionMap[309][ROWLIMIT] = ActionEntry(REDUCE, 257);
   _actionMap[309][UNION] = ActionEntry(REDUCE, 257);
   _actionMap[309][ENDTOKEN] = ActionEntry(REDUCE, 257);
   _actionMap[309][RB] = ActionEntry(REDUCE, 257);
   _actionMap[309][SEMICOLON] = ActionEntry(REDUCE, 257);
   _actionMap[309][RETURNTOKEN] = ActionEntry(REDUCE, 257);
   _actionMap[310][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[310][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[310][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[310][ObjSpec] = 448;
   _actionMap[39][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[39][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[39][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[39][ObjSpec] = 180;
   _actionMap[40][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[40][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[40][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[40][ObjSpec] = 181;
   _actionMap[41][IDENTIFIER] = ActionEntry(SHIFT, 183);
   _jumpMap[41][CounterId] = 182;
   _actionMap[42][KEY] = ActionEntry(SHIFT, 184);
   _actionMap[43][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[43][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[43][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[43][ObjSpec] = 185;
   _actionMap[44][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[44][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[44][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[44][ObjSpec] = 186;
   _actionMap[45][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[45][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[45][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[45][ObjSpec] = 187;
   _actionMap[46][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[46][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[46][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[46][ObjSpec] = 188;
   _actionMap[47][ENDTOKEN] = ActionEntry(ACCEPT, 0);
   _actionMap[48][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[48][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[48][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[48][ObjSpec] = 189;
}
void Cego::loadParser218()
{
   _actionMap[49][IDENTIFIED] = ActionEntry(SHIFT, 190);
   _actionMap[50][LB] = ActionEntry(SHIFT, 191);
   _actionMap[51][TO] = ActionEntry(REDUCE, 367);
   _actionMap[51][VALUES] = ActionEntry(REDUCE, 367);
   _actionMap[51][SELECT] = ActionEntry(REDUCE, 367);
   _actionMap[51][SET] = ActionEntry(REDUCE, 367);
   _actionMap[51][AS] = ActionEntry(REDUCE, 367);
   _actionMap[51][DROP] = ActionEntry(REDUCE, 367);
   _actionMap[51][MODIFY] = ActionEntry(REDUCE, 367);
   _actionMap[51][RENAME] = ActionEntry(REDUCE, 367);
   _actionMap[51][ADD] = ActionEntry(REDUCE, 367);
   _actionMap[51][JOIN] = ActionEntry(REDUCE, 367);
   _actionMap[51][INNER] = ActionEntry(REDUCE, 367);
   _actionMap[51][RIGHT] = ActionEntry(REDUCE, 367);
   _actionMap[51][LEFT] = ActionEntry(REDUCE, 367);
   _actionMap[51][KSEP] = ActionEntry(REDUCE, 367);
   _actionMap[51][RETURNTOKEN] = ActionEntry(REDUCE, 367);
   _actionMap[51][SEMICOLON] = ActionEntry(REDUCE, 367);
   _actionMap[51][RB] = ActionEntry(REDUCE, 367);
   _actionMap[51][ENDTOKEN] = ActionEntry(REDUCE, 367);
   _actionMap[51][UNION] = ActionEntry(REDUCE, 367);
   _actionMap[51][ROWLIMIT] = ActionEntry(REDUCE, 367);
   _actionMap[51][ORDER] = ActionEntry(REDUCE, 367);
   _actionMap[51][GROUP] = ActionEntry(REDUCE, 367);
   _actionMap[51][WHERE] = ActionEntry(REDUCE, 367);
   _actionMap[51][LB] = ActionEntry(REDUCE, 367);
   _actionMap[51][IDENTIFIER] = ActionEntry(REDUCE, 367);
   _actionMap[51][ON] = ActionEntry(REDUCE, 367);
   _actionMap[52][TO] = ActionEntry(REDUCE, 368);
   _actionMap[52][VALUES] = ActionEntry(REDUCE, 368);
   _actionMap[52][SELECT] = ActionEntry(REDUCE, 368);
   _actionMap[52][SET] = ActionEntry(REDUCE, 368);
   _actionMap[52][AS] = ActionEntry(REDUCE, 368);
   _actionMap[52][DROP] = ActionEntry(REDUCE, 368);
   _actionMap[52][MODIFY] = ActionEntry(REDUCE, 368);
   _actionMap[52][RENAME] = ActionEntry(REDUCE, 368);
   _actionMap[52][ADD] = ActionEntry(REDUCE, 368);
   _actionMap[52][JOIN] = ActionEntry(REDUCE, 368);
   _actionMap[52][INNER] = ActionEntry(REDUCE, 368);
   _actionMap[52][RIGHT] = ActionEntry(REDUCE, 368);
   _actionMap[52][LEFT] = ActionEntry(REDUCE, 368);
   _actionMap[52][KSEP] = ActionEntry(REDUCE, 368);
   _actionMap[52][RETURNTOKEN] = ActionEntry(REDUCE, 368);
   _actionMap[52][SEMICOLON] = ActionEntry(REDUCE, 368);
   _actionMap[52][RB] = ActionEntry(REDUCE, 368);
   _actionMap[52][ENDTOKEN] = ActionEntry(REDUCE, 368);
   _actionMap[52][UNION] = ActionEntry(REDUCE, 368);
   _actionMap[52][ROWLIMIT] = ActionEntry(REDUCE, 368);
   _actionMap[52][ORDER] = ActionEntry(REDUCE, 368);
   _actionMap[52][GROUP] = ActionEntry(REDUCE, 368);
}
void Cego::loadParser219()
{
   _actionMap[52][WHERE] = ActionEntry(REDUCE, 368);
   _actionMap[52][LB] = ActionEntry(REDUCE, 368);
   _actionMap[52][IDENTIFIER] = ActionEntry(REDUCE, 368);
   _actionMap[52][ON] = ActionEntry(REDUCE, 368);
   _actionMap[53][TO] = ActionEntry(REDUCE, 369);
   _actionMap[53][VALUES] = ActionEntry(REDUCE, 369);
   _actionMap[53][SELECT] = ActionEntry(REDUCE, 369);
   _actionMap[53][SET] = ActionEntry(REDUCE, 369);
   _actionMap[53][AS] = ActionEntry(REDUCE, 369);
   _actionMap[53][DROP] = ActionEntry(REDUCE, 369);
   _actionMap[53][MODIFY] = ActionEntry(REDUCE, 369);
   _actionMap[53][RENAME] = ActionEntry(REDUCE, 369);
   _actionMap[53][ADD] = ActionEntry(REDUCE, 369);
   _actionMap[53][JOIN] = ActionEntry(REDUCE, 369);
   _actionMap[53][INNER] = ActionEntry(REDUCE, 369);
   _actionMap[53][RIGHT] = ActionEntry(REDUCE, 369);
   _actionMap[53][LEFT] = ActionEntry(REDUCE, 369);
   _actionMap[53][KSEP] = ActionEntry(REDUCE, 369);
   _actionMap[53][RETURNTOKEN] = ActionEntry(REDUCE, 369);
   _actionMap[53][SEMICOLON] = ActionEntry(REDUCE, 369);
   _actionMap[53][RB] = ActionEntry(REDUCE, 369);
   _actionMap[53][ENDTOKEN] = ActionEntry(REDUCE, 369);
   _actionMap[53][UNION] = ActionEntry(REDUCE, 369);
   _actionMap[53][ROWLIMIT] = ActionEntry(REDUCE, 369);
   _actionMap[53][ORDER] = ActionEntry(REDUCE, 369);
   _actionMap[53][GROUP] = ActionEntry(REDUCE, 369);
   _actionMap[53][WHERE] = ActionEntry(REDUCE, 369);
   _actionMap[53][IDENTIFIER] = ActionEntry(REDUCE, 369);
   _actionMap[53][ON] = ActionEntry(REDUCE, 369);
   _actionMap[53][LB] = ActionEntry(REDUCE, 369);
   _actionMap[54][IDENTIFIER] = ActionEntry(SHIFT, 192);
   _actionMap[55][BEGIN] = ActionEntry(SHIFT, 193);
   _actionMap[56][SEMICOLON] = ActionEntry(REDUCE, 50);
   _actionMap[57][INDEX] = ActionEntry(SHIFT, 196);
   _actionMap[57][BTREE] = ActionEntry(SHIFT, 195);
   _jumpMap[57][IndexType] = 194;
   _actionMap[58][IDENTIFIER] = ActionEntry(SHIFT, 183);
   _jumpMap[58][CounterId] = 197;
   _actionMap[59][INDEX] = ActionEntry(SHIFT, 196);
   _actionMap[59][BTREE] = ActionEntry(SHIFT, 195);
   _jumpMap[59][IndexType] = 198;
   _actionMap[60][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[60][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[60][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[60][ObjSpec] = 199;
   _actionMap[61][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[61][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[61][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[61][ObjSpec] = 200;
   _actionMap[62][INDEX] = ActionEntry(REDUCE, 183);
}
void Cego::loadParser220()
{
   _actionMap[62][BTREE] = ActionEntry(REDUCE, 183);
   _actionMap[63][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[63][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[63][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[63][ObjSpec] = 201;
   _actionMap[64][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[64][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[64][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[64][ObjSpec] = 202;
   _actionMap[65][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[65][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[65][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[65][ObjSpec] = 203;
   _actionMap[66][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[66][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[66][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[66][ObjSpec] = 204;
   _actionMap[67][KEY] = ActionEntry(SHIFT, 205);
   _actionMap[68][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[68][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[68][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[68][ObjSpec] = 206;
   _actionMap[69][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[69][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[69][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[69][ObjSpec] = 207;
   _actionMap[70][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[70][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[70][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[70][ObjSpec] = 208;
   _actionMap[71][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[71][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[71][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[71][ObjSpec] = 209;
   _actionMap[72][EXISTS] = ActionEntry(SHIFT, 210);
   _actionMap[73][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[73][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[73][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[73][ObjSpec] = 211;
   _actionMap[74][IDENTIFIER] = ActionEntry(SHIFT, 212);
   _actionMap[74][SEMICOLON] = ActionEntry(REDUCE, 75);
   _actionMap[75][IDENTIFIER] = ActionEntry(REDUCE, 77);
   _actionMap[75][SEMICOLON] = ActionEntry(REDUCE, 77);
   _actionMap[76][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[76][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[76][TableSetOpt] = 213;
   _actionMap[77][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[77][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[77][TableSetOpt] = 215;
   _actionMap[78][FOR] = ActionEntry(SHIFT, 214);
}
void Cego::loadParser221()
{
   _actionMap[78][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[78][TableSetOpt] = 216;
   _actionMap[79][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[79][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[79][TableSetOpt] = 217;
   _actionMap[80][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[80][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[80][TableSetOpt] = 218;
   _actionMap[81][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[81][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[81][TableSetOpt] = 219;
   _actionMap[82][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[82][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[82][TableSetOpt] = 220;
   _actionMap[83][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[83][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[83][TableSetOpt] = 221;
   _actionMap[84][SEMICOLON] = ActionEntry(REDUCE, 2);
   _actionMap[85][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[85][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[85][TableSetOpt] = 222;
   _actionMap[86][FOR] = ActionEntry(SHIFT, 214);
   _actionMap[86][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[86][TableSetOpt] = 223;
   _actionMap[87][SEMICOLON] = ActionEntry(REDUCE, 51);
   _actionMap[88][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[88][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[88][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[88][ObjSpec] = 224;
   _actionMap[89][SEMICOLON] = ActionEntry(REDUCE, 42);
   _actionMap[90][PLUS] = ActionEntry(SHIFT, 227);
   _actionMap[90][MINUS] = ActionEntry(SHIFT, 226);
   _actionMap[90][CONCAT] = ActionEntry(SHIFT, 225);
   _actionMap[90][SEMICOLON] = ActionEntry(REDUCE, 69);
   _actionMap[91][STAR] = ActionEntry(SHIFT, 228);
   _actionMap[91][DIVISION] = ActionEntry(SHIFT, 229);
   _actionMap[91][WHEN] = ActionEntry(REDUCE, 142);
   _actionMap[91][ELSE] = ActionEntry(REDUCE, 142);
   _actionMap[91][LEFT] = ActionEntry(REDUCE, 142);
   _actionMap[91][RIGHT] = ActionEntry(REDUCE, 142);
   _actionMap[91][INNER] = ActionEntry(REDUCE, 142);
   _actionMap[91][JOIN] = ActionEntry(REDUCE, 142);
   _actionMap[91][RETURNTOKEN] = ActionEntry(REDUCE, 142);
   _actionMap[91][ORDER] = ActionEntry(REDUCE, 142);
   _actionMap[91][GROUP] = ActionEntry(REDUCE, 142);
   _actionMap[91][WHERE] = ActionEntry(REDUCE, 142);
   _actionMap[91][BEGIN] = ActionEntry(REDUCE, 142);
   _actionMap[91][THEN] = ActionEntry(REDUCE, 142);
   _actionMap[91][OR] = ActionEntry(REDUCE, 142);
   _actionMap[91][AS] = ActionEntry(REDUCE, 142);
}
void Cego::loadParser222()
{
   _actionMap[91][FROM] = ActionEntry(REDUCE, 142);
   _actionMap[91][END_TOKEN] = ActionEntry(REDUCE, 142);
   _actionMap[91][AND] = ActionEntry(REDUCE, 142);
   _actionMap[91][LIKE] = ActionEntry(REDUCE, 142);
   _actionMap[91][IS] = ActionEntry(REDUCE, 142);
   _actionMap[91][BETWEEN] = ActionEntry(REDUCE, 142);
   _actionMap[91][NOT] = ActionEntry(REDUCE, 142);
   _actionMap[91][INTOK] = ActionEntry(REDUCE, 142);
   _actionMap[91][EQU] = ActionEntry(REDUCE, 142);
   _actionMap[91][NEGATION] = ActionEntry(REDUCE, 142);
   _actionMap[91][LT] = ActionEntry(REDUCE, 142);
   _actionMap[91][MT] = ActionEntry(REDUCE, 142);
   _actionMap[91][DESC] = ActionEntry(REDUCE, 142);
   _actionMap[91][ASC] = ActionEntry(REDUCE, 142);
   _actionMap[91][KSEP] = ActionEntry(REDUCE, 142);
   _actionMap[91][ROWLIMIT] = ActionEntry(REDUCE, 142);
   _actionMap[91][UNION] = ActionEntry(REDUCE, 142);
   _actionMap[91][ENDTOKEN] = ActionEntry(REDUCE, 142);
   _actionMap[91][RB] = ActionEntry(REDUCE, 142);
   _actionMap[91][SEMICOLON] = ActionEntry(REDUCE, 142);
   _actionMap[91][CONCAT] = ActionEntry(REDUCE, 142);
   _actionMap[91][MINUS] = ActionEntry(REDUCE, 142);
   _actionMap[91][PLUS] = ActionEntry(REDUCE, 142);
   _actionMap[92][WHEN] = ActionEntry(REDUCE, 146);
   _actionMap[92][ELSE] = ActionEntry(REDUCE, 146);
   _actionMap[92][LEFT] = ActionEntry(REDUCE, 146);
   _actionMap[92][RIGHT] = ActionEntry(REDUCE, 146);
   _actionMap[92][INNER] = ActionEntry(REDUCE, 146);
   _actionMap[92][JOIN] = ActionEntry(REDUCE, 146);
   _actionMap[92][RETURNTOKEN] = ActionEntry(REDUCE, 146);
   _actionMap[92][ORDER] = ActionEntry(REDUCE, 146);
   _actionMap[92][GROUP] = ActionEntry(REDUCE, 146);
   _actionMap[92][WHERE] = ActionEntry(REDUCE, 146);
   _actionMap[92][BEGIN] = ActionEntry(REDUCE, 146);
   _actionMap[92][THEN] = ActionEntry(REDUCE, 146);
   _actionMap[92][OR] = ActionEntry(REDUCE, 146);
   _actionMap[92][FROM] = ActionEntry(REDUCE, 146);
   _actionMap[92][AS] = ActionEntry(REDUCE, 146);
   _actionMap[92][END_TOKEN] = ActionEntry(REDUCE, 146);
   _actionMap[92][AND] = ActionEntry(REDUCE, 146);
   _actionMap[92][INTOK] = ActionEntry(REDUCE, 146);
   _actionMap[92][NOT] = ActionEntry(REDUCE, 146);
   _actionMap[92][BETWEEN] = ActionEntry(REDUCE, 146);
   _actionMap[92][IS] = ActionEntry(REDUCE, 146);
   _actionMap[92][LIKE] = ActionEntry(REDUCE, 146);
   _actionMap[92][MT] = ActionEntry(REDUCE, 146);
   _actionMap[92][LT] = ActionEntry(REDUCE, 146);
   _actionMap[92][NEGATION] = ActionEntry(REDUCE, 146);
   _actionMap[92][EQU] = ActionEntry(REDUCE, 146);
   _actionMap[92][RB] = ActionEntry(REDUCE, 146);
}
void Cego::loadParser223()
{
   _actionMap[92][ENDTOKEN] = ActionEntry(REDUCE, 146);
   _actionMap[92][UNION] = ActionEntry(REDUCE, 146);
   _actionMap[92][ROWLIMIT] = ActionEntry(REDUCE, 146);
   _actionMap[92][KSEP] = ActionEntry(REDUCE, 146);
   _actionMap[92][ASC] = ActionEntry(REDUCE, 146);
   _actionMap[92][DESC] = ActionEntry(REDUCE, 146);
   _actionMap[92][SEMICOLON] = ActionEntry(REDUCE, 146);
   _actionMap[92][PLUS] = ActionEntry(REDUCE, 146);
   _actionMap[92][MINUS] = ActionEntry(REDUCE, 146);
   _actionMap[92][DIVISION] = ActionEntry(REDUCE, 146);
   _actionMap[92][STAR] = ActionEntry(REDUCE, 146);
   _actionMap[92][CONCAT] = ActionEntry(REDUCE, 146);
   _actionMap[93][WHEN] = ActionEntry(REDUCE, 154);
   _actionMap[93][ELSE] = ActionEntry(REDUCE, 154);
   _actionMap[93][LEFT] = ActionEntry(REDUCE, 154);
   _actionMap[93][RIGHT] = ActionEntry(REDUCE, 154);
   _actionMap[93][INNER] = ActionEntry(REDUCE, 154);
   _actionMap[93][JOIN] = ActionEntry(REDUCE, 154);
   _actionMap[93][RETURNTOKEN] = ActionEntry(REDUCE, 154);
   _actionMap[93][ORDER] = ActionEntry(REDUCE, 154);
   _actionMap[93][GROUP] = ActionEntry(REDUCE, 154);
   _actionMap[93][WHERE] = ActionEntry(REDUCE, 154);
   _actionMap[93][BEGIN] = ActionEntry(REDUCE, 154);
   _actionMap[93][THEN] = ActionEntry(REDUCE, 154);
   _actionMap[93][OR] = ActionEntry(REDUCE, 154);
   _actionMap[93][AS] = ActionEntry(REDUCE, 154);
   _actionMap[93][FROM] = ActionEntry(REDUCE, 154);
   _actionMap[93][END_TOKEN] = ActionEntry(REDUCE, 154);
   _actionMap[93][AND] = ActionEntry(REDUCE, 154);
   _actionMap[93][LIKE] = ActionEntry(REDUCE, 154);
   _actionMap[93][IS] = ActionEntry(REDUCE, 154);
   _actionMap[93][BETWEEN] = ActionEntry(REDUCE, 154);
   _actionMap[93][NOT] = ActionEntry(REDUCE, 154);
   _actionMap[93][INTOK] = ActionEntry(REDUCE, 154);
   _actionMap[93][EQU] = ActionEntry(REDUCE, 154);
   _actionMap[93][NEGATION] = ActionEntry(REDUCE, 154);
   _actionMap[93][LT] = ActionEntry(REDUCE, 154);
   _actionMap[93][MT] = ActionEntry(REDUCE, 154);
   _actionMap[93][DESC] = ActionEntry(REDUCE, 154);
   _actionMap[93][ASC] = ActionEntry(REDUCE, 154);
   _actionMap[93][KSEP] = ActionEntry(REDUCE, 154);
   _actionMap[93][ROWLIMIT] = ActionEntry(REDUCE, 154);
   _actionMap[93][UNION] = ActionEntry(REDUCE, 154);
   _actionMap[93][ENDTOKEN] = ActionEntry(REDUCE, 154);
   _actionMap[93][RB] = ActionEntry(REDUCE, 154);
   _actionMap[93][SEMICOLON] = ActionEntry(REDUCE, 154);
   _actionMap[93][CONCAT] = ActionEntry(REDUCE, 154);
   _actionMap[93][STAR] = ActionEntry(REDUCE, 154);
   _actionMap[93][DIVISION] = ActionEntry(REDUCE, 154);
   _actionMap[93][MINUS] = ActionEntry(REDUCE, 154);
}
void Cego::loadParser224()
{
   _actionMap[93][PLUS] = ActionEntry(REDUCE, 154);
   _actionMap[94][WHEN] = ActionEntry(SHIFT, 232);
   _jumpMap[94][CaseCondition] = 231;
   _jumpMap[94][CaseConditionList] = 230;
   _actionMap[95][WHEN] = ActionEntry(REDUCE, 151);
   _actionMap[95][ELSE] = ActionEntry(REDUCE, 151);
   _actionMap[95][LEFT] = ActionEntry(REDUCE, 151);
   _actionMap[95][RIGHT] = ActionEntry(REDUCE, 151);
   _actionMap[95][INNER] = ActionEntry(REDUCE, 151);
   _actionMap[95][JOIN] = ActionEntry(REDUCE, 151);
   _actionMap[95][RETURNTOKEN] = ActionEntry(REDUCE, 151);
   _actionMap[95][ORDER] = ActionEntry(REDUCE, 151);
   _actionMap[95][GROUP] = ActionEntry(REDUCE, 151);
   _actionMap[95][WHERE] = ActionEntry(REDUCE, 151);
   _actionMap[95][BEGIN] = ActionEntry(REDUCE, 151);
   _actionMap[95][THEN] = ActionEntry(REDUCE, 151);
   _actionMap[95][OR] = ActionEntry(REDUCE, 151);
   _actionMap[95][AS] = ActionEntry(REDUCE, 151);
   _actionMap[95][FROM] = ActionEntry(REDUCE, 151);
   _actionMap[95][END_TOKEN] = ActionEntry(REDUCE, 151);
   _actionMap[95][AND] = ActionEntry(REDUCE, 151);
   _actionMap[95][LIKE] = ActionEntry(REDUCE, 151);
   _actionMap[95][IS] = ActionEntry(REDUCE, 151);
   _actionMap[95][BETWEEN] = ActionEntry(REDUCE, 151);
   _actionMap[95][NOT] = ActionEntry(REDUCE, 151);
   _actionMap[95][INTOK] = ActionEntry(REDUCE, 151);
   _actionMap[95][EQU] = ActionEntry(REDUCE, 151);
   _actionMap[95][NEGATION] = ActionEntry(REDUCE, 151);
   _actionMap[95][LT] = ActionEntry(REDUCE, 151);
   _actionMap[95][MT] = ActionEntry(REDUCE, 151);
   _actionMap[95][DESC] = ActionEntry(REDUCE, 151);
   _actionMap[95][ASC] = ActionEntry(REDUCE, 151);
   _actionMap[95][KSEP] = ActionEntry(REDUCE, 151);
   _actionMap[95][ROWLIMIT] = ActionEntry(REDUCE, 151);
   _actionMap[95][UNION] = ActionEntry(REDUCE, 151);
   _actionMap[95][ENDTOKEN] = ActionEntry(REDUCE, 151);
   _actionMap[95][RB] = ActionEntry(REDUCE, 151);
   _actionMap[95][SEMICOLON] = ActionEntry(REDUCE, 151);
   _actionMap[95][CONCAT] = ActionEntry(REDUCE, 151);
   _actionMap[95][STAR] = ActionEntry(REDUCE, 151);
   _actionMap[95][DIVISION] = ActionEntry(REDUCE, 151);
   _actionMap[95][MINUS] = ActionEntry(REDUCE, 151);
   _actionMap[95][PLUS] = ActionEntry(REDUCE, 151);
   _actionMap[96][WHEN] = ActionEntry(REDUCE, 150);
   _actionMap[96][ELSE] = ActionEntry(REDUCE, 150);
   _actionMap[96][LEFT] = ActionEntry(REDUCE, 150);
   _actionMap[96][RIGHT] = ActionEntry(REDUCE, 150);
   _actionMap[96][INNER] = ActionEntry(REDUCE, 150);
   _actionMap[96][JOIN] = ActionEntry(REDUCE, 150);
   _actionMap[96][RETURNTOKEN] = ActionEntry(REDUCE, 150);
}
void Cego::loadParser225()
{
   _actionMap[96][ORDER] = ActionEntry(REDUCE, 150);
   _actionMap[96][GROUP] = ActionEntry(REDUCE, 150);
   _actionMap[96][WHERE] = ActionEntry(REDUCE, 150);
   _actionMap[96][AS] = ActionEntry(REDUCE, 150);
   _actionMap[96][FROM] = ActionEntry(REDUCE, 150);
   _actionMap[96][END_TOKEN] = ActionEntry(REDUCE, 150);
   _actionMap[96][BEGIN] = ActionEntry(REDUCE, 150);
   _actionMap[96][THEN] = ActionEntry(REDUCE, 150);
   _actionMap[96][OR] = ActionEntry(REDUCE, 150);
   _actionMap[96][AND] = ActionEntry(REDUCE, 150);
   _actionMap[96][LIKE] = ActionEntry(REDUCE, 150);
   _actionMap[96][IS] = ActionEntry(REDUCE, 150);
   _actionMap[96][BETWEEN] = ActionEntry(REDUCE, 150);
   _actionMap[96][NOT] = ActionEntry(REDUCE, 150);
   _actionMap[96][INTOK] = ActionEntry(REDUCE, 150);
   _actionMap[96][EQU] = ActionEntry(REDUCE, 150);
   _actionMap[96][NEGATION] = ActionEntry(REDUCE, 150);
   _actionMap[96][LT] = ActionEntry(REDUCE, 150);
   _actionMap[96][MT] = ActionEntry(REDUCE, 150);
   _actionMap[96][DESC] = ActionEntry(REDUCE, 150);
   _actionMap[96][ASC] = ActionEntry(REDUCE, 150);
   _actionMap[96][KSEP] = ActionEntry(REDUCE, 150);
   _actionMap[96][ROWLIMIT] = ActionEntry(REDUCE, 150);
   _actionMap[96][UNION] = ActionEntry(REDUCE, 150);
   _actionMap[96][ENDTOKEN] = ActionEntry(REDUCE, 150);
   _actionMap[96][RB] = ActionEntry(REDUCE, 150);
   _actionMap[96][SEMICOLON] = ActionEntry(REDUCE, 150);
   _actionMap[96][CONCAT] = ActionEntry(REDUCE, 150);
   _actionMap[96][STAR] = ActionEntry(REDUCE, 150);
   _actionMap[96][DIVISION] = ActionEntry(REDUCE, 150);
   _actionMap[96][MINUS] = ActionEntry(REDUCE, 150);
   _actionMap[96][PLUS] = ActionEntry(REDUCE, 150);
   _actionMap[97][WHEN] = ActionEntry(REDUCE, 349);
   _actionMap[97][ELSE] = ActionEntry(REDUCE, 349);
   _actionMap[97][LEFT] = ActionEntry(REDUCE, 349);
   _actionMap[97][RIGHT] = ActionEntry(REDUCE, 349);
   _actionMap[97][INNER] = ActionEntry(REDUCE, 349);
   _actionMap[97][JOIN] = ActionEntry(REDUCE, 349);
   _actionMap[97][RETURNTOKEN] = ActionEntry(REDUCE, 349);
   _actionMap[97][ORDER] = ActionEntry(REDUCE, 349);
   _actionMap[97][GROUP] = ActionEntry(REDUCE, 349);
   _actionMap[97][WHERE] = ActionEntry(REDUCE, 349);
   _actionMap[97][NULLTOKEN] = ActionEntry(REDUCE, 349);
   _actionMap[97][FROM] = ActionEntry(REDUCE, 349);
   _actionMap[97][AS] = ActionEntry(REDUCE, 349);
   _actionMap[97][END_TOKEN] = ActionEntry(REDUCE, 349);
   _actionMap[97][BEGIN] = ActionEntry(REDUCE, 349);
   _actionMap[97][THEN] = ActionEntry(REDUCE, 349);
   _actionMap[97][OR] = ActionEntry(REDUCE, 349);
   _actionMap[97][AND] = ActionEntry(REDUCE, 349);
}
void Cego::loadParser226()
{
   _actionMap[97][INTOK] = ActionEntry(REDUCE, 349);
   _actionMap[97][NOT] = ActionEntry(REDUCE, 349);
   _actionMap[97][BETWEEN] = ActionEntry(REDUCE, 349);
   _actionMap[97][IS] = ActionEntry(REDUCE, 349);
   _actionMap[97][LIKE] = ActionEntry(REDUCE, 349);
   _actionMap[97][MT] = ActionEntry(REDUCE, 349);
   _actionMap[97][LT] = ActionEntry(REDUCE, 349);
   _actionMap[97][NEGATION] = ActionEntry(REDUCE, 349);
   _actionMap[97][EQU] = ActionEntry(REDUCE, 349);
   _actionMap[97][RB] = ActionEntry(REDUCE, 349);
   _actionMap[97][ENDTOKEN] = ActionEntry(REDUCE, 349);
   _actionMap[97][UNION] = ActionEntry(REDUCE, 349);
   _actionMap[97][ROWLIMIT] = ActionEntry(REDUCE, 349);
   _actionMap[97][KSEP] = ActionEntry(REDUCE, 349);
   _actionMap[97][ASC] = ActionEntry(REDUCE, 349);
   _actionMap[97][DESC] = ActionEntry(REDUCE, 349);
   _actionMap[97][SEMICOLON] = ActionEntry(REDUCE, 349);
   _actionMap[97][PLUS] = ActionEntry(REDUCE, 349);
   _actionMap[97][MINUS] = ActionEntry(REDUCE, 349);
   _actionMap[97][DIVISION] = ActionEntry(REDUCE, 349);
   _actionMap[97][STAR] = ActionEntry(REDUCE, 349);
   _actionMap[97][CONCAT] = ActionEntry(REDUCE, 349);
   _actionMap[98][WHEN] = ActionEntry(REDUCE, 355);
   _actionMap[98][ELSE] = ActionEntry(REDUCE, 355);
   _actionMap[98][LEFT] = ActionEntry(REDUCE, 355);
   _actionMap[98][RIGHT] = ActionEntry(REDUCE, 355);
   _actionMap[98][INNER] = ActionEntry(REDUCE, 355);
   _actionMap[98][JOIN] = ActionEntry(REDUCE, 355);
   _actionMap[98][RETURNTOKEN] = ActionEntry(REDUCE, 355);
   _actionMap[98][ORDER] = ActionEntry(REDUCE, 355);
   _actionMap[98][GROUP] = ActionEntry(REDUCE, 355);
   _actionMap[98][WHERE] = ActionEntry(REDUCE, 355);
   _actionMap[98][NULLTOKEN] = ActionEntry(REDUCE, 355);
   _actionMap[98][FROM] = ActionEntry(REDUCE, 355);
   _actionMap[98][AS] = ActionEntry(REDUCE, 355);
   _actionMap[98][END_TOKEN] = ActionEntry(REDUCE, 355);
   _actionMap[98][BEGIN] = ActionEntry(REDUCE, 355);
   _actionMap[98][THEN] = ActionEntry(REDUCE, 355);
   _actionMap[98][OR] = ActionEntry(REDUCE, 355);
   _actionMap[98][AND] = ActionEntry(REDUCE, 355);
   _actionMap[98][INTOK] = ActionEntry(REDUCE, 355);
   _actionMap[98][NOT] = ActionEntry(REDUCE, 355);
   _actionMap[98][BETWEEN] = ActionEntry(REDUCE, 355);
   _actionMap[98][IS] = ActionEntry(REDUCE, 355);
   _actionMap[98][LIKE] = ActionEntry(REDUCE, 355);
   _actionMap[98][MT] = ActionEntry(REDUCE, 355);
   _actionMap[98][LT] = ActionEntry(REDUCE, 355);
   _actionMap[98][NEGATION] = ActionEntry(REDUCE, 355);
   _actionMap[98][EQU] = ActionEntry(REDUCE, 355);
   _actionMap[98][RB] = ActionEntry(REDUCE, 355);
}
void Cego::loadParser227()
{
   _actionMap[98][ENDTOKEN] = ActionEntry(REDUCE, 355);
   _actionMap[98][UNION] = ActionEntry(REDUCE, 355);
   _actionMap[98][ROWLIMIT] = ActionEntry(REDUCE, 355);
   _actionMap[98][KSEP] = ActionEntry(REDUCE, 355);
   _actionMap[98][ASC] = ActionEntry(REDUCE, 355);
   _actionMap[98][DESC] = ActionEntry(REDUCE, 355);
   _actionMap[98][SEMICOLON] = ActionEntry(REDUCE, 355);
   _actionMap[98][PLUS] = ActionEntry(REDUCE, 355);
   _actionMap[98][MINUS] = ActionEntry(REDUCE, 355);
   _actionMap[98][DIVISION] = ActionEntry(REDUCE, 355);
   _actionMap[98][STAR] = ActionEntry(REDUCE, 355);
   _actionMap[98][CONCAT] = ActionEntry(REDUCE, 355);
   _actionMap[99][WHEN] = ActionEntry(REDUCE, 148);
   _actionMap[99][ELSE] = ActionEntry(REDUCE, 148);
   _actionMap[99][LEFT] = ActionEntry(REDUCE, 148);
   _actionMap[99][RIGHT] = ActionEntry(REDUCE, 148);
   _actionMap[99][INNER] = ActionEntry(REDUCE, 148);
   _actionMap[99][JOIN] = ActionEntry(REDUCE, 148);
   _actionMap[99][RETURNTOKEN] = ActionEntry(REDUCE, 148);
   _actionMap[99][ORDER] = ActionEntry(REDUCE, 148);
   _actionMap[99][GROUP] = ActionEntry(REDUCE, 148);
   _actionMap[99][WHERE] = ActionEntry(REDUCE, 148);
   _actionMap[99][AS] = ActionEntry(REDUCE, 148);
   _actionMap[99][FROM] = ActionEntry(REDUCE, 148);
   _actionMap[99][END_TOKEN] = ActionEntry(REDUCE, 148);
   _actionMap[99][BEGIN] = ActionEntry(REDUCE, 148);
   _actionMap[99][THEN] = ActionEntry(REDUCE, 148);
   _actionMap[99][OR] = ActionEntry(REDUCE, 148);
   _actionMap[99][AND] = ActionEntry(REDUCE, 148);
   _actionMap[99][LIKE] = ActionEntry(REDUCE, 148);
   _actionMap[99][IS] = ActionEntry(REDUCE, 148);
   _actionMap[99][BETWEEN] = ActionEntry(REDUCE, 148);
   _actionMap[99][NOT] = ActionEntry(REDUCE, 148);
   _actionMap[99][INTOK] = ActionEntry(REDUCE, 148);
   _actionMap[99][EQU] = ActionEntry(REDUCE, 148);
   _actionMap[99][NEGATION] = ActionEntry(REDUCE, 148);
   _actionMap[99][LT] = ActionEntry(REDUCE, 148);
   _actionMap[99][MT] = ActionEntry(REDUCE, 148);
   _actionMap[99][DESC] = ActionEntry(REDUCE, 148);
   _actionMap[99][ASC] = ActionEntry(REDUCE, 148);
   _actionMap[99][KSEP] = ActionEntry(REDUCE, 148);
   _actionMap[99][ROWLIMIT] = ActionEntry(REDUCE, 148);
   _actionMap[99][UNION] = ActionEntry(REDUCE, 148);
   _actionMap[99][ENDTOKEN] = ActionEntry(REDUCE, 148);
   _actionMap[99][RB] = ActionEntry(REDUCE, 148);
   _actionMap[99][SEMICOLON] = ActionEntry(REDUCE, 148);
   _actionMap[99][CONCAT] = ActionEntry(REDUCE, 148);
   _actionMap[99][STAR] = ActionEntry(REDUCE, 148);
   _actionMap[99][DIVISION] = ActionEntry(REDUCE, 148);
   _actionMap[99][MINUS] = ActionEntry(REDUCE, 148);
}
void Cego::loadParser228()
{
   _actionMap[99][PLUS] = ActionEntry(REDUCE, 148);
   _actionMap[100][LB] = ActionEntry(SHIFT, 233);
   _actionMap[101][WHEN] = ActionEntry(REDUCE, 354);
   _actionMap[101][ELSE] = ActionEntry(REDUCE, 354);
   _actionMap[101][LEFT] = ActionEntry(REDUCE, 354);
   _actionMap[101][RIGHT] = ActionEntry(REDUCE, 354);
   _actionMap[101][INNER] = ActionEntry(REDUCE, 354);
   _actionMap[101][JOIN] = ActionEntry(REDUCE, 354);
   _actionMap[101][RETURNTOKEN] = ActionEntry(REDUCE, 354);
   _actionMap[101][ORDER] = ActionEntry(REDUCE, 354);
   _actionMap[101][GROUP] = ActionEntry(REDUCE, 354);
   _actionMap[101][WHERE] = ActionEntry(REDUCE, 354);
   _actionMap[101][NULLTOKEN] = ActionEntry(REDUCE, 354);
   _actionMap[101][FROM] = ActionEntry(REDUCE, 354);
   _actionMap[101][AS] = ActionEntry(REDUCE, 354);
   _actionMap[101][END_TOKEN] = ActionEntry(REDUCE, 354);
   _actionMap[101][BEGIN] = ActionEntry(REDUCE, 354);
   _actionMap[101][THEN] = ActionEntry(REDUCE, 354);
   _actionMap[101][OR] = ActionEntry(REDUCE, 354);
   _actionMap[101][AND] = ActionEntry(REDUCE, 354);
   _actionMap[101][INTOK] = ActionEntry(REDUCE, 354);
   _actionMap[101][NOT] = ActionEntry(REDUCE, 354);
   _actionMap[101][BETWEEN] = ActionEntry(REDUCE, 354);
   _actionMap[101][IS] = ActionEntry(REDUCE, 354);
   _actionMap[101][LIKE] = ActionEntry(REDUCE, 354);
   _actionMap[101][MT] = ActionEntry(REDUCE, 354);
   _actionMap[101][LT] = ActionEntry(REDUCE, 354);
   _actionMap[101][NEGATION] = ActionEntry(REDUCE, 354);
   _actionMap[101][EQU] = ActionEntry(REDUCE, 354);
   _actionMap[101][RB] = ActionEntry(REDUCE, 354);
   _actionMap[101][ENDTOKEN] = ActionEntry(REDUCE, 354);
   _actionMap[101][UNION] = ActionEntry(REDUCE, 354);
   _actionMap[101][ROWLIMIT] = ActionEntry(REDUCE, 354);
   _actionMap[101][KSEP] = ActionEntry(REDUCE, 354);
   _actionMap[101][ASC] = ActionEntry(REDUCE, 354);
   _actionMap[101][DESC] = ActionEntry(REDUCE, 354);
   _actionMap[101][SEMICOLON] = ActionEntry(REDUCE, 354);
   _actionMap[101][PLUS] = ActionEntry(REDUCE, 354);
   _actionMap[101][MINUS] = ActionEntry(REDUCE, 354);
   _actionMap[101][DIVISION] = ActionEntry(REDUCE, 354);
   _actionMap[101][STAR] = ActionEntry(REDUCE, 354);
   _actionMap[101][CONCAT] = ActionEntry(REDUCE, 354);
   _actionMap[102][LB] = ActionEntry(SHIFT, 234);
   _actionMap[103][LB] = ActionEntry(SHIFT, 235);
   _actionMap[104][LB] = ActionEntry(SHIFT, 236);
   _actionMap[105][LB] = ActionEntry(SHIFT, 237);
   _actionMap[106][LB] = ActionEntry(SHIFT, 238);
   _actionMap[107][WHEN] = ActionEntry(REDUCE, 165);
   _actionMap[108][LB] = ActionEntry(SHIFT, 239);
   _actionMap[109][LB] = ActionEntry(SHIFT, 240);
}
void Cego::loadParser229()
{
   _actionMap[110][LB] = ActionEntry(SHIFT, 241);
   _actionMap[111][LB] = ActionEntry(SHIFT, 242);
   _actionMap[112][LB] = ActionEntry(SHIFT, 243);
   _actionMap[113][WHEN] = ActionEntry(REDUCE, 363);
   _actionMap[113][ELSE] = ActionEntry(REDUCE, 363);
   _actionMap[113][LEFT] = ActionEntry(REDUCE, 363);
   _actionMap[113][RIGHT] = ActionEntry(REDUCE, 363);
   _actionMap[113][INNER] = ActionEntry(REDUCE, 363);
   _actionMap[113][JOIN] = ActionEntry(REDUCE, 363);
   _actionMap[113][RETURNTOKEN] = ActionEntry(REDUCE, 363);
   _actionMap[113][ORDER] = ActionEntry(REDUCE, 363);
   _actionMap[113][GROUP] = ActionEntry(REDUCE, 363);
   _actionMap[113][WHERE] = ActionEntry(REDUCE, 363);
   _actionMap[113][FROM] = ActionEntry(REDUCE, 363);
   _actionMap[113][AS] = ActionEntry(REDUCE, 363);
   _actionMap[113][END_TOKEN] = ActionEntry(REDUCE, 363);
   _actionMap[113][BEGIN] = ActionEntry(REDUCE, 363);
   _actionMap[113][THEN] = ActionEntry(REDUCE, 363);
   _actionMap[113][OR] = ActionEntry(REDUCE, 363);
   _actionMap[113][AND] = ActionEntry(REDUCE, 363);
   _actionMap[113][NULLTOKEN] = ActionEntry(REDUCE, 363);
   _actionMap[113][INTOK] = ActionEntry(REDUCE, 363);
   _actionMap[113][NOT] = ActionEntry(REDUCE, 363);
   _actionMap[113][BETWEEN] = ActionEntry(REDUCE, 363);
   _actionMap[113][IS] = ActionEntry(REDUCE, 363);
   _actionMap[113][LIKE] = ActionEntry(REDUCE, 363);
   _actionMap[113][MT] = ActionEntry(REDUCE, 363);
   _actionMap[113][LT] = ActionEntry(REDUCE, 363);
   _actionMap[113][NEGATION] = ActionEntry(REDUCE, 363);
   _actionMap[113][EQU] = ActionEntry(REDUCE, 363);
   _actionMap[113][RB] = ActionEntry(REDUCE, 363);
   _actionMap[113][ENDTOKEN] = ActionEntry(REDUCE, 363);
   _actionMap[113][UNION] = ActionEntry(REDUCE, 363);
   _actionMap[113][ROWLIMIT] = ActionEntry(REDUCE, 363);
   _actionMap[113][KSEP] = ActionEntry(REDUCE, 363);
   _actionMap[113][ASC] = ActionEntry(REDUCE, 363);
   _actionMap[113][DESC] = ActionEntry(REDUCE, 363);
   _actionMap[113][SEMICOLON] = ActionEntry(REDUCE, 363);
   _actionMap[113][PLUS] = ActionEntry(REDUCE, 363);
   _actionMap[113][MINUS] = ActionEntry(REDUCE, 363);
   _actionMap[113][DIVISION] = ActionEntry(REDUCE, 363);
   _actionMap[113][STAR] = ActionEntry(REDUCE, 363);
   _actionMap[113][CONCAT] = ActionEntry(REDUCE, 363);
   _actionMap[114][IDENTIFIER] = ActionEntry(SHIFT, 244);
   _actionMap[115][LB] = ActionEntry(SHIFT, 245);
   _actionMap[116][LB] = ActionEntry(SHIFT, 246);
   _actionMap[117][LB] = ActionEntry(SHIFT, 247);
   _actionMap[118][LB] = ActionEntry(SHIFT, 248);
   _actionMap[119][LB] = ActionEntry(SHIFT, 249);
   _actionMap[120][LB] = ActionEntry(SHIFT, 250);
}
void Cego::loadParser230()
{
   _actionMap[121][LB] = ActionEntry(SHIFT, 251);
   _actionMap[122][LB] = ActionEntry(SHIFT, 252);
   _actionMap[123][LB] = ActionEntry(SHIFT, 253);
   _actionMap[124][LB] = ActionEntry(SHIFT, 254);
   _actionMap[125][WHEN] = ActionEntry(REDUCE, 361);
   _actionMap[125][ELSE] = ActionEntry(REDUCE, 361);
   _actionMap[125][LEFT] = ActionEntry(REDUCE, 361);
   _actionMap[125][RIGHT] = ActionEntry(REDUCE, 361);
   _actionMap[125][INNER] = ActionEntry(REDUCE, 361);
   _actionMap[125][JOIN] = ActionEntry(REDUCE, 361);
   _actionMap[125][RETURNTOKEN] = ActionEntry(REDUCE, 361);
   _actionMap[125][ORDER] = ActionEntry(REDUCE, 361);
   _actionMap[125][GROUP] = ActionEntry(REDUCE, 361);
   _actionMap[125][WHERE] = ActionEntry(REDUCE, 361);
   _actionMap[125][FROM] = ActionEntry(REDUCE, 361);
   _actionMap[125][AS] = ActionEntry(REDUCE, 361);
   _actionMap[125][END_TOKEN] = ActionEntry(REDUCE, 361);
   _actionMap[125][BEGIN] = ActionEntry(REDUCE, 361);
   _actionMap[125][THEN] = ActionEntry(REDUCE, 361);
   _actionMap[125][OR] = ActionEntry(REDUCE, 361);
   _actionMap[125][AND] = ActionEntry(REDUCE, 361);
   _actionMap[125][NULLTOKEN] = ActionEntry(REDUCE, 361);
   _actionMap[125][INTOK] = ActionEntry(REDUCE, 361);
   _actionMap[125][NOT] = ActionEntry(REDUCE, 361);
   _actionMap[125][BETWEEN] = ActionEntry(REDUCE, 361);
   _actionMap[125][IS] = ActionEntry(REDUCE, 361);
   _actionMap[125][LIKE] = ActionEntry(REDUCE, 361);
   _actionMap[125][MT] = ActionEntry(REDUCE, 361);
   _actionMap[125][LT] = ActionEntry(REDUCE, 361);
   _actionMap[125][NEGATION] = ActionEntry(REDUCE, 361);
   _actionMap[125][EQU] = ActionEntry(REDUCE, 361);
   _actionMap[125][RB] = ActionEntry(REDUCE, 361);
   _actionMap[125][ENDTOKEN] = ActionEntry(REDUCE, 361);
   _actionMap[125][UNION] = ActionEntry(REDUCE, 361);
   _actionMap[125][ROWLIMIT] = ActionEntry(REDUCE, 361);
   _actionMap[125][KSEP] = ActionEntry(REDUCE, 361);
   _actionMap[125][ASC] = ActionEntry(REDUCE, 361);
   _actionMap[125][DESC] = ActionEntry(REDUCE, 361);
   _actionMap[125][SEMICOLON] = ActionEntry(REDUCE, 361);
   _actionMap[125][PLUS] = ActionEntry(REDUCE, 361);
   _actionMap[125][MINUS] = ActionEntry(REDUCE, 361);
   _actionMap[125][DIVISION] = ActionEntry(REDUCE, 361);
   _actionMap[125][STAR] = ActionEntry(REDUCE, 361);
   _actionMap[125][CONCAT] = ActionEntry(REDUCE, 361);
   _actionMap[126][LB] = ActionEntry(SHIFT, 255);
   _actionMap[127][LB] = ActionEntry(SHIFT, 256);
   _actionMap[128][LB] = ActionEntry(SHIFT, 257);
   _actionMap[129][LB] = ActionEntry(SHIFT, 258);
   _actionMap[130][LB] = ActionEntry(SHIFT, 259);
   _actionMap[131][LB] = ActionEntry(SHIFT, 260);
}
void Cego::loadParser231()
{
   _actionMap[132][LB] = ActionEntry(SHIFT, 261);
   _actionMap[133][LB] = ActionEntry(SHIFT, 262);
   _actionMap[134][LB] = ActionEntry(SHIFT, 263);
   _actionMap[135][LB] = ActionEntry(SHIFT, 264);
   _actionMap[136][WHEN] = ActionEntry(REDUCE, 360);
   _actionMap[136][ELSE] = ActionEntry(REDUCE, 360);
   _actionMap[136][LEFT] = ActionEntry(REDUCE, 360);
   _actionMap[136][RIGHT] = ActionEntry(REDUCE, 360);
   _actionMap[136][INNER] = ActionEntry(REDUCE, 360);
   _actionMap[136][JOIN] = ActionEntry(REDUCE, 360);
   _actionMap[136][RETURNTOKEN] = ActionEntry(REDUCE, 360);
   _actionMap[136][ORDER] = ActionEntry(REDUCE, 360);
   _actionMap[136][GROUP] = ActionEntry(REDUCE, 360);
   _actionMap[136][WHERE] = ActionEntry(REDUCE, 360);
   _actionMap[136][FROM] = ActionEntry(REDUCE, 360);
   _actionMap[136][AS] = ActionEntry(REDUCE, 360);
   _actionMap[136][END_TOKEN] = ActionEntry(REDUCE, 360);
   _actionMap[136][BEGIN] = ActionEntry(REDUCE, 360);
   _actionMap[136][THEN] = ActionEntry(REDUCE, 360);
   _actionMap[136][OR] = ActionEntry(REDUCE, 360);
   _actionMap[136][AND] = ActionEntry(REDUCE, 360);
   _actionMap[136][NULLTOKEN] = ActionEntry(REDUCE, 360);
   _actionMap[136][INTOK] = ActionEntry(REDUCE, 360);
   _actionMap[136][NOT] = ActionEntry(REDUCE, 360);
   _actionMap[136][BETWEEN] = ActionEntry(REDUCE, 360);
   _actionMap[136][IS] = ActionEntry(REDUCE, 360);
   _actionMap[136][LIKE] = ActionEntry(REDUCE, 360);
   _actionMap[136][MT] = ActionEntry(REDUCE, 360);
   _actionMap[136][LT] = ActionEntry(REDUCE, 360);
   _actionMap[136][NEGATION] = ActionEntry(REDUCE, 360);
   _actionMap[136][EQU] = ActionEntry(REDUCE, 360);
   _actionMap[136][RB] = ActionEntry(REDUCE, 360);
   _actionMap[136][ENDTOKEN] = ActionEntry(REDUCE, 360);
   _actionMap[136][UNION] = ActionEntry(REDUCE, 360);
   _actionMap[136][ROWLIMIT] = ActionEntry(REDUCE, 360);
   _actionMap[136][KSEP] = ActionEntry(REDUCE, 360);
   _actionMap[136][ASC] = ActionEntry(REDUCE, 360);
   _actionMap[136][DESC] = ActionEntry(REDUCE, 360);
   _actionMap[136][SEMICOLON] = ActionEntry(REDUCE, 360);
   _actionMap[136][PLUS] = ActionEntry(REDUCE, 360);
   _actionMap[136][MINUS] = ActionEntry(REDUCE, 360);
   _actionMap[136][DIVISION] = ActionEntry(REDUCE, 360);
   _actionMap[136][STAR] = ActionEntry(REDUCE, 360);
   _actionMap[136][CONCAT] = ActionEntry(REDUCE, 360);
   _actionMap[137][LB] = ActionEntry(SHIFT, 265);
   _actionMap[138][LB] = ActionEntry(SHIFT, 266);
   _actionMap[139][LB] = ActionEntry(SHIFT, 267);
   _actionMap[140][LB] = ActionEntry(SHIFT, 268);
   _actionMap[141][WHEN] = ActionEntry(REDUCE, 362);
   _actionMap[141][ELSE] = ActionEntry(REDUCE, 362);
}
void Cego::loadParser232()
{
   _actionMap[141][LEFT] = ActionEntry(REDUCE, 362);
   _actionMap[141][RIGHT] = ActionEntry(REDUCE, 362);
   _actionMap[141][INNER] = ActionEntry(REDUCE, 362);
   _actionMap[141][JOIN] = ActionEntry(REDUCE, 362);
   _actionMap[141][RETURNTOKEN] = ActionEntry(REDUCE, 362);
   _actionMap[141][ORDER] = ActionEntry(REDUCE, 362);
   _actionMap[141][GROUP] = ActionEntry(REDUCE, 362);
   _actionMap[141][WHERE] = ActionEntry(REDUCE, 362);
   _actionMap[141][FROM] = ActionEntry(REDUCE, 362);
   _actionMap[141][AS] = ActionEntry(REDUCE, 362);
   _actionMap[141][END_TOKEN] = ActionEntry(REDUCE, 362);
   _actionMap[141][BEGIN] = ActionEntry(REDUCE, 362);
   _actionMap[141][THEN] = ActionEntry(REDUCE, 362);
   _actionMap[141][OR] = ActionEntry(REDUCE, 362);
   _actionMap[141][AND] = ActionEntry(REDUCE, 362);
   _actionMap[141][NULLTOKEN] = ActionEntry(REDUCE, 362);
   _actionMap[141][INTOK] = ActionEntry(REDUCE, 362);
   _actionMap[141][NOT] = ActionEntry(REDUCE, 362);
   _actionMap[141][BETWEEN] = ActionEntry(REDUCE, 362);
   _actionMap[141][IS] = ActionEntry(REDUCE, 362);
   _actionMap[141][LIKE] = ActionEntry(REDUCE, 362);
   _actionMap[141][MT] = ActionEntry(REDUCE, 362);
   _actionMap[141][LT] = ActionEntry(REDUCE, 362);
   _actionMap[141][NEGATION] = ActionEntry(REDUCE, 362);
   _actionMap[141][EQU] = ActionEntry(REDUCE, 362);
   _actionMap[141][RB] = ActionEntry(REDUCE, 362);
   _actionMap[141][ENDTOKEN] = ActionEntry(REDUCE, 362);
   _actionMap[141][UNION] = ActionEntry(REDUCE, 362);
   _actionMap[141][ROWLIMIT] = ActionEntry(REDUCE, 362);
   _actionMap[141][KSEP] = ActionEntry(REDUCE, 362);
   _actionMap[141][ASC] = ActionEntry(REDUCE, 362);
   _actionMap[141][DESC] = ActionEntry(REDUCE, 362);
   _actionMap[141][SEMICOLON] = ActionEntry(REDUCE, 362);
   _actionMap[141][PLUS] = ActionEntry(REDUCE, 362);
   _actionMap[141][MINUS] = ActionEntry(REDUCE, 362);
   _actionMap[141][DIVISION] = ActionEntry(REDUCE, 362);
   _actionMap[141][STAR] = ActionEntry(REDUCE, 362);
   _actionMap[141][CONCAT] = ActionEntry(REDUCE, 362);
   _actionMap[142][LB] = ActionEntry(SHIFT, 269);
   _actionMap[143][LB] = ActionEntry(SHIFT, 270);
   _actionMap[144][LONG] = ActionEntry(SHIFT, 277);
   _actionMap[144][BIGINT] = ActionEntry(SHIFT, 273);
   _actionMap[144][SMALLINT] = ActionEntry(SHIFT, 278);
   _actionMap[144][TINYINT] = ActionEntry(SHIFT, 279);
   _actionMap[144][DOUBLE] = ActionEntry(SHIFT, 275);
   _actionMap[144][DECIMAL] = ActionEntry(SHIFT, 274);
   _actionMap[144][FIXED] = ActionEntry(SHIFT, 276);
   _actionMap[144][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[144][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[144][INTVAL] = ActionEntry(SHIFT, 147);
}
void Cego::loadParser233()
{
   _actionMap[144][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[144][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[144][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[144][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[144][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[144][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[144][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[144][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[144][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[144][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[144][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[144][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[144][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[144][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[144][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[144][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[144][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[144][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[144][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[144][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[144][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[144][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[144][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[144][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[144][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[144][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[144][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[144][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[144][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[144][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[144][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[144][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[144][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[144][LB] = ActionEntry(SHIFT, 144);
   _actionMap[144][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[144][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[144][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[144][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[144][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[144][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[144][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[144][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[144][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[144][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[144][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[144][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[144][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[144][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[144][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[144][MAX] = ActionEntry(SHIFT, 122);
}
void Cego::loadParser234()
{
   _actionMap[144][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[144][ObjSpec] = 100;
   _jumpMap[144][Constant] = 99;
   _jumpMap[144][SignedFloat] = 98;
   _jumpMap[144][SignedInt] = 97;
   _jumpMap[144][Attribute] = 96;
   _jumpMap[144][Function] = 95;
   _jumpMap[144][SelectStatement] = 272;
   _jumpMap[144][CasePrepare] = 94;
   _jumpMap[144][CaseClause] = 93;
   _jumpMap[144][Factor] = 92;
   _jumpMap[144][Term] = 91;
   _jumpMap[144][Expr] = 271;
   _actionMap[145][INTVAL] = ActionEntry(SHIFT, 280);
   _actionMap[146][FLOATVAL] = ActionEntry(SHIFT, 282);
   _actionMap[146][INTVAL] = ActionEntry(SHIFT, 281);
   _actionMap[147][WHEN] = ActionEntry(REDUCE, 345);
   _actionMap[147][ELSE] = ActionEntry(REDUCE, 345);
   _actionMap[147][LEFT] = ActionEntry(REDUCE, 345);
   _actionMap[147][RIGHT] = ActionEntry(REDUCE, 345);
   _actionMap[147][INNER] = ActionEntry(REDUCE, 345);
   _actionMap[147][JOIN] = ActionEntry(REDUCE, 345);
   _actionMap[147][RETURNTOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[147][ORDER] = ActionEntry(REDUCE, 345);
   _actionMap[147][GROUP] = ActionEntry(REDUCE, 345);
   _actionMap[147][WHERE] = ActionEntry(REDUCE, 345);
   _actionMap[147][AS] = ActionEntry(REDUCE, 345);
   _actionMap[147][FROM] = ActionEntry(REDUCE, 345);
   _actionMap[147][END_TOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[147][BEGIN] = ActionEntry(REDUCE, 345);
   _actionMap[147][THEN] = ActionEntry(REDUCE, 345);
   _actionMap[147][OR] = ActionEntry(REDUCE, 345);
   _actionMap[147][AND] = ActionEntry(REDUCE, 345);
   _actionMap[147][NULLTOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[147][LIKE] = ActionEntry(REDUCE, 345);
   _actionMap[147][IS] = ActionEntry(REDUCE, 345);
   _actionMap[147][BETWEEN] = ActionEntry(REDUCE, 345);
   _actionMap[147][NOT] = ActionEntry(REDUCE, 345);
   _actionMap[147][INTOK] = ActionEntry(REDUCE, 345);
   _actionMap[147][EQU] = ActionEntry(REDUCE, 345);
   _actionMap[147][NEGATION] = ActionEntry(REDUCE, 345);
   _actionMap[147][LT] = ActionEntry(REDUCE, 345);
   _actionMap[147][MT] = ActionEntry(REDUCE, 345);
   _actionMap[147][DESC] = ActionEntry(REDUCE, 345);
   _actionMap[147][ASC] = ActionEntry(REDUCE, 345);
   _actionMap[147][KSEP] = ActionEntry(REDUCE, 345);
   _actionMap[147][ROWLIMIT] = ActionEntry(REDUCE, 345);
   _actionMap[147][UNION] = ActionEntry(REDUCE, 345);
   _actionMap[147][ENDTOKEN] = ActionEntry(REDUCE, 345);
   _actionMap[147][RB] = ActionEntry(REDUCE, 345);
}
void Cego::loadParser235()
{
   _actionMap[147][SEMICOLON] = ActionEntry(REDUCE, 345);
   _actionMap[147][CONCAT] = ActionEntry(REDUCE, 345);
   _actionMap[147][STAR] = ActionEntry(REDUCE, 345);
   _actionMap[147][DIVISION] = ActionEntry(REDUCE, 345);
   _actionMap[147][MINUS] = ActionEntry(REDUCE, 345);
   _actionMap[147][PLUS] = ActionEntry(REDUCE, 345);
   _actionMap[148][WHEN] = ActionEntry(REDUCE, 347);
   _actionMap[148][ELSE] = ActionEntry(REDUCE, 347);
   _actionMap[148][LEFT] = ActionEntry(REDUCE, 347);
   _actionMap[148][RIGHT] = ActionEntry(REDUCE, 347);
   _actionMap[148][INNER] = ActionEntry(REDUCE, 347);
   _actionMap[148][JOIN] = ActionEntry(REDUCE, 347);
   _actionMap[148][RETURNTOKEN] = ActionEntry(REDUCE, 347);
   _actionMap[148][ORDER] = ActionEntry(REDUCE, 347);
   _actionMap[148][GROUP] = ActionEntry(REDUCE, 347);
   _actionMap[148][WHERE] = ActionEntry(REDUCE, 347);
   _actionMap[148][AS] = ActionEntry(REDUCE, 347);
   _actionMap[148][FROM] = ActionEntry(REDUCE, 347);
   _actionMap[148][END_TOKEN] = ActionEntry(REDUCE, 347);
   _actionMap[148][BEGIN] = ActionEntry(REDUCE, 347);
   _actionMap[148][THEN] = ActionEntry(REDUCE, 347);
   _actionMap[148][OR] = ActionEntry(REDUCE, 347);
   _actionMap[148][AND] = ActionEntry(REDUCE, 347);
   _actionMap[148][NULLTOKEN] = ActionEntry(REDUCE, 347);
   _actionMap[148][LIKE] = ActionEntry(REDUCE, 347);
   _actionMap[148][IS] = ActionEntry(REDUCE, 347);
   _actionMap[148][BETWEEN] = ActionEntry(REDUCE, 347);
   _actionMap[148][NOT] = ActionEntry(REDUCE, 347);
   _actionMap[148][INTOK] = ActionEntry(REDUCE, 347);
   _actionMap[148][EQU] = ActionEntry(REDUCE, 347);
   _actionMap[148][NEGATION] = ActionEntry(REDUCE, 347);
   _actionMap[148][LT] = ActionEntry(REDUCE, 347);
   _actionMap[148][MT] = ActionEntry(REDUCE, 347);
   _actionMap[148][DESC] = ActionEntry(REDUCE, 347);
   _actionMap[148][ASC] = ActionEntry(REDUCE, 347);
   _actionMap[148][KSEP] = ActionEntry(REDUCE, 347);
   _actionMap[148][ROWLIMIT] = ActionEntry(REDUCE, 347);
   _actionMap[148][UNION] = ActionEntry(REDUCE, 347);
   _actionMap[148][ENDTOKEN] = ActionEntry(REDUCE, 347);
   _actionMap[148][RB] = ActionEntry(REDUCE, 347);
   _actionMap[148][SEMICOLON] = ActionEntry(REDUCE, 347);
   _actionMap[148][CONCAT] = ActionEntry(REDUCE, 347);
   _actionMap[148][STAR] = ActionEntry(REDUCE, 347);
   _actionMap[148][DIVISION] = ActionEntry(REDUCE, 347);
   _actionMap[148][MINUS] = ActionEntry(REDUCE, 347);
   _actionMap[148][PLUS] = ActionEntry(REDUCE, 347);
   _actionMap[149][WHEN] = ActionEntry(REDUCE, 342);
   _actionMap[149][ELSE] = ActionEntry(REDUCE, 342);
   _actionMap[149][LEFT] = ActionEntry(REDUCE, 342);
   _actionMap[149][RIGHT] = ActionEntry(REDUCE, 342);
}
void Cego::loadParser236()
{
   _actionMap[149][INNER] = ActionEntry(REDUCE, 342);
   _actionMap[149][JOIN] = ActionEntry(REDUCE, 342);
   _actionMap[149][RETURNTOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[149][ORDER] = ActionEntry(REDUCE, 342);
   _actionMap[149][GROUP] = ActionEntry(REDUCE, 342);
   _actionMap[149][WHERE] = ActionEntry(REDUCE, 342);
   _actionMap[149][FROM] = ActionEntry(REDUCE, 342);
   _actionMap[149][AS] = ActionEntry(REDUCE, 342);
   _actionMap[149][END_TOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[149][BEGIN] = ActionEntry(REDUCE, 342);
   _actionMap[149][THEN] = ActionEntry(REDUCE, 342);
   _actionMap[149][OR] = ActionEntry(REDUCE, 342);
   _actionMap[149][AND] = ActionEntry(REDUCE, 342);
   _actionMap[149][INTOK] = ActionEntry(REDUCE, 342);
   _actionMap[149][NOT] = ActionEntry(REDUCE, 342);
   _actionMap[149][BETWEEN] = ActionEntry(REDUCE, 342);
   _actionMap[149][IS] = ActionEntry(REDUCE, 342);
   _actionMap[149][LIKE] = ActionEntry(REDUCE, 342);
   _actionMap[149][MT] = ActionEntry(REDUCE, 342);
   _actionMap[149][LT] = ActionEntry(REDUCE, 342);
   _actionMap[149][NEGATION] = ActionEntry(REDUCE, 342);
   _actionMap[149][EQU] = ActionEntry(REDUCE, 342);
   _actionMap[149][RB] = ActionEntry(REDUCE, 342);
   _actionMap[149][ENDTOKEN] = ActionEntry(REDUCE, 342);
   _actionMap[149][UNION] = ActionEntry(REDUCE, 342);
   _actionMap[149][ROWLIMIT] = ActionEntry(REDUCE, 342);
   _actionMap[149][KSEP] = ActionEntry(REDUCE, 342);
   _actionMap[149][ASC] = ActionEntry(REDUCE, 342);
   _actionMap[149][DESC] = ActionEntry(REDUCE, 342);
   _actionMap[149][SEMICOLON] = ActionEntry(REDUCE, 342);
   _actionMap[149][PLUS] = ActionEntry(REDUCE, 342);
   _actionMap[149][MINUS] = ActionEntry(REDUCE, 342);
   _actionMap[149][LB] = ActionEntry(REDUCE, 367);
   _actionMap[149][DIVISION] = ActionEntry(REDUCE, 342);
   _actionMap[149][STAR] = ActionEntry(REDUCE, 342);
   _actionMap[149][CONCAT] = ActionEntry(REDUCE, 342);
   _actionMap[150][WHEN] = ActionEntry(REDUCE, 147);
   _actionMap[150][ELSE] = ActionEntry(REDUCE, 147);
   _actionMap[150][LEFT] = ActionEntry(REDUCE, 147);
   _actionMap[150][RIGHT] = ActionEntry(REDUCE, 147);
   _actionMap[150][INNER] = ActionEntry(REDUCE, 147);
   _actionMap[150][JOIN] = ActionEntry(REDUCE, 147);
   _actionMap[150][RETURNTOKEN] = ActionEntry(REDUCE, 147);
   _actionMap[150][ORDER] = ActionEntry(REDUCE, 147);
   _actionMap[150][GROUP] = ActionEntry(REDUCE, 147);
   _actionMap[150][WHERE] = ActionEntry(REDUCE, 147);
   _actionMap[150][AS] = ActionEntry(REDUCE, 147);
   _actionMap[150][FROM] = ActionEntry(REDUCE, 147);
   _actionMap[150][END_TOKEN] = ActionEntry(REDUCE, 147);
   _actionMap[150][BEGIN] = ActionEntry(REDUCE, 147);
}
void Cego::loadParser237()
{
   _actionMap[150][THEN] = ActionEntry(REDUCE, 147);
   _actionMap[150][OR] = ActionEntry(REDUCE, 147);
   _actionMap[150][AND] = ActionEntry(REDUCE, 147);
   _actionMap[150][LIKE] = ActionEntry(REDUCE, 147);
   _actionMap[150][IS] = ActionEntry(REDUCE, 147);
   _actionMap[150][BETWEEN] = ActionEntry(REDUCE, 147);
   _actionMap[150][NOT] = ActionEntry(REDUCE, 147);
   _actionMap[150][INTOK] = ActionEntry(REDUCE, 147);
   _actionMap[150][EQU] = ActionEntry(REDUCE, 147);
   _actionMap[150][NEGATION] = ActionEntry(REDUCE, 147);
   _actionMap[150][LT] = ActionEntry(REDUCE, 147);
   _actionMap[150][MT] = ActionEntry(REDUCE, 147);
   _actionMap[150][DESC] = ActionEntry(REDUCE, 147);
   _actionMap[150][ASC] = ActionEntry(REDUCE, 147);
   _actionMap[150][KSEP] = ActionEntry(REDUCE, 147);
   _actionMap[150][ROWLIMIT] = ActionEntry(REDUCE, 147);
   _actionMap[150][UNION] = ActionEntry(REDUCE, 147);
   _actionMap[150][ENDTOKEN] = ActionEntry(REDUCE, 147);
   _actionMap[150][RB] = ActionEntry(REDUCE, 147);
   _actionMap[150][SEMICOLON] = ActionEntry(REDUCE, 147);
   _actionMap[150][CONCAT] = ActionEntry(REDUCE, 147);
   _actionMap[150][STAR] = ActionEntry(REDUCE, 147);
   _actionMap[150][DIVISION] = ActionEntry(REDUCE, 147);
   _actionMap[150][MINUS] = ActionEntry(REDUCE, 147);
   _actionMap[150][PLUS] = ActionEntry(REDUCE, 147);
   _actionMap[151][WHEN] = ActionEntry(REDUCE, 343);
   _actionMap[151][ELSE] = ActionEntry(REDUCE, 343);
   _actionMap[151][LEFT] = ActionEntry(REDUCE, 343);
   _actionMap[151][RIGHT] = ActionEntry(REDUCE, 343);
   _actionMap[151][INNER] = ActionEntry(REDUCE, 343);
   _actionMap[151][JOIN] = ActionEntry(REDUCE, 343);
   _actionMap[151][RETURNTOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[151][ORDER] = ActionEntry(REDUCE, 343);
   _actionMap[151][GROUP] = ActionEntry(REDUCE, 343);
   _actionMap[151][WHERE] = ActionEntry(REDUCE, 343);
   _actionMap[151][FROM] = ActionEntry(REDUCE, 343);
   _actionMap[151][AS] = ActionEntry(REDUCE, 343);
   _actionMap[151][END_TOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[151][BEGIN] = ActionEntry(REDUCE, 343);
   _actionMap[151][THEN] = ActionEntry(REDUCE, 343);
   _actionMap[151][OR] = ActionEntry(REDUCE, 343);
   _actionMap[151][AND] = ActionEntry(REDUCE, 343);
   _actionMap[151][INTOK] = ActionEntry(REDUCE, 343);
   _actionMap[151][NOT] = ActionEntry(REDUCE, 343);
   _actionMap[151][BETWEEN] = ActionEntry(REDUCE, 343);
   _actionMap[151][IS] = ActionEntry(REDUCE, 343);
   _actionMap[151][LIKE] = ActionEntry(REDUCE, 343);
   _actionMap[151][MT] = ActionEntry(REDUCE, 343);
   _actionMap[151][LT] = ActionEntry(REDUCE, 343);
   _actionMap[151][NEGATION] = ActionEntry(REDUCE, 343);
}
void Cego::loadParser238()
{
   _actionMap[151][EQU] = ActionEntry(REDUCE, 343);
   _actionMap[151][RB] = ActionEntry(REDUCE, 343);
   _actionMap[151][ENDTOKEN] = ActionEntry(REDUCE, 343);
   _actionMap[151][UNION] = ActionEntry(REDUCE, 343);
   _actionMap[151][ROWLIMIT] = ActionEntry(REDUCE, 343);
   _actionMap[151][KSEP] = ActionEntry(REDUCE, 343);
   _actionMap[151][ASC] = ActionEntry(REDUCE, 343);
   _actionMap[151][DESC] = ActionEntry(REDUCE, 343);
   _actionMap[151][SEMICOLON] = ActionEntry(REDUCE, 343);
   _actionMap[151][PLUS] = ActionEntry(REDUCE, 343);
   _actionMap[151][MINUS] = ActionEntry(REDUCE, 343);
   _actionMap[151][LB] = ActionEntry(REDUCE, 368);
   _actionMap[151][DIVISION] = ActionEntry(REDUCE, 343);
   _actionMap[151][STAR] = ActionEntry(REDUCE, 343);
   _actionMap[151][CONCAT] = ActionEntry(REDUCE, 343);
   _actionMap[152][STAR] = ActionEntry(SHIFT, 283);
   _actionMap[153][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[153][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[153][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[153][ObjSpec] = 284;
   _actionMap[154][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[154][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[154][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[154][ObjSpec] = 285;
   _actionMap[155][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[155][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[155][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[155][ObjSpec] = 286;
   _actionMap[156][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[156][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[156][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[156][ObjSpec] = 287;
   _actionMap[157][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[157][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[157][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[157][ObjSpec] = 288;
   _actionMap[158][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[158][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[158][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[158][ObjSpec] = 289;
   _actionMap[159][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[159][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[159][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[159][ObjSpec] = 290;
   _actionMap[160][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[160][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[160][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[160][ObjSpec] = 291;
   _actionMap[161][FROM] = ActionEntry(SHIFT, 292);
   _actionMap[162][FLOATVAL] = ActionEntry(SHIFT, 148);
}
void Cego::loadParser239()
{
   _actionMap[162][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[162][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[162][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[162][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[162][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[162][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[162][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[162][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[162][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[162][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[162][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[162][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[162][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[162][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[162][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[162][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[162][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[162][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[162][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[162][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[162][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[162][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[162][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[162][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[162][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[162][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[162][BITAND] = ActionEntry(SHIFT, 103);
   _actionMap[162][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[162][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[162][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[162][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[162][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[162][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[162][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[162][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[162][LB] = ActionEntry(SHIFT, 144);
   _actionMap[162][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[162][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[162][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[162][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[162][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[162][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[162][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[162][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[162][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[162][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[162][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[162][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[162][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[162][AVG] = ActionEntry(SHIFT, 102);
}
void Cego::loadParser240()
{
   _actionMap[162][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[162][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[162][ObjSpec] = 100;
   _jumpMap[162][Constant] = 99;
   _jumpMap[162][SignedFloat] = 98;
   _jumpMap[162][SignedInt] = 97;
   _jumpMap[162][Attribute] = 96;
   _jumpMap[162][Function] = 95;
   _jumpMap[162][SelectItem] = 295;
   _jumpMap[162][SelectionList] = 294;
   _jumpMap[162][CasePrepare] = 94;
   _jumpMap[162][CaseClause] = 93;
   _jumpMap[162][Factor] = 92;
   _jumpMap[162][Term] = 91;
   _jumpMap[162][Expr] = 293;
   _actionMap[163][VARREF] = ActionEntry(REDUCE, 242);
   _actionMap[163][FETCH] = ActionEntry(REDUCE, 242);
   _actionMap[163][LB] = ActionEntry(REDUCE, 242);
   _actionMap[163][COUNT] = ActionEntry(REDUCE, 242);
   _actionMap[163][SUM] = ActionEntry(REDUCE, 242);
   _actionMap[163][AVG] = ActionEntry(REDUCE, 242);
   _actionMap[163][MIN] = ActionEntry(REDUCE, 242);
   _actionMap[163][MAX] = ActionEntry(REDUCE, 242);
   _actionMap[163][CASE] = ActionEntry(REDUCE, 242);
   _actionMap[163][TRIM] = ActionEntry(REDUCE, 242);
   _actionMap[163][RTRIM] = ActionEntry(REDUCE, 242);
   _actionMap[163][LTRIM] = ActionEntry(REDUCE, 242);
   _actionMap[163][ROUND] = ActionEntry(REDUCE, 242);
   _actionMap[163][DATE2STR] = ActionEntry(REDUCE, 242);
   _actionMap[163][DATE2INT] = ActionEntry(REDUCE, 242);
   _actionMap[163][INT2DATE] = ActionEntry(REDUCE, 242);
   _actionMap[163][LOWER] = ActionEntry(REDUCE, 242);
   _actionMap[163][UPPER] = ActionEntry(REDUCE, 242);
   _actionMap[163][LEFT] = ActionEntry(REDUCE, 242);
   _actionMap[163][RIGHT] = ActionEntry(REDUCE, 242);
   _actionMap[163][GETPOS] = ActionEntry(REDUCE, 242);
   _actionMap[163][SUBSTR] = ActionEntry(REDUCE, 242);
   _actionMap[163][REPLACE] = ActionEntry(REDUCE, 242);
   _actionMap[163][LENGTH] = ActionEntry(REDUCE, 242);
   _actionMap[163][TRUNC] = ActionEntry(REDUCE, 242);
   _actionMap[163][STR2INT] = ActionEntry(REDUCE, 242);
   _actionMap[163][STR2LONG] = ActionEntry(REDUCE, 242);
   _actionMap[163][STR2DATE] = ActionEntry(REDUCE, 242);
   _actionMap[163][RANDSTR] = ActionEntry(REDUCE, 242);
   _actionMap[163][RANDINT] = ActionEntry(REDUCE, 242);
   _actionMap[163][MOD] = ActionEntry(REDUCE, 242);
   _actionMap[163][DIV] = ActionEntry(REDUCE, 242);
   _actionMap[163][POWER] = ActionEntry(REDUCE, 242);
   _actionMap[163][BITAND] = ActionEntry(REDUCE, 242);
   _actionMap[163][BITOR] = ActionEntry(REDUCE, 242);
}
void Cego::loadParser241()
{
   _actionMap[163][BITXOR] = ActionEntry(REDUCE, 242);
   _actionMap[163][BLOBSIZE] = ActionEntry(REDUCE, 242);
   _actionMap[163][NEXTCOUNT] = ActionEntry(REDUCE, 242);
   _actionMap[163][SETCOUNT] = ActionEntry(REDUCE, 242);
   _actionMap[163][IDENTIFIER] = ActionEntry(REDUCE, 242);
   _actionMap[163][QUALIFIEDOBJ] = ActionEntry(REDUCE, 242);
   _actionMap[163][QUALIFIEDTS] = ActionEntry(REDUCE, 242);
   _actionMap[163][QUALIFIEDPRE] = ActionEntry(REDUCE, 242);
   _actionMap[163][STRINGVAL] = ActionEntry(REDUCE, 242);
   _actionMap[163][DATE] = ActionEntry(REDUCE, 242);
   _actionMap[163][SYSDATE] = ActionEntry(REDUCE, 242);
   _actionMap[163][NULLTOKEN] = ActionEntry(REDUCE, 242);
   _actionMap[163][TRUEVAL] = ActionEntry(REDUCE, 242);
   _actionMap[163][FALSEVAL] = ActionEntry(REDUCE, 242);
   _actionMap[163][LAB] = ActionEntry(REDUCE, 242);
   _actionMap[163][FLOATVAL] = ActionEntry(REDUCE, 242);
   _actionMap[163][MINUS] = ActionEntry(REDUCE, 242);
   _actionMap[163][INTVAL] = ActionEntry(REDUCE, 242);
   _actionMap[164][FROM] = ActionEntry(REDUCE, 204);
   _actionMap[165][OFF] = ActionEntry(SHIFT, 296);
   _actionMap[165][ON] = ActionEntry(SHIFT, 297);
   _actionMap[166][OFF] = ActionEntry(SHIFT, 298);
   _actionMap[166][ON] = ActionEntry(SHIFT, 299);
   _actionMap[167][IDENTIFIER] = ActionEntry(SHIFT, 183);
   _jumpMap[167][CounterId] = 300;
   _actionMap[168][IDENTIFIER] = ActionEntry(SHIFT, 301);
   _actionMap[169][IDENTIFIER] = ActionEntry(SHIFT, 302);
   _actionMap[170][EQU] = ActionEntry(SHIFT, 303);
   _actionMap[171][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[171][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[171][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[171][ObjSpec] = 304;
   _actionMap[172][SEMICOLON] = ActionEntry(REDUCE, 17);
   _actionMap[173][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[173][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[173][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[173][ObjSpec] = 305;
   _actionMap[174][SEMICOLON] = ActionEntry(REDUCE, 18);
   _actionMap[175][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[175][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[175][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[175][ObjSpec] = 306;
   _actionMap[176][SEMICOLON] = ActionEntry(REDUCE, 187);
   _actionMap[177][SEMICOLON] = ActionEntry(REDUCE, 15);
   _actionMap[178][IDENTIFIER] = ActionEntry(SHIFT, 309);
   _actionMap[178][SET] = ActionEntry(REDUCE, 258);
   _jumpMap[178][UpdDelAlias] = 307;
   _actionMap[179][CALL] = ActionEntry(SHIFT, 310);
   _actionMap[1][TABLE] = ActionEntry(SHIFT, 45);
   _actionMap[1][INDEX] = ActionEntry(SHIFT, 43);
}
void Cego::loadParser242()
{
   _actionMap[1][VIEW] = ActionEntry(SHIFT, 46);
   _actionMap[1][PROCEDURE] = ActionEntry(SHIFT, 44);
   _actionMap[1][FOREIGN] = ActionEntry(SHIFT, 42);
   _actionMap[1][CHECK] = ActionEntry(SHIFT, 40);
   _actionMap[1][BTREE] = ActionEntry(SHIFT, 39);
   _actionMap[1][COUNTER] = ActionEntry(SHIFT, 41);
   _actionMap[2][SEMICOLON] = ActionEntry(SHIFT, 47);
   _actionMap[3][SEMICOLON] = ActionEntry(REDUCE, 31);
   _actionMap[4][SEMICOLON] = ActionEntry(REDUCE, 32);
   _actionMap[5][SEMICOLON] = ActionEntry(REDUCE, 33);
   _actionMap[6][SEMICOLON] = ActionEntry(REDUCE, 43);
   _actionMap[7][SEMICOLON] = ActionEntry(REDUCE, 41);
   _actionMap[8][SEMICOLON] = ActionEntry(REDUCE, 45);
   _actionMap[9][SEMICOLON] = ActionEntry(REDUCE, 44);
   _actionMap[10][SEMICOLON] = ActionEntry(REDUCE, 46);
   _actionMap[11][SEMICOLON] = ActionEntry(REDUCE, 47);
   _actionMap[12][TABLE] = ActionEntry(SHIFT, 48);
   _actionMap[13][IDENTIFIER] = ActionEntry(SHIFT, 49);
   _actionMap[14][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[14][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[14][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[14][ObjSpec] = 50;
   _actionMap[15][INDEX] = ActionEntry(SHIFT, 54);
   _actionMap[16][SEMICOLON] = ActionEntry(REDUCE, 188);
   _actionMap[17][VIEW] = ActionEntry(SHIFT, 63);
   _actionMap[17][TABLE] = ActionEntry(SHIFT, 61);
   _actionMap[17][PRIMARY] = ActionEntry(SHIFT, 59);
   _actionMap[17][COUNTER] = ActionEntry(SHIFT, 58);
   _actionMap[17][PROCEDURE] = ActionEntry(SHIFT, 60);
   _actionMap[17][UNIQUE] = ActionEntry(SHIFT, 62);
   _actionMap[17][INDEX] = ActionEntry(REDUCE, 184);
   _actionMap[17][BTREE] = ActionEntry(REDUCE, 184);
   _jumpMap[17][IndexOption] = 57;
   _jumpMap[17][ProcDef] = 56;
   _jumpMap[17][ProcHead] = 55;
   _actionMap[18][FROM] = ActionEntry(SHIFT, 64);
   _actionMap[19][TABLE] = ActionEntry(SHIFT, 70);
   _actionMap[19][INDEX] = ActionEntry(SHIFT, 68);
   _actionMap[19][BTREE] = ActionEntry(SHIFT, 65);
   _actionMap[19][VIEW] = ActionEntry(SHIFT, 71);
   _actionMap[19][FOREIGN] = ActionEntry(SHIFT, 67);
   _actionMap[19][CHECK] = ActionEntry(SHIFT, 66);
   _actionMap[19][PROCEDURE] = ActionEntry(SHIFT, 69);
   _actionMap[20][COUNTER] = ActionEntry(REDUCE, 64);
   _actionMap[20][IF] = ActionEntry(SHIFT, 72);
   _actionMap[20][BTREE] = ActionEntry(REDUCE, 64);
   _actionMap[20][CHECK] = ActionEntry(REDUCE, 64);
   _actionMap[20][FOREIGN] = ActionEntry(REDUCE, 64);
   _actionMap[20][PROCEDURE] = ActionEntry(REDUCE, 64);
   _actionMap[20][VIEW] = ActionEntry(REDUCE, 64);
}
void Cego::loadParser243()
{
   _actionMap[20][INDEX] = ActionEntry(REDUCE, 64);
   _actionMap[20][TABLE] = ActionEntry(REDUCE, 64);
   _actionMap[21][INTO] = ActionEntry(SHIFT, 73);
   _actionMap[22][IDENTIFIER] = ActionEntry(SHIFT, 75);
   _jumpMap[22][JdbcArgList] = 74;
   _actionMap[23][TABLESET] = ActionEntry(SHIFT, 84);
   _actionMap[23][TABLE] = ActionEntry(SHIFT, 83);
   _actionMap[23][PROCEDURE] = ActionEntry(SHIFT, 81);
   _actionMap[23][VIEW] = ActionEntry(SHIFT, 86);
   _actionMap[23][INDEX] = ActionEntry(SHIFT, 79);
   _actionMap[23][BTREE] = ActionEntry(SHIFT, 76);
   _actionMap[23][KEY] = ActionEntry(SHIFT, 80);
   _actionMap[23][COUNTER] = ActionEntry(SHIFT, 78);
   _actionMap[23][SYSOBJ] = ActionEntry(SHIFT, 82);
   _actionMap[23][TMPOBJ] = ActionEntry(SHIFT, 85);
   _actionMap[23][CHECK] = ActionEntry(SHIFT, 77);
   _actionMap[24][VIEW] = ActionEntry(SHIFT, 88);
   _actionMap[24][PROCEDURE] = ActionEntry(SHIFT, 60);
   _jumpMap[24][ProcDef] = 87;
   _jumpMap[24][ProcHead] = 55;
   _actionMap[25][SELECT] = ActionEntry(SHIFT, 30);
   _jumpMap[25][SelectStatement] = 89;
   _actionMap[26][FLOATVAL] = ActionEntry(SHIFT, 148);
   _actionMap[26][MINUS] = ActionEntry(SHIFT, 146);
   _actionMap[26][INTVAL] = ActionEntry(SHIFT, 147);
   _actionMap[26][TRIM] = ActionEntry(SHIFT, 140);
   _actionMap[26][RTRIM] = ActionEntry(SHIFT, 132);
   _actionMap[26][LTRIM] = ActionEntry(SHIFT, 120);
   _actionMap[26][ROUND] = ActionEntry(SHIFT, 131);
   _actionMap[26][DATE2STR] = ActionEntry(SHIFT, 110);
   _actionMap[26][DATE2INT] = ActionEntry(SHIFT, 111);
   _actionMap[26][INT2DATE] = ActionEntry(SHIFT, 116);
   _actionMap[26][LOWER] = ActionEntry(SHIFT, 119);
   _actionMap[26][UPPER] = ActionEntry(SHIFT, 143);
   _actionMap[26][LEFT] = ActionEntry(SHIFT, 117);
   _actionMap[26][RIGHT] = ActionEntry(SHIFT, 130);
   _actionMap[26][GETPOS] = ActionEntry(SHIFT, 115);
   _actionMap[26][SUBSTR] = ActionEntry(SHIFT, 134);
   _actionMap[26][REPLACE] = ActionEntry(SHIFT, 129);
   _actionMap[26][LENGTH] = ActionEntry(SHIFT, 118);
   _actionMap[26][TRUNC] = ActionEntry(SHIFT, 142);
   _actionMap[26][STR2INT] = ActionEntry(SHIFT, 137);
   _actionMap[26][STR2LONG] = ActionEntry(SHIFT, 138);
   _actionMap[26][STR2DATE] = ActionEntry(SHIFT, 139);
   _actionMap[26][RANDSTR] = ActionEntry(SHIFT, 127);
   _actionMap[26][RANDINT] = ActionEntry(SHIFT, 128);
   _actionMap[26][MOD] = ActionEntry(SHIFT, 123);
   _actionMap[26][DIV] = ActionEntry(SHIFT, 112);
   _actionMap[26][POWER] = ActionEntry(SHIFT, 126);
   _actionMap[26][BITAND] = ActionEntry(SHIFT, 103);
}
void Cego::loadParser244()
{
   _actionMap[26][BITOR] = ActionEntry(SHIFT, 104);
   _actionMap[26][BITXOR] = ActionEntry(SHIFT, 105);
   _actionMap[26][BLOBSIZE] = ActionEntry(SHIFT, 106);
   _actionMap[26][NEXTCOUNT] = ActionEntry(SHIFT, 124);
   _actionMap[26][SETCOUNT] = ActionEntry(SHIFT, 133);
   _actionMap[26][IDENTIFIER] = ActionEntry(SHIFT, 149);
   _actionMap[26][QUALIFIEDOBJ] = ActionEntry(SHIFT, 151);
   _actionMap[26][QUALIFIEDPRE] = ActionEntry(SHIFT, 152);
   _actionMap[26][LB] = ActionEntry(SHIFT, 144);
   _actionMap[26][STRINGVAL] = ActionEntry(SHIFT, 101);
   _actionMap[26][DATE] = ActionEntry(SHIFT, 109);
   _actionMap[26][SYSDATE] = ActionEntry(SHIFT, 136);
   _actionMap[26][NULLTOKEN] = ActionEntry(SHIFT, 125);
   _actionMap[26][TRUEVAL] = ActionEntry(SHIFT, 141);
   _actionMap[26][FALSEVAL] = ActionEntry(SHIFT, 113);
   _actionMap[26][LAB] = ActionEntry(SHIFT, 145);
   _actionMap[26][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _actionMap[26][CASE] = ActionEntry(SHIFT, 107);
   _actionMap[26][VARREF] = ActionEntry(SHIFT, 150);
   _actionMap[26][FETCH] = ActionEntry(SHIFT, 114);
   _actionMap[26][COUNT] = ActionEntry(SHIFT, 108);
   _actionMap[26][SUM] = ActionEntry(SHIFT, 135);
   _actionMap[26][AVG] = ActionEntry(SHIFT, 102);
   _actionMap[26][MIN] = ActionEntry(SHIFT, 121);
   _actionMap[26][MAX] = ActionEntry(SHIFT, 122);
   _jumpMap[26][ObjSpec] = 100;
   _jumpMap[26][Constant] = 99;
   _jumpMap[26][SignedFloat] = 98;
   _jumpMap[26][SignedInt] = 97;
   _jumpMap[26][Attribute] = 96;
   _jumpMap[26][Function] = 95;
   _jumpMap[26][CasePrepare] = 94;
   _jumpMap[26][CaseClause] = 93;
   _jumpMap[26][Factor] = 92;
   _jumpMap[26][Term] = 91;
   _jumpMap[26][Expr] = 90;
   _actionMap[27][TABLE] = ActionEntry(SHIFT, 157);
   _actionMap[27][INDEX] = ActionEntry(SHIFT, 154);
   _actionMap[27][KEY] = ActionEntry(SHIFT, 155);
   _actionMap[27][PROCEDURE] = ActionEntry(SHIFT, 156);
   _actionMap[27][VIEW] = ActionEntry(SHIFT, 158);
   _actionMap[27][CHECK] = ActionEntry(SHIFT, 153);
   _actionMap[28][TABLE] = ActionEntry(SHIFT, 160);
   _actionMap[28][INDEX] = ActionEntry(SHIFT, 159);
   _actionMap[29][SEMICOLON] = ActionEntry(REDUCE, 189);
   _actionMap[30][DISTINCT] = ActionEntry(SHIFT, 163);
   _actionMap[30][VARREF] = ActionEntry(REDUCE, 243);
   _actionMap[30][FETCH] = ActionEntry(REDUCE, 243);
   _actionMap[30][LB] = ActionEntry(REDUCE, 243);
   _actionMap[30][COUNT] = ActionEntry(REDUCE, 243);
}
void Cego::loadParser245()
{
   _actionMap[30][SUM] = ActionEntry(REDUCE, 243);
   _actionMap[30][AVG] = ActionEntry(REDUCE, 243);
   _actionMap[30][MIN] = ActionEntry(REDUCE, 243);
   _actionMap[30][MAX] = ActionEntry(REDUCE, 243);
   _actionMap[30][CASE] = ActionEntry(REDUCE, 243);
   _actionMap[30][TRIM] = ActionEntry(REDUCE, 243);
   _actionMap[30][RTRIM] = ActionEntry(REDUCE, 243);
   _actionMap[30][LTRIM] = ActionEntry(REDUCE, 243);
   _actionMap[30][ROUND] = ActionEntry(REDUCE, 243);
   _actionMap[30][DATE2STR] = ActionEntry(REDUCE, 243);
   _actionMap[30][DATE2INT] = ActionEntry(REDUCE, 243);
   _actionMap[30][INT2DATE] = ActionEntry(REDUCE, 243);
   _actionMap[30][LOWER] = ActionEntry(REDUCE, 243);
   _actionMap[30][UPPER] = ActionEntry(REDUCE, 243);
   _actionMap[30][LEFT] = ActionEntry(REDUCE, 243);
   _actionMap[30][RIGHT] = ActionEntry(REDUCE, 243);
   _actionMap[30][GETPOS] = ActionEntry(REDUCE, 243);
   _actionMap[30][SUBSTR] = ActionEntry(REDUCE, 243);
   _actionMap[30][REPLACE] = ActionEntry(REDUCE, 243);
   _actionMap[30][LENGTH] = ActionEntry(REDUCE, 243);
   _actionMap[30][TRUNC] = ActionEntry(REDUCE, 243);
   _actionMap[30][STR2INT] = ActionEntry(REDUCE, 243);
   _actionMap[30][STR2LONG] = ActionEntry(REDUCE, 243);
   _actionMap[30][STR2DATE] = ActionEntry(REDUCE, 243);
   _actionMap[30][RANDSTR] = ActionEntry(REDUCE, 243);
   _actionMap[30][RANDINT] = ActionEntry(REDUCE, 243);
   _actionMap[30][MOD] = ActionEntry(REDUCE, 243);
   _actionMap[30][DIV] = ActionEntry(REDUCE, 243);
   _actionMap[30][POWER] = ActionEntry(REDUCE, 243);
   _actionMap[30][BITAND] = ActionEntry(REDUCE, 243);
   _actionMap[30][BITOR] = ActionEntry(REDUCE, 243);
   _actionMap[30][BITXOR] = ActionEntry(REDUCE, 243);
   _actionMap[30][BLOBSIZE] = ActionEntry(REDUCE, 243);
   _actionMap[30][NEXTCOUNT] = ActionEntry(REDUCE, 243);
   _actionMap[30][SETCOUNT] = ActionEntry(REDUCE, 243);
   _actionMap[30][IDENTIFIER] = ActionEntry(REDUCE, 243);
   _actionMap[30][QUALIFIEDOBJ] = ActionEntry(REDUCE, 243);
   _actionMap[30][QUALIFIEDTS] = ActionEntry(REDUCE, 243);
   _actionMap[30][QUALIFIEDPRE] = ActionEntry(REDUCE, 243);
   _actionMap[30][STRINGVAL] = ActionEntry(REDUCE, 243);
   _actionMap[30][DATE] = ActionEntry(REDUCE, 243);
   _actionMap[30][SYSDATE] = ActionEntry(REDUCE, 243);
   _actionMap[30][NULLTOKEN] = ActionEntry(REDUCE, 243);
   _actionMap[30][TRUEVAL] = ActionEntry(REDUCE, 243);
   _actionMap[30][FALSEVAL] = ActionEntry(REDUCE, 243);
   _actionMap[30][LAB] = ActionEntry(REDUCE, 243);
   _actionMap[30][FLOATVAL] = ActionEntry(REDUCE, 243);
   _actionMap[30][MINUS] = ActionEntry(REDUCE, 243);
   _actionMap[30][INTVAL] = ActionEntry(REDUCE, 243);
   _actionMap[30][STAR] = ActionEntry(SHIFT, 164);
}
void Cego::loadParser246()
{
   _jumpMap[30][DistinctOpt] = 162;
   _jumpMap[30][Selection] = 161;
   _actionMap[31][TABLESET] = ActionEntry(SHIFT, 169);
   _actionMap[31][APPEND] = ActionEntry(SHIFT, 165);
   _actionMap[31][AUTOCOMMIT] = ActionEntry(SHIFT, 166);
   _actionMap[31][ISOLATION] = ActionEntry(SHIFT, 168);
   _actionMap[31][IDENTIFIER] = ActionEntry(SHIFT, 170);
   _actionMap[31][COUNTER] = ActionEntry(SHIFT, 167);
   _actionMap[32][POOL] = ActionEntry(SHIFT, 172);
   _actionMap[32][SYSTEMSPACE] = ActionEntry(SHIFT, 174);
   _actionMap[32][PROCEDURE] = ActionEntry(SHIFT, 173);
   _actionMap[32][VIEW] = ActionEntry(SHIFT, 175);
   _actionMap[32][CHECK] = ActionEntry(SHIFT, 171);
   _actionMap[33][TRANSACTION] = ActionEntry(SHIFT, 176);
   _actionMap[34][SEMICOLON] = ActionEntry(REDUCE, 1);
   _actionMap[35][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[35][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[35][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[35][ObjSpec] = 177;
   _actionMap[36][IDENTIFIER] = ActionEntry(SHIFT, 51);
   _actionMap[36][QUALIFIEDOBJ] = ActionEntry(SHIFT, 52);
   _actionMap[36][QUALIFIEDTS] = ActionEntry(SHIFT, 53);
   _jumpMap[36][ObjSpec] = 178;
   _actionMap[37][SEMICOLON] = ActionEntry(REDUCE, 16);
   _actionMap[38][EQU] = ActionEntry(SHIFT, 179);
   _actionMap[0][DROP] = ActionEntry(SHIFT, 20);
   _actionMap[0][RENAME] = ActionEntry(SHIFT, 27);
   _actionMap[0][ALTER] = ActionEntry(SHIFT, 12);
   _actionMap[0][UPDATE] = ActionEntry(SHIFT, 36);
   _actionMap[0][DELETETOK] = ActionEntry(SHIFT, 18);
   _actionMap[0][INSERT] = ActionEntry(SHIFT, 21);
   _actionMap[0][SELECT] = ActionEntry(SHIFT, 30);
   _actionMap[0][ROLLBACK] = ActionEntry(SHIFT, 29);
   _actionMap[0][COMMIT] = ActionEntry(SHIFT, 16);
   _actionMap[0][START_TOKEN] = ActionEntry(SHIFT, 33);
   _actionMap[0][SYNC] = ActionEntry(SHIFT, 34);
   _actionMap[0][LIST] = ActionEntry(SHIFT, 23);
   _actionMap[0][TABLEINFO] = ActionEntry(SHIFT, 35);
   _actionMap[0][UPTIME] = ActionEntry(SHIFT, 37);
   _actionMap[0][SHOW] = ActionEntry(SHIFT, 32);
   _actionMap[0][DESC] = ActionEntry(SHIFT, 19);
   _actionMap[0][SET] = ActionEntry(SHIFT, 31);
   _actionMap[0][AUTHORIZE] = ActionEntry(SHIFT, 13);
   _actionMap[0][REORGANIZE] = ActionEntry(SHIFT, 28);
   _actionMap[0][PLAN] = ActionEntry(SHIFT, 25);
   _actionMap[0][CREATE] = ActionEntry(SHIFT, 17);
   _actionMap[0][LOAD] = ActionEntry(SHIFT, 24);
   _actionMap[0][CALL] = ActionEntry(SHIFT, 14);
   _actionMap[0][VARREF] = ActionEntry(SHIFT, 38);
   _actionMap[0][PRINT] = ActionEntry(SHIFT, 26);
}
void Cego::loadParser247()
{
   _actionMap[0][CHECK] = ActionEntry(SHIFT, 15);
   _actionMap[0][JDBC] = ActionEntry(SHIFT, 22);
   _jumpMap[0][RenameStatement] = 11;
   _jumpMap[0][AlterStatement] = 10;
   _jumpMap[0][DeleteStatement] = 9;
   _jumpMap[0][UpdateStatement] = 8;
   _jumpMap[0][SelectStatement] = 7;
   _jumpMap[0][InsertStatement] = 6;
   _jumpMap[0][RollbackStatement] = 5;
   _jumpMap[0][CommitStatement] = 4;
   _jumpMap[0][StartStatement] = 3;
   _jumpMap[0][Statement] = 2;
   _jumpMap[0][DropOpt] = 1;
}
void Cego::loadParser248()
{
   _prodInfo.Insert(ProdEntry(369, ObjSpec, 1));
   _prodInfo.Insert(ProdEntry(368, ObjSpec, 1));
   _prodInfo.Insert(ProdEntry(367, ObjSpec, 1));
   _prodInfo.Insert(ProdEntry(366, DateValue, 1));
   _prodInfo.Insert(ProdEntry(365, DateFormat, 1));
   _prodInfo.Insert(ProdEntry(364, Constant, 5));
   _prodInfo.Insert(ProdEntry(363, Constant, 1));
   _prodInfo.Insert(ProdEntry(362, Constant, 1));
   _prodInfo.Insert(ProdEntry(361, Constant, 1));
   _prodInfo.Insert(ProdEntry(360, Constant, 1));
   _prodInfo.Insert(ProdEntry(359, Constant, 6));
   _prodInfo.Insert(ProdEntry(358, Constant, 4));
   _prodInfo.Insert(ProdEntry(357, Constant, 4));
   _prodInfo.Insert(ProdEntry(356, Constant, 4));
   _prodInfo.Insert(ProdEntry(355, Constant, 1));
   _prodInfo.Insert(ProdEntry(354, Constant, 1));
   _prodInfo.Insert(ProdEntry(353, Constant, 4));
   _prodInfo.Insert(ProdEntry(352, Constant, 4));
   _prodInfo.Insert(ProdEntry(351, Constant, 4));
   _prodInfo.Insert(ProdEntry(350, Constant, 4));
   _prodInfo.Insert(ProdEntry(349, Constant, 1));
   _prodInfo.Insert(ProdEntry(348, SignedFloat, 2));
   _prodInfo.Insert(ProdEntry(347, SignedFloat, 1));
   _prodInfo.Insert(ProdEntry(346, SignedInt, 2));
   _prodInfo.Insert(ProdEntry(345, SignedInt, 1));
   _prodInfo.Insert(ProdEntry(344, Attribute, 2));
   _prodInfo.Insert(ProdEntry(343, Attribute, 1));
   _prodInfo.Insert(ProdEntry(342, Attribute, 1));
   _prodInfo.Insert(ProdEntry(341, Comparison, 2));
   _prodInfo.Insert(ProdEntry(340, Comparison, 2));
   _prodInfo.Insert(ProdEntry(339, Comparison, 1));
   _prodInfo.Insert(ProdEntry(338, Comparison, 1));
   _prodInfo.Insert(ProdEntry(337, Comparison, 2));
   _prodInfo.Insert(ProdEntry(336, Comparison, 1));
   _prodInfo.Insert(ProdEntry(335, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(334, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(333, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(332, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(331, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(330, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(329, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(328, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(327, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(326, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(325, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(324, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(323, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(322, QueryPredicate, 2));
   _prodInfo.Insert(ProdEntry(321, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(320, QueryPredicate, 4));
   _prodInfo.Insert(ProdEntry(319, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(318, QueryPredicate, 4));
   _prodInfo.Insert(ProdEntry(317, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(316, QueryPredicate, 5));
   _prodInfo.Insert(ProdEntry(315, QueryPredicate, 3));
   _prodInfo.Insert(ProdEntry(314, QueryPredicate, 6));
   _prodInfo.Insert(ProdEntry(313, QueryPredicate, 5));
   _prodInfo.Insert(ProdEntry(312, QueryPredicate, 4));
   _prodInfo.Insert(ProdEntry(311, QueryCondition, 1));
   _prodInfo.Insert(ProdEntry(310, QueryCondition, 3));
   _prodInfo.Insert(ProdEntry(309, QueryCondition, 3));
   _prodInfo.Insert(ProdEntry(308, NoWhere, 0));
   _prodInfo.Insert(ProdEntry(307, WhereClause, 1));
   _prodInfo.Insert(ProdEntry(306, WhereClause, 2));
   _prodInfo.Insert(ProdEntry(305, ExpressionList, 1));
   _prodInfo.Insert(ProdEntry(304, ExpressionList, 3));
   _prodInfo.Insert(ProdEntry(303, Function, 3));
   _prodInfo.Insert(ProdEntry(302, Function, 4));
   _prodInfo.Insert(ProdEntry(301, Function, 6));
   _prodInfo.Insert(ProdEntry(300, Function, 4));
   _prodInfo.Insert(ProdEntry(299, Function, 4));
   _prodInfo.Insert(ProdEntry(298, Function, 4));
   _prodInfo.Insert(ProdEntry(297, Function, 4));
   _prodInfo.Insert(ProdEntry(296, Function, 4));
   _prodInfo.Insert(ProdEntry(295, Function, 4));
   _prodInfo.Insert(ProdEntry(294, Function, 4));
   _prodInfo.Insert(ProdEntry(293, Function, 4));
   _prodInfo.Insert(ProdEntry(292, Function, 4));
   _prodInfo.Insert(ProdEntry(291, Function, 4));
   _prodInfo.Insert(ProdEntry(290, Function, 4));
   _prodInfo.Insert(ProdEntry(289, Function, 4));
   _prodInfo.Insert(ProdEntry(288, Function, 4));
   _prodInfo.Insert(ProdEntry(287, Function, 4));
   _prodInfo.Insert(ProdEntry(286, Function, 4));
   _prodInfo.Insert(ProdEntry(285, Function, 4));
   _prodInfo.Insert(ProdEntry(284, Function, 4));
   _prodInfo.Insert(ProdEntry(283, Function, 4));
   _prodInfo.Insert(ProdEntry(282, Function, 4));
   _prodInfo.Insert(ProdEntry(281, Function, 4));
   _prodInfo.Insert(ProdEntry(280, Function, 4));
   _prodInfo.Insert(ProdEntry(279, Function, 4));
   _prodInfo.Insert(ProdEntry(278, Function, 4));
   _prodInfo.Insert(ProdEntry(277, Function, 4));
   _prodInfo.Insert(ProdEntry(276, Function, 4));
   _prodInfo.Insert(ProdEntry(275, Function, 4));
   _prodInfo.Insert(ProdEntry(274, Function, 4));
   _prodInfo.Insert(ProdEntry(273, Function, 4));
   _prodInfo.Insert(ProdEntry(272, Function, 4));
   _prodInfo.Insert(ProdEntry(271, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(270, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(269, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(268, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(267, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(266, RenameStatement, 5));
   _prodInfo.Insert(ProdEntry(265, AlterOption, 5));
   _prodInfo.Insert(ProdEntry(264, AlterOption, 3));
   _prodInfo.Insert(ProdEntry(263, AlterOption, 3));
   _prodInfo.Insert(ProdEntry(262, AlterOption, 3));
   _prodInfo.Insert(ProdEntry(261, AlterList, 1));
   _prodInfo.Insert(ProdEntry(260, AlterList, 3));
   _prodInfo.Insert(ProdEntry(259, AlterStatement, 4));
   _prodInfo.Insert(ProdEntry(258, UpdDelAlias, 0));
   _prodInfo.Insert(ProdEntry(257, UpdDelAlias, 1));
   _prodInfo.Insert(ProdEntry(256, DeleteStatement, 5));
   _prodInfo.Insert(ProdEntry(255, ReturnVar, 3));
   _prodInfo.Insert(ProdEntry(254, ReturnVarList, 1));
   _prodInfo.Insert(ProdEntry(253, ReturnVarList, 3));
   _prodInfo.Insert(ProdEntry(252, UpdReturnOpt, 0));
   _prodInfo.Insert(ProdEntry(251, UpdReturnOpt, 2));
   _prodInfo.Insert(ProdEntry(250, Assignment, 3));
   _prodInfo.Insert(ProdEntry(249, UpdateList, 1));
   _prodInfo.Insert(ProdEntry(248, UpdateList, 3));
   _prodInfo.Insert(ProdEntry(247, UpdateStatement, 7));
   _prodInfo.Insert(ProdEntry(246, NoLimit, 0));
   _prodInfo.Insert(ProdEntry(245, LimitOpt, 1));
   _prodInfo.Insert(ProdEntry(244, LimitOpt, 2));
   _prodInfo.Insert(ProdEntry(243, DistinctOpt, 0));
   _prodInfo.Insert(ProdEntry(242, DistinctOpt, 1));
   _prodInfo.Insert(ProdEntry(241, DefaultOrderOpt, 0));
   _prodInfo.Insert(ProdEntry(240, DefaultOrderOpt, 1));
   _prodInfo.Insert(ProdEntry(239, OrderingOpt, 1));
   _prodInfo.Insert(ProdEntry(238, OrderingOpt, 1));
   _prodInfo.Insert(ProdEntry(237, OrderingList, 2));
   _prodInfo.Insert(ProdEntry(236, OrderingList, 4));
   _prodInfo.Insert(ProdEntry(235, NoOrdering, 0));
   _prodInfo.Insert(ProdEntry(234, OrderingClause, 1));
   _prodInfo.Insert(ProdEntry(233, OrderingClause, 3));
   _prodInfo.Insert(ProdEntry(232, NoHaving, 0));
   _prodInfo.Insert(ProdEntry(231, HavingClause, 1));
   _prodInfo.Insert(ProdEntry(230, HavingClause, 4));
   _prodInfo.Insert(ProdEntry(229, GroupList, 1));
   _prodInfo.Insert(ProdEntry(228, GroupList, 3));
   _prodInfo.Insert(ProdEntry(227, NoGroup, 0));
   _prodInfo.Insert(ProdEntry(226, GroupClause, 1));
   _prodInfo.Insert(ProdEntry(225, GroupClause, 4));
   _prodInfo.Insert(ProdEntry(224, NoAliasOpt, 0));
   _prodInfo.Insert(ProdEntry(223, AliasOpt, 1));
   _prodInfo.Insert(ProdEntry(222, AliasOpt, 2));
   _prodInfo.Insert(ProdEntry(221, JoinTableOn, 1));
   _prodInfo.Insert(ProdEntry(220, Table, 2));
   _prodInfo.Insert(ProdEntry(219, Table, 1));
   _prodInfo.Insert(ProdEntry(218, TableList, 1));
   _prodInfo.Insert(ProdEntry(217, TableList, 3));
   _prodInfo.Insert(ProdEntry(216, InnerJoin, 1));
   _prodInfo.Insert(ProdEntry(215, InnerJoin, 2));
   _prodInfo.Insert(ProdEntry(214, JoinSpec, 6));
   _prodInfo.Insert(ProdEntry(213, JoinSpec, 6));
   _prodInfo.Insert(ProdEntry(212, JoinSpec, 4));
   _prodInfo.Insert(ProdEntry(211, JoinSpecList, 2));
   _prodInfo.Insert(ProdEntry(210, JoinSpecList, 2));
   _prodInfo.Insert(ProdEntry(209, TableSource, 1));
   _prodInfo.Insert(ProdEntry(208, TableSource, 1));
   _prodInfo.Insert(ProdEntry(207, SelectItem, 2));
   _prodInfo.Insert(ProdEntry(206, SelectionList, 1));
   _prodInfo.Insert(ProdEntry(205, SelectionList, 3));
   _prodInfo.Insert(ProdEntry(204, Selection, 1));
   _prodInfo.Insert(ProdEntry(203, Selection, 2));
   _prodInfo.Insert(ProdEntry(202, SelectStatement, 9));
   _prodInfo.Insert(ProdEntry(201, InsertValueList, 1));
   _prodInfo.Insert(ProdEntry(200, InsertValueList, 3));
   _prodInfo.Insert(ProdEntry(199, InsertArgList, 1));
   _prodInfo.Insert(ProdEntry(198, InsertArgList, 3));
   _prodInfo.Insert(ProdEntry(197, InsertValueSpec, 3));
   _prodInfo.Insert(ProdEntry(196, InsertValueSpecList, 1));
   _prodInfo.Insert(ProdEntry(195, InsertValueSpecList, 3));
   _prodInfo.Insert(ProdEntry(194, InsertPrepare, 1));
   _prodInfo.Insert(ProdEntry(193, InsertArgSpec, 0));
   _prodInfo.Insert(ProdEntry(192, InsertArgSpec, 3));
   _prodInfo.Insert(ProdEntry(191, InsertStatement, 5));
   _prodInfo.Insert(ProdEntry(190, InsertStatement, 6));
   _prodInfo.Insert(ProdEntry(189, RollbackStatement, 1));
   _prodInfo.Insert(ProdEntry(188, CommitStatement, 1));
   _prodInfo.Insert(ProdEntry(187, StartStatement, 2));
   _prodInfo.Insert(ProdEntry(186, IndexType, 1));
   _prodInfo.Insert(ProdEntry(185, IndexType, 1));
   _prodInfo.Insert(ProdEntry(184, IndexOption, 0));
   _prodInfo.Insert(ProdEntry(183, IndexOption, 1));
   _prodInfo.Insert(ProdEntry(182, SimpleAttr, 1));
   _prodInfo.Insert(ProdEntry(181, SimpleAttrList, 1));
   _prodInfo.Insert(ProdEntry(180, SimpleAttrList, 3));
   _prodInfo.Insert(ProdEntry(179, DefaultDefOpt, 0));
   _prodInfo.Insert(ProdEntry(178, DefaultOpt, 1));
   _prodInfo.Insert(ProdEntry(177, DefaultOpt, 2));
   _prodInfo.Insert(ProdEntry(176, DefaultNullOpt, 0));
   _prodInfo.Insert(ProdEntry(175, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(174, NullOpt, 2));
   _prodInfo.Insert(ProdEntry(173, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(172, ColumnDesc, 4));
   _prodInfo.Insert(ProdEntry(171, KeyColumn, 1));
   _prodInfo.Insert(ProdEntry(170, KeyColumn, 2));
   _prodInfo.Insert(ProdEntry(169, ColumnList, 1));
   _prodInfo.Insert(ProdEntry(168, ColumnList, 3));
   _prodInfo.Insert(ProdEntry(167, FetchArgList, 1));
   _prodInfo.Insert(ProdEntry(166, FetchArgList, 3));
   _prodInfo.Insert(ProdEntry(165, CasePrepare, 1));
   _prodInfo.Insert(ProdEntry(164, CaseCondition, 4));
   _prodInfo.Insert(ProdEntry(163, CaseConditionList, 1));
   _prodInfo.Insert(ProdEntry(162, CaseConditionList, 2));
   _prodInfo.Insert(ProdEntry(161, CaseClause, 5));
   _prodInfo.Insert(ProdEntry(160, Factor, 4));
   _prodInfo.Insert(ProdEntry(159, Factor, 4));
   _prodInfo.Insert(ProdEntry(158, Factor, 5));
   _prodInfo.Insert(ProdEntry(157, Factor, 4));
   _prodInfo.Insert(ProdEntry(156, Factor, 4));
   _prodInfo.Insert(ProdEntry(155, Factor, 4));
   _prodInfo.Insert(ProdEntry(154, Factor, 1));
   _prodInfo.Insert(ProdEntry(153, Factor, 3));
   _prodInfo.Insert(ProdEntry(152, Factor, 3));
   _prodInfo.Insert(ProdEntry(151, Factor, 1));
   _prodInfo.Insert(ProdEntry(150, Factor, 1));
   _prodInfo.Insert(ProdEntry(149, Factor, 6));
   _prodInfo.Insert(ProdEntry(148, Factor, 1));
   _prodInfo.Insert(ProdEntry(147, Factor, 1));
   _prodInfo.Insert(ProdEntry(146, Term, 1));
   _prodInfo.Insert(ProdEntry(145, Term, 3));
   _prodInfo.Insert(ProdEntry(144, Term, 3));
   _prodInfo.Insert(ProdEntry(143, Expr, 3));
   _prodInfo.Insert(ProdEntry(142, Expr, 1));
   _prodInfo.Insert(ProdEntry(141, Expr, 3));
   _prodInfo.Insert(ProdEntry(140, Expr, 3));
   _prodInfo.Insert(ProdEntry(139, ProcPredicate, 4));
   _prodInfo.Insert(ProdEntry(138, ProcPredicate, 3));
   _prodInfo.Insert(ProdEntry(137, ProcPredicate, 3));
   _prodInfo.Insert(ProdEntry(136, ProcPredicate, 3));
   _prodInfo.Insert(ProdEntry(135, ProcCondition, 1));
   _prodInfo.Insert(ProdEntry(134, ProcCondition, 3));
   _prodInfo.Insert(ProdEntry(133, ProcCondition, 3));
   _prodInfo.Insert(ProdEntry(132, ProcWhileCondition, 1));
   _prodInfo.Insert(ProdEntry(131, ProcStatement, 5));
   _prodInfo.Insert(ProdEntry(130, ProcElsIfCondition, 1));
   _prodInfo.Insert(ProdEntry(129, ProcIfCondition, 1));
   _prodInfo.Insert(ProdEntry(128, ProcElsePart, 1));
   _prodInfo.Insert(ProdEntry(127, ProcElseOpt, 0));
   _prodInfo.Insert(ProdEntry(126, ProcElseOpt, 2));
   _prodInfo.Insert(ProdEntry(125, ProcElsIfOpt, 4));
   _prodInfo.Insert(ProdEntry(124, ProcElsIfList, 0));
   _prodInfo.Insert(ProdEntry(123, ProcElsIfList, 2));
   _prodInfo.Insert(ProdEntry(122, ProcIfPart, 4));
   _prodInfo.Insert(ProdEntry(121, ProcStatement, 4));
   _prodInfo.Insert(ProdEntry(120, ProcExceptionType, 1));
   _prodInfo.Insert(ProdEntry(119, ProcValueList, 1));
   _prodInfo.Insert(ProdEntry(118, ProcValueList, 3));
   _prodInfo.Insert(ProdEntry(117, ProcValueListOpt, 0));
   _prodInfo.Insert(ProdEntry(116, ProcValueListOpt, 1));
   _prodInfo.Insert(ProdEntry(115, ProcExceptionStmt, 5));
   _prodInfo.Insert(ProdEntry(114, ProcExceptionList, 0));
   _prodInfo.Insert(ProdEntry(113, ProcExceptionList, 2));
   _prodInfo.Insert(ProdEntry(112, ProcBlockStart, 1));
   _prodInfo.Insert(ProdEntry(111, ProcStatement, 3));
   _prodInfo.Insert(ProdEntry(110, ProcStatement, 2));
   _prodInfo.Insert(ProdEntry(109, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(108, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(107, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(106, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(105, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(104, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(103, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(102, ProcStatement, 2));
   _prodInfo.Insert(ProdEntry(101, ProcNoAssignment, 0));
   _prodInfo.Insert(ProdEntry(100, ProcInitialAssignment, 1));
   _prodInfo.Insert(ProdEntry(99, ProcInitialAssignment, 2));
   _prodInfo.Insert(ProdEntry(98, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(97, ProcStatement, 1));
   _prodInfo.Insert(ProdEntry(96, ProcStatement, 3));
   _prodInfo.Insert(ProdEntry(95, ProcStatement, 2));
   _prodInfo.Insert(ProdEntry(94, ProcStatement, 4));
   _prodInfo.Insert(ProdEntry(93, ProcStatement, 4));
   _prodInfo.Insert(ProdEntry(92, ProcStatementList, 2));
   _prodInfo.Insert(ProdEntry(91, ProcStatementList, 3));
   _prodInfo.Insert(ProdEntry(90, ProcStmtBlock, 2));
   _prodInfo.Insert(ProdEntry(89, ProcArg, 3));
   _prodInfo.Insert(ProdEntry(88, ProcArg, 3));
   _prodInfo.Insert(ProdEntry(87, ProcArgList, 1));
   _prodInfo.Insert(ProdEntry(86, ProcArgList, 3));
   _prodInfo.Insert(ProdEntry(85, ProcArgOpt, 0));
   _prodInfo.Insert(ProdEntry(84, ProcArgOpt, 1));
   _prodInfo.Insert(ProdEntry(83, ReturnOpt, 0));
   _prodInfo.Insert(ProdEntry(82, ReturnOpt, 2));
   _prodInfo.Insert(ProdEntry(81, ProcDef, 4));
   _prodInfo.Insert(ProdEntry(80, ProcHead, 6));
   _prodInfo.Insert(ProdEntry(79, UnionAllOpt, 0));
   _prodInfo.Insert(ProdEntry(78, UnionAllOpt, 3));
   _prodInfo.Insert(ProdEntry(77, JdbcArgList, 1));
   _prodInfo.Insert(ProdEntry(76, JdbcArgList, 2));
   _prodInfo.Insert(ProdEntry(75, Statement, 2));
   _prodInfo.Insert(ProdEntry(74, CounterId, 1));
   _prodInfo.Insert(ProdEntry(73, Statement, 5));
   _prodInfo.Insert(ProdEntry(72, Statement, 3));
   _prodInfo.Insert(ProdEntry(71, Statement, 3));
   _prodInfo.Insert(ProdEntry(70, Statement, 3));
   _prodInfo.Insert(ProdEntry(69, Statement, 2));
   _prodInfo.Insert(ProdEntry(68, Statement, 4));
   _prodInfo.Insert(ProdEntry(67, Statement, 8));
   _prodInfo.Insert(ProdEntry(66, Statement, 15));
   _prodInfo.Insert(ProdEntry(65, DropOpt, 3));
   _prodInfo.Insert(ProdEntry(64, DropOpt, 1));
   _prodInfo.Insert(ProdEntry(63, Statement, 3));
   _prodInfo.Insert(ProdEntry(62, Statement, 3));
   _prodInfo.Insert(ProdEntry(61, Statement, 4));
   _prodInfo.Insert(ProdEntry(60, Statement, 3));
   _prodInfo.Insert(ProdEntry(59, Statement, 3));
   _prodInfo.Insert(ProdEntry(58, Statement, 3));
   _prodInfo.Insert(ProdEntry(57, Statement, 3));
   _prodInfo.Insert(ProdEntry(56, Statement, 9));
   _prodInfo.Insert(ProdEntry(55, Statement, 8));
   _prodInfo.Insert(ProdEntry(54, Statement, 6));
   _prodInfo.Insert(ProdEntry(53, Statement, 7));
   _prodInfo.Insert(ProdEntry(52, Statement, 5));
   _prodInfo.Insert(ProdEntry(51, Statement, 2));
   _prodInfo.Insert(ProdEntry(50, Statement, 2));
   _prodInfo.Insert(ProdEntry(49, Statement, 5));
   _prodInfo.Insert(ProdEntry(48, Statement, 5));
   _prodInfo.Insert(ProdEntry(47, Statement, 1));
   _prodInfo.Insert(ProdEntry(46, Statement, 1));
   _prodInfo.Insert(ProdEntry(45, Statement, 1));
   _prodInfo.Insert(ProdEntry(44, Statement, 1));
   _prodInfo.Insert(ProdEntry(43, Statement, 1));
   _prodInfo.Insert(ProdEntry(42, Statement, 2));
   _prodInfo.Insert(ProdEntry(41, Statement, 1));
   _prodInfo.Insert(ProdEntry(40, Statement, 3));
   _prodInfo.Insert(ProdEntry(39, Statement, 3));
   _prodInfo.Insert(ProdEntry(38, Statement, 3));
   _prodInfo.Insert(ProdEntry(37, Statement, 3));
   _prodInfo.Insert(ProdEntry(36, Statement, 3));
   _prodInfo.Insert(ProdEntry(35, Statement, 3));
   _prodInfo.Insert(ProdEntry(34, Statement, 3));
   _prodInfo.Insert(ProdEntry(33, Statement, 1));
   _prodInfo.Insert(ProdEntry(32, Statement, 1));
   _prodInfo.Insert(ProdEntry(31, Statement, 1));
   _prodInfo.Insert(ProdEntry(30, Statement, 7));
   _prodInfo.Insert(ProdEntry(29, Statement, 3));
   _prodInfo.Insert(ProdEntry(28, Statement, 3));
   _prodInfo.Insert(ProdEntry(27, Statement, 3));
   _prodInfo.Insert(ProdEntry(26, Statement, 3));
   _prodInfo.Insert(ProdEntry(25, Statement, 3));
   _prodInfo.Insert(ProdEntry(24, Statement, 3));
   _prodInfo.Insert(ProdEntry(23, Statement, 4));
   _prodInfo.Insert(ProdEntry(22, Statement, 3));
   _prodInfo.Insert(ProdEntry(21, Statement, 3));
   _prodInfo.Insert(ProdEntry(20, Statement, 3));
   _prodInfo.Insert(ProdEntry(19, Statement, 3));
   _prodInfo.Insert(ProdEntry(18, Statement, 2));
   _prodInfo.Insert(ProdEntry(17, Statement, 2));
   _prodInfo.Insert(ProdEntry(16, Statement, 1));
   _prodInfo.Insert(ProdEntry(15, Statement, 2));
   _prodInfo.Insert(ProdEntry(14, TableSetOpt, 0));
   _prodInfo.Insert(ProdEntry(13, TableSetOpt, 2));
   _prodInfo.Insert(ProdEntry(12, Statement, 3));
   _prodInfo.Insert(ProdEntry(11, Statement, 3));
   _prodInfo.Insert(ProdEntry(10, Statement, 3));
   _prodInfo.Insert(ProdEntry(9, Statement, 3));
   _prodInfo.Insert(ProdEntry(8, Statement, 3));
   _prodInfo.Insert(ProdEntry(7, Statement, 3));
   _prodInfo.Insert(ProdEntry(6, Statement, 3));
   _prodInfo.Insert(ProdEntry(5, Statement, 3));
   _prodInfo.Insert(ProdEntry(4, Statement, 3));
   _prodInfo.Insert(ProdEntry(3, Statement, 3));
   _prodInfo.Insert(ProdEntry(2, Statement, 2));
   _prodInfo.Insert(ProdEntry(1, Statement, 1));
   _prodInfo.Insert(ProdEntry(0, Start, 2));
}

Cego::Cego()
{
   loadScanner();
   for ( int i=0; i < 835; i++)
   {
      int j;
      for ( j = 0; j < 180; j++)
         _actionMap[i][j] = ActionEntry();
      for ( j = 0; j < 117; j++)
         _jumpMap[i][j] = -1;
   }
   loadParser0();
   loadParser1();
   loadParser2();
   loadParser3();
   loadParser4();
   loadParser5();
   loadParser6();
   loadParser7();
   loadParser8();
   loadParser9();
   loadParser10();
   loadParser11();
   loadParser12();
   loadParser13();
   loadParser14();
   loadParser15();
   loadParser16();
   loadParser17();
   loadParser18();
   loadParser19();
   loadParser20();
   loadParser21();
   loadParser22();
   loadParser23();
   loadParser24();
   loadParser25();
   loadParser26();
   loadParser27();
   loadParser28();
   loadParser29();
   loadParser30();
   loadParser31();
   loadParser32();
   loadParser33();
   loadParser34();
   loadParser35();
   loadParser36();
   loadParser37();
   loadParser38();
   loadParser39();
   loadParser40();
   loadParser41();
   loadParser42();
   loadParser43();
   loadParser44();
   loadParser45();
   loadParser46();
   loadParser47();
   loadParser48();
   loadParser49();
   loadParser50();
   loadParser51();
   loadParser52();
   loadParser53();
   loadParser54();
   loadParser55();
   loadParser56();
   loadParser57();
   loadParser58();
   loadParser59();
   loadParser60();
   loadParser61();
   loadParser62();
   loadParser63();
   loadParser64();
   loadParser65();
   loadParser66();
   loadParser67();
   loadParser68();
   loadParser69();
   loadParser70();
   loadParser71();
   loadParser72();
   loadParser73();
   loadParser74();
   loadParser75();
   loadParser76();
   loadParser77();
   loadParser78();
   loadParser79();
   loadParser80();
   loadParser81();
   loadParser82();
   loadParser83();
   loadParser84();
   loadParser85();
   loadParser86();
   loadParser87();
   loadParser88();
   loadParser89();
   loadParser90();
   loadParser91();
   loadParser92();
   loadParser93();
   loadParser94();
   loadParser95();
   loadParser96();
   loadParser97();
   loadParser98();
   loadParser99();
   loadParser100();
   loadParser101();
   loadParser102();
   loadParser103();
   loadParser104();
   loadParser105();
   loadParser106();
   loadParser107();
   loadParser108();
   loadParser109();
   loadParser110();
   loadParser111();
   loadParser112();
   loadParser113();
   loadParser114();
   loadParser115();
   loadParser116();
   loadParser117();
   loadParser118();
   loadParser119();
   loadParser120();
   loadParser121();
   loadParser122();
   loadParser123();
   loadParser124();
   loadParser125();
   loadParser126();
   loadParser127();
   loadParser128();
   loadParser129();
   loadParser130();
   loadParser131();
   loadParser132();
   loadParser133();
   loadParser134();
   loadParser135();
   loadParser136();
   loadParser137();
   loadParser138();
   loadParser139();
   loadParser140();
   loadParser141();
   loadParser142();
   loadParser143();
   loadParser144();
   loadParser145();
   loadParser146();
   loadParser147();
   loadParser148();
   loadParser149();
   loadParser150();
   loadParser151();
   loadParser152();
   loadParser153();
   loadParser154();
   loadParser155();
   loadParser156();
   loadParser157();
   loadParser158();
   loadParser159();
   loadParser160();
   loadParser161();
   loadParser162();
   loadParser163();
   loadParser164();
   loadParser165();
   loadParser166();
   loadParser167();
   loadParser168();
   loadParser169();
   loadParser170();
   loadParser171();
   loadParser172();
   loadParser173();
   loadParser174();
   loadParser175();
   loadParser176();
   loadParser177();
   loadParser178();
   loadParser179();
   loadParser180();
   loadParser181();
   loadParser182();
   loadParser183();
   loadParser184();
   loadParser185();
   loadParser186();
   loadParser187();
   loadParser188();
   loadParser189();
   loadParser190();
   loadParser191();
   loadParser192();
   loadParser193();
   loadParser194();
   loadParser195();
   loadParser196();
   loadParser197();
   loadParser198();
   loadParser199();
   loadParser200();
   loadParser201();
   loadParser202();
   loadParser203();
   loadParser204();
   loadParser205();
   loadParser206();
   loadParser207();
   loadParser208();
   loadParser209();
   loadParser210();
   loadParser211();
   loadParser212();
   loadParser213();
   loadParser214();
   loadParser215();
   loadParser216();
   loadParser217();
   loadParser218();
   loadParser219();
   loadParser220();
   loadParser221();
   loadParser222();
   loadParser223();
   loadParser224();
   loadParser225();
   loadParser226();
   loadParser227();
   loadParser228();
   loadParser229();
   loadParser230();
   loadParser231();
   loadParser232();
   loadParser233();
   loadParser234();
   loadParser235();
   loadParser236();
   loadParser237();
   loadParser238();
   loadParser239();
   loadParser240();
   loadParser241();
   loadParser242();
   loadParser243();
   loadParser244();
   loadParser245();
   loadParser246();
   loadParser247();
   loadParser248();
   _isReserved = false;
}

Cego::~Cego()
{
}

void Cego::parse()
{
   StackT<StackEntry> s;
   StackEntry se(NONE, 0, 0);
   s.Push(se);
   _isReserved = false;
   if ( shiftToken() == false )
   {
      Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
      throw Exception(EXLOC, msg);
   }
   while ( true )
   {
      Action a;
      int num;
      if ( getAction(s.getTop()->getState(), _token, a, num) )
      {
         switch (a)
         {
            case SHIFT:
            {
               StackEntry se(TOKEN, _token, num, _tokenVal);
               s.Push(se);
               if ( shiftToken() == false )
               {
                  Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               break;
            }
            case REDUCE:
            {
               _tokenList.Empty();
               ProdEntry* pPE = _prodInfo.Find(num);
               for (int i=0; i<pPE->getNumSymbol();i++)
               {
                  StackEntry se;
                  s.Pop(se);
                  if (se.getSymbol() == TOKEN)
                     _tokenList.Insert(se.getTval());
               }
               int fstate;
               if (getJump(s.getTop()->getState(), pPE->getProd(), fstate))
               {
                  StackEntry se(PROD, pPE->getId(), fstate, _tokenVal);
                  s.Push(se);
               }
               else
               {
                  Chain msg = "Cannot reduce after token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               switch (num)
               {
                  case 369:
                     setObject3();
                     break;
                  case 368:
                     setObject2();
                     break;
                  case 367:
                     setObject1();
                     break;
                  case 366:
                     miscDateValue();
                     break;
                  case 365:
                     miscDateFormat();
                     break;
                  case 364:
                     miscBlobRef();
                     break;
                  case 363:
                     miscFalseValue();
                     break;
                  case 362:
                     miscTrueValue();
                     break;
                  case 361:
                     miscNull();
                     break;
                  case 360:
                     miscSysDate();
                     break;
                  case 359:
                     miscFormatDate();
                     break;
                  case 358:
                     miscFixedValue();
                     break;
                  case 357:
                     miscDecimalValue();
                     break;
                  case 356:
                     miscDoubleValue();
                     break;
                  case 355:
                     miscFloatValue();
                     break;
                  case 354:
                     miscStringValue();
                     break;
                  case 353:
                     miscTinyIntValue();
                     break;
                  case 352:
                     miscSmallIntValue();
                     break;
                  case 351:
                     miscBigIntValue();
                     break;
                  case 350:
                     miscLongValue();
                     break;
                  case 349:
                     miscIntValue();
                     break;
                  case 348:
                     miscNegatedFloatString();
                     break;
                  case 347:
                     miscFloatString();
                     break;
                  case 346:
                     miscNegatedIntString();
                     break;
                  case 345:
                     miscIntString();
                     break;
                  case 344:
                     miscAttribute3();
                     break;
                  case 343:
                     miscAttribute2();
                     break;
                  case 342:
                     miscAttribute1();
                     break;
                  case 341:
                     miscMoreEqualComp();
                     break;
                  case 340:
                     miscLessEqualComp();
                     break;
                  case 339:
                     miscMoreComp();
                     break;
                  case 338:
                     miscLessComp();
                     break;
                  case 337:
                     miscNotEqualComp();
                     break;
                  case 336:
                     miscEqualComp();
                     break;
                  case 335:
                     miscBlobType();
                     break;
                  case 334:
                     miscFixedType();
                     break;
                  case 333:
                     miscDecimalType();
                     break;
                  case 332:
                     miscTinyIntType();
                     break;
                  case 331:
                     miscSmallIntType();
                     break;
                  case 330:
                     miscDoubleType();
                     break;
                  case 329:
                     miscFloatType();
                     break;
                  case 328:
                     miscBigIntType();
                     break;
                  case 327:
                     miscBoolType();
                     break;
                  case 326:
                     miscDateTimeType();
                     break;
                  case 325:
                     miscStringType();
                     break;
                  case 324:
                     miscLongType();
                     break;
                  case 323:
                     miscIntType();
                     break;
                  case 322:
                     wcPredicateNotPredicate();
                     break;
                  case 321:
                     wcPredicateCondition();
                     break;
                  case 320:
                     wcPredicateNotLikeComp();
                     break;
                  case 319:
                     wcPredicateLikeComp();
                     break;
                  case 318:
                     wcPredicateNotNullComp();
                     break;
                  case 317:
                     wcPredicateNullComp();
                     break;
                  case 316:
                     wcPredicateBetween();
                     break;
                  case 315:
                     wcPredicateExprComp();
                     break;
                  case 314:
                     wcPredicateQueryNotIn();
                     break;
                  case 313:
                     wcPredicateQueryIn();
                     break;
                  case 312:
                     wcPredicateQueryExists();
                     break;
                  case 311:
                     wcConditionPredicate();
                     break;
                  case 310:
                     wcConditionOr();
                     break;
                  case 309:
                     wcConditionAnd();
                     break;
                  case 307:
                     wcEmptyClause();
                     break;
                  case 306:
                     wcWhereClause();
                     break;
                  case 305:
                     functionExprList2();
                     break;
                  case 304:
                     functionExprList1();
                     break;
                  case 303:
                     functionUserDef2();
                     break;
                  case 302:
                     functionUserDef1();
                     break;
                  case 301:
                     functionSetCount();
                     break;
                  case 300:
                     functionNextCount();
                     break;
                  case 299:
                     functionNative();
                     break;
                  case 298:
                     functionNative();
                     break;
                  case 297:
                     functionNative();
                     break;
                  case 296:
                     functionNative();
                     break;
                  case 295:
                     functionNative();
                     break;
                  case 294:
                     functionNative();
                     break;
                  case 293:
                     functionNative();
                     break;
                  case 292:
                     functionNative();
                     break;
                  case 291:
                     functionNative();
                     break;
                  case 290:
                     functionNative();
                     break;
                  case 289:
                     functionNative();
                     break;
                  case 288:
                     functionNative();
                     break;
                  case 287:
                     functionNative();
                     break;
                  case 286:
                     functionNative();
                     break;
                  case 285:
                     functionNative();
                     break;
                  case 284:
                     functionNative();
                     break;
                  case 283:
                     functionNative();
                     break;
                  case 282:
                     functionNative();
                     break;
                  case 281:
                     functionNative();
                     break;
                  case 280:
                     functionNative();
                     break;
                  case 279:
                     functionNative();
                     break;
                  case 278:
                     functionNative();
                     break;
                  case 277:
                     functionNative();
                     break;
                  case 276:
                     functionNative();
                     break;
                  case 275:
                     functionNative();
                     break;
                  case 274:
                     functionNative();
                     break;
                  case 273:
                     functionNative();
                     break;
                  case 272:
                     functionNative();
                     break;
                  case 271:
                     renameCheck();
                     break;
                  case 270:
                     renameView();
                     break;
                  case 269:
                     renameProcedure();
                     break;
                  case 268:
                     renameKey();
                     break;
                  case 267:
                     renameIndex();
                     break;
                  case 266:
                     renameTable();
                     break;
                  case 265:
                     alterRenameCol();
                     break;
                  case 264:
                     alterModCol();
                     break;
                  case 263:
                     alterAddCol();
                     break;
                  case 262:
                     alterDropCol();
                     break;
                  case 259:
                     alterStore();
                     break;
                  case 257:
                     setUpdDelAlias();
                     break;
                  case 256:
                     deleteStore();
                     break;
                  case 255:
                     returnVarAssignment();
                     break;
                  case 250:
                     updateAssignment();
                     break;
                  case 247:
                     updateStore();
                     break;
                  case 245:
                     selectLimitOpt2();
                     break;
                  case 244:
                     selectLimitOpt1();
                     break;
                  case 242:
                     selectDistinctOpt();
                     break;
                  case 239:
                     selectOrderingDesc();
                     break;
                  case 238:
                     selectOrderingAsc();
                     break;
                  case 237:
                     selectOrderingList2();
                     break;
                  case 236:
                     selectOrderingList1();
                     break;
                  case 234:
                     selectEmptyOrderingClause();
                     break;
                  case 233:
                     selectOrderingClause();
                     break;
                  case 231:
                     selectEmptyHavingClause();
                     break;
                  case 230:
                     selectHavingClause();
                     break;
                  case 229:
                     selectGroupList2();
                     break;
                  case 228:
                     selectGroupList1();
                     break;
                  case 226:
                     selectEmptyGroupClause();
                     break;
                  case 225:
                     selectGroupClause();
                     break;
                  case 223:
                     noAliasOpt();
                     break;
                  case 222:
                     aliasOpt();
                     break;
                  case 221:
                     selectStackJoinTable();
                     break;
                  case 220:
                     selectTable2();
                     break;
                  case 219:
                     selectTable1();
                     break;
                  case 214:
                     selectRightOuterJoinStore();
                     break;
                  case 213:
                     selectLeftOuterJoinStore();
                     break;
                  case 212:
                     selectInnerJoinStore();
                     break;
                  case 209:
                     selectJoinSpecStore();
                     break;
                  case 208:
                     selectTableListStore();
                     break;
                  case 207:
                     selectItem();
                     break;
                  case 206:
                     selectionList2();
                     break;
                  case 205:
                     selectionList1();
                     break;
                  case 204:
                     selectSelectionStore2();
                     break;
                  case 203:
                     selectSelectionStore1();
                     break;
                  case 202:
                     selectStore();
                     break;
                  case 201:
                     insertExprValue();
                     break;
                  case 200:
                     insertExprValue();
                     break;
                  case 199:
                     insertArg();
                     break;
                  case 198:
                     insertArg();
                     break;
                  case 197:
                     insertValueSpecStoreExecute();
                     break;
                  case 194:
                     insertPrepare();
                     break;
                  case 191:
                     insertBySelectStore();
                     break;
                  case 190:
                     insertStore();
                     break;
                  case 189:
                     rollbackStore();
                     break;
                  case 188:
                     commitStore();
                     break;
                  case 187:
                     startStore();
                     break;
                  case 186:
                     setBTreeIndex();
                     break;
                  case 185:
                     setAVLIndex();
                     break;
                  case 183:
                     setUniqueIndex();
                     break;
                  case 182:
                     createSimpleAttr();
                     break;
                  case 181:
                     createSimpleAttrList();
                     break;
                  case 178:
                     defaultNullOpt();
                     break;
                  case 177:
                     defaultOpt();
                     break;
                  case 175:
                     setNullOpt();
                     break;
                  case 174:
                     setNotNullOpt();
                     break;
                  case 173:
                     setNullOpt();
                     break;
                  case 172:
                     setColumnDesc();
                     break;
                  case 171:
                     setOrdinaryColumn();
                     break;
                  case 170:
                     setPrimaryColumn();
                     break;
                  case 167:
                     procStoreFetchArg2();
                     break;
                  case 166:
                     procStoreFetchArg1();
                     break;
                  case 165:
                     casePrepare();
                     break;
                  case 164:
                     caseCondition();
                     break;
                  case 163:
                     caseConditionList2();
                     break;
                  case 162:
                     caseConditionList1();
                     break;
                  case 161:
                     caseClause();
                     break;
                  case 160:
                     procFactor14();
                     break;
                  case 159:
                     procFactor13();
                     break;
                  case 158:
                     procFactor12();
                     break;
                  case 157:
                     procFactor11();
                     break;
                  case 156:
                     procFactor10();
                     break;
                  case 155:
                     procFactor9();
                     break;
                  case 154:
                     procFactor8();
                     break;
                  case 153:
                     procFactor7();
                     break;
                  case 152:
                     procFactor6();
                     break;
                  case 151:
                     procFactor5();
                     break;
                  case 150:
                     procFactor4();
                     break;
                  case 149:
                     procFactor3();
                     break;
                  case 148:
                     procFactor2();
                     break;
                  case 147:
                     procFactor1();
                     break;
                  case 146:
                     procTerm3();
                     break;
                  case 145:
                     procTerm2();
                     break;
                  case 144:
                     procTerm1();
                     break;
                  case 143:
                     procExpr4();
                     break;
                  case 142:
                     procExpr3();
                     break;
                  case 141:
                     procExpr2();
                     break;
                  case 140:
                     procExpr1();
                     break;
                  case 139:
                     procPredicate4();
                     break;
                  case 138:
                     procPredicate3();
                     break;
                  case 137:
                     procPredicate2();
                     break;
                  case 136:
                     procPredicate1();
                     break;
                  case 135:
                     procCondition3();
                     break;
                  case 134:
                     procCondition2();
                     break;
                  case 133:
                     procCondition1();
                     break;
                  case 132:
                     procWhileCondition();
                     break;
                  case 131:
                     procWhileStatement();
                     break;
                  case 130:
                     procElsIfCondition();
                     break;
                  case 129:
                     procIfCondition();
                     break;
                  case 128:
                     procElsePart();
                     break;
                  case 126:
                     procStoreElseBlock();
                     break;
                  case 125:
                     procStoreIfBlock();
                     break;
                  case 122:
                     procStoreIfBlock();
                     break;
                  case 121:
                     procIfStatement();
                     break;
                  case 120:
                     procExceptionCondition();
                     break;
                  case 119:
                     procExprValue();
                     break;
                  case 118:
                     procExprValue();
                     break;
                  case 116:
                     procValueSpec();
                     break;
                  case 115:
                     procExceptionStatement();
                     break;
                  case 112:
                     procBlockStart();
                     break;
                  case 111:
                     procBlockStatement();
                     break;
                  case 110:
                     procReturnStatement2();
                     break;
                  case 109:
                     procReturnStatement1();
                     break;
                  case 108:
                     procQueryStatement();
                     break;
                  case 107:
                     procQueryStatement();
                     break;
                  case 106:
                     procQueryStatement();
                     break;
                  case 105:
                     procQueryStatement();
                     break;
                  case 104:
                     procQueryStatement();
                     break;
                  case 103:
                     procQueryStatement();
                     break;
                  case 102:
                     procThrowStatement();
                     break;
                  case 100:
                     procInitialAssignment2();
                     break;
                  case 99:
                     procInitialAssignment1();
                     break;
                  case 98:
                     procNoopStatement();
                     break;
                  case 97:
                     procAssign2NullStatement();
                     break;
                  case 96:
                     procAssignStatement();
                     break;
                  case 95:
                     procCursorCloseStatement();
                     break;
                  case 94:
                     procCursorCreateStatement();
                     break;
                  case 93:
                     procVarStatement();
                     break;
                  case 92:
                     procStoreBlock();
                     break;
                  case 89:
                     procArg2();
                     break;
                  case 88:
                     procArg1();
                     break;
                  case 82:
                     procReturnOpt();
                     break;
                  case 81:
                     procStore();
                     break;
                  case 80:
                     procHead();
                     break;
                  case 78:
                     unionAllStore();
                     break;
                  case 77:
                     jdbcArg2();
                     break;
                  case 76:
                     jdbcArg1();
                     break;
                  case 75:
                     jdbcInfo();
                     break;
                  case 74:
                     execCounterId();
                     break;
                  case 73:
                     execSetCounter();
                     break;
                  case 72:
                     execDropCounter();
                     break;
                  case 71:
                     execCreateCounter();
                     break;
                  case 70:
                     execIndexCheck();
                     break;
                  case 69:
                     execPrint();
                     break;
                  case 68:
                     execAssignStatement();
                     break;
                  case 67:
                     execCheckCreate();
                     break;
                  case 66:
                     execForeignKeyCreate();
                     break;
                  case 65:
                     dropOpt2();
                     break;
                  case 64:
                     dropOpt1();
                     break;
                  case 63:
                     execBTreeDrop();
                     break;
                  case 62:
                     execCheckDrop();
                     break;
                  case 61:
                     execFKeyDrop();
                     break;
                  case 60:
                     execProcDrop();
                     break;
                  case 59:
                     execViewDrop();
                     break;
                  case 58:
                     execIndexDrop();
                     break;
                  case 57:
                     execTableDrop();
                     break;
                  case 56:
                     execIndexCreate();
                     break;
                  case 55:
                     execPrimaryIndexCreate();
                     break;
                  case 54:
                     execUserTableCreate();
                     break;
                  case 53:
                     execFuncCall();
                     break;
                  case 52:
                     execProcCall();
                     break;
                  case 51:
                     execProcLoad();
                     break;
                  case 50:
                     execProcCreate();
                     break;
                  case 49:
                     execViewLoad();
                     break;
                  case 48:
                     execViewCreate();
                     break;
                  case 47:
                     execQuery();
                     break;
                  case 46:
                     execQuery();
                     break;
                  case 45:
                     execQuery();
                     break;
                  case 44:
                     execQuery();
                     break;
                  case 42:
                     execSelectPlan();
                     break;
                  case 41:
                     execSelect();
                     break;
                  case 40:
                     execIndexReorganize();
                     break;
                  case 39:
                     execTableReorganize();
                     break;
                  case 38:
                     execSetIsolation();
                     break;
                  case 37:
                     execDisableAutoCommit();
                     break;
                  case 36:
                     execEnableAutoCommit();
                     break;
                  case 35:
                     execDisableAppendMode();
                     break;
                  case 34:
                     execEnableAppendMode();
                     break;
                  case 33:
                     execQuery();
                     break;
                  case 32:
                     execQuery();
                     break;
                  case 31:
                     execQuery();
                     break;
                  case 30:
                     execAuthUser();
                     break;
                  case 29:
                     execSetTableSet();
                     break;
                  case 28:
                     execCheckShow();
                     break;
                  case 27:
                     execViewShow();
                     break;
                  case 26:
                     execProcShow();
                     break;
                  case 25:
                     execProcDesc();
                     break;
                  case 24:
                     execCheckDesc();
                     break;
                  case 23:
                     execKeyDesc();
                     break;
                  case 22:
                     execViewDesc();
                     break;
                  case 21:
                     execBTreeDesc();
                     break;
                  case 20:
                     execIndexDesc();
                     break;
                  case 19:
                     execTableDesc();
                     break;
                  case 18:
                     execShowSystemSpace();
                     break;
                  case 17:
                     execShowPool();
                     break;
                  case 16:
                     execShowUptime();
                     break;
                  case 15:
                     execTableInfo();
                     break;
                  case 13:
                     setTableSetOpt();
                     break;
                  case 12:
                     execListCheck();
                     break;
                  case 11:
                     execListTmpObj();
                     break;
                  case 10:
                     execListSysObj();
                     break;
                  case 9:
                     execListCounter();
                     break;
                  case 8:
                     execListKey();
                     break;
                  case 7:
                     execListBTree();
                     break;
                  case 6:
                     execListIndex();
                     break;
                  case 5:
                     execListView();
                     break;
                  case 4:
                     execListProc();
                     break;
                  case 3:
                     execListTable();
                     break;
                  case 2:
                     execListTableSet();
                     break;
                  case 1:
                     execSync();
                     break;
               }
               break;
            }
            case ACCEPT:
            {
               return;
            }
            default:
               break;
         }
      }
      else
      {
         Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
         throw Exception(EXLOC, msg);
      }
   }
}


bool Cego::getAction(int state, Cego::Token token, Cego::Action& a, int& num)
{
    if (_actionMap[state][token].getAction() != NULLACTION )
    {
	a = _actionMap[state][token].getAction();
	num = _actionMap[state][token].getNum();
	return true;
    }
    else
    {
	return false;
    }
}

bool Cego::getJump(int state, Production prod, int& fstate)
{
    if ( _jumpMap[state][prod] > 0 )
    {
       fstate = _jumpMap[state][prod];
	    return true;
    }
    else
    {
	    return false;
    }
}

bool Cego::isSepSign(char c)
{
   if (c == ';') return true;
   if (c == ',') return true;
   if (c == '=') return true;
   if (c == '<') return true;
   if (c == '>') return true;
   if (c == ')') return true;
   if (c == '(') return true;
   if (c == '[') return true;
   if (c == ']') return true;
   if (c == '/') return true;
   if (c == '+') return true;
   if (c == '-') return true;
   if (c == '|') return true;
   if (c == '*') return true;
   return false;
}
bool Cego::isSepIgnore(char c)
{
   if (c == '\t') return true;
   if (c == ' ') return true;
   if (c == '\n') return true;
   return false;
}
bool Cego::shiftToken()
{
   unsigned long i=0;
   char c;
   while ( isSepIgnore(c = nextChar()) && ! _isReserved );
   if ( _isReserved )
   {
      _token = _reservedToken;
      _isReserved = false;
      return true;
   }
   if (c == 0)
   {
      _token = ENDTOKEN;
      return true;
   }
   if (isSepSign(c))
   {
      _tokenVal[i]=c;
       i++;
   }
   else
   {
      while (c && ! isSepIgnore(c) && ! ( isSepSign(c) && i>0 ) )
      {
         _tokenVal[i]=c;
         i++;
         c = nextChar();
      }
      if (isSepSign(c)) backChar();
   }
   _tokenVal[i]=0;
   Scanner* pS = _scannerList.First();
   while (pS)
   {
      if (pS->checkPattern(_tokenVal))
      {
         _token = pS->getToken();
         return true;
      }
      pS=_scannerList.Next();
   }
   return false;
}
void Cego::setReserved(Token t)
{
   _reservedToken = t;
   _isReserved = true;
}
